// Certif.h : Declaration of the CCertif

#ifndef __CERTIF_H_
#define __CERTIF_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CCertif
class ATL_NO_VTABLE CCertif : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CCertif, &CLSID_Certif>,
	public IDispatchImpl<ICertif, &IID_ICertif, &LIBID_EIDLIBCTRLLib>
{
public:
	CCertif()
	{
        m_lStatus = BEID_CERTSTATUS_CERT_NOT_VALIDATED;
	}
	~CCertif();

DECLARE_REGISTRY_RESOURCEID(IDR_CERTIF)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCertif)
	COM_INTERFACE_ENTRY(ICertif)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ICertif
public:
	STDMETHOD(SetStatus)(/*[in]*/long lStatus);
	STDMETHOD(SetCertif)(/*[in]*/VARIANT vtCertif);
	STDMETHOD(SetLabel)(/*[in]*/BSTR bstrLabel);
	STDMETHOD(GetStatus)(/*[out, retval]*/ long *plStatus);
	STDMETHOD(GetLabel)(/*[out, retval]*/BSTR *bstrLabel);
	STDMETHOD(GetCertif)(/*[out, retval]*/VARIANT *pvtCertif);

private:
    long m_lStatus;
    _bstr_t m_strLabel;
    _variant_t m_vtCertif;
};

#endif //__CERTIF_H_
