// CertifCheck.h : Declaration of the CCertifCheck

#ifndef __CERTIFCHECK_H_
#define __CERTIFCHECK_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CCertifCheck
class ATL_NO_VTABLE CCertifCheck : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CCertifCheck, &CLSID_CertifCheck>,
	public IDispatchImpl<ICertifCheck, &IID_ICertifCheck, &LIBID_EIDLIBCTRLLib>
{
public:
	CCertifCheck()
	{
        long m_lPolicy = 0;
        long m_lSignatureCheck = -1;
	}
	~CCertifCheck();

DECLARE_REGISTRY_RESOURCEID(IDR_CERTIFCHECK)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCertifCheck)
	COM_INTERFACE_ENTRY(ICertifCheck)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ICertifCheck
public:
	STDMETHOD(SetCertificates)(/*[in]*/ VARIANT vtCertificates);
	STDMETHOD(SetSignatureCheck)(/*[in]*/long lSignatureCheck);
	STDMETHOD(SetPolicy)(/*[in]*/long lPolicy);
	STDMETHOD(GetCertificates)(/*[out, retval]*/ VARIANT *pvtCertificates);
	STDMETHOD(GetSignatureCheck)(/*[out, retval]*/long *plSignatureCheck);
	STDMETHOD(GetPolicy)(/*[out, retval]*/long *plPolicy);

private:
    long m_lPolicy;
    long m_lSignatureCheck;
    _variant_t m_vtCertificates;
};

#endif //__CERTIFCHECK_H_
