// EIDlib.h : Declaration of the CEIDlib

#ifndef __EIDLIB_H_
#define __EIDLIB_H_

#include "resource.h"       // main symbols
#include <atlctl.h>

#define E_INTERNAL_ERROR        0x80000001
#define E_BEID_ERROR            0x80000002

/////////////////////////////////////////////////////////////////////////////
// CEIDlib
class ATL_NO_VTABLE CEIDlib : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IEIDlib, &IID_IEIDlib, &LIBID_EIDLIBCTRLLib>,
	public CComControl<CEIDlib>,
	public IPersistStreamInitImpl<CEIDlib>,
	public IOleControlImpl<CEIDlib>,
	public IOleObjectImpl<CEIDlib>,
	public IOleInPlaceActiveObjectImpl<CEIDlib>,
	public IViewObjectExImpl<CEIDlib>,
	public IOleInPlaceObjectWindowlessImpl<CEIDlib>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CEIDlib>,
	public IPersistStorageImpl<CEIDlib>,
	public ISpecifyPropertyPagesImpl<CEIDlib>,
	public IQuickActivateImpl<CEIDlib>,
	public IDataObjectImpl<CEIDlib>,
	public IProvideClassInfo2Impl<&CLSID_EIDlib, &DIID__IEIDlibEvents, &LIBID_EIDLIBCTRLLib>,
	public IPropertyNotifySinkCP<CEIDlib>,
	public CComCoClass<CEIDlib, &CLSID_EIDlib>
{
private:
    long  m_lCardHandle;
public:
	CEIDlib();
    ~CEIDlib ();

DECLARE_REGISTRY_RESOURCEID(IDR_EIDLIB)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CEIDlib)
	COM_INTERFACE_ENTRY(IEIDlib)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CEIDlib)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CEIDlib)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CEIDlib)
	CHAIN_MSG_MAP(CComControl<CEIDlib>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_IEIDlib,
		};
		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
            if (::InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IEIDlib
public:
	STDMETHOD(GetRawData)(/*[out]*/ IRaw **ppRaw, IRetStatus **ppRetStatus);
	STDMETHOD(SetRawData)(/*[in]*/ IRaw *pRaw, IRetStatus **ppRetStatus);
	STDMETHOD(WriteFile)(/*[in]*/IPin *pPIN, /*[in]*/VARIANT vtFileID, /*[in]*/VARIANT vtData, /*[out, retval]*/IRetStatus **ppRetStatus);
	STDMETHOD(ReadFile)(/*[in]*/IPin *pPIN, /*[in]*/VARIANT vtFileId, /*[out]*/VARIANT *pvtData, /*[out, retval]*/IRetStatus **ppRetStatus);
	STDMETHOD(GetPinStatus)(/*[in]*/IPin *pPIN, /*[in]*/BOOL bSignature, /*[out]*/VARIANT *pvtSignature, /*[out]*/long *plTriesLeft, /*[out, retval]*/IRetStatus **ppRetStatus);
	STDMETHOD(ChangePin)(/*[in]*/IPin *pPIN, /*[in]*/BSTR strOldPin, /*[in]*/BSTR strNewPin, /*[out]*/ long *plTriesLeft, /*[out, retval]*/IRetStatus **ppRetStatus);
	STDMETHOD(VerifyPIN)(/*[in]*/IPin *pPIN, /*[in]*/BSTR bstrPin, /*[out]*/ long *plTriesLeft, /*[out, retval]*/IRetStatus **ppRetStatus);
	STDMETHOD(SendAPDU)(/*[in]*/VARIANT vtCommand, /*[in]*/IPin *pPIN, /*[out]*/VARIANT *pvtResponse, /*[out, retval]*/IRetStatus **ppRetStatus);
	STDMETHOD(SelectApplication)(/*[in]*/VARIANT vtApplication, /*[out, retval]*/IRetStatus **ppRetStatus);
	STDMETHOD(FlushCache)(/*[out, retval]*/IRetStatus **ppRetStatus);
	STDMETHOD(EndTransaction)(/*[out, retval]*/IRetStatus **ppRetStatus);
	STDMETHOD(BeginTransaction)(/*[out, retval]*/IRetStatus **ppRetStatus);
	STDMETHOD(GetVersionInfo)(/*[in]*/BOOL bSignature, /*[out]*/IMapCollection **ppMapCollection, /*[out]*/VARIANT *pvtSignature, /*[out, retval]*/ IRetStatus **ppRetStatus);
	STDMETHOD(GetPicture)(/*[out]*/IMapCollection **ppMapCollection, /*[out]*/ICertifCheck **ppCertifCheck, /*[out, retval]*/ IRetStatus **ppRetStatus);
	STDMETHOD(GetAddress)(/*[out]*/IMapCollection **ppMapCollection, /*[out]*/ICertifCheck **ppCertifCheck, /*[out, retval]*/ IRetStatus **ppRetStatus);
	STDMETHOD(GetID)(/*[out]*/IMapCollection **ppMapCollection, /*[out]*/ICertifCheck **ppCertifCheck, /*[out, retval]*/ IRetStatus **ppRetStatus);
	STDMETHOD(Exit)(/*[out, retval]*/ IRetStatus **ppRetStatus);
	STDMETHOD(Init)(/*[in]*/BSTR strReaderName, /*[in]*/long lOCSP, /*[in]*/long lCRL, /*[out]*/long *plHandle, /*[out, retval]*/ IRetStatus **ppRetStatus);


	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);

		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
		LPCTSTR pszText = _T("EID library ActiveX");
		TextOut(di.hdcDraw, 
			(rc.left + rc.right) / 2, 
			(rc.top + rc.bottom) / 2, 
			pszText, 
			lstrlen(pszText));

		return S_OK;
	}

private:
    void FillStatus(BEID_Status *pStatus, IRetStatus *pRetStatus);
    void FillCertifCheck(BEID_Certif_Check *pCheck, ICertifCheck *pRetCheck);
    void FillPinData(BEID_Pin *pPin, IPin *pIPin);
    void DeletePinData(BEID_Pin *pPin);
    void FillRawData(BEID_Raw *pRaw, IRaw *pIRaw);
};

#endif //__EIDLIB_H_
