// MapCollection.cpp : Implementation of CMapCollection
#include "stdafx.h"
#include "EidLibCtrl.h"
#include "MapCollection.h"

/////////////////////////////////////////////////////////////////////////////
// CMapCollection

CMapCollection::CMapCollection()
{
}

CMapCollection::~CMapCollection()
{
    m_StringMap.clear();
}

STDMETHODIMP CMapCollection::GetValue(BSTR strKey, VARIANT *pvtValue)
{
    HRESULT hRes = S_OK;

    if(NULL == pvtValue)
        return E_POINTER;
    
    _variant_t vtTemp;

    // Find Value
    MapIt it;
    it = m_StringMap.find(strKey);
    if(it != m_StringMap.end())
    {
        vtTemp = (*it).second;
    }
    ::VariantCopy (pvtValue, &vtTemp);

    return hRes;
}

STDMETHODIMP CMapCollection::SetValue(BSTR strKey, VARIANT vtValue)
{
    m_StringMap[strKey] = _variant_t (vtValue);

	return S_OK;
}

STDMETHODIMP CMapCollection::GetCount(long *plCount)
{
    if(plCount == NULL)
        return E_POINTER;

    *plCount = m_StringMap.size();

	return S_OK;
}

STDMETHODIMP CMapCollection::Clear()
{
    m_StringMap.clear();

	return S_OK;
}
