// MapCollection.h : Declaration of the CMapCollection

#ifndef __MAPCOLLECTION_H_
#define __MAPCOLLECTION_H_

#include "resource.h"       // main symbols
#include <map>
#include <comdef.h>
/////////////////////////////////////////////////////////////////////////////
// CMapCollection
class ATL_NO_VTABLE CMapCollection : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMapCollection, &CLSID_MapCollection>,
	public IDispatchImpl<IMapCollection, &IID_IMapCollection, &LIBID_EIDLIBCTRLLib>
{
public:
	CMapCollection();
    ~CMapCollection();

DECLARE_REGISTRY_RESOURCEID(IDR_MAPCOLLECTION)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMapCollection)
	COM_INTERFACE_ENTRY(IMapCollection)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IMapCollection
public:
	STDMETHOD(Clear)();
	STDMETHOD(GetCount)(/*[out, retval]*/long *plCount);
	STDMETHOD(SetValue)(/*[in]*/BSTR strKey, /*[in]*/VARIANT vtValue);
	STDMETHOD(GetValue)(/*[in]*/BSTR strKey, /*[out, retval]*/ VARIANT *pvtValue);

private:
    std::map<_bstr_t, _variant_t> m_StringMap;
    typedef std::map<_bstr_t, _variant_t>::iterator  MapIt;
};

#endif //__MAPCOLLECTION_H_
