// Pin.h : Declaration of the CPin

#ifndef __PIN_H_
#define __PIN_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CPin
class ATL_NO_VTABLE CPin : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CPin, &CLSID_Pin>,
	public IDispatchImpl<IPin, &IID_IPin, &LIBID_EIDLIBCTRLLib>
{
public:
	CPin()
	{
        m_lUsageCode = BEID_USAGE_AUTH;
        m_lType = BEID_PIN_TYPE_PKCS15;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_PIN)
DECLARE_NOT_AGGREGATABLE(CPin)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CPin)
	COM_INTERFACE_ENTRY(IPin)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IPin
public:
	STDMETHOD(GetLongUsage)(/*[out, retval]*/ BSTR *pstrLongUsage);
	STDMETHOD(GetShortUsage)(/*[out, retval]*/ BSTR *pstrShortUsage);
	STDMETHOD(GetUsageCode)(/*[out, retval]*/ long *plUsageCode);
	STDMETHOD(GetID)(/*[out, retval]*/ VARIANT *pvtID);
	STDMETHOD(GetPinType)(/*[out, retval]*/ long *plType);
	STDMETHOD(SetLongUsage)(/*[in]*/ BSTR strLongUsage);
	STDMETHOD(SetShortUsage)(/*[in]*/ BSTR strShortUsage);
	STDMETHOD(SetUsageCode)(/*[in]*/ long lUsageCode);
	STDMETHOD(SetID)(/*[in]*/ VARIANT vtID);
	STDMETHOD(SetPinType)(/*[IN]*/ long lType);

private:
    _bstr_t m_strShortUsage;
    _bstr_t m_strLongUsage;
    long m_lUsageCode;
    long m_lType;
    _variant_t m_vtID;
};

#endif //__PIN_H_
