// Raw.h : Declaration of the CRaw

#ifndef __RAW_H_
#define __RAW_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CRaw
class ATL_NO_VTABLE CRaw : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CRaw, &CLSID_Raw>,
	public IDispatchImpl<IRaw, &IID_IRaw, &LIBID_EIDLIBCTRLLib>
{
public:
	CRaw()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_RAW)
DECLARE_NOT_AGGREGATABLE(CRaw)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CRaw)
	COM_INTERFACE_ENTRY(IRaw)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IRaw
public:
	STDMETHOD(GetResponseData)(/*[out]*/ VARIANT *pvtResponseData);
	STDMETHOD(SetResponseData)(/*[in]*/ VARIANT vtResponseData);
	STDMETHOD(GetChallengeData)(/*[out]*/ VARIANT *pvtChallengeData);
	STDMETHOD(SetChallengeData)(/*[in]*/ VARIANT vtChallengeData);
	STDMETHOD(GetTokenInfoData)(/*[out]*/ VARIANT *pvtTokenInfoData);
	STDMETHOD(SetTokenInfoData)(/*[in]*/ VARIANT vtTokenInfoData);
	STDMETHOD(GetCardData)(/*[out]*/ VARIANT *pvtCardData);
	STDMETHOD(SetCardData)(/*[in]*/ VARIANT vtCardData);
	STDMETHOD(GetRNData)(/*[out]*/ VARIANT *pvtRNData);
	STDMETHOD(SetRNData)(/*[in]*/ VARIANT vtRNData);
	STDMETHOD(GetPictureData)(/*[out]*/ VARIANT *pvtPictureData);
	STDMETHOD(SetPictureData)(/*[in]*/ VARIANT vtPictureData);
	STDMETHOD(GetAddrSigData)(/*[out]*/ VARIANT *pvtAddrSigData);
	STDMETHOD(SetAddrSigData)(/*[in]*/ VARIANT vtAddrSigData);
	STDMETHOD(GetAddrData)(/*[out]*/ VARIANT *pvtAddrData);
	STDMETHOD(SetAddrData)(/*[in]*/ VARIANT vtAddrData);
	STDMETHOD(GetIDSigData)(/*[out]*/ VARIANT *pvtIDSigData);
	STDMETHOD(SetIDSigData)(/*[in]*/ VARIANT vtIDSigData);
	STDMETHOD(GetIDData)(/*[out]*/ VARIANT *pvtID);
	STDMETHOD(SetIDData)(/*[in]*/ VARIANT vtID);

private:
    _variant_t m_vtIDData;
    _variant_t m_vtIDSigData;
    _variant_t m_vtAddrData;
    _variant_t m_vtAddrSigData;
    _variant_t m_vtPictureData;
    _variant_t m_vtRNData;
    _variant_t m_vtCardData;
    _variant_t m_vtTokenInfoData;
    _variant_t m_vtChallengeData;
    _variant_t m_vtResponseData;
};

#endif //__RAW_H_
