// CertificatesPage.cpp : implementation file
//

#include "stdafx.h"
#include "eidgui.h"
#include "CertificatesPage.h"
#include "FontSize.h"
#include <atlbase.h>

//#include "ScConfig.h"
#include <vector>
using namespace std;
#include "BelgianEIDConfig.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MY_ENCODING_TYPE  (X509_ASN_ENCODING | PKCS_7_ASN_ENCODING)
#define BELGIAN_EID_CARD 0x00000020

extern CEidGUIApp theApp;

///////////////////////////////////////////////////
/* Helper Functions */
void ASN1_GENERALIZEDTIME_Print(ASN1_GENERALIZEDTIME *tm, CString & strTime);
void ASN1_UTCTIME_Print(ASN1_UTCTIME *tm, CString & strTime);

void ASN1_TIME_Print(ASN1_TIME *tm, CString & strTime)
{
    strTime.Empty();
	if(tm->type == V_ASN1_UTCTIME)
        ASN1_UTCTIME_Print(tm, strTime);
	if(tm->type == V_ASN1_GENERALIZEDTIME)
		ASN1_GENERALIZEDTIME_Print(tm, strTime);
}

void ASN1_GENERALIZEDTIME_Print(ASN1_GENERALIZEDTIME *tm, CString & strTime)
{
	char *v;
	int gmt=0;
	int i;
	int y=0,M=0,d=0,h=0,m=0,s=0;

	i=tm->length;
	v=(char *)tm->data;

	if (i < 12) return;
	if (v[i-1] == 'Z') gmt=1;
	for (i=0; i<12; i++)
		if ((v[i] > '9') || (v[i] < '0')) return;
	y= (v[0]-'0')*1000+(v[1]-'0')*100 + (v[2]-'0')*10+(v[3]-'0');
	M= (v[4]-'0')*10+(v[5]-'0');
	if ((M > 12) || (M < 1)) return;
	d= (v[6]-'0')*10+(v[7]-'0');
	h= (v[8]-'0')*10+(v[9]-'0');
	m=  (v[10]-'0')*10+(v[11]-'0');
	if (	(v[12] >= '0') && (v[12] <= '9') &&
		(v[13] >= '0') && (v[13] <= '9'))
		s=  (v[12]-'0')*10+(v[13]-'0');

    SYSTEMTIME tSysTimeLocal = {0};
    tSysTimeLocal.wYear = y+1900;
    tSysTimeLocal.wMonth = M;
    tSysTimeLocal.wDay = d;
    tSysTimeLocal.wHour = h;
    tSysTimeLocal.wMinute = m;
    tSysTimeLocal.wSecond = s;
    if(gmt = 1)
    {
        FILETIME tFileTime = {0};
        FILETIME tFileTimeLocal = {0};

        ::SystemTimeToFileTime(&tSysTimeLocal, &tFileTime); 
        ::FileTimeToLocalFileTime(&tFileTime, &tFileTimeLocal);
        memset(&tSysTimeLocal, 0, sizeof(SYSTEMTIME));
        ::FileTimeToSystemTime(&tFileTimeLocal, &tSysTimeLocal); 
    }

    COleDateTime oDate( tSysTimeLocal.wYear, tSysTimeLocal.wMonth, tSysTimeLocal.wDay, 
        tSysTimeLocal.wHour, tSysTimeLocal.wMinute, tSysTimeLocal.wSecond );
    strTime = oDate.Format(VAR_DATEVALUEONLY);
}

void ASN1_UTCTIME_Print(ASN1_UTCTIME *tm, CString & strTime)
{
	char *v;
	int gmt=0;
	int i;
	int y=0,M=0,d=0,h=0,m=0,s=0;

	i=tm->length;
	v=(char *)tm->data;

	if (i < 10) return;
	if (v[i-1] == 'Z') gmt=1;
	for (i=0; i<10; i++)
		if ((v[i] > '9') || (v[i] < '0')) return;
	y= (v[0]-'0')*10+(v[1]-'0');
	if (y < 50) y+=100;
	M= (v[2]-'0')*10+(v[3]-'0');
	if ((M > 12) || (M < 1)) return;
	d= (v[4]-'0')*10+(v[5]-'0');
	h= (v[6]-'0')*10+(v[7]-'0');
	m=  (v[8]-'0')*10+(v[9]-'0');
	if (	(v[10] >= '0') && (v[10] <= '9') &&
		(v[11] >= '0') && (v[11] <= '9'))
		s=  (v[10]-'0')*10+(v[11]-'0');

    SYSTEMTIME tSysTimeLocal = {0};
    tSysTimeLocal.wYear = y+1900;
    tSysTimeLocal.wMonth = M;
    tSysTimeLocal.wDay = d;
    tSysTimeLocal.wHour = h;
    tSysTimeLocal.wMinute = m;
    tSysTimeLocal.wSecond = s;
    if(gmt = 1)
    {
        FILETIME tFileTime = {0};
        FILETIME tFileTimeLocal = {0};

        ::SystemTimeToFileTime(&tSysTimeLocal, &tFileTime); 
        ::FileTimeToLocalFileTime(&tFileTime, &tFileTimeLocal);
        memset(&tSysTimeLocal, 0, sizeof(SYSTEMTIME));
        ::FileTimeToSystemTime(&tFileTimeLocal, &tSysTimeLocal); 
    }

    COleDateTime oDate( tSysTimeLocal.wYear, tSysTimeLocal.wMonth, tSysTimeLocal.wDay, 
        tSysTimeLocal.wHour, tSysTimeLocal.wMinute, tSysTimeLocal.wSecond );
    strTime = oDate.Format(VAR_DATEVALUEONLY);
}

/////////////////////////////////////////////////////////////////////////////
// CCertificatesPage property page

IMPLEMENT_DYNCREATE(CCertificatesPage, CPropertyPage)

CCertificatesPage::CCertificatesPage() : CPropertyPage(CCertificatesPage::IDD)
{
    memset(&m_VersionInfo, 0, sizeof(BEID_VersionInfo));
	//{{AFX_DATA_INIT(CCertificatesPage)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CCertificatesPage::~CCertificatesPage()
{
    ClearMap();
}

void CCertificatesPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCertificatesPage)
	DDX_Control(pDX, IDC_BUTTON_REGISTER, m_CtrlRegister);
	DDX_Control(pDX, IDC_STATIC_TREE_CERTIFICATES_LABEL, m_CtrlCertTreeLabel);
	DDX_Control(pDX, IDC_STATIC_CERTIFICATES_VALIDUNTIL_VAL, m_CtrlValidUntilVal);
	DDX_Control(pDX, IDC_STATIC_CERTIFICATES_VALIDUNTIL, m_CtrlValidUntil);
	DDX_Control(pDX, IDC_STATIC_CERTIFICATES_VALIDFROM_VAL, m_CtrlValidFromVal);
	DDX_Control(pDX, IDC_STATIC_CERTIFICATES_VALIDFROM, m_CtrlValidFrom);
	DDX_Control(pDX, IDC_STATIC_CERTIFICATES_STATUS_VAL, m_CtrlStatusVal);
	DDX_Control(pDX, IDC_STATIC_CERTIFICATES_STATUS, m_CtrlStatus);
	DDX_Control(pDX, IDC_STATIC_CERTIFICATES_OWNER_VAL, m_CtrlOwnerVal);
	DDX_Control(pDX, IDC_STATIC_CERTIFICATES_OWNER, m_CtrlOwner);
	DDX_Control(pDX, IDC_STATIC_CERTIFICATES_KEYLENGTH_VAL, m_CtrlKeyLengthVal);
	DDX_Control(pDX, IDC_STATIC_CERTIFICATES_KEYLENGTH, m_CtrlKeyLength);
	DDX_Control(pDX, IDC_STATIC_CERTIFICATES_ISSUER_VAL, m_CtrlIssuerVal);
	DDX_Control(pDX, IDC_STATIC_CERTIFICATES_ISSUER, m_CtrlIssuer);
	DDX_Control(pDX, IDC_BUTTONCERTIFICATES_DETAILS, m_CtrlDetails);
	DDX_Control(pDX, IDC_TREE_CERTIFICATES, m_CtrlCertificates);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCertificatesPage, CPropertyPage)
	//{{AFX_MSG_MAP(CCertificatesPage)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_CERTIFICATES, OnSelchangedTreeCertificates)
	ON_BN_CLICKED(IDC_BUTTONCERTIFICATES_DETAILS, OnButtoncertificatesDetails)
	ON_BN_CLICKED(IDC_BUTTON_REGISTER, OnButtonRegister)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCertificatesPage message handlers

void CCertificatesPage::SetCertificateData(BEID_Certif_Check *pCertifs)
{
    ASSERT(pCertifs);

    ClearMap();

    for (int i = 0; i < pCertifs->certificatesLength; ++i)
    {
        char *pszLabel = pCertifs->certificates[i].certifLabel;
        long lLength = pCertifs->certificates[i].certifLength;

        X509 *pX509 = NULL;
        if(lLength > 0 && 0 != strcmp(pszLabel, "RN"))
        {
            unsigned char *pData = pCertifs->certificates[i].certif;
            CCertif *pCertif = new CCertif(pData, lLength, 
                                                        pszLabel, pCertifs->certificates[i].certifStatus);
            if (NULL != (pX509 = d2i_X509(&pX509, &pData, lLength)))
            {
                pCertif->SetX509(pX509);
                ASN1_INTEGER *pSerialNr = X509_get_serialNumber(pX509);
                char *pSerialKey = theApp.Hexify(pSerialNr->data, pSerialNr->length);
                //char szName[512] = {0};
                //X509_NAME_oneline(X509_get_subject_name(pX509), szName, sizeof(szName));
                m_oMapCertifs[pSerialKey] = pCertif; 
                delete pSerialKey;
                pX509 = NULL;
            }
        }
    }
    FillTree();
}

void CCertificatesPage::SetVersionInfoData(BEID_VersionInfo *pVersion)
{
    ASSERT(pVersion);
    memcpy(&m_VersionInfo, pVersion, sizeof(BEID_VersionInfo));
}

void CCertificatesPage::ClearMap()
{
    MapCertifsIt it;
    for (it = m_oMapCertifs.begin(); it != m_oMapCertifs.end(); ++it)
    {
        CCertif *pCertif = (*it).second;
        if(pCertif != NULL)
        {
            delete pCertif;
        }
    }
    m_oMapCertifs.clear();
}


void CCertificatesPage::GetCertChain(X509 *cert, X509_STORE *store, STACK_OF(X509) **ppChain)
{
  X509 *pIssuerRet = NULL;
  X509_STORE_CTX *ctx = 0;
  STACK_OF(X509) *chn = NULL;

  if ((ctx = X509_STORE_CTX_new()) != 0) 
  {
    if (X509_STORE_CTX_init(ctx, store, cert, 0) == 1)
    {
	    X509_verify_cert(ctx); 
        chn = X509_STORE_CTX_get1_chain(ctx);
    }

    *ppChain = chn;
    X509_STORE_CTX_free(ctx);
  }
}

void CCertificatesPage::FillTree()
{
    if(m_hWnd == NULL || !::IsWindow(m_hWnd))
        return;

    m_CtrlCertificates.DeleteAllItems();
  
    SetTextFields (NULL);

    if (0 == m_oMapCertifs.size())
    {
        return;
    }
    STACK_OF(X509) *certs = sk_X509_new_null();
    X509_STORE *store = NULL;
    MapCertifsIt it;

    // Fill certs stack
    for (it = m_oMapCertifs.begin(); it != m_oMapCertifs.end(); ++it)
    {
            CCertif *pCertif = (*it).second;
            if(pCertif)
            {
                X509 *pX509 = (X509 *)pCertif->GetX509(); 
                sk_X509_push(certs, pX509);
                pX509 = NULL;
            }
    }

    // Create store
    store = X509_STORE_new();
    for (int i = 0; i < sk_X509_num(certs); i++)
    {
        X509_STORE_add_cert(store, sk_X509_value(certs, i));
    }

    // Build tree
    m_CtrlCertificates.SetFont(&m_oFont); 

    HTREEITEM hApp = m_CtrlCertificates.InsertItem(_T("BELPIC"), TVI_ROOT);
    m_CtrlCertificates.SetItemImage(hApp, 1, 1);
    for(i = 0; i < sk_X509_num(certs); ++i)
    {
        X509 *pValue = sk_X509_value(certs, i);
        if(pValue != NULL)
        {
            STACK_OF(X509) *pChain = NULL;
            GetCertChain(pValue, store, &pChain);
            if(pChain != NULL)
            {
                HTREEITEM hRoot = m_CtrlCertificates.GetRootItem(); 
                HTREEITEM hCurrent = hRoot;
                for(int j = sk_X509_num(pChain) - 1; j  >= 0 ; j--)
                {
                    X509 *pCert = sk_X509_value(pChain, j);
                    ASN1_INTEGER *pSerialNr = X509_get_serialNumber(pCert);
                    char *pSerialKey = theApp.Hexify(pSerialNr->data, pSerialNr->length);
                
                    MapCertifsIt it = m_oMapCertifs.find(pSerialKey);
                    delete pSerialKey;
                    if(it == m_oMapCertifs.end())
                        continue;

                    CCertif *pCertif = (*it).second;
                    // First Find in Tree
                    HTREEITEM hFound = FindData(hRoot, (DWORD)pCertif);
                    if(NULL == hFound)
                    {
                        char szName[256] = {0};
                        X509_NAME_get_text_by_NID(X509_get_subject_name(pCert), NID_commonName, szName, sizeof(szName));
                        CString strItem;
                        strItem = theApp.DecodeFromUTF8(szName); 
                        hCurrent = m_CtrlCertificates.InsertItem(strItem, hCurrent);
                        m_CtrlCertificates.SetItemData(hCurrent, (DWORD)pCertif);
                        m_CtrlCertificates.SetItemImage(hCurrent, 0 ,0);
                    }
                    else
                    {
                        hCurrent = hFound;
                    }
                }
                sk_X509_free(pChain);
            }
            pValue = NULL;
        }
    }
    X509_STORE_free(store);

    HTREEITEM hRoot = m_CtrlCertificates.GetRootItem();
    if(hRoot != NULL)
    {
        m_CtrlCertificates.Expand(hRoot, TVE_EXPAND); 
    }
}

HTREEITEM CCertificatesPage::FindData(HTREEITEM hti, DWORD dwData)
{
    if(hti == NULL) return NULL;		
    if(m_CtrlCertificates.GetItemData( hti ) == dwData)
    {
        return hti;
    }

    hti = m_CtrlCertificates.GetChildItem( hti );	
    do	
    {		
	    HTREEITEM hti_res;
	    if((hti_res = FindData( hti, dwData)) !=NULL )
		    return hti_res; 

    }while( (hti = m_CtrlCertificates.GetNextSiblingItem( hti )) != NULL );		
    return NULL;
}

BOOL CCertificatesPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
    LoadStrings();
    InitControls();
	FillTree();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCertificatesPage::LoadStrings()
{
    if(m_hWnd == NULL || !::IsWindow(m_hWnd))
        return;

    CString strTemp;

    // Labels
    strTemp.LoadString(IDS_STRING_CERTIFICATES_DLGTITLE);
    SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_CERTS_TREE_LABEL);
	m_CtrlCertTreeLabel.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_CERTS_VALIDUNTIL);
	m_CtrlValidUntil.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_CERTS_VALIDFROM);
	m_CtrlValidFrom.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_CERTS_STATUS);
	m_CtrlStatus.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_CERTS_OWNER);
	m_CtrlOwner.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_CERTS_KEYLENGTH);
	m_CtrlKeyLength.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_CERTS_ISSUER);
	m_CtrlIssuer.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_CERTS_DETAILS);
	m_CtrlDetails.SetWindowText(strTemp);	
}

void CCertificatesPage::InitControls() 
{
    // Tree Control
    m_imgList.Create(IDB_BITMAP_CERTIFICATES_IMG, 16, 16, RGB (192,192,192));
	m_CtrlCertificates.SetImageList(&m_imgList, TVSIL_NORMAL);    

    // Data fields
    COLORREF crBack = RGB(255,255,255);
    m_CtrlValidUntilVal.SetBackgroundColor(crBack);
	m_CtrlValidFromVal.SetBackgroundColor(crBack);
	m_CtrlStatusVal.SetBackgroundColor(crBack);
	m_CtrlOwnerVal.SetBackgroundColor(crBack);
	m_CtrlKeyLengthVal.SetBackgroundColor(crBack);
	m_CtrlIssuerVal.SetBackgroundColor(crBack);

     // Data fields Font
    CConfig & oConfig = theApp.GetConfig();
    CString strFontData = theApp.GetDataFont();
    int iHeight = oConfig.m_lFontSize; 
    if(!strFontData.IsEmpty())
    {
        m_CtrlValidUntilVal.SetFont(strFontData, iHeight);
	    m_CtrlValidFromVal.SetFont(strFontData, iHeight);
	    m_CtrlStatusVal.SetFont(strFontData, iHeight);
	    m_CtrlOwnerVal.SetFont(strFontData, iHeight);
	    m_CtrlKeyLengthVal.SetFont(strFontData, iHeight);
	    m_CtrlIssuerVal.SetFont(strFontData, iHeight);

        CFont *pCurFont = m_CtrlCertificates.GetFont();
        LOGFONT lfCurLogFont = {0}; 
        pCurFont->GetLogFont(&lfCurLogFont);
		_tcsncpy(lfCurLogFont.lfFaceName, strFontData, sizeof(lfCurLogFont.lfFaceName)/sizeof(TCHAR)-1);
        lfCurLogFont.lfHeight = GetFontHeight(iHeight);
	    m_oFont.CreateFontIndirect(&lfCurLogFont);
        m_CtrlCertificates.SetFont(&m_oFont); 
    }
}

void CCertificatesPage::OnSelchangedTreeCertificates(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
    CCertif *pCertif = (CCertif *)m_CtrlCertificates.GetItemData (pNMTreeView->itemNew.hItem);

    if(!m_CtrlCertificates.ItemHasChildren(pNMTreeView->itemNew.hItem))
    {
        m_CtrlRegister.EnableWindow(TRUE); 
    }
    else
    {
        m_CtrlRegister.EnableWindow(FALSE); 
    }
    SetTextFields (pCertif);

    *pResult = 0;	
}

void CCertificatesPage::SetTextFields(CCertif *pCertif) 
{
    if(pCertif == NULL)
    {
        // Clear all fields
        m_CtrlValidUntilVal.SetWindowText(_T(""));
	    m_CtrlValidFromVal.SetWindowText(_T(""));
	    m_CtrlStatusVal.SetWindowText(_T(""));
	    m_CtrlOwnerVal.SetWindowText(_T(""));
	    m_CtrlKeyLengthVal.SetWindowText(_T(""));
	    m_CtrlIssuerVal.SetWindowText(_T(""));
        m_CtrlDetails.EnableWindow(FALSE);
        m_CtrlRegister.EnableWindow(FALSE);
    }
    else
    {
        CString strTemp;
        X509 *pX509 = (X509 *)pCertif->GetX509();
        char szName[256] = {0};
        X509_NAME_get_text_by_NID(X509_get_subject_name(pX509), NID_commonName, szName, sizeof(szName));
        strTemp = theApp.DecodeFromUTF8(szName); 
	    m_CtrlOwnerVal.SetWindowText(strTemp);
        memset(szName, 0, sizeof(szName));
        X509_NAME_get_text_by_NID(X509_get_issuer_name(pX509), NID_commonName, szName, sizeof(szName));
        strTemp = theApp.DecodeFromUTF8(szName); 
	    m_CtrlIssuerVal.SetWindowText(strTemp);
        memset(szName, 0, sizeof(szName));

        EVP_PKEY *pKey = X509_get_pubkey(pX509);
        if(pKey != NULL)
        {
            long lLen = EVP_PKEY_bits(pKey);
            strTemp.Format(_T("%ld bits"), lLen);  
            EVP_PKEY_free(pKey);
        }
	    m_CtrlKeyLengthVal.SetWindowText(strTemp);

        
        ASN1_TIME *pASN1Time = X509_get_notBefore(pX509);
        ASN1_TIME_Print(pASN1Time, strTemp);
	    m_CtrlValidFromVal.SetWindowText(strTemp);
        pASN1Time = X509_get_notAfter(pX509);
        ASN1_TIME_Print(pASN1Time, strTemp);
        m_CtrlValidUntilVal.SetWindowText(strTemp);

        VerifyCertErrorString(pCertif->GetCertStatus(), strTemp); 
	    m_CtrlStatusVal.SetWindowText(strTemp);
        m_CtrlDetails.EnableWindow(TRUE);
    }
    RedrawWindow();
}

void CCertificatesPage::VerifyCertErrorString(long lStatus, CString & strError)
{
    strError.Empty();
	switch ((int)lStatus)
	{
	case BEID_CERTSTATUS_CERT_VALIDATED_OK:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_CERT_VALIDATED_OK);
		return;
	case BEID_CERTSTATUS_CERT_NOT_VALIDATED:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_CERT_NOT_VALIDATED);
		return;
	case BEID_CERTSTATUS_UNABLE_TO_GET_ISSUER_CERT:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_UNABLE_TO_GET_ISSUER_CERT);
		return;
	case BEID_CERTSTATUS_UNABLE_TO_GET_CRL:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_UNABLE_TO_GET_CRL);
		return;
	case BEID_CERTSTATUS_UNABLE_TO_DECRYPT_CERT_SIGNATURE:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_UNABLE_TO_DECRYPT_CERT_SIGNATURE);
		return;
	case BEID_CERTSTATUS_UNABLE_TO_DECRYPT_CRL_SIGNATURE:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_UNABLE_TO_DECRYPT_CRL_SIGNATURE);
		return;
	case BEID_CERTSTATUS_UNABLE_TO_DECODE_ISSUER_PUBLIC_KEY:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_UNABLE_TO_DECODE_ISSUER_PUBLIC_KEY);
		return;
	case BEID_CERTSTATUS_CERT_SIGNATURE_FAILURE:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_CERT_SIGNATURE_FAILURE);
		return;
	case BEID_CERTSTATUS_CRL_SIGNATURE_FAILURE:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_CRL_SIGNATURE_FAILURE);
		return;
	case BEID_CERTSTATUS_CERT_NOT_YET_VALID:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_CERT_NOT_YET_VALID);
		return;
	case BEID_CERTSTATUS_CRL_NOT_YET_VALID:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_CRL_NOT_YET_VALID);
		return;
	case BEID_CERTSTATUS_CERT_HAS_EXPIRED:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_CERT_HAS_EXPIRED);
		return;
	case BEID_CERTSTATUS_CRL_HAS_EXPIRED:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_CRL_HAS_EXPIRED);
		return;
	case BEID_CERTSTATUS_ERR_IN_CERT_NOT_BEFORE_FIELD:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_ERR_IN_CERT_NOT_BEFORE_FIELD);
		return;
	case BEID_CERTSTATUS_ERR_IN_CERT_NOT_AFTER_FIELD:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_ERR_IN_CERT_NOT_AFTER_FIELD);
		return;
	case BEID_CERTSTATUS_ERR_IN_CRL_LAST_UPDATE_FIELD:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_ERR_IN_CRL_LAST_UPDATE_FIELD);
		return;
	case BEID_CERTSTATUS_ERR_IN_CRL_NEXT_UPDATE_FIELD:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_ERR_IN_CRL_NEXT_UPDATE_FIELD);
		return;
	case BEID_CERTSTATUS_OUT_OF_MEM:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_OUT_OF_MEM);
		return;
	case BEID_CERTSTATUS_DEPTH_ZERO_SELF_SIGNED_CERT:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_DEPTH_ZERO_SELF_SIGNED_CERT);
		return;
	case BEID_CERTSTATUS_SELF_SIGNED_CERT_IN_CHAIN:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_SELF_SIGNED_CERT_IN_CHAIN);
		return;
	case BEID_CERTSTATUS_UNABLE_TO_GET_ISSUER_CERT_LOCALLY:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_UNABLE_TO_GET_ISSUER_CERT_LOCALLY);
		return;
	case BEID_CERTSTATUS_UNABLE_TO_VERIFY_LEAF_SIGNATURE:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_UNABLE_TO_VERIFY_LEAF_SIGNATURE);
		return;
	case BEID_CERTSTATUS_CERT_CHAIN_TOO_LONG:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_CERT_CHAIN_TOO_LONG);
		return;
	case BEID_CERTSTATUS_CERT_REVOKED:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_CERT_REVOKED);
		return;
	case BEID_CERTSTATUS_INVALID_CA:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_INVALID_CA);
		return;
	case BEID_CERTSTATUS_PATH_LENGTH_EXCEEDED:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_PATH_LENGTH_EXCEEDED);
		return;
	case BEID_CERTSTATUS_INVALID_PURPOSE:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_INVALID_PURPOSE);
		return;
	case BEID_CERTSTATUS_CERT_UNTRUSTED:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_CERT_UNTRUSTED);
		return;
	case BEID_CERTSTATUS_CERT_REJECTED:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_CERT_REJECTED);
		return;
	case BEID_CERTSTATUS_SUBJECT_ISSUER_MISMATCH:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_SUBJECT_ISSUER_MISMATCH);
		return;
	case BEID_CERTSTATUS_AKID_SKID_MISMATCH:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_AKID_SKID_MISMATCH);
		return;
	case BEID_CERTSTATUS_AKID_ISSUER_SERIAL_MISMATCH:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_AKID_ISSUER_SERIAL_MISMATCH);
		return;
	case BEID_CERTSTATUS_KEYUSAGE_NO_CERTSIGN:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_KEYUSAGE_NO_CERTSIGN);
		return;
	case BEID_CERTSTATUS_UNABLE_TO_GET_CRL_ISSUER:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_UNABLE_TO_GET_CRL_ISSUER);
		return;
	case BEID_CERTSTATUS_UNHANDLED_CRITICAL_EXTENSION:
        strError.LoadString(IDS_STRING_BEID_CERTSTATUS_UNHANDLED_CRITICAL_EXTENSION);
		return;

	default:
        strError.LoadString(IDS_STRING_BEID_STATUS_UNKNOWN);
		return;
		}
}

void CCertificatesPage::OnButtoncertificatesDetails() 
{
    CCertif *pCertif = NULL;
    HTREEITEM hItem = m_CtrlCertificates.GetSelectedItem ();
    if (NULL != hItem)
    {
        pCertif = (CCertif *)m_CtrlCertificates.GetItemData (hItem);
    }

    if (NULL != pCertif)
    {
        CWaitCursor wc;
        CString strFile = theApp.MakeTempFile();
        FILE *pfcert = NULL;
#ifdef _UNICODE
        USES_CONVERSION;
        pfcert = fopen(W2A(strFile), "w+b");
#else
        pfcert = fopen(strFile, "w+b");
#endif
        if(pfcert != NULL)
        {
            fwrite(pCertif->GetData(), sizeof(unsigned char), pCertif->GetLength(), pfcert);
            fclose(pfcert);
        }
        else
        {
            return;
        }
        int (CALLBACK *ptr) (HWND, HINSTANCE, LPSTR, int);

        HINSTANCE hModule;

        hModule = LoadLibrary (_T("CryptExt.dll"));
        if(NULL != hModule)
        {
            ptr = (int (CALLBACK *)(HWND, HINSTANCE, LPSTR, int)) GetProcAddress (hModule, "CryptExtOpenCER");
    #ifdef _UNICODE
            USES_CONVERSION;
            (*ptr) (NULL, hModule, W2A(strFile), SW_NORMAL);
    #else
            (*ptr) (NULL, hModule, (char *)(const char *)strFile, SW_NORMAL);
    #endif
            FreeLibrary (hModule);
        }
        ::DeleteFile(strFile);
    }	
}

void CCertificatesPage::OnButtonRegister() 
{
    theApp.ClearStatusBarText(); 
	if(0 == CreateContextFile())
    {
        theApp.SetStatusBarText(IDS_STRING_REGISTER_OK); 
    }
    else
    {
        theApp.SetStatusBarText(IDS_STRING_REGISTER_NOK); 
    }
}

int CCertificatesPage::CreateContextFile()
{
    int iError = 0;
    PCCERT_CONTEXT pCertContext = NULL;
    DWORD  dwFlags =  CERT_STORE_NO_CRYPT_RELEASE_FLAG;
    CString strFullFilePath;
    BYTE  KeyUsageBits = 0;    // Intended key usage bits copied to here.
    DWORD cbKeyUsageByteCount = 1; // 1 byte will be copied to *pbKeyUsage

    try
    {
        HTREEITEM hItem = m_CtrlCertificates.GetSelectedItem();
        while(hItem != NULL)
        {
            CCertif *pCertif = (CCertif *)m_CtrlCertificates.GetItemData(hItem); 
            if(pCertif != NULL)
            {
                // Create a certificate context in memory
                pCertContext = CertCreateCertificateContext(MY_ENCODING_TYPE, pCertif->GetData(), pCertif->GetLength());

                DWORD dwLastError = GetLastError ();
                if(NULL == pCertContext)  // Did we get a context?
                    throw (int)ERR_CREATE_CERT_CONTEXT;

                CertGetIntendedKeyUsage(X509_ASN_ENCODING, pCertContext->pCertInfo, &KeyUsageBits, cbKeyUsageByteCount);
                pCertif->SetKeyUsage(KeyUsageBits);
                pCertif->SetKeyLength(CertGetPublicKeyLength (X509_ASN_ENCODING, &pCertContext->pCertInfo->SubjectPublicKeyInfo)/8); 

                // Only store the context of the certificates with usages for an end-user i.e. no CA or root certificates
                if (((KeyUsageBits & CERT_DIGITAL_SIGNATURE_KEY_USAGE) == CERT_DIGITAL_SIGNATURE_KEY_USAGE) ||
                    ((KeyUsageBits & CERT_NON_REPUDIATION_KEY_USAGE) == CERT_NON_REPUDIATION_KEY_USAGE))
                {
                    if(!StoreUserCerts (pCertContext, KeyUsageBits, pCertif))
                        throw ERR_CANNOT_ADD_CERTIFICATE_TO_STORE;
                }
                else
                {
                    if(!StoreAuthorityCerts (pCertContext, KeyUsageBits))
                        throw ERR_CANNOT_ADD_CERTIFICATE_TO_STORE;
                }
                if (NULL != pCertContext)
                    CertFreeCertificateContext (pCertContext);
            }
            hItem = m_CtrlCertificates.GetParentItem(hItem);
        }
        if (!StoreConfigurationFile ())
            throw (int)ERR_CANNOT_SAVE_CONFIGURATIONFILE;
    }
    catch (int e)
    {
        iError = e;
    }

    return (iError);
}

BOOL CCertificatesPage::StoreUserCerts (PCCERT_CONTEXT pCertContext, BYTE KeyUsageBits, CCertif *pCertData)
{
    DWORD  dwFlags =  CERT_STORE_NO_CRYPT_RELEASE_FLAG;
    HCERTSTORE  hMyStore = NULL;              // memory store handle
    int iError = 0;

    USES_CONVERSION;
    try
    {
        hMyStore = CertOpenSystemStore (NULL, _T("MY"));
        if (NULL == hMyStore)
            throw (int) ERR_CANNOT_CREATE_MEM_STORE;

        // Initalize the CRYPT_KEY_PROV_INFO data structure.
        // Note: pwszContainerName and pwszProvName can be set to NULL 
        // to use the default container and provider.
        CRYPT_KEY_PROV_INFO *pCryptKeyProvInfo;
        DWORD dwPropId = CERT_KEY_PROV_INFO_PROP_ID; 
        pCryptKeyProvInfo = new CRYPT_KEY_PROV_INFO;

        // Get the serial number from the card
        char *pSerialKey = theApp.Hexify(m_VersionInfo.SerialNumber, sizeof(m_VersionInfo.SerialNumber));

        char strContainerName[1000];
        memset (strContainerName, '\0', 1000);
        sprintf (strContainerName, "%s(%s)", pCertData->GetID(), pSerialKey);

        pCryptKeyProvInfo->pwszContainerName = A2W (strContainerName);
#ifdef _UNICODE
        pCryptKeyProvInfo->pwszProvName = _T("Belgium Identity Card CSP");
#else
        pCryptKeyProvInfo->pwszProvName = L"Belgium Identity Card CSP";
#endif
        pCryptKeyProvInfo->dwProvType = PROV_RSA_FULL;
        pCryptKeyProvInfo->dwFlags = 0;
        pCryptKeyProvInfo->cProvParam = 0;
        pCryptKeyProvInfo->rgProvParam = NULL;
        pCryptKeyProvInfo->dwKeySpec = AT_KEYEXCHANGE;
        //
        // Set the property.
        if(!CertSetCertificateContextProperty(
                                                pCertContext,       // A pointer to the certificate
                                                     // where the propertiy will be set.
                                                dwPropId,           // An identifier of the property to be set. 
                                                     // In this case, CERT_KEY_PROV_INFO_PROP_ID
                                                     // is to be set to provide a pointer with the
                                                     // certificate to its associated private key 
                                                     // container.
                                                dwFlags,            // The flag used in this case is   
                                                     // CERT_STORE_NO_CRYPT_RELEASE_FLAG
                                                     // indicating that the cryptographic 
                                                     // context aquired should not
                                                     // be released when the function finishes.
                                                pCryptKeyProvInfo   // A pointer to a data structure that holds
                                                     // infomation on the private key container to
                                                     // be associated with this certificate.
                                                ))
            throw (int) ERR_CANNOT_SET_PROPERTY;

        if (NULL != pCryptKeyProvInfo)
            delete (pCryptKeyProvInfo);
        pCryptKeyProvInfo = NULL;

        // Set friendly names for the certificates
        CRYPT_DATA_BLOB tpFriendlyName;
        CString strFriendlyName;

        if (((KeyUsageBits & CERT_NON_REPUDIATION_KEY_USAGE) == CERT_NON_REPUDIATION_KEY_USAGE))
        {
            pCertData->SetKeyID(0x03);
            strFriendlyName.LoadString (IDS_NON_REPUDIATION);
        }
        else
        {
            pCertData->SetKeyID(0x02);
            strFriendlyName.LoadString (IDS_AUTHENTICATION);
        }

        tpFriendlyName.pbData = (BYTE *) malloc ((strFriendlyName.GetLength () + 1) * sizeof (WCHAR));
        memset (tpFriendlyName.pbData, '\0', (strFriendlyName.GetLength () + 1) * sizeof (WCHAR));
        tpFriendlyName.cbData = (strFriendlyName.GetLength () + 1)  * sizeof (WCHAR);
#ifdef _UNICODE
        memcpy (tpFriendlyName.pbData, (const char *)(char *)(LPCTSTR)strFriendlyName, tpFriendlyName.cbData);
#else
        memcpy (tpFriendlyName.pbData, (const char *)A2W ((char *)(LPCTSTR)strFriendlyName), tpFriendlyName.cbData);
#endif
        // Set the property.
        if(!CertSetCertificateContextProperty(
                                                pCertContext,       // A pointer to the certificate
                                                     // where the propertiy will be set.
                                                CERT_FRIENDLY_NAME_PROP_ID,           // An identifier of the property to be set. 
                                                     // In this case, CERT_KEY_PROV_INFO_PROP_ID
                                                     // is to be set to provide a pointer with the
                                                     // certificate to its associated private key 
                                                     // container.
                                                dwFlags,            // The flag used in this case is   
                                                     // CERT_STORE_NO_CRYPT_RELEASE_FLAG
                                                     // indicating that the cryptographic 
                                                     // context aquired should not
                                                     // be released when the function finishes.
                                                &tpFriendlyName   // A pointer to a data structure that holds
                                                     // infomation on the private key container to
                                                     // be associated with this certificate.
                                                ))
            throw (int) ERR_CANNOT_SET_PROPERTY;

        if (NULL != tpFriendlyName.pbData)
            free (tpFriendlyName.pbData);
        tpFriendlyName.pbData = NULL;

        if (((KeyUsageBits & CERT_NON_REPUDIATION_KEY_USAGE) == CERT_NON_REPUDIATION_KEY_USAGE))
        {
            if (!CertAddEnhancedKeyUsageIdentifier (pCertContext, szOID_PKIX_KP_EMAIL_PROTECTION))
                throw (int) ERR_CANNOT_SET_PROPERTY;
        }
        else
        {
            if (!CertAddEnhancedKeyUsageIdentifier (pCertContext, szOID_PKIX_KP_EMAIL_PROTECTION))
                throw (int) ERR_CANNOT_SET_PROPERTY;
            if (!CertAddEnhancedKeyUsageIdentifier (pCertContext, szOID_PKIX_KP_CLIENT_AUTH))
                throw (int) ERR_CANNOT_SET_PROPERTY;
        }

        if(!CertAddCertificateContextToStore(hMyStore, pCertContext, CERT_STORE_ADD_REPLACE_EXISTING, NULL))
            throw (int) ERR_CANNOT_ADD_CERTIFICATE_TO_STORE;
        CertCloseStore (hMyStore, CERT_CLOSE_STORE_FORCE_FLAG);
        hMyStore = NULL;
    }
    catch (int e)
    {
        CertCloseStore (hMyStore, CERT_CLOSE_STORE_FORCE_FLAG);
        hMyStore = NULL;
        iError = e;
    }

    return (iError == 0 ? TRUE : FALSE);
}

BOOL CCertificatesPage::StoreAuthorityCerts(PCCERT_CONTEXT  pCertContext, BYTE  KeyUsageBits)
{
    HCERTSTORE  hMemoryStore = NULL;              // memory store handle
    int iError = 0;

    try
    {
        if ((KeyUsageBits & CERT_KEY_CERT_SIGN_KEY_USAGE) == CERT_KEY_CERT_SIGN_KEY_USAGE)
        {
            if (memcmp (pCertContext->pCertInfo->Issuer.pbData, 
                        pCertContext->pCertInfo->Subject.pbData, 
                        pCertContext->pCertInfo->Subject.cbData) == 0)
            {
                hMemoryStore = CertOpenSystemStore (NULL, _T("ROOT"));
                if (NULL == hMemoryStore)
                    throw (int) ERR_CANNOT_CREATE_MEM_STORE;
            }
            else
            {
                hMemoryStore = CertOpenSystemStore (NULL, _T("CA"));
                if (NULL == hMemoryStore)
                    throw (int) ERR_CANNOT_CREATE_MEM_STORE;
            }
            if (!CertAddEnhancedKeyUsageIdentifier (pCertContext, szOID_PKIX_KP_EMAIL_PROTECTION))
                throw (int) ERR_CANNOT_SET_PROPERTY;
            if (!CertAddEnhancedKeyUsageIdentifier (pCertContext, szOID_PKIX_KP_SERVER_AUTH))
                throw (int) ERR_CANNOT_SET_PROPERTY;
            if(!CertAddCertificateContextToStore(hMemoryStore, pCertContext, CERT_STORE_ADD_NEWER, NULL))
            {
                if (GetLastError () != CRYPT_E_EXISTS)
                    throw (int) ERR_CANNOT_ADD_CERTIFICATE_TO_STORE;
            }
            CertCloseStore (hMemoryStore, CERT_CLOSE_STORE_FORCE_FLAG);
            hMemoryStore = NULL;
        }
    }
    catch (int e)
    {
        CertCloseStore (hMemoryStore, CERT_CLOSE_STORE_FORCE_FLAG);
        hMemoryStore = NULL;
        iError = e;
    }

    return (iError == 0 ? TRUE : FALSE);

}
BOOL CCertificatesPage::StoreConfigurationFile ()
{
   BOOL bReturnVal = TRUE;
   bReturnVal = StoreBelgianEIDConfigurationFile ();
   return (bReturnVal);
}

BOOL CCertificatesPage::StoreBelgianEIDConfigurationFile ()
{
    BOOL bReturnVal = TRUE;
    CSlotInfo *pSlotInfo;
    CScConfig oConfig;
    MapCertifsIt it;
    CBelgianEIDConfig *pConfig = static_cast <CBelgianEIDConfig *>(oConfig.CreateConfigObject (BELGIAN_EID_CARD));

    pSlotInfo = new CSlotInfo;

    unsigned char ucCardID[6] = {0x42, 0x45, 0x4C, 0x50, 0x49, 0x43};
    pConfig->SetCardID (ucCardID, sizeof(ucCardID));
    //pSlotInfo->SetSlotName (m_SlotInfo.slotDescription, sizeof (m_SlotInfo.slotDescription));

    for (it = m_oMapCertifs.begin (); it != m_oMapCertifs.end (); it++)
    {
        CCertif *pCertif = (*it).second;
        // Only keep  the certificates in case it is a certificate with usages for an end-user i.e. no CA or root certificates
        if ( ((pCertif->GetKeyUsage () & CERT_DIGITAL_SIGNATURE_KEY_USAGE) == CERT_DIGITAL_SIGNATURE_KEY_USAGE) ||
             ((pCertif->GetKeyUsage () & CERT_NON_REPUDIATION_KEY_USAGE) == CERT_NON_REPUDIATION_KEY_USAGE) )
        {
            CKeyInfo *pKeyInfo;
            pKeyInfo = new CKeyInfo;

            pKeyInfo->SetKeyContainerName ((unsigned char *)pCertif->GetID(), strlen ((const char *)pCertif->GetID())+1);
            pKeyInfo->SetKeyLength (pCertif->GetKeyLength ());
            pKeyInfo->SetKeyID (pCertif->GetKeyID());

            pKeyInfo->SetKeyUsage ((DWORD)pCertif->GetKeyUsage());
            pSlotInfo->AddKeyInfo (pKeyInfo);
        }
    }

    pConfig->AddSlotInfo (pSlotInfo);

    pConfig->Write ();
    return (bReturnVal);
}

