#if !defined(AFX_CERTIFICATESPAGE_H__9762816E_D600_4CD7_ADC6_10DF27097F11__INCLUDED_)
#define AFX_CERTIFICATESPAGE_H__9762816E_D600_4CD7_ADC6_10DF27097F11__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CertificatesPage.h : header file
//

#pragma warning(disable:4786)

#include <string>
#include <map>
#include "Certif.h"
#include "XColorStatic.h"

#include <openssl/ssl.h>
#include <wincrypt.h>

#define ERR_CREATE_CERT_CONTEXT                       0x8000000D
#define ERR_CANNOT_SET_PROPERTY                       0x8000000F
#define ERR_CANNOT_CREATE_MEM_STORE               0x80000010
#define ERR_CANNOT_ADD_CERTIFICATE_TO_STORE   0x80000011
#define ERR_CANNOT_CREATE_CONTEXT_FILE            0x80000012
#define ERR_CANNOT_SAVE_CONTEXT_FILE               0x80000013
#define ERR_CANNOT_WRITE_CONTEXT_FILE             0x80000014
#define ERR_CANCELLED_BY_USER                            0x80000015
#define ERR_CANNOT_SET_REG_KEY                         0x80000016
#define ERR_CANNOT_SAVE_CONFIGURATIONFILE       0x80000017

/////////////////////////////////////////////////////////////////////////////
// CCertificatesPage dialog

class CCertificatesPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CCertificatesPage)

// Construction
public:
	CCertificatesPage();
	~CCertificatesPage();

    void SetCertificateData(BEID_Certif_Check *pCertifs);
    void SetVersionInfoData(BEID_VersionInfo *pVersion);
    void LoadStrings();

// Dialog Data
	//{{AFX_DATA(CCertificatesPage)
	enum { IDD = IDD_PAGE_CERTIFICATES };
	CButton	m_CtrlRegister;
	CStatic	m_CtrlCertTreeLabel;
	CXColorStatic	m_CtrlValidUntilVal;
	CStatic	m_CtrlValidUntil;
	CXColorStatic	m_CtrlValidFromVal;
	CStatic	m_CtrlValidFrom;
	CXColorStatic	m_CtrlStatusVal;
	CStatic	m_CtrlStatus;
	CXColorStatic	m_CtrlOwnerVal;
	CStatic	m_CtrlOwner;
	CXColorStatic	m_CtrlKeyLengthVal;
	CStatic	m_CtrlKeyLength;
	CXColorStatic	m_CtrlIssuerVal;
	CStatic	m_CtrlIssuer;
	CButton	m_CtrlDetails;
	CTreeCtrl	m_CtrlCertificates;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CCertificatesPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CCertificatesPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangedTreeCertificates(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtoncertificatesDetails();
	afx_msg void OnButtonRegister();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

    void ClearMap();
    void GetCertChain(X509 *cert, X509_STORE *store, STACK_OF(X509) **ppChain);
    HTREEITEM FindData(HTREEITEM hti, DWORD dwData);
    void FillTree();
    void InitControls();
    void SetTextFields(CCertif *pCertif) ;
    void VerifyCertErrorString(long lStatus, CString & strError);
    int CreateContextFile();
    BOOL StoreUserCerts (PCCERT_CONTEXT pCertContext, BYTE KeyUsageBits, CCertif *pCertData);
    BOOL StoreAuthorityCerts(PCCERT_CONTEXT  pCertContext, BYTE  KeyUsageBits);
    BOOL StoreConfigurationFile ();
    BOOL StoreBelgianEIDConfigurationFile ();

private:
    BEID_VersionInfo m_VersionInfo;
  	CImageList m_imgList;
    CFont m_oFont;

    std::map<CString, CCertif *> m_oMapCertifs;
    typedef std::map<CString, CCertif *>::iterator MapCertifsIt;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CERTIFICATESPAGE_H__9762816E_D600_4CD7_ADC6_10DF27097F11__INCLUDED_)
