// Config.cpp: implementation of the CConfig class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "eidgui.h"
#include "Config.h"

#include <atlbase.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CConfig::CConfig()
{
    m_dwLanguage = -1;
    m_StrReader = _T("");
    m_dwCRL = 0;
    m_dwOCSP = 0;
    m_lFontSize = 9;
    m_strFonts = _T("TITUS Cyberbit Basic,Arial Unicode MS");
}

CConfig::~CConfig()
{

}

void CConfig::Load()
{
    CRegKey oRegKey;
    if(ERROR_SUCCESS == oRegKey.Create(HKEY_CURRENT_USER, _T("Software\\Fedict\\eidGUI"), 
                                                REG_NONE, REG_OPTION_NON_VOLATILE, KEY_READ | KEY_WRITE))
    {
        TCHAR szBuffer[256] = {0};
        DWORD dwLen = sizeof(szBuffer);
        DWORD dwTemp = 0;
        if(ERROR_SUCCESS == oRegKey.QueryValue(szBuffer, _T("SCReader"), &dwLen))
        {
            m_StrReader = szBuffer;
        }
        if(ERROR_SUCCESS == oRegKey.QueryValue(dwTemp, _T("Language")))
        {
            m_dwLanguage = dwTemp;
        }
        if(ERROR_SUCCESS == oRegKey.QueryValue(dwTemp, _T("OCSP")))
        {
            m_dwOCSP = dwTemp;
        }
        if(ERROR_SUCCESS == oRegKey.QueryValue(dwTemp, _T("CRL")))
        {
            m_dwCRL = dwTemp;
        }
        memset(szBuffer, 0, sizeof(szBuffer));
        dwLen = sizeof(szBuffer);
        if(ERROR_SUCCESS == oRegKey.QueryValue(szBuffer, _T("Fonts"), &dwLen))
        {
            m_strFonts = szBuffer;
        }
        if(ERROR_SUCCESS == oRegKey.QueryValue(dwTemp, _T("Fontsize")))
        {
            m_lFontSize = dwTemp;
        }
        oRegKey.Close(); 
    }
}

void CConfig::Save()
{
    CRegKey oRegKey;
    if(ERROR_SUCCESS == oRegKey.Create(HKEY_CURRENT_USER, _T("Software\\Fedict\\eidGUI"), 
                                                REG_NONE, REG_OPTION_NON_VOLATILE, KEY_READ | KEY_WRITE))
    {
        oRegKey.SetValue(m_StrReader, _T("SCReader"));
        oRegKey.SetValue(m_dwLanguage, _T("Language"));
        oRegKey.SetValue(m_dwOCSP, _T("OCSP"));
        oRegKey.SetValue(m_dwCRL, _T("CRL"));
        oRegKey.SetValue(m_strFonts, _T("Fonts"));
        oRegKey.SetValue(m_lFontSize, _T("Fontsize"));
        oRegKey.Close(); 
    }
}
