// IdentityPage.cpp : implementation file
//

#include "stdafx.h"
#include "eidgui.h"
#include "IdentityPage.h"
#include "../CXImage/CXImage/ximage.h"
#include "FontSize.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define STR_DUTCH_BEL _T("BELGI")
#define STR_DUTCH_IDEN _T("IDENTITEITSKAART")
#define STR_FRENCH_BEL _T("BELGIQUE")
#define STR_FRENCH_IDEN _T("CARTE D'IDENTITE")
#define STR_GERMAN_BEL _T("BELGIEN")
#define STR_GERMAN_IDEN _T("PERSONALAUSWEIS")
#define STR_ENGLISH_BEL _T("BELGIUM")
#define STR_ENGLISH_IDEN _T("IDENTITY CARD")


extern CEidGUIApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CIdentityPage property page

IMPLEMENT_DYNCREATE(CIdentityPage, CPropertyPage)

CIdentityPage::CIdentityPage() : CPropertyPage(CIdentityPage::IDD)
{
    m_pBrush = NULL;
	m_rgbBackground = RGB(128,255,128); 
	m_rgbBackgroundVal = RGB(255,255,255); 
    m_pFont = NULL;
    m_hIconGreen = NULL;
    m_hIconRed = NULL;
    m_hIconYellow = NULL;
    m_hIconOff = NULL;
    memset(&m_Picture, 0, sizeof(BEID_Bytes));
    m_gpPicture = NULL;

	//{{AFX_DATA_INIT(CIdentityPage)
	//}}AFX_DATA_INIT
}

CIdentityPage::~CIdentityPage()
{
    if(m_gpPicture != NULL)
    {
        m_gpPicture->Release(); 
        m_gpPicture = NULL;
    }
    if(m_Picture.length > 0)
    {
        delete [] m_Picture.data;
    }
    memset(&m_Picture, 0, sizeof(BEID_Bytes));

	if (m_pBrush)
	{
		m_pBrush->DeleteObject();
		delete m_pBrush;
	}
    ::DestroyIcon(m_hIconGreen); 
    ::DestroyIcon(m_hIconRed); 
    ::DestroyIcon(m_hIconYellow); 
    ::DestroyIcon(m_hIconOff); 
}

void CIdentityPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIdentityPage)
	DDX_Control(pDX, IDC_BUTTON_IDENTITY_PRINT, m_CtrlButtonPrint);
	DDX_Control(pDX, IDC_STATIC_STATUS_IDENTITY, m_CtrlStatusIdentity);
	DDX_Control(pDX, IDC_STATIC_STATUS_ADDRESS, m_CtrlStatusAddress);
	DDX_Control(pDX, IDC_STATIC_STATUS_PICTURE, m_CtrlStatusPicture);
	DDX_Control(pDX, IDC_STATIC_PICTURE_CARD, m_CtrlPictureCard);
	DDX_Control(pDX, IDC_STATIC_SPECIAL_GROUP, m_CtrlSpecialGroup);
	DDX_Control(pDX, IDC_STATIC_CARDINFO_GROUP, m_CtrlCardInfoGroup);
	DDX_Control(pDX, IDC_STATIC_ADDRESS_GROUP, m_CtrlAddressGroup);
	DDX_Control(pDX, IDC_CHECK_SPECIALSTATUS_YELLOW_VAL, m_CtrlSpecialYellowVal);
	DDX_Control(pDX, IDC_CHECK_SPECIALSTATUS_WHITE_VAL, m_CtrlSpecialWhiteVal);
	DDX_Control(pDX, IDC_CHECK_SPECIALSTATUS_MINORITY_VAL, m_CtrlSpecialMinorityVal);
	DDX_Control(pDX, IDC_STATIC_SPECIALSTATUS_YELLOW, m_CtrlSpecialYellow);
	DDX_Control(pDX, IDC_STATIC_SPECIALSTATUS_WHITE, m_CtrlSpecialWhite);
	DDX_Control(pDX, IDC_STATIC_SPECIALSTATUS_MINORITY, m_CtrlSpecialMinority);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_TITLE_VAL, m_CtrlIdenTitleVal);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_TITLE, m_CtrlIdenTitle);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_SEX_VAL, m_CtrlIdenSexVal);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_SEX, m_CtrlIdenSex);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_NATIONALNR_VAL, m_CtrlIdenNationalityNrVal);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_NATIONALNR, m_CtrlIdenNationalityNr);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_NATIONALITY_VAL, m_CtrlIdenNationalityVal);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_NATIONALITY, m_CtrlIdenNationality);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_NAME_VAL, m_CtrlIdenNameVal);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_NAME, m_CtrlIdenName);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_GROUP, m_CtrlIdenGroup);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_GIVENNAMES_VAL3, m_CtrlIdenGivenNamesVal3);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_GIVENNAMES_VAL1, m_CtrlIdenGivenNamesVal1);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_GIVENNAMES, m_CtrlIdenGivenNames);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_BIRTHPLACE_VAL, m_CtrlIdenBirthPlaceVal);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_BIRTHPLACE, m_CtrlIdenBirthPlace);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_BIRTHDATE_VAL, m_CtrlIdenBirthDateVal);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_BIRTHDATE, m_CtrlIdenBirthDate);
	DDX_Control(pDX, IDC_STATIC_CARDINFO_VALIDUNTIL_VAL, m_CtrlCardInfoUntilVal);
	DDX_Control(pDX, IDC_STATIC_CARDINFO_VALIDUNTIL, m_CtrlCardInfoUntil);
	DDX_Control(pDX, IDC_STATIC_CARDINFO_VALIDFROM_VAL, m_CtrlCardInfoFromVal);
	DDX_Control(pDX, IDC_STATIC_CARDINFO_VALIDFROM, m_CtrlCardInfoFrom);
	DDX_Control(pDX, IDC_STATIC_CARDINFO_MUNICIPALITY_VAL, m_CtrlCardInfoMunicipalityVal);
	DDX_Control(pDX, IDC_STATIC_CARDINFO_MUNICIPALITY, m_CtrlCardInfoMunicipality);
	DDX_Control(pDX, IDC_STATIC_CARDINFO_CHIPNR_VAL, m_CtrlCardInfoChipNrVal);
	DDX_Control(pDX, IDC_STATIC_CARDINFO_CHIPNR, m_CtrlCardInfoChipNr);
	DDX_Control(pDX, IDC_STATIC_CARDINFO_CARDNR_VAL, m_CtrlCardInfoCardNrVal);
	DDX_Control(pDX, IDC_STATIC_CARDINFO_CARDNR, m_CtrlCardInfoCardNr);
	DDX_Control(pDX, IDC_STATIC_ADDRESS_ZIP_VAL, m_CtrlAddressZipVal);
	DDX_Control(pDX, IDC_STATIC_ADDRESS_ZIP, m_CtrlAddressZip);
	DDX_Control(pDX, IDC_STATIC_ADDRESS_STREET_VAL, m_CtrlAddressStreetVal);
	DDX_Control(pDX, IDC_STATIC_ADDRESS_STREET, m_CtrlAddressStreet);
	DDX_Control(pDX, IDC_STATIC_ADDRESS_MUNICIPALITY_VAL, m_CtrlAddressMunicipalityVal);
	DDX_Control(pDX, IDC_STATIC_ADDRESS_COUNTRY_VAL, m_CtrlAddressCountryVal);
	DDX_Control(pDX, IDC_STATIC_ADDRESS_MUNICIPALITY, m_CtrlAddressMunicipality);
	DDX_Control(pDX, IDC_STATIC_ADDRESS_COUNTRY, m_CtrlAddressCountry);
	DDX_Control(pDX, IDC_BUTTON_CHIP, m_ButtonChip);
	DDX_Control(pDX, IDC_BUTTON_BITMAP_ARROW, m_BitmapArrow);
	DDX_Control(pDX, IDC_STATIC_BITMAP_LOGO, m_BitmapLogo);
	DDX_Control(pDX, IDC_STATIC_BITMAP_BELGIUM, m_BitmapBelgium);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_HEADER8, m_StaticHeader8);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_HEADER7, m_StaticHeader7);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_HEADER6, m_StaticHeader6);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_HEADER5, m_StaticHeader5);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_HEADER4, m_StaticHeader4);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_HEADER3, m_StaticHeader3);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_HEADER2, m_StaticHeader2);
	DDX_Control(pDX, IDC_STATIC_IDENTITY_HEADER1, m_StaticHeader1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CIdentityPage, CPropertyPage)
	//{{AFX_MSG_MAP(CIdentityPage)
	ON_WM_PAINT()
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_BUTTON_CHIP, OnButtonChip)
	ON_BN_CLICKED(IDC_BUTTON_BITMAP_ARROW, OnButtonBitmapArrow)
	ON_BN_CLICKED(IDC_BUTTON_IDENTITY_PRINT, OnButtonIdentityPrint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIdentityPage message handlers
BOOL CIdentityPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	m_pBrush = new CBrush(m_rgbBackground);

    m_pFont = GetFont();

	// Create the tool tip
	m_Tip.Create(this);

    LoadIcons();
    LoadStrings();
    InitControls();


    return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE

}

void CIdentityPage::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	dc.SaveDC();

    CRect rect;
	GetClientRect(rect);
    rect.DeflateRect(0, 10, 0, 0);

    dc.FillRect(&rect, m_pBrush);

	dc.RestoreDC(-1);

	// Do not call CPropertyPage::OnPaint() for painting messages
}

void CIdentityPage::InitControls() 
{
    // Bitmaps
    /*CRect oRect;
    m_BitmapArrow.GetClientRect (&oRect);

    HBITMAP hBmpChip = ::LoadBitmap(AfxGetResourceHandle(), MAKEINTRESOURCE(IDB_BITMAP_ARROW)); 
    CxImage oChip;
    oChip.CreateFromHBITMAP(hBmpChip);
    oChip.Resample (oRect.right, oRect.bottom);
    oChip.Save("small.bmp", CXIMAGE_FORMAT_BMP);
*/
    m_ButtonChip.SetBitmaps(IDB_BITMAP_CHIP, RGB(255, 255, 255));
    m_ButtonChip.SetFlat();
    m_ButtonChip.DrawFlatFocus(FALSE);
	m_ButtonChip.DrawBorder(FALSE, FALSE);
    HCURSOR hCursHand;
    hCursHand = ::LoadCursor(NULL, MAKEINTRESOURCE(32649)); 
    m_ButtonChip.SetBtnCursor(hCursHand);

    m_BitmapArrow.SetBitmaps(IDB_BITMAP_ARROW, RGB(255, 255, 255));
    m_BitmapArrow.SetFlat();
    m_BitmapArrow.DrawFlatFocus(FALSE);
	m_BitmapArrow.DrawBorder(FALSE, FALSE);
    m_BitmapArrow.SetBtnCursor(hCursHand);

    m_CtrlButtonPrint.SetBitmaps(IDB_BITMAP_PRINT, RGB(255, 255, 255));
    m_CtrlButtonPrint.SetFlat();
    m_CtrlButtonPrint.DrawFlatFocus(FALSE);
	m_CtrlButtonPrint.DrawBorder(FALSE, FALSE);
    m_CtrlButtonPrint.SetBtnCursor(hCursHand);    

    m_BitmapBelgium.SetBitmap(IDB_BITMAP_BELGIUM); 
    m_BitmapLogo.SetBitmap(IDB_BITMAP_LOGO);
    m_CtrlSpecialYellowVal.SetBitmap(IDB_BITMAP_UNCHECKED); 
    m_CtrlSpecialWhiteVal.SetBitmap(IDB_BITMAP_UNCHECKED); 
    m_CtrlSpecialMinorityVal.SetBitmap(IDB_BITMAP_UNCHECKED); 

	DWORD dwStyle = ::GetWindowLong(m_CtrlStatusIdentity.m_hWnd, GWL_STYLE);
	DWORD dwNewStyle = dwStyle | SS_ICON;
	::SetWindowLong(m_CtrlStatusIdentity.m_hWnd, GWL_STYLE, dwNewStyle);
	dwStyle = ::GetWindowLong(m_CtrlStatusAddress.m_hWnd, GWL_STYLE);
	::SetWindowLong(m_CtrlStatusAddress.m_hWnd, GWL_STYLE, dwNewStyle);
	dwStyle = ::GetWindowLong(m_CtrlStatusPicture.m_hWnd, GWL_STYLE);
	::SetWindowLong(m_CtrlStatusPicture.m_hWnd, GWL_STYLE, dwNewStyle);

    m_CtrlStatusIdentity.SetIcon(m_hIconOff);
    m_CtrlStatusIdentity.SetBackgroundColor(m_rgbBackground);
    m_CtrlStatusAddress.SetIcon(m_hIconOff);
    m_CtrlStatusAddress.SetBackgroundColor(m_rgbBackground);
    m_CtrlStatusPicture.SetIcon(m_hIconOff);
    m_CtrlStatusPicture.SetBackgroundColor(m_rgbBackground);

    // Labels
    m_StaticHeader1.SetBackgroundColor(m_rgbBackground);
    m_StaticHeader2.SetBackgroundColor(m_rgbBackground);
    m_StaticHeader3.SetBackgroundColor(m_rgbBackground);
    m_StaticHeader4.SetBackgroundColor(m_rgbBackground);
    m_StaticHeader5.SetBackgroundColor(m_rgbBackground);
    m_StaticHeader6.SetBackgroundColor(m_rgbBackground);
    m_StaticHeader7.SetBackgroundColor(m_rgbBackground);
    m_StaticHeader8.SetBackgroundColor(m_rgbBackground);
    m_CtrlSpecialYellow.SetBackgroundColor(m_rgbBackground);
    m_CtrlSpecialWhite.SetBackgroundColor(m_rgbBackground);
    m_CtrlSpecialMinority.SetBackgroundColor(m_rgbBackground);
    m_CtrlIdenTitle.SetBackgroundColor(m_rgbBackground);
    m_CtrlIdenSex.SetBackgroundColor(m_rgbBackground);
    m_CtrlIdenNationalityNr.SetBackgroundColor(m_rgbBackground);
    m_CtrlIdenNationality.SetBackgroundColor(m_rgbBackground);
    m_CtrlIdenName.SetBackgroundColor(m_rgbBackground);
    m_CtrlIdenGivenNames.SetBackgroundColor(m_rgbBackground);
    m_CtrlIdenBirthPlace.SetBackgroundColor(m_rgbBackground);
    m_CtrlIdenBirthDate.SetBackgroundColor(m_rgbBackground);
    m_CtrlCardInfoUntil.SetBackgroundColor(m_rgbBackground);
    m_CtrlCardInfoFrom.SetBackgroundColor(m_rgbBackground);
    m_CtrlCardInfoMunicipality.SetBackgroundColor(m_rgbBackground);
    m_CtrlCardInfoChipNr.SetBackgroundColor(m_rgbBackground);
    m_CtrlCardInfoCardNr.SetBackgroundColor(m_rgbBackground);
    m_CtrlAddressZip.SetBackgroundColor(m_rgbBackground);
    m_CtrlAddressStreet.SetBackgroundColor(m_rgbBackground);
    m_CtrlAddressMunicipality.SetBackgroundColor(m_rgbBackground);
	m_CtrlAddressCountry.SetBackgroundColor(m_rgbBackground);

    // Values
    m_CtrlIdenTitleVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlIdenSexVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlIdenNationalityNrVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlIdenNationalityVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlIdenNameVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlIdenGivenNamesVal3.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlIdenGivenNamesVal1.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlIdenBirthPlaceVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlIdenBirthDateVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlCardInfoUntilVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlCardInfoFromVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlCardInfoMunicipalityVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlCardInfoChipNrVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlCardInfoCardNrVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlAddressZipVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlAddressStreetVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlAddressMunicipalityVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlAddressCountryVal.SetBackgroundColor(m_rgbBackgroundVal);
    m_CtrlPictureCard.SetBitmap(IDB_BITMAP_PICTURE_EMPTY);

    // Set Font for the headers
    CFont *pHeaderFont = m_StaticHeader1.GetFont(); 
    LOGFONT lf;
	memset(&lf, 0, sizeof(lf));
	pHeaderFont->GetLogFont(&lf);
    lf.lfWeight = FW_BOLD;

    CFont fHeaderSmall;
    lf.lfHeight = 14; 
    fHeaderSmall.CreateFontIndirect(&lf); 
    CFont fHeaderBig;
    lf.lfHeight = 22; 
    fHeaderBig.CreateFontIndirect(&lf); 
    m_StaticHeader1.SetFont(&fHeaderBig);
    m_StaticHeader5.SetFont(&fHeaderSmall);
    m_StaticHeader2.SetFont(&fHeaderBig);
    m_StaticHeader6.SetFont(&fHeaderSmall);
    m_StaticHeader3.SetFont(&fHeaderBig);
    m_StaticHeader7.SetFont(&fHeaderSmall);
    m_StaticHeader4.SetFont(&fHeaderBig);
    m_StaticHeader8.SetFont(&fHeaderSmall);

    // Data fields Font
    CConfig & oConfig = theApp.GetConfig();
    CString strFontData = theApp.GetDataFont();
    int iHeight = oConfig.m_lFontSize; 
    if(!strFontData.IsEmpty())
    {
        /*
        LOGFONT lf = {0};
        m_CtrlIdenNameVal.GetFont()->GetLogFont(&lf);
        int iHeightNormal = GetFontPointSize(lf.lfHeight);
        */
        m_CtrlIdenNameVal.SetFont(strFontData, iHeight);
        m_CtrlIdenGivenNamesVal1.SetFont(strFontData, iHeight);
        m_CtrlIdenGivenNamesVal3.SetFont(strFontData, iHeight);
        m_CtrlIdenTitleVal.SetFont(strFontData, iHeight);
        m_CtrlIdenSexVal.SetFont(strFontData, iHeight);
        m_CtrlIdenNationalityNrVal.SetFont(strFontData, iHeight);
        m_CtrlIdenNationalityVal.SetFont(strFontData, iHeight);
        m_CtrlIdenBirthPlaceVal.SetFont(strFontData, iHeight);
        m_CtrlIdenBirthDateVal.SetFont(strFontData, iHeight);
        m_CtrlCardInfoUntilVal.SetFont(strFontData, iHeight);
        m_CtrlCardInfoFromVal.SetFont(strFontData, iHeight);
        m_CtrlCardInfoMunicipalityVal.SetFont(strFontData, iHeight);
        m_CtrlCardInfoChipNrVal.SetFont(strFontData, iHeight);
        m_CtrlCardInfoCardNrVal.SetFont(strFontData, iHeight);
        m_CtrlAddressZipVal.SetFont(strFontData, iHeight);
        m_CtrlAddressStreetVal.SetFont(strFontData, iHeight);
        m_CtrlAddressMunicipalityVal.SetFont(strFontData, iHeight);
        m_CtrlAddressCountryVal.SetFont(strFontData, iHeight);
    }
}

HBRUSH CIdentityPage::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CPropertyPage::OnCtlColor(pDC, pWnd, nCtlColor);
	
    int iID = pWnd->GetDlgCtrlID();
    if (iID == IDC_STATIC_IDENTITY_GROUP || iID == IDC_STATIC_ADDRESS_GROUP ||
        iID == IDC_STATIC_SPECIAL_GROUP || iID == IDC_STATIC_CARDINFO_GROUP ||
        iID == IDC_CHECK_SPECIALSTATUS_WHITE_VAL || iID == IDC_CHECK_SPECIALSTATUS_YELLOW_VAL ||
        iID == IDC_CHECK_SPECIALSTATUS_MINORITY_VAL)
    {
        pDC->SetBkColor(m_rgbBackground);
        return (HBRUSH)(m_pBrush->GetSafeHandle());
    }
    
    // TODO: Return a different brush if the default is not desired
	return hbr;
}

void CIdentityPage::LoadIcons()
{
    m_hIconRed = (HICON)::LoadImage(AfxGetInstanceHandle(), 
                                        MAKEINTRESOURCE(IDI_ICON_RED),
                                        IMAGE_ICON, 
                                        16, 16, 
                                        LR_LOADMAP3DCOLORS);
    m_hIconGreen = (HICON)::LoadImage(AfxGetInstanceHandle(), 
                                        MAKEINTRESOURCE(IDI_ICON_GREEN),
                                        IMAGE_ICON, 
                                        16, 16, 
                                        LR_LOADMAP3DCOLORS);
    m_hIconYellow = (HICON)::LoadImage(AfxGetInstanceHandle(), 
                                        MAKEINTRESOURCE(IDI_ICON_YELLOW),
                                        IMAGE_ICON, 
                                        16, 16, 
                                        LR_LOADMAP3DCOLORS);
    m_hIconOff = (HICON)::LoadImage(AfxGetInstanceHandle(), 
                                        MAKEINTRESOURCE(IDI_ICON_OFF),
                                        IMAGE_ICON, 
                                        16, 16, 
                                        LR_LOADMAP3DCOLORS);
}

void CIdentityPage::LoadStrings()
{
    if(m_hWnd == NULL || !::IsWindow(m_hWnd))
        return;

    CString strTemp;
    // Fill Headers
    LCID lcid = GetThreadLocale();
    switch (lcid)
    {
      case 0x0813:   // Dutch (Belgian)
          m_StaticHeader1.SetWindowText(STR_DUTCH_BEL);
          m_StaticHeader2.SetWindowText(STR_FRENCH_BEL);
          m_StaticHeader3.SetWindowText(STR_GERMAN_BEL);
          m_StaticHeader4.SetWindowText(STR_ENGLISH_BEL);
          m_StaticHeader5.SetWindowText(STR_DUTCH_IDEN);
          m_StaticHeader6.SetWindowText(STR_FRENCH_IDEN);
          m_StaticHeader7.SetWindowText(STR_GERMAN_IDEN);
          m_StaticHeader8.SetWindowText(STR_ENGLISH_IDEN);
      break;
      case 0x080c:   // French (Belgian) 
          m_StaticHeader1.SetWindowText(STR_FRENCH_BEL);
          m_StaticHeader2.SetWindowText(STR_DUTCH_BEL);
          m_StaticHeader3.SetWindowText(STR_GERMAN_BEL);
          m_StaticHeader4.SetWindowText(STR_ENGLISH_BEL);
          m_StaticHeader5.SetWindowText(STR_FRENCH_IDEN);
          m_StaticHeader6.SetWindowText(STR_DUTCH_IDEN);
          m_StaticHeader7.SetWindowText(STR_GERMAN_IDEN);
          m_StaticHeader8.SetWindowText(STR_ENGLISH_IDEN);
      break;
      case 0x0407:   // German (Standard) 
          m_StaticHeader1.SetWindowText(STR_GERMAN_BEL);
          m_StaticHeader2.SetWindowText(STR_FRENCH_BEL);
          m_StaticHeader3.SetWindowText(STR_DUTCH_BEL);
          m_StaticHeader4.SetWindowText(STR_ENGLISH_BEL);
          m_StaticHeader5.SetWindowText(STR_GERMAN_IDEN);
          m_StaticHeader6.SetWindowText(STR_FRENCH_IDEN);
          m_StaticHeader7.SetWindowText(STR_DUTCH_IDEN);
          m_StaticHeader8.SetWindowText(STR_ENGLISH_IDEN);
        break;
      case 0x0809:   // English (United Kingdom) 
      default:          // Unknown language
          m_StaticHeader1.SetWindowText(STR_ENGLISH_BEL);
          m_StaticHeader2.SetWindowText(STR_FRENCH_BEL);
          m_StaticHeader3.SetWindowText(STR_DUTCH_BEL);
          m_StaticHeader4.SetWindowText(STR_GERMAN_BEL);
          m_StaticHeader5.SetWindowText(STR_ENGLISH_IDEN);
          m_StaticHeader6.SetWindowText(STR_FRENCH_IDEN);
          m_StaticHeader7.SetWindowText(STR_DUTCH_IDEN);
          m_StaticHeader8.SetWindowText(STR_GERMAN_IDEN);
      break;
    }

    // Labels
    strTemp.LoadString(IDS_STRING_IDENTITY_DLGTITLE);
    SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_SPECIALGROUP);
    m_CtrlSpecialGroup.SetWindowText(strTemp); 
    strTemp.LoadString(IDS_STRING_IDENTITYGROUP);
    m_CtrlIdenGroup.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_ADDRESSGROUP);
    m_CtrlAddressGroup.SetWindowText(strTemp); 
    strTemp.LoadString(IDS_STRING_CARDINFOGROUP);
    m_CtrlCardInfoGroup.SetWindowText(strTemp); 
    strTemp.LoadString(IDS_STRING_SPECIAL_WHITE);
    m_CtrlSpecialWhite.SetWindowText(strTemp); 
    strTemp.LoadString(IDS_STRING_SPECIAL_YELLOW);
    m_CtrlSpecialYellow.SetWindowText(strTemp); 
    strTemp.LoadString(IDS_STRING_SPECIAL_MINORITY);
    m_CtrlSpecialMinority.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_IDENTITY_TITLE);
    m_CtrlIdenTitle.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_IDENTITY_NAME);
    m_CtrlIdenName.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_IDENTITY_GIVENNAMES);
    m_CtrlIdenGivenNames.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_IDENTITY_BIRTHPLACE);
    m_CtrlIdenBirthPlace.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_IDENTITY_BIRTHDATE);
    m_CtrlIdenBirthDate.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_IDENTITY_SEX);
    m_CtrlIdenSex.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_IDENTITY_NATIONALITY);
    m_CtrlIdenNationality.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_IDENTITY_NATIONAL_NR);
    m_CtrlIdenNationalityNr.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_ADDRESS_STREET);
    m_CtrlAddressStreet.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_ADDRESS_ZIP);
    m_CtrlAddressZip.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_ADDRESS_MUNICIPALITY);
    m_CtrlAddressMunicipality.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_ADDRESS_COUNTRY);
    m_CtrlAddressCountry.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_CARDINFO_CHIPNR);
    m_CtrlCardInfoChipNr.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_CARDINFO_CARDNR);
    m_CtrlCardInfoCardNr.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_CARDINFO_FROM);
    m_CtrlCardInfoFrom.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_CARDINFO_UNTIL);
    m_CtrlCardInfoUntil.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_CARDINFO_MUNICIPALITY);
    m_CtrlCardInfoMunicipality.SetWindowText(strTemp);

    // ToolTips
    strTemp.LoadString(IDS_STRING_CHIP_READCARD);
    m_Tip.AddTool(&m_ButtonChip, strTemp); 
    strTemp.LoadString(IDS_STRING_ARROW_CLEAR);
    m_Tip.AddTool(&m_BitmapArrow, strTemp); 
    strTemp.LoadString(IDS_STRING_IDENTITY_PRINT);
    m_Tip.AddTool(&m_CtrlButtonPrint, strTemp);     
}

void CIdentityPage::OnButtonChip() 
{
	theApp.ReadCard(); 
}


void CIdentityPage::SetIDData(BEID_ID_Data *pIDData, long lSignature, BOOL bClear /* FALSE */)
{
    ASSERT(pIDData);

    if(bClear || BEID_SIGNATURE_VALID == lSignature || BEID_SIGNATURE_VALID_WRONG_RRNCERT == lSignature)
    {
        CString strTemp, strTemp1, strTemp2;
        strTemp = theApp.DecodeFromUTF8(pIDData->name);
        m_CtrlIdenNameVal.SetWindowText(strTemp);
        strTemp1 = theApp.DecodeFromUTF8(pIDData->firstName1);
        strTemp2 = theApp.DecodeFromUTF8(pIDData->firstName2);
        strTemp.Format(_T("%s  %s"), strTemp1, strTemp2); 
        m_CtrlIdenGivenNamesVal1.SetWindowText(strTemp);
        strTemp = theApp.DecodeFromUTF8(pIDData->firstName3);
        m_CtrlIdenGivenNamesVal3.SetWindowText(strTemp);
        strTemp = theApp.DecodeFromUTF8(pIDData->birthLocation);
        m_CtrlIdenBirthPlaceVal.SetWindowText(strTemp);
        FillDate(pIDData->birthDate, strTemp);
        m_CtrlIdenBirthDateVal.SetWindowText(strTemp);
        m_CtrlIdenNationalityVal.SetWindowText(CString(pIDData->nationality));
        m_CtrlIdenSexVal.SetWindowText(CString(pIDData->sex));
        strTemp = theApp.DecodeFromUTF8(pIDData->nobleCondition);
        m_CtrlIdenTitleVal.SetWindowText(strTemp);
        strTemp.Empty(); 
        if(strlen(pIDData->nationalNumber) > 0)
        {
            char szDummy2[3] = {0};
            char szDummy3[4] = {0};
            strTemp += strncpy(szDummy2, pIDData->nationalNumber, 2);
            strTemp += ".";
            strTemp += strncpy(szDummy2, pIDData->nationalNumber + 2, 2);
            strTemp += ".";
            strTemp += strncpy(szDummy2, pIDData->nationalNumber + 4, 2);
            strTemp += "-";
            strTemp += strncpy(szDummy3, pIDData->nationalNumber + 6, 3);
            strTemp += ".";
            strTemp += strncpy(szDummy2, pIDData->nationalNumber + 9, 2);
        }
        m_CtrlIdenNationalityNrVal.SetWindowText(strTemp);

        // Special status
        m_CtrlSpecialYellowVal.SetBitmap(pIDData->yellowCane ? IDB_BITMAP_CHECKED : IDB_BITMAP_UNCHECKED); 
        m_CtrlSpecialWhiteVal.SetBitmap(pIDData->whiteCane ? IDB_BITMAP_CHECKED : IDB_BITMAP_UNCHECKED); 
        m_CtrlSpecialMinorityVal.SetBitmap(pIDData->extendedMinority ? IDB_BITMAP_CHECKED : IDB_BITMAP_UNCHECKED); 

        // Card Info
        m_CtrlCardInfoChipNrVal.SetWindowText(CString(pIDData->chipNumber));
        strTemp.Empty(); 
        if(strlen(pIDData->cardNumber) > 0)
        {
            char szDummy2[3] = {0};
            char szDummy3[4] = {0};
            char szDummy7[8] = {0};
            strTemp += strncpy(szDummy3, pIDData->cardNumber, 3);
            strTemp += ".";
            strTemp += strncpy(szDummy7, pIDData->cardNumber + 3, 7);
            strTemp += ".";
            strTemp += strncpy(szDummy2, pIDData->cardNumber + 10, 2);
        }
        m_CtrlCardInfoCardNrVal.SetWindowText(strTemp);
        strTemp = theApp.DecodeFromUTF8(pIDData->municipality);
        m_CtrlCardInfoMunicipalityVal.SetWindowText(strTemp);
        FillDate(pIDData->validityDateBegin, strTemp);
        m_CtrlCardInfoFromVal.SetWindowText(strTemp);
        FillDate(pIDData->validityDateEnd, strTemp);
        m_CtrlCardInfoUntilVal.SetWindowText(strTemp);
    }
    FillStatus(m_CtrlStatusIdentity, lSignature);
}

void CIdentityPage::SetAddressData(BEID_Address *pADData, long lSignature, BOOL bClear /* FALSE */)
{
    ASSERT(pADData);

    if(bClear || BEID_SIGNATURE_VALID == lSignature || BEID_SIGNATURE_VALID_WRONG_RRNCERT == lSignature)
    {
        CString strTemp;
        strTemp = theApp.DecodeFromUTF8(pADData->street);
        m_CtrlAddressStreetVal.SetWindowText(strTemp);
        m_CtrlAddressZipVal.SetWindowText(CString(pADData->zip));
        strTemp = theApp.DecodeFromUTF8(pADData->municipality);
        m_CtrlAddressMunicipalityVal.SetWindowText(strTemp);
        if(!strTemp.IsEmpty()) 
        {
            strTemp = pADData->country;
            if (!bClear && strTemp.IsEmpty())
            {
                strTemp = "be";
            }
        }
        m_CtrlAddressCountryVal.SetWindowText(strTemp);
    }
    FillStatus(m_CtrlStatusAddress, lSignature);
}

void CIdentityPage::SetPictureData(BEID_Bytes *pPicData, long lSignature, BOOL bClear /* FALSE */)
{
    ASSERT(pPicData);

    if(m_Picture.length > 0)
    {
        delete [] m_Picture.data;
    }
    memset(&m_Picture, 0, sizeof(BEID_Bytes));
    m_Picture.length = pPicData->length;
    m_Picture.data = new unsigned char[m_Picture.length];
    memcpy(m_Picture.data, pPicData->data, m_Picture.length);

    if(bClear || BEID_SIGNATURE_VALID == lSignature || BEID_SIGNATURE_VALID_WRONG_RRNCERT == lSignature)
    {
        CRect oRect;
        m_CtrlPictureCard.GetClientRect (&oRect);

        if(pPicData->length > 0 && pPicData->data != NULL)
        {
            CxImage oImage(pPicData->data, pPicData->length, CXIMAGE_FORMAT_JPG);
            oImage.Resample (oRect.right, oRect.bottom);
            HBITMAP hBitmap = oImage.MakeBitmap(m_CtrlPictureCard.GetDC()->m_hDC);
            m_CtrlPictureCard.SetBitmap(hBitmap);
        }
        else
        {
            m_CtrlPictureCard.SetBitmap(IDB_BITMAP_PICTURE_EMPTY);
        }
    }
    FillStatus(m_CtrlStatusPicture, lSignature);
}

void CIdentityPage::FillStatus(CXColorStatic & oControl, long lSignature)
{
    CString strTemp;
    switch (lSignature)
    {
    case BEID_SIGNATURE_PROCESSING_ERROR:
        oControl.SetIcon(m_hIconOff);
	    m_Tip.DelTool(&oControl);
        break;
    case BEID_SIGNATURE_VALID:
        oControl.SetIcon(m_hIconGreen);
        strTemp.LoadString(IDS_STRING_GREEN_STATE);
	    m_Tip.AddTool(&oControl, strTemp);//, m_hIconGreen);
        break;
    case BEID_SIGNATURE_INVALID:
    case BEID_SIGNATURE_INVALID_WRONG_RRNCERT:
        oControl.SetIcon(m_hIconRed);
        strTemp.LoadString(IDS_STRING_RED_STATE);
        m_Tip.AddTool(&oControl, strTemp);//, m_hIconRed);
        break;
    case BEID_SIGNATURE_VALID_WRONG_RRNCERT:
        oControl.SetIcon(m_hIconYellow);
        strTemp.LoadString(IDS_STRING_YELLOW_STATE);
	    m_Tip.AddTool(&oControl, strTemp);//, m_hIconYellow);
        break;
    }
}

void CIdentityPage::FillDate(char *pszSource, CString & strResult)
{
    strResult.Empty();
    if(strlen(pszSource) > 0)
    {
        char szYear[5] = {0};
        char szMonth[3] = {0};
        char szDay[3] = {0};
        strncpy(szYear, pszSource, 4);
        strncpy(szMonth, pszSource + 4, 2);
        strncpy(szDay, pszSource + 6, 2);

        COleDateTime oDate( atoi(szYear), atoi(szMonth), atoi(szDay), 0, 0, 0 );
        strResult = oDate.Format(VAR_DATEVALUEONLY);
    }
}

void CIdentityPage::OnButtonBitmapArrow() 
{
	theApp.ClearPages(); 
}


BOOL CIdentityPage::PreTranslateMessage(MSG* pMsg) 
{
	m_Tip.RelayEvent(pMsg);
	return CPropertyPage::PreTranslateMessage(pMsg);
}

void CIdentityPage::OnBeginPrinting(CDC *pDC, CPrintInfo* pInfo)
{
    // maybe pre cache some pens or brushes, or modify the
    // properties of the DC
   static HFONT hf = NULL;
   CString strFontData = theApp.GetDataFont();
   LOGFONT lf = {0}; 
   if(strFontData.IsEmpty())
   {
      CFont *pFont = m_CtrlIdenNameVal.GetFont();
      pFont->GetLogFont(&lf); 
      strFontData = lf.lfFaceName; 
   }
   if (!hf) 
   {
       hf = CreateFont(-MulDiv(10, GetDeviceCaps(pDC->m_hDC, LOGPIXELSY), 72), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, strFontData);                
   }          
   
   SelectObject(pDC->m_hDC, hf);
 
    
    if(LoadPicture(m_Picture.data, m_Picture.length, (void **)&m_gpPicture) == -1) 
    {
        m_gpPicture = NULL;
    }
}

void CIdentityPage::OnPrint(CDC *pDC, CPrintInfo* pInfo)
{
    // Do your drawing/printing exactly as you would in a
    // CView::OnDraw function. The CPrintInfo structure
    // will give you the bounds and the current page number
    CString strTemp;
    CString strTempVal;
    TEXTMETRIC tm = {0};
    pDC->GetTextMetrics(&tm);
    int h  = tm.tmHeight + tm.tmInternalLeading + 10; // +10 ==> more vertical space between lines;
    int xPage = pDC->GetDeviceCaps(HORZRES);
    int yPage = pDC->GetDeviceCaps(VERTRES);
    int xPixels = pDC->GetDeviceCaps(LOGPIXELSX);
    int yPixels = pDC->GetDeviceCaps(LOGPIXELSY);
    int w = 90;
    int iXPosLabels = 3*w;
    int iXPosTitle  = 10*w;
    int iXPosValues = 25*w;        
 
    // Print Picture
    if(m_gpPicture != NULL)
    {
        static const int HIMETRIC_INCH = 2540;
        CRect rc(0, 0, xPixels-1, yPixels-1);
        long hmWidth = 0;
        long hmHeight = 0;
        int nWidth = 0;
        int nHeight = 0;

        /* get width and height of picture */
        m_gpPicture->get_Width(&hmWidth);
        m_gpPicture->get_Height(&hmHeight);
    
        /* convert himetric to pixels */
        nWidth = MulDiv(hmWidth, xPixels, HIMETRIC_INCH);
        nHeight = MulDiv(hmHeight, yPixels, HIMETRIC_INCH);

        /* display picture using IPicture::Render */
        m_gpPicture->Render(pDC->m_hDC, iXPosValues, 0, nWidth, nHeight, 0, hmHeight, hmWidth, -hmHeight, &rc);
    }

    // Print Logo
    CBitmap bitmap;
    CDC memDC;
    CDC memDC2;
    CClientDC dcClient(this);
    int width  = 709; // fixme: hardcoded
    int height = 783; // fixme: hardcoded

    memDC.CreateCompatibleDC( &dcClient );
    memDC2.CreateCompatibleDC(pDC);
    bitmap.LoadBitmap(IDB_BITMAP_LOGO_PRINT);
    memDC.SelectObject(bitmap);         
    HBITMAP hMemBitmap = CreateCompatibleBitmap(memDC2.m_hDC,width, height);
    memDC2.SelectObject(hMemBitmap);        
    memDC2.BitBlt(0, 0, width, height, &memDC,  0, 0, SRCCOPY);                
    pDC->StretchBlt(iXPosLabels, 0, (int)(width*1.5), (int)(height*1.5), &memDC2, 0, 0, width, height, SRCCOPY);

    if (hMemBitmap)
        DeleteObject(hMemBitmap);

    // Print Data
    int x = 0;
    int y = 13*h-10-2;

    MoveToEx(pDC->m_hDC, 0, y, NULL);
    pDC->LineTo(xPage-1, y);   
    y += 2;
       
    m_StaticHeader1.GetWindowText(strTemp); 
    pDC->TextOut(iXPosTitle, y, strTemp);
    y += h;
    m_StaticHeader5.GetWindowText(strTemp); 
    pDC->TextOut(iXPosTitle, y, strTemp);
    y += h+2;    
    MoveToEx(pDC->m_hDC, 0, y, NULL);
    pDC->LineTo(xPage-1, y);   

    y = 15*h;
    strTemp.LoadString(IDS_STRING_CARDINFO_CARDNR);
    m_CtrlCardInfoCardNrVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.LoadString(IDS_STRING_CARDINFO_CHIPNR);
    m_CtrlCardInfoChipNrVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.LoadString(IDS_STRING_CARDINFO_FROM);
    m_CtrlCardInfoFromVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.LoadString(IDS_STRING_CARDINFO_UNTIL);
    m_CtrlCardInfoUntilVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.LoadString(IDS_STRING_IDENTITY_NATIONAL_NR);
    m_CtrlIdenNationalityNrVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.LoadString(IDS_STRING_IDENTITY_TITLE);
    m_CtrlIdenTitleVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.LoadString(IDS_STRING_IDENTITY_NAME);
    m_CtrlIdenNameVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.LoadString(IDS_STRING_IDENTITY_GIVENNAMES);
    m_CtrlIdenGivenNamesVal1.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.LoadString(IDS_STRING_IDENTITY_NATIONALITY);
    m_CtrlIdenNationalityVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.LoadString(IDS_STRING_IDENTITY_SEX);
    m_CtrlIdenSexVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.LoadString(IDS_STRING_IDENTITY_BIRTHDATE);
    m_CtrlIdenBirthDateVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.LoadString(IDS_STRING_IDENTITY_BIRTHPLACE);
    m_CtrlIdenBirthPlaceVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.LoadString(IDS_STRING_ADDRESSGROUP);
    m_CtrlAddressStreetVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.Empty();
    m_CtrlAddressMunicipalityVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;

    strTemp.LoadString(IDS_STRING_CARDINFO_MUNICIPALITY);
    m_CtrlCardInfoMunicipalityVal.GetWindowText(strTempVal);
    pDC->TextOut(iXPosLabels, y, strTemp);
    pDC->TextOut(iXPosValues, y, strTempVal);
    y += h;
  
    MoveToEx(pDC->m_hDC, 0, y+2, NULL);
    pDC->LineTo(xPage-1, y+2);   
    MoveToEx(pDC->m_hDC, 0, y-h-2, NULL);
    pDC->LineTo(xPage-1, y-h-2);   
}

void CIdentityPage::OnEndPrinting(CDC *pDC, CPrintInfo* pInfo)
{
    // Clean up pens or brushes, or restore the DC
    if (m_gpPicture)
    {
        m_gpPicture->Release();
        m_gpPicture = NULL;
    }
}

void CIdentityPage::Print()
{
    CDC dc;
    CPrintDialog printDlg(FALSE);

    if (printDlg.DoModal() == IDCANCEL)     // Get printer settings from user
        return;

    CWaitCursor wc;

    dc.Attach(printDlg.GetPrinterDC());     // Get and attach a printer DC
    dc.m_bPrinting = TRUE;

    CString strTitle;
    strTitle.LoadString(IDS_STRING_APP_TITLE);

    DOCINFO di;                             // Initialise print document details
    ::ZeroMemory (&di, sizeof (DOCINFO));
    di.cbSize = sizeof (DOCINFO);
    di.lpszDocName = strTitle;

    dc.StartDoc(&di);    // Begin a new print job

    // Get the printing extents and store in the m_rectDraw field of a 
    // CPrintInfo object
    CPrintInfo Info;
    Info.m_rectDraw.SetRect(0,0, 
                            dc.GetDeviceCaps(HORZRES), 
                            dc.GetDeviceCaps(VERTRES));

    OnBeginPrinting(&dc, &Info);            // Call your "Init printing" function
    dc.StartPage();                     // begin new page
    OnPrint(&dc, &Info);                // Call your "Print page" function
    dc.EndPage();                       // end page
    OnEndPrinting(&dc, &Info);              // Call your "Clean up" function
    dc.EndDoc();                        // end a print job
    dc.DeleteDC();                          // delete the printer DC
}


int CIdentityPage::LoadPicture(void *buf, DWORD buflen, void **handle)
{
    LPVOID pvData = NULL;        
    LPSTREAM pstm = NULL;
    HGLOBAL hGlobal;
    HRESULT hr;
    
    /* alloc memory */
    hGlobal = GlobalAlloc(GMEM_MOVEABLE, buflen);
    if (!hGlobal)
            return -1;
    pvData = GlobalLock(hGlobal);
    if (!pvData)
            return -1;

    memcpy(pvData, buf, buflen);
    GlobalUnlock(hGlobal);

    /* create IStream* from global memory */
    hr = CreateStreamOnHGlobal(hGlobal, TRUE, &pstm);
    if (!SUCCEEDED(hr) || !pstm)
            return -1;

    /* Create IPicture from image file */
    hr = OleLoadPicture(pstm, buflen, FALSE, IID_IPicture, handle);
    if (!SUCCEEDED(hr) || !handle)
            return -1;
    pstm->Release();

    return 0;
}

void CIdentityPage::OnButtonIdentityPrint() 
{
    Print();	
}
