#if !defined(AFX_IDENTITYPAGE_H__B6D0B745_70FE_436B_B7ED_2355C1283180__INCLUDED_)
#define AFX_IDENTITYPAGE_H__B6D0B745_70FE_436B_B7ED_2355C1283180__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// IdentityPage.h : header file
//

#include "XColorStatic.h"
#include "BitmapPicture.h"
#include "BtnST.h"
#include "../CXImage/CXImage/ximage.h"

/////////////////////////////////////////////////////////////////////////////
// CIdentityPage dialog

class CIdentityPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CIdentityPage)

// Construction
public:
	CIdentityPage();
	~CIdentityPage();
    void LoadStrings();
    void SetIDData(BEID_ID_Data *pIDData, long lSignature, BOOL bClear = FALSE);
    void SetAddressData(BEID_Address *pADData, long lSignature, BOOL bClear = FALSE);
    void SetPictureData(BEID_Bytes *pPicData, long lSignature, BOOL bClear = FALSE);

// Dialog Data
	//{{AFX_DATA(CIdentityPage)
	enum { IDD = IDD_PAGE_IDENTITY };
	CButtonST	m_CtrlButtonPrint;
	CXColorStatic	m_CtrlStatusIdentity;
	CXColorStatic	m_CtrlStatusAddress;
	CXColorStatic	m_CtrlStatusPicture;
	CBitmapPicture	m_CtrlPictureCard;
	CButton	m_CtrlSpecialGroup;
	CButton	m_CtrlCardInfoGroup;
	CButton	m_CtrlAddressGroup;
	CBitmapPicture	m_CtrlSpecialYellowVal;
	CBitmapPicture	m_CtrlSpecialWhiteVal;
	CBitmapPicture	m_CtrlSpecialMinorityVal;
	CXColorStatic	m_CtrlSpecialYellow;
	CXColorStatic	m_CtrlSpecialWhite;
	CXColorStatic	m_CtrlSpecialMinority;
	CXColorStatic	m_CtrlIdenTitleVal;
	CXColorStatic	m_CtrlIdenTitle;
	CXColorStatic	m_CtrlIdenSexVal;
	CXColorStatic	m_CtrlIdenSex;
	CXColorStatic	m_CtrlIdenNationalityNrVal;
	CXColorStatic	m_CtrlIdenNationalityNr;
	CXColorStatic	m_CtrlIdenNationalityVal;
	CXColorStatic	m_CtrlIdenNationality;
	CXColorStatic	m_CtrlIdenNameVal;
	CXColorStatic	m_CtrlIdenName;
	CButton	m_CtrlIdenGroup;
	CXColorStatic	m_CtrlIdenGivenNamesVal3;
	CXColorStatic	m_CtrlIdenGivenNamesVal1;
	CXColorStatic	m_CtrlIdenGivenNames;
	CXColorStatic	m_CtrlIdenBirthPlaceVal;
	CXColorStatic	m_CtrlIdenBirthPlace;
	CXColorStatic	m_CtrlIdenBirthDateVal;
	CXColorStatic	m_CtrlIdenBirthDate;
	CXColorStatic	m_CtrlCardInfoUntilVal;
	CXColorStatic	m_CtrlCardInfoUntil;
	CXColorStatic	m_CtrlCardInfoFromVal;
	CXColorStatic	m_CtrlCardInfoFrom;
	CXColorStatic	m_CtrlCardInfoMunicipalityVal;
	CXColorStatic	m_CtrlCardInfoMunicipality;
	CXColorStatic	m_CtrlCardInfoChipNrVal;
	CXColorStatic	m_CtrlCardInfoChipNr;
	CXColorStatic	m_CtrlCardInfoCardNrVal;
	CXColorStatic	m_CtrlCardInfoCardNr;
	CXColorStatic	m_CtrlAddressZipVal;
	CXColorStatic	m_CtrlAddressZip;
	CXColorStatic	m_CtrlAddressStreetVal;
	CXColorStatic	m_CtrlAddressStreet;
	CXColorStatic	m_CtrlAddressMunicipalityVal;
	CXColorStatic	m_CtrlAddressCountryVal;
	CXColorStatic	m_CtrlAddressMunicipality;
	CXColorStatic	m_CtrlAddressCountry;
	CButtonST	m_ButtonChip;
	CButtonST	m_BitmapArrow;
	CBitmapPicture	m_BitmapLogo;
	CBitmapPicture	m_BitmapBelgium;
	CXColorStatic	m_StaticHeader8;
	CXColorStatic	m_StaticHeader7;
	CXColorStatic	m_StaticHeader6;
	CXColorStatic	m_StaticHeader5;
	CXColorStatic	m_StaticHeader4;
	CXColorStatic	m_StaticHeader3;
	CXColorStatic	m_StaticHeader2;
	CXColorStatic	m_StaticHeader1;
	//}}AFX_DATA
	CToolTipCtrl m_Tip;

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CIdentityPage)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CIdentityPage)
	    virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnButtonChip();
	afx_msg void OnButtonBitmapArrow();
	afx_msg void OnButtonIdentityPrint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

    void OnBeginPrinting(CDC *pDC, CPrintInfo* pInfo);
    void OnPrint(CDC *pDC, CPrintInfo* pInfo);
    void OnEndPrinting(CDC *pDC, CPrintInfo* pInfo);
    void InitControls();
    void LoadIcons();
    void FillStatus(CXColorStatic & oControl, long lSignature);
    void FillDate(char *pszSource, CString & strResult);
    void Print();
    int LoadPicture(void *buf, DWORD buflen, void **handle);

private:
	COLORREF m_rgbBackground;
	COLORREF m_rgbBackgroundVal;
	CBrush * m_pBrush;
	CFont *	m_pFont;
    HICON m_hIconGreen;
    HICON m_hIconRed;
    HICON m_hIconYellow;
    HICON m_hIconOff;
    BEID_Bytes m_Picture;
    LPPICTURE m_gpPicture;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IDENTITYPAGE_H__B6D0B745_70FE_436B_B7ED_2355C1283180__INCLUDED_)
