// OptionsPage.cpp : implementation file
//

#include "stdafx.h"
#include "eidgui.h"
#include "OptionsPage.h"

#include <opensc/opensc.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CEidGUIApp theApp;

/////////////////////////////////////////////////////////////////////////////
// COptionsPage property page

IMPLEMENT_DYNCREATE(COptionsPage, CPropertyPage)

COptionsPage::COptionsPage() : CPropertyPage(COptionsPage::IDD)
{
	//{{AFX_DATA_INIT(COptionsPage)
	m_iLanguage = -1;
	//}}AFX_DATA_INIT
}

COptionsPage::~COptionsPage()
{
}

void COptionsPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsPage)
	DDX_Control(pDX, IDC_BUTTON_OPTIONS_APPLY, m_CtrlApply);
	DDX_Control(pDX, IDC_STATIC_OPTIONS_VALIDATION_GROUP, m_CtrlValidation);
	DDX_Control(pDX, IDC_STATIC_OPTIONS_READER_GROUP, m_CtrlReaders);
	DDX_Control(pDX, IDC_STATIC_OPTIONS_OCSP, m_CtrlOCSP);
	DDX_Control(pDX, IDC_STATIC_OPTIONS_LANGUAGE_GROUP, m_CtrlLanguage);
	DDX_Control(pDX, IDC_STATIC_OPTIONS_GERMAN, m_CtrlGerman);
	DDX_Control(pDX, IDC_STATIC_OPTIONS_FRENCH, m_CtrlFrench);
	DDX_Control(pDX, IDC_STATIC_OPTIONS_English, m_CtrlEnglish);
	DDX_Control(pDX, IDC_STATIC_OPTIONS_DUTCH, m_CtrlDutch);
	DDX_Control(pDX, IDC_STATIC_OPTIONS_CRL, m_CtrlCRL);
	DDX_Control(pDX, IDC_COMBO_OPTIONS_READER_VAL, m_CtrlReaderVal);
	DDX_Control(pDX, IDC_COMBO_OPTIONS_OCSP_VAL, m_CtrlOCSPVal);
	DDX_Control(pDX, IDC_COMBO_OPTIONS_CRL_VAL, m_CtrlCRLVal);
	DDX_Radio(pDX, IDC_RADIO_OPTIONS_DUTCH_VAL, m_iLanguage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionsPage, CPropertyPage)
	//{{AFX_MSG_MAP(COptionsPage)
	ON_BN_CLICKED(IDC_BUTTON_OPTIONS_APPLY, OnButtonOptionsApply)
	ON_CBN_SELCHANGE(IDC_COMBO_OPTIONS_OCSP_VAL, OnSelchangeComboOptionsOcspVal)
	ON_CBN_SELCHANGE(IDC_COMBO_OPTIONS_CRL_VAL, OnSelchangeComboOptionsCrlVal)
	ON_CBN_SELCHANGE(IDC_COMBO_OPTIONS_READER_VAL, OnSelchangeComboOptionsReaderVal)
	ON_BN_CLICKED(IDC_RADIO_OPTIONS_FRENCH_VAL, OnStaticOptionsLanguage)
	ON_BN_CLICKED(IDC_RADIO_OPTIONS_GERMAN_VAL, OnStaticOptionsLanguage)
	ON_BN_CLICKED(IDC_RADIO_OPTIONS_ENGLISH_VAL, OnStaticOptionsLanguage)
	ON_BN_CLICKED(IDC_RADIO_OPTIONS_DUTCH_VAL, OnStaticOptionsLanguage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsPage message handlers

BOOL COptionsPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
    LoadStrings();
    InitControls();
    
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptionsPage::LoadStrings()
{
    if(m_hWnd == NULL || !::IsWindow(m_hWnd))
        return;

    CString strTemp;

    // Labels
    strTemp.LoadString(IDS_STRING_OPTIONS_DLGTITLE);
    SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_OPTIONS_LANGUAGE_GROUP);
    m_CtrlLanguage.SetWindowText(strTemp); 
    /*
    strTemp.LoadString(IDS_STRING_OPTIONS_LANGUAGE_DUTCH);
    m_CtrlDutch.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_OPTIONS_LANGUAGE_FRENCH);
    m_CtrlFrench.SetWindowText(strTemp);    
    strTemp.LoadString(IDS_STRING_OPTIONS_LANGUAGE_GERMAN);
    m_CtrlGerman.SetWindowText(strTemp);    
    strTemp.LoadString(IDS_STRING_OPTIONS_LANGUAGE_ENGLISH);
    m_CtrlEnglish.SetWindowText(strTemp);
    */
    strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_GROUP);
    m_CtrlValidation.SetWindowText(strTemp); 
    strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_OCSP);
    m_CtrlOCSP.SetWindowText(strTemp); 
    strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_CRL);
    m_CtrlCRL.SetWindowText(strTemp); 
    strTemp.LoadString(IDS_STRING_OPTIONS_READER_GROUP);
    m_CtrlReaders.SetWindowText(strTemp);
    strTemp.LoadString(IDS_STRING_OPTIONS_APPLY);
    m_CtrlApply.SetWindowText(strTemp);
    if (m_CtrlReaderVal.GetCount() > 0)
    {
        int iSel = m_CtrlReaderVal.GetCurSel(); 
        m_CtrlReaderVal.DeleteString(0); 
        strTemp.LoadString(IDS_STRING_OPTIONS_READERS_EMPTY);
        m_CtrlReaderVal.InsertString(0, strTemp);
        m_CtrlReaderVal.SetCurSel(iSel); 
    }
    int iCount = m_CtrlOCSPVal.GetCount();
    if (iCount > 0)
    {
        int iSel = m_CtrlOCSPVal.GetCurSel();
        m_CtrlOCSPVal.ResetContent();
        strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_NOTUSED);
        m_CtrlOCSPVal.AddString(strTemp); 
        strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_OPTIONAL);
        m_CtrlOCSPVal.AddString(strTemp); 
        if(iCount > 2)
        {
            strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_MANDATORY);
            m_CtrlOCSPVal.AddString(strTemp);         
        }
        m_CtrlOCSPVal.SetCurSel(iSel); 
    }
    iCount = m_CtrlCRLVal.GetCount();
    if (iCount > 0)
    {
        int iSel = m_CtrlCRLVal.GetCurSel(); 
        m_CtrlCRLVal.ResetContent(); 
        strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_NOTUSED);
        m_CtrlCRLVal.AddString(strTemp); 
        strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_OPTIONAL);
        m_CtrlCRLVal.AddString(strTemp); 
        if(iCount > 2)
        {
            strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_MANDATORY);
            m_CtrlCRLVal.AddString(strTemp); 
        }
        m_CtrlCRLVal.SetCurSel(iSel); 
    }
}

void COptionsPage::InitControls() 
{
    // Fill validation combo's
    CString strTemp;
    strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_NOTUSED);
    m_CtrlOCSPVal.AddString(strTemp); 
    m_CtrlCRLVal.AddString(strTemp); 
    strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_OPTIONAL);
    m_CtrlOCSPVal.AddString(strTemp); 
    m_CtrlCRLVal.AddString(strTemp); 
    strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_MANDATORY);
    m_CtrlOCSPVal.AddString(strTemp); 
    m_CtrlCRLVal.AddString(strTemp); 

    // List Readers
    CString strSel;
    strSel.LoadString(IDS_STRING_OPTIONS_READERS_EMPTY);
    m_CtrlReaderVal.AddString(strSel);
    int iRet = 0;
    struct sc_context *pCtx = NULL;

	if( SC_NO_ERROR == sc_establish_context(&pCtx, NULL))
    {
	    for (int i = 0; i < pCtx->reader_count; i++) 
        {
		    m_CtrlReaderVal.AddString(CString(pCtx->reader[i]->name));
	    }
        if (pCtx)
		    sc_release_context(pCtx);
    }

    // Set Selection
    CConfig & oConfig = theApp.GetConfig();
    if (!oConfig.m_StrReader.IsEmpty())
    {
        if(CB_ERR != (m_CtrlReaderVal.FindStringExact(-1, oConfig.m_StrReader)))
        {
            strSel = oConfig.m_StrReader;
        }
        else
        {
            oConfig.m_StrReader.Empty();  
        }
    }
    m_CtrlReaderVal.SelectString(-1, strSel);

    // OCSP CRL
    if(CB_ERR == m_CtrlOCSPVal.SetCurSel(oConfig.m_dwOCSP))
    {
        m_CtrlOCSPVal.SetCurSel(0);
    }
    if(CB_ERR == m_CtrlCRLVal.SetCurSel(oConfig.m_dwCRL))
    {
        m_CtrlCRLVal.SetCurSel(0);
    }
    // Language
    m_iLanguage = oConfig.m_dwLanguage; 
    UpdateData(FALSE);    
    AdjustOCSP();
    AdjustCRL();
}

void COptionsPage::OnButtonOptionsApply() 
{
    UpdateData(TRUE);
    CConfig & oConfig = theApp.GetConfig();
    oConfig.m_dwLanguage = m_iLanguage;
    oConfig.m_dwOCSP = m_CtrlOCSPVal.GetCurSel();    
    oConfig.m_dwCRL = m_CtrlCRLVal.GetCurSel();
    int iIndex = m_CtrlReaderVal.GetCurSel();
    if (iIndex > 0)
    {
         m_CtrlReaderVal.GetLBText(iIndex, oConfig.m_StrReader);   
    }
    else
    {
        oConfig.m_StrReader = _T("");
    }
    theApp.SaveConfiguration(); 
}

void COptionsPage::OnSelchangeComboOptionsOcspVal() 
{
    AdjustCRL();
    OnButtonOptionsApply();
}

void COptionsPage::OnSelchangeComboOptionsCrlVal() 
{
    AdjustOCSP();
    OnButtonOptionsApply();	
}

void COptionsPage::OnSelchangeComboOptionsReaderVal() 
{
    OnButtonOptionsApply();	
}


void COptionsPage::OnStaticOptionsLanguage() 
{
    int iLanguage = m_iLanguage;
    UpdateData(TRUE);
	if(iLanguage != m_iLanguage)
    {
        OnButtonOptionsApply();
        theApp.SwitchLanguage(); 
    }
}

void COptionsPage::AdjustCRL()
{
    int iIndex = m_CtrlOCSPVal.GetCurSel();
    if (iIndex == 2)
    {
        // Remove Mandatory selection from CRL
        if(3 == m_CtrlCRLVal.GetCount())
        {
            m_CtrlCRLVal.DeleteString(2); 
        }
    }
    else
    {
        // Add Mandatory selection to CRL
        if(2 == m_CtrlCRLVal.GetCount())
        {
            CString strTemp;
            strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_MANDATORY);
            m_CtrlCRLVal.AddString(strTemp);             
        }
    }
}

void COptionsPage::AdjustOCSP() 
{
    int iIndex = m_CtrlCRLVal.GetCurSel();
    if (iIndex == 2)
    {
        // Remove Mandatory selection from OCSP
        if(3 == m_CtrlOCSPVal.GetCount())
        {
            m_CtrlOCSPVal.DeleteString(2); 
        }
    }
    else
    {
        // Add Mandatory selection to OCSP
        if(2 == m_CtrlOCSPVal.GetCount())
        {
            CString strTemp;
            strTemp.LoadString(IDS_STRING_OPTIONS_VALIDATION_MANDATORY);
            m_CtrlOCSPVal.AddString(strTemp);             
        }
    }
    OnButtonOptionsApply();	
}
