// eidGUI.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "eidGUI.h"
#include "MyPropertySheet.h"
#include "IdentityPage.h"
#include "CertificatesPage.h"
#include "CardDataPage.h"
#include "OptionsPage.h"

#include <atlbase.h>
#include <opensc/opensc.h>
#include <opensc/pkcs15.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char CEidGUIApp::hexChars[] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};

int  CALLBACK MyEnumFontFamExProc(
  ENUMLOGFONTEX *lpelfe,    // logical-font data
  NEWTEXTMETRICEX *lpntme,  // physical-font data
  DWORD FontType,           // type of font
  LPARAM lParam             // application-defined data
)
{
    return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CEidGUIApp

BEGIN_MESSAGE_MAP(CEidGUIApp, CWinApp)
	//{{AFX_MSG_MAP(CEidGUIApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEidGUIApp construction

CEidGUIApp::CEidGUIApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CEidGUIApp object

CEidGUIApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CEidGUIApp initialization

BOOL CEidGUIApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

    LoadConfiguration();

   // Map different language IDs to known language IDs
   LCID lcid = MapLanguage ();

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

    memset(m_szTempPath, 0, sizeof(m_szTempPath));
    ::GetTempPath(sizeof(m_szTempPath), m_szTempPath);

    CIdentityPage oIdentity;
    CCertificatesPage oCertificates;
    COptionsPage oOptions;
    CCardDataPage oCardData;

    CMyPropertySheet oPropSheet (_T(""));
   	m_pMainWnd = &oPropSheet;
    m_FontData = ParseFonts();
    oPropSheet.EnableStackedTabs(FALSE);
    oPropSheet.HideApplyButton (TRUE);
    oPropSheet.ShowHelpButton (FALSE);
    oPropSheet.UseHeaderCtrl(FALSE);
    oPropSheet.SetButtonsRight(FALSE);

    oPropSheet.AddPage(&oIdentity);    
    oPropSheet.AddPage(&oCertificates); 
    oPropSheet.AddPage(&oCardData);     
    oPropSheet.AddPage(&oOptions);    
	int nResponse = oPropSheet.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

    // Set the language ID back to its standard value
    SetThreadLocale (lcid);

    SaveConfiguration();

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

void CEidGUIApp::LoadConfiguration()
{
    m_Config.Load();
    
}

void CEidGUIApp::SaveConfiguration()
{
    m_Config.Save();
}

void CEidGUIApp::SwitchLanguage ()
{
    MapLanguage();
    ((CMyPropertySheet *)m_pMainWnd)->LoadStrings();

    CIdentityPage *pPageId = (CIdentityPage *)((CMyPropertySheet *)m_pMainWnd)->GetPage(0);
    if(pPageId != NULL)
    {
        pPageId->LoadStrings(); 
    }

    CCertificatesPage *pPageCert = (CCertificatesPage *)((CMyPropertySheet *)m_pMainWnd)->GetPage(1);
    if(pPageCert != NULL)
    {
        pPageCert->LoadStrings();
    }

    CCardDataPage *pPageCardData = (CCardDataPage *)((CMyPropertySheet *)m_pMainWnd)->GetPage(2);
    if(pPageCardData != NULL)
    {
        pPageCardData->LoadStrings();
    }

    COptionsPage *pPageOptions = (COptionsPage *)((CMyPropertySheet *)m_pMainWnd)->GetPage(3);
    if(pPageOptions != NULL)
    {
        pPageOptions->LoadStrings();
    }
}

LCID CEidGUIApp::MapLanguage ()
{
   LCID lcid;

   // Get the language code for the current thread
   lcid = GetThreadLocale ();
   if(m_Config.m_dwLanguage >= 0 )
   {
       switch(m_Config.m_dwLanguage)
       {
       case 0: // Dutch
         SetThreadLocale (0x0813);     // Always set to Dutch (Belgian)
           break;
       case 1: // French
         SetThreadLocale (0x080c);     // Always set to French (Belgian)
           break;
       case 2: // German
         SetThreadLocale (0x0407);     // Always set to German (Standard)
           break;
       case 3:
         SetThreadLocale (0x0809);  // Always set to English (United Kingdom)
           break;
       default:
         SetThreadLocale (0x0809);  // Always set to English (United Kingdom)
         m_Config.m_dwLanguage = 3;
           break;
       }
       return lcid;
   }
   
   switch (lcid)
   {
      case 0x0413:   // Dutch (Standard) 
      case 0x0813:   // Dutch (Belgian) 
         SetThreadLocale (0x0813);     // Always set to Dutch (Belgian)
         m_Config.m_dwLanguage = 0;
      break;
      case 0x040c:   // French (Standard) 
      case 0x080c:   // French (Belgian) 
      case 0x0c0c:   // French (Canadian) 
      case 0x100c:   // French (Swiss) 
      case 0x140c:   // French (Luxembourg) 
         SetThreadLocale (0x080c);     // Always set to French (Belgian)
         m_Config.m_dwLanguage = 1;
      break;

      case 0x0407:   // German (Standard) 
      case 0x0807:   // German (Swiss) 
      case 0x0c07:   // German (Austrian) 
      case 0x1007:   // German (Luxembourg) 
      case 0x1407:   // German (Liechtenstein) 
         SetThreadLocale (0x0407);     // Always set to German (Standard)
         m_Config.m_dwLanguage = 2;
      break;

      case 0x0409:   // English (United States) 
      case 0x0809:   // English (United Kingdom) 
      case 0x0c09:   // English (Australian) 
      case 0x1009:   // English (Canadian) 
      case 0x1409:   // English (New Zealand) 
      case 0x1809:   // English (Ireland) 
      case 0x1c09:   // English (South Africa) 
      case 0x2009:   // English (Jamaica) 
      case 0x2409:   // English (Caribbean) 
      case 0x2809:   // English (Belize) 
      case 0x2c09:   //English (Trinidad) 
         SetThreadLocale (0x0809);  // Always set to English (United Kingdom)
         m_Config.m_dwLanguage = 3;
      break;
      default:          // Unknown language
         SetThreadLocale (0x0809);  // Always set to English (United Kingdom)
         m_Config.m_dwLanguage = 3;
      break;
   }
   return (lcid);    // Return the default language ID
}



void CEidGUIApp::ReadCard()
{
    ClearPages();
    BEID_Exit();
#ifdef _TIMING_READ
    clock_t         t1, t2;        
    t1 = clock();
#endif
    long lHandle = 0;
    // Alround buffer
    BYTE buffer[4096] = {0};
    BEID_Bytes tBytes = {0};
    tBytes.length = 4096;
    tBytes.data = buffer;

    BEID_Status tStatus = {0};
    BEID_ID_Data idData = {0};
    BEID_Address adData = {0};
    BEID_Certif_Check tCheck = {0};

    CIdentityPage *pPage = (CIdentityPage *)((CMyPropertySheet *)m_pMainWnd)->GetPage(0);
    CCertificatesPage *pPageCert = (CCertificatesPage *)((CMyPropertySheet *)m_pMainWnd)->GetPage(1);
    CCardDataPage *pPageCardData = (CCardDataPage *)((CMyPropertySheet *)m_pMainWnd)->GetPage(2);
    if(pPage == NULL)
        return;

    CWaitCursor wait;

    pPage->SetRedraw(FALSE); 
    ((CMyPropertySheet *)m_pMainWnd)->SetStatusBarText(IDS_STRING_STATBAR_CONNECT_CARD);
    try
    {
#ifdef _UNICODE
        // wWinMainCRTStartup linker
        USES_CONVERSION;
        tStatus = BEID_Init(W2A((LPTSTR )(LPCTSTR)m_Config.m_StrReader), m_Config.m_dwOCSP, m_Config.m_dwCRL, &lHandle);
#else
        tStatus = BEID_Init((LPTSTR )(LPCTSTR)m_Config.m_StrReader, m_Config.m_dwOCSP, m_Config.m_dwCRL, &lHandle);
#endif
        if(BEID_OK != tStatus.general)
            throw(&tStatus);

        // Read ID Data
        ((CMyPropertySheet *)m_pMainWnd)->SetStatusBarText(IDS_STRING_STATBAR_READING_ID);
        tStatus = BEID_GetID(&idData, &tCheck);
        if(BEID_OK != tStatus.general)
            throw(&tStatus);

        long lSignatureID = tCheck.signatureCheck;
        pPage->SetIDData(&idData, tCheck.signatureCheck);
        if(pPageCert != NULL)
        {
            pPageCert->SetCertificateData(&tCheck); 
        }
        memset(&tCheck, 0, sizeof(BEID_Certif_Check));
        // Read Address Data
        ((CMyPropertySheet *)m_pMainWnd)->SetStatusBarText(IDS_STRING_STATBAR_READING_ADDRESS);
        tStatus = BEID_GetAddress(&adData, &tCheck);
        if(BEID_OK != tStatus.general)
            throw(&tStatus);

        pPage->SetAddressData(&adData, tCheck.signatureCheck);
        memset(&tCheck, 0, sizeof(BEID_Certif_Check));
        // Read Picture Data
        if(BEID_SIGNATURE_VALID == lSignatureID || BEID_SIGNATURE_VALID_WRONG_RRNCERT == lSignatureID)
        {
            ((CMyPropertySheet *)m_pMainWnd)->SetStatusBarText(IDS_STRING_STATBAR_READING_PICTURE);
            tStatus = BEID_GetPicture(&tBytes, &tCheck);
            if(BEID_OK != tStatus.general)
                throw(&tStatus);

            if(BEID_SIGNATURE_VALID == tCheck.signatureCheck && BEID_SIGNATURE_VALID_WRONG_RRNCERT == lSignatureID)
            {
                tCheck.signatureCheck = lSignatureID;
            }
            pPage->SetPictureData(&tBytes, tCheck.signatureCheck);
        }
        else
        {
            BEID_Bytes tBytesClear = {0};
            pPage->SetPictureData(&tBytesClear, BEID_SIGNATURE_INVALID, TRUE);
        }
        // Read VersionInfo
        BEID_VersionInfo tVersionInfo = {0};
        BEID_Bytes tSignature = {0};
        BYTE bufferSig[256] = {0};
        tSignature.length = 256;
        tSignature.data = bufferSig;

        ((CMyPropertySheet *)m_pMainWnd)->SetStatusBarText(IDS_STRING_STATBAR_READING_VERSION);
        tStatus = BEID_GetVersionInfo(&tVersionInfo, FALSE, &tSignature);
        if(BEID_OK != tStatus.general)
            throw(&tStatus);

        if(pPageCardData != NULL)
        {
            pPageCardData->SetVersionInfoData(&tVersionInfo); 
        }
        if(pPageCert != NULL)
        {
            pPageCert->SetVersionInfoData(&tVersionInfo);
        }

        // Read PinData
        ((CMyPropertySheet *)m_pMainWnd)->SetStatusBarText(IDS_STRING_STATBAR_READING_PINDATA);
        std::map<CString, std::vector<CPin> > PinMap;
        if( BEID_OK == ReadPINs(PinMap))
        {
            GetPINStatus(PinMap);
            if(pPageCardData != NULL)
            {
                pPageCardData->SetPINData(PinMap); 
            }
        }
        
        ((CMyPropertySheet *)m_pMainWnd)->SetStatusBarText(IDS_STRING_STATBAR_READING_DONE);
    }
    catch(BEID_Status *pStatus)
    {
        FillStatusError(pStatus);
        BEID_Exit();
    }
#ifdef _TIMING_READ
    t2 = clock();
    double elapsed = (double)(t2 - t1) / CLOCKS_PER_SEC;
    char buf[256] = {0};
    sprintf(buf, "elapsed = %lf", elapsed);
    MessageBoxA(NULL,buf,"Timer",MB_OK);
#endif
    pPage->SetRedraw(TRUE);
    pPage->RedrawWindow(); 
}

void CEidGUIApp::ClearPages()
{
     ((CMyPropertySheet *)m_pMainWnd)->SetStatusBarText(_T(""));

    // Alround buffer
    BEID_Bytes tBytes = {0};
    BEID_ID_Data idData = {0};
    BEID_Address adData = {0};

    CIdentityPage *pPageId = (CIdentityPage *)((CMyPropertySheet *)m_pMainWnd)->GetPage(0);
    if(pPageId == NULL)
        return;

    pPageId->SetIDData(&idData, BEID_SIGNATURE_PROCESSING_ERROR, TRUE);
    pPageId->SetAddressData(&adData, BEID_SIGNATURE_PROCESSING_ERROR, TRUE);
    pPageId->SetPictureData(&tBytes, BEID_SIGNATURE_PROCESSING_ERROR, TRUE);
    
    pPageId->RedrawWindow(); 

    BEID_VersionInfo tVersionInfo = {0};
    BEID_Certif_Check tCheck = {0};
    CCertificatesPage *pPageCert = (CCertificatesPage *)((CMyPropertySheet *)m_pMainWnd)->GetPage(1);
    if(pPageCert != NULL)
    {
        pPageCert->SetCertificateData(&tCheck);
        pPageCert->SetVersionInfoData(&tVersionInfo);
    }

    std::map<CString, std::vector<CPin> > PinMap;

    CCardDataPage *pPageCardData = (CCardDataPage *)((CMyPropertySheet *)m_pMainWnd)->GetPage(2);
    if(pPageCardData != NULL)
    {
        pPageCardData->SetVersionInfoData(&tVersionInfo);
        pPageCardData->SetPINData(PinMap); 
    }
}

void CEidGUIApp::FillStatusError(BEID_Status *pStatus)
{
    ASSERT(pStatus);

    CString strTemp(_T(""));
    switch (pStatus->general)
    {
    case BEID_OK:
    break;
    case BEID_E_SYSTEM:
    case BEID_E_PCSC:
        {
            LPVOID lpMsgBuf;
		    if(FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |	FORMAT_MESSAGE_FROM_SYSTEM | 
                FORMAT_MESSAGE_IGNORE_INSERTS,	NULL, pStatus->general == BEID_E_PCSC ? pStatus->pcsc : pStatus->system, 0, 
			    (LPTSTR) &lpMsgBuf,	0, NULL) != 0)
            {
                CString strPrefix;
                strPrefix.LoadString(IDS_STRING_BEID_SYSTEM_ERR);
                strTemp = strPrefix + (LPCTSTR)lpMsgBuf;
		        // Free the buffer.
		        LocalFree( lpMsgBuf );
            }
        }
        break;
    case BEID_E_CARD:
        {
            CString strFormat;
            strFormat.LoadString(IDS_STRING_BEID_E_CARD);
            strTemp.Format(strFormat, pStatus->cardSW[0], pStatus->cardSW[1]); 
        }
        break;
    default: // BEID_ERR
        strTemp.LoadString(IDS_STRING_BEID_E_BASE + pStatus->general);
        break;
    }
    ((CMyPropertySheet *)m_pMainWnd)->SetStatusBarText(strTemp);
}

CString CEidGUIApp::ParseFonts()
{
    CString strRet;
    CConfig & oConfig = GetConfig();
    CString strFonts = oConfig.m_strFonts;
    CString strFontSel;
    int iIndex = 0;
    int iStart = 0;
    long lFontSize = oConfig.m_lFontSize; 
    bool bFound = false;
    while(-1 != (iIndex = strFonts.Find(_T(","), iIndex)))
    {
        strFontSel = strFonts.Mid(iStart, iIndex - iStart);
        strFontSel.TrimLeft(); 
        strFontSel.TrimRight();
        if(IsInstalledFont(strFontSel))
        {
            strRet = strFontSel;
            bFound = true;
            break;
        }
        iStart = ++iIndex;
    }
    if(!bFound && iStart< strFonts.GetLength())
    {
        strFontSel = strFonts.Mid(iStart);
        strFontSel.TrimLeft(); 
        strFontSel.TrimRight(); 
        if(IsInstalledFont(strFontSel))
        {
            strRet = strFontSel;
        }
    }
    return strRet;
}

bool CEidGUIApp::IsInstalledFont(const CString & strFont)
{
	LOGFONT lf;
    HDC hDc = NULL;
	memset(&lf, 0, sizeof(lf));
	_tcsncpy(lf.lfFaceName, strFont, sizeof(lf.lfFaceName)/sizeof(TCHAR)-1);
    lf.lfCharSet = DEFAULT_CHARSET;
	//lf.lfHeight = GetFontHeight(lFontSize);
    hDc = ::GetDC(m_pMainWnd->m_hWnd) ; 
    int iRet = EnumFontFamiliesEx(hDc, &lf,  (FONTENUMPROC)MyEnumFontFamExProc, 0, 0);
    ::ReleaseDC (m_pMainWnd->m_hWnd, hDc);

    return iRet == 0 ? true : false;
}

char *CEidGUIApp::Hexify(unsigned char * pData, unsigned long ulLen) 
{
    char *pszHex = new char[ulLen*2 + 1];
    memset(pszHex, 0, ulLen*2 + 1);
    if(pData != NULL)
    {
        int j = 0;
        for(unsigned long i = 0; i < ulLen; i++) 
        {
            pszHex[j++] = hexChars[pData[i]>>4 & 0x0F];
            pszHex[j++] = hexChars[pData[i] & 0x0F];
         }
    }
    return pszHex;
}

long CEidGUIApp::ReadPINs(std::map<CString, std::vector<CPin> > & PinMap)
{
    long lRet = BEID_OK;

    struct sc_context *pCtx = NULL;
    struct sc_reader *pReader = NULL;
    struct sc_card *pCard = NULL;
    CString strReader(m_Config.m_StrReader);

	if( BEID_OK == sc_establish_context(&pCtx, NULL))
    {
        if(strReader.IsEmpty())
        {
            // Find a reader
            for(int i = 0; i < pCtx->reader_count; i++)
            {
                pReader = pCtx->reader[i];
                if(pReader != NULL)
                {
                    lRet = sc_connect_card(pReader, 0, &pCard);
                    if(BEID_OK == lRet)
                        break;
                    pReader = NULL;
                }
            }
        }
        else
        {
            for(int i = 0; i < pCtx->reader_count; i++)
            {
                pReader = pCtx->reader[i];
                if(0 == _tcscmp(CString(pReader->name), strReader))
                    break;
                pReader = NULL;
            }
            if(pReader != NULL)
            {
                lRet = sc_connect_card(pReader, 0, &pCard);
            }
        }

        if(pCard != NULL)
        {
            struct sc_pkcs15_card *p15Card = NULL;
            struct sc_pkcs15_pin_info *pPinInfo = NULL;

            if(BEID_OK == (lRet = sc_pkcs15_bind(pCard, &p15Card)))
            {
                // list pins
                int iNumber = 0;
                struct sc_pkcs15_object *pObjs[32];
                struct sc_pkcs15_pin_info *pPinInfo = NULL;
	            iNumber = sc_pkcs15_get_objects(p15Card, SC_PKCS15_TYPE_AUTH_PIN, pObjs, 32);
                std::vector<CPin> VecPin;

                CString strApp = p15Card->label;
                for (int i = 0; i < iNumber; i++) 
                {
                    CPin oPin;
                    pPinInfo = (struct sc_pkcs15_pin_info *)pObjs[i]->data;
                    oPin.SetReference(pPinInfo->reference);
                    oPin.SetTriesLeft(pPinInfo->tries_left);
                    oPin.SetFlags(pPinInfo->flags);
                    oPin.SetLabel(CString(pObjs[i]->label));
                    oPin.SetType(pPinInfo->type);
                    oPin.SetAuthID(pPinInfo->auth_id.value, pPinInfo->auth_id.len); 
                    oPin.SetApplication(strApp);
                    oPin.SetPinPad(p15Card->card->slot->capabilities & SC_SLOT_CAP_PIN_PAD ? true : false);
                    VecPin.push_back(oPin);
                    pPinInfo = NULL;
                }
                if(VecPin.size() > 0)
                {
                    PinMap[strApp] = VecPin;
                    VecPin.clear();
                }
            }
            if (p15Card != NULL)
            {
		        sc_pkcs15_unbind(p15Card);
            }        
        
            sc_disconnect_card(pCard, 0);
        }

        if (pCtx)
		    sc_release_context(pCtx);
    }
    return lRet;
}

void CEidGUIApp::GetPINStatus(std::map<CString, std::vector<CPin> > & PinMap)
{
    // Get Pin Status
    BEID_Status tStatus = {0};

    std::map<CString, std::vector<CPin> >::iterator it;
    for (it = PinMap.begin(); it != PinMap.end(); ++it)
    {
        for(int i = 0; i < (*it).second.size(); ++i)
        {
            CPin & oPin = (*it).second[i];
            BEID_Bytes tSignature = {0};
            BYTE bufferSig[256] = {0};
            tSignature.length = 256;
            tSignature.data = bufferSig;
            BEID_Pin tPin = {0};
            tPin.id = oPin.GetReference();
            tPin.pinType = oPin.GetType();
            char *pszUsage = Hexify(oPin.GetAuthID().GetData(), oPin.GetAuthID().GetSize());
            tPin.usageCode = atol(pszUsage);
            delete [] pszUsage;
            long lLeft = 0;
            tStatus = BEID_GetPINStatus(&tPin, &lLeft, FALSE, &tSignature);
            if(BEID_OK == tStatus.general)
            {
                oPin.SetTriesLeft(lLeft);
            }
            else
            {
                oPin.SetTriesLeft(-1);
            }
        }
    }
}

bool CEidGUIApp::ChangePin(CPin *pPin)
{
    ASSERT(pPin);
   ((CMyPropertySheet *)m_pMainWnd)->SetStatusBarText(IDS_STRING_STATBAR_CHANGING_PIN);

    BEID_Status tStatus = {0};

    BEID_Pin tPin = {0};
    tPin.id = pPin->GetReference();
    tPin.pinType = pPin->GetType();
    char *pszUsage = Hexify(pPin->GetAuthID().GetData(), pPin->GetAuthID().GetSize());
    tPin.usageCode = atol(pszUsage);
    delete [] pszUsage;
    long lLeft = 0;
    tStatus = BEID_ChangePIN(&tPin, NULL, NULL, &lLeft);
    if(BEID_OK != tStatus.general)
    {
        if(BEID_E_CARD < tStatus.general)
        {
            pPin->SetTriesLeft(-1);
        }
        else
        {
            pPin->SetTriesLeft(lLeft);
        }
        FillStatusError(&tStatus);
        if(BEID_E_PCSC == tStatus.general)
        {
            BEID_Exit();
            theApp.ClearPages();
        }
        return false;
    }
    else
    {
         pPin->SetTriesLeft(-1);
        ((CMyPropertySheet *)m_pMainWnd)->SetStatusBarText(IDS_STRING_STATBAR_CHANGING_PIN_OK);
    }
    return true;
}


int CEidGUIApp::ExitInstance() 
{
    BEID_Exit();	
	return CWinApp::ExitInstance();
}


CString CEidGUIApp::DecodeFromUTF8(char *pszUTF8)
{
    CString sFinal;
    CString sTemp;
#ifdef _UNICODE
    USES_CONVERSION;
    int iSize = 0;
    TCHAR szTemp[256] = {0};
    sTemp = A2W(pszUTF8);
    iSize = MultiByteToWideChar(CP_UTF8, 0, pszUTF8, sTemp.GetLength(), NULL, iSize);
    MultiByteToWideChar(CP_UTF8, 0, pszUTF8, sTemp.GetLength(), szTemp, sizeof(szTemp));
    sFinal = szTemp;
#else
    sFinal = pszUTF8;
#endif
    return sFinal;
}

CString CEidGUIApp::MakeTempFile()
{
    CString sFinal;
    TCHAR szFile[MAX_PATH] = {0};
    ::GetTempFileName(m_szTempPath, _T("eid"), 0, szFile);
    sFinal = szFile;
    return sFinal;
}

void CEidGUIApp::SetStatusBarText(unsigned int uiMsg)
{
   ((CMyPropertySheet *)m_pMainWnd)->SetStatusBarText(uiMsg);
}

void CEidGUIApp::ClearStatusBarText()
{
   ((CMyPropertySheet *)m_pMainWnd)->SetStatusBarText("");
}
