// eidGUI.h : main header file for the EIDGUI application
//

#if !defined(AFX_EIDGUI_H__7B8E6D84_4A1E_4BD3_AA3D_35EF90E2072E__INCLUDED_)
#define AFX_EIDGUI_H__7B8E6D84_4A1E_4BD3_AA3D_35EF90E2072E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#pragma warning(disable:4786)

#include "resource.h"		// main symbols
#include "Config.h"		// main symbols

#include <map>
#include <vector>
#include "Pin.h"

/////////////////////////////////////////////////////////////////////////////
// CEidGUIApp:
// See eidGUI.cpp for the implementation of this class
//

class CEidGUIApp : public CWinApp
{
public:
	CEidGUIApp();

    void ReadCard();
    void ClearPages();
    void LoadConfiguration();
    void SaveConfiguration();
    CConfig & GetConfig() { return m_Config; }
    CString GetDataFont() { return m_FontData; }
    char *Hexify(unsigned char * pData, unsigned long ulLen);
    bool ChangePin(CPin *pPin);
    void SwitchLanguage();
    CString DecodeFromUTF8(char *pszUTF8);
    CString MakeTempFile();
    void SetStatusBarText(unsigned int uiMsg);
    void ClearStatusBarText();

    // Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEidGUIApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CEidGUIApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

    bool IsInstalledFont(const CString & strFont);
    CString ParseFonts();
    long ReadPINs(std::map<CString, std::vector<CPin> > & PinMap);
    void GetPINStatus(std::map<CString, std::vector<CPin> > & PinMap);

private:
    static char hexChars[];
    void FillStatusError(BEID_Status *pStatus);
    LCID MapLanguage();
    CConfig m_Config;
    CString m_FontData;
    TCHAR m_szTempPath[MAX_PATH];
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EIDGUI_H__7B8E6D84_4A1E_4BD3_AA3D_35EF90E2072E__INCLUDED_)
