#include "eidviewerTypes.h"

#define BACK_RCOLOR 135
#define BACK_GCOLOR 207
#define BACK_BCOLOR 163

#include <wx/datetime.h>

void ASN1_TIME_Print(ASN1_TIME *tm, wxString & strTime)
{
    strTime.Empty();
	if(tm->type == V_ASN1_UTCTIME)
        ASN1_UTCTIME_Print(tm, strTime);
	if(tm->type == V_ASN1_GENERALIZEDTIME)
		ASN1_GENERALIZEDTIME_Print(tm, strTime);
}

void ASN1_GENERALIZEDTIME_Print(ASN1_GENERALIZEDTIME *tm, wxString & strTime)
{
	char *v;
	int gmt=0;
	int i;
	int y=0,M=0,d=0,h=0,m=0,s=0;

	i=tm->length;
	v=(char *)tm->data;

	if (i < 12) return;
	if (v[i-1] == 'Z') gmt=1;
	for (i=0; i<12; i++)
		if ((v[i] > '9') || (v[i] < '0')) return;
	y= (v[0]-'0')*1000+(v[1]-'0')*100 + (v[2]-'0')*10+(v[3]-'0');
	M= (v[4]-'0')*10+(v[5]-'0');
	if ((M > 12) || (M < 1)) return;
	d= (v[6]-'0')*10+(v[7]-'0');
	h= (v[8]-'0')*10+(v[9]-'0');
	m=  (v[10]-'0')*10+(v[11]-'0');
	if (	(v[12] >= '0') && (v[12] <= '9') &&
		(v[13] >= '0') && (v[13] <= '9'))
		s=  (v[12]-'0')*10+(v[13]-'0');

    wxDateTime oDateTime(d, (wxDateTime::Month)(M -1), y+1900, h, m, s);
/*    SYSTEMTIME tSysTimeLocal = {0};
    tSysTimeLocal.wYear = y+1900;
    tSysTimeLocal.wMonth = M;
    tSysTimeLocal.wDay = d;
    tSysTimeLocal.wHour = h;
    tSysTimeLocal.wMinute = m;
    tSysTimeLocal.wSecond = s;*/
    if(gmt == 1)
    {
        oDateTime.MakeGMT();
        /*FILETIME tFileTime = {0};
        FILETIME tFileTimeLocal = {0};

        ::SystemTimeToFileTime(&tSysTimeLocal, &tFileTime); 
        ::FileTimeToLocalFileTime(&tFileTime, &tFileTimeLocal);
        memset(&tSysTimeLocal, 0, sizeof(SYSTEMTIME));
        ::FileTimeToSystemTime(&tFileTimeLocal, &tSysTimeLocal); */
    }

    strTime = oDateTime.FormatDate();
    /*COleDateTime oDate( tSysTimeLocal.wYear, tSysTimeLocal.wMonth, tSysTimeLocal.wDay, 
        tSysTimeLocal.wHour, tSysTimeLocal.wMinute, tSysTimeLocal.wSecond );
    strTime = oDate.Format(VAR_DATEVALUEONLY);*/
}

void ASN1_UTCTIME_Print(ASN1_UTCTIME *tm, wxString & strTime)
{
	char *v;
	int gmt=0;
	int i;
	int y=0,M=0,d=0,h=0,m=0,s=0;

	i=tm->length;
	v=(char *)tm->data;

	if (i < 10) return;
	if (v[i-1] == 'Z') gmt=1;
	for (i=0; i<10; i++)
		if ((v[i] > '9') || (v[i] < '0')) return;
	y= (v[0]-'0')*10+(v[1]-'0');
	if (y < 50) y+=100;
	M= (v[2]-'0')*10+(v[3]-'0');
	if ((M > 12) || (M < 1)) return;
	d= (v[4]-'0')*10+(v[5]-'0');
	h= (v[6]-'0')*10+(v[7]-'0');
	m=  (v[8]-'0')*10+(v[9]-'0');
	if (	(v[10] >= '0') && (v[10] <= '9') &&
		(v[11] >= '0') && (v[11] <= '9'))
		s=  (v[10]-'0')*10+(v[11]-'0');

    wxDateTime oDateTime(d, (wxDateTime::Month)(M -1), y+1900, h, m, s);
/*    SYSTEMTIME tSysTimeLocal = {0};
    tSysTimeLocal.wYear = y+1900;
    tSysTimeLocal.wMonth = M;
    tSysTimeLocal.wDay = d;
    tSysTimeLocal.wHour = h;
    tSysTimeLocal.wMinute = m;
    tSysTimeLocal.wSecond = s;*/
    if(gmt == 1)
    {
        oDateTime.MakeGMT();
        /*FILETIME tFileTime = {0};
        FILETIME tFileTimeLocal = {0};

        ::SystemTimeToFileTime(&tSysTimeLocal, &tFileTime); 
        ::FileTimeToLocalFileTime(&tFileTime, &tFileTimeLocal);
        memset(&tSysTimeLocal, 0, sizeof(SYSTEMTIME));
        ::FileTimeToSystemTime(&tFileTimeLocal, &tSysTimeLocal); */
    }

    strTime = oDateTime.FormatDate();
    /*COleDateTime oDate( tSysTimeLocal.wYear, tSysTimeLocal.wMonth, tSysTimeLocal.wDay, 
        tSysTimeLocal.wHour, tSysTimeLocal.wMinute, tSysTimeLocal.wSecond );
    strTime = oDate.Format(VAR_DATEVALUEONLY);*/
}

wxBitmap eidBitmapsFunc( size_t index )
{
    if (index == 0)
    {
        static const unsigned char data[] = 
        {
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,132,223,116,173,0,13,169,0,22,171,0,16,144,143,86,145,135,83,158,48,51,171,
            0,16,160,32,45,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,172,0,18,165,0,35,165,0,35,165,0,35,167,0,29,167,0,
            29,166,0,32,165,0,35,170,0,23,134,215,113,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,146,127,82,173,0,18,169,0,27,165,0,36,165,0,36,165,0,36,165,0,36,
            165,0,36,165,0,36,165,0,36,165,0,36,167,0,33,155,72,62,171,0,21,170,0,24,159,
            40,50,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,149,111,78,147,127,83,149,111,78,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,148,128,84,171,0,28,167,0,39,167,0,39,167,0,39,167,0,39,167,
            0,39,167,0,39,167,0,39,167,0,39,167,0,39,167,0,39,167,0,39,168,0,36,167,0,
            39,167,0,39,169,0,34,162,32,51,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,134,215,114,161,40,54,171,0,32,169,0,
            34,174,0,23,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,174,0,23,167,0,40,167,0,40,167,0,40,167,0,
            40,167,0,40,167,0,40,167,0,40,167,0,40,167,0,40,167,0,40,167,0,40,167,0,40,
            167,0,40,167,0,40,167,0,40,167,0,40,169,0,34,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,132,223,117,175,0,26,169,0,40,
            167,0,42,167,0,42,172,0,32,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,147,128,85,170,0,37,167,0,42,167,0,42,
            167,0,42,167,0,42,167,0,42,167,0,42,167,0,42,167,0,42,167,0,42,167,0,42,167,
            0,42,167,0,42,167,0,42,167,0,42,167,0,42,167,0,42,167,0,42,169,0,40,174,0,
            29,161,40,56,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,148,127,87,175,0,32,169,
            0,46,169,0,46,169,0,46,169,0,46,170,0,43,162,48,61,147,135,89,148,127,87,147,135,
            89,162,48,61,175,0,32,174,0,35,178,0,27,133,223,118,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,175,0,32,169,0,46,169,
            0,46,169,0,46,169,0,46,169,0,46,169,0,46,169,0,46,169,0,46,169,0,46,169,0,
            46,169,0,46,169,0,46,169,0,46,169,0,46,169,0,46,169,0,46,169,0,46,169,0,46,
            169,0,46,169,0,46,170,0,43,173,0,38,174,0,35,174,0,35,175,0,32,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,148,127,86,179,0,34,173,0,
            43,171,0,49,171,0,49,171,0,49,171,0,49,171,0,49,171,0,49,172,0,46,173,0,43,
            173,0,43,173,0,43,172,0,46,171,0,49,171,0,49,171,0,49,178,0,33,133,223,118,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,164,40,61,176,0,38,171,0,
            49,171,0,49,171,0,49,171,0,49,171,0,49,171,0,49,171,0,49,171,0,49,171,0,49,
            171,0,49,171,0,49,171,0,49,171,0,49,171,0,49,171,0,49,171,0,49,171,0,49,171,
            0,49,171,0,49,171,0,49,171,0,49,171,0,49,171,0,49,171,0,49,171,0,49,171,0,
            49,173,0,43,165,32,58,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,147,127,84,176,0,28,172,0,40,
            171,0,49,172,0,51,172,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,
            0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,
            52,178,0,39,147,143,95,149,127,90,151,119,87,135,207,163,164,40,64,177,0,42,173,0,49,
            171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,
            0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,
            52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,171,0,52,
            171,0,52,171,0,52,171,0,52,174,0,47,164,40,64,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,133,223,117,176,0,21,170,0,36,169,
            0,44,170,0,45,171,0,49,172,0,51,171,0,53,174,0,55,174,0,55,174,0,55,174,0,
            55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,
            174,0,55,174,0,55,174,0,55,176,0,50,176,0,50,176,0,50,178,0,47,175,0,52,174,
            0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,
            55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,
            174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,
            0,55,174,0,55,174,0,55,174,0,55,174,0,55,174,0,55,175,0,52,179,0,45,165,48,
            68,150,127,91,136,207,114,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,161,32,48,171,0,27,168,0,
            41,167,0,41,169,0,44,170,0,45,171,0,49,172,0,51,171,0,52,175,0,56,175,0,57,
            175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,
            0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,
            58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,
            175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,
            0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,
            58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,175,0,58,
            175,0,58,177,0,55,178,0,53,184,0,44,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,132,223,116,174,0,15,167,0,34,
            167,0,39,168,0,41,167,0,41,169,0,44,170,0,45,171,0,49,172,0,51,171,0,52,175,
            0,56,176,0,58,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,
            60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,
            176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,
            0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,
            60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,
            176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,
            0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,184,0,45,134,223,119,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,146,127,80,170,0,20,166,
            0,36,165,0,36,167,0,39,168,0,41,167,0,41,169,0,44,170,0,45,171,0,49,172,0,
            51,171,0,52,175,0,56,176,0,57,177,0,61,178,0,64,179,0,65,179,0,65,179,0,65,
            179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,
            0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,
            65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,
            179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,
            0,65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,175,0,58,179,0,65,179,0,
            65,179,0,65,179,0,65,179,0,65,179,0,65,179,0,65,178,0,65,177,0,62,176,0,58,
            186,0,38,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,171,0,
            16,164,0,35,166,0,36,165,0,36,167,0,39,168,0,41,167,0,41,169,0,44,170,0,45,
            171,0,49,172,0,51,171,0,52,175,0,56,176,0,57,177,0,61,177,0,64,180,0,66,180,
            0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,
            67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,
            180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,
            0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,
            67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,
            180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,179,0,65,176,
            0,62,177,0,56,169,32,66,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,169,0,22,164,0,35,166,0,36,165,0,36,167,0,39,168,0,41,167,0,41,169,
            0,44,170,0,45,171,0,49,172,0,51,171,0,52,175,0,56,176,0,57,177,0,61,177,0,
            64,180,0,65,181,0,69,182,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,
            181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,
            0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,
            71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,
            181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,
            0,71,181,0,71,181,0,71,181,0,71,181,0,71,181,0,71,182,0,71,182,0,70,181,0,
            68,179,0,65,176,0,62,184,0,45,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,169,0,22,164,0,35,166,0,36,165,0,36,167,0,39,168,0,
            41,167,0,41,169,0,44,170,0,45,171,0,49,172,0,51,171,0,52,175,0,56,176,0,57,
            177,0,61,177,0,64,180,0,65,180,0,69,183,0,72,184,0,74,184,0,74,184,0,74,184,
            0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,
            74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,
            184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,
            0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,
            74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,74,184,0,75,183,0,72,
            182,0,70,181,0,68,179,0,65,179,0,57,148,144,98,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,169,0,22,164,0,35,166,0,36,165,0,36,
            167,0,39,168,0,41,167,0,41,169,0,44,170,0,45,171,0,49,172,0,51,171,0,52,175,
            0,56,176,0,57,177,0,61,177,0,64,180,0,65,180,0,69,183,0,72,185,0,75,186,0,
            77,186,0,77,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,
            185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,
            0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,
            76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,
            185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,77,186,0,77,185,
            0,76,182,0,71,182,0,70,181,0,68,179,0,65,179,0,57,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,134,215,113,168,0,25,164,0,35,166,
            0,36,165,0,36,167,0,39,168,0,41,167,0,41,169,0,44,170,0,45,171,0,49,172,0,
            51,171,0,52,175,0,56,176,0,57,177,0,61,177,0,64,180,0,65,180,0,69,183,0,72,
            185,0,75,186,0,77,187,0,77,188,0,81,188,0,80,188,0,80,188,0,80,188,0,80,188,
            0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,
            80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,
            188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,
            0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,80,188,0,
            79,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,179,0,65,185,0,49,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,167,0,
            28,164,0,35,166,0,36,165,0,36,167,0,39,168,0,41,167,0,41,169,0,44,170,0,45,
            171,0,49,172,0,51,171,0,52,175,0,56,176,0,57,177,0,61,177,0,64,180,0,65,180,
            0,69,183,0,72,185,0,75,186,0,77,186,0,77,189,0,82,189,0,82,189,0,82,189,0,
            82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,
            189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,
            0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,
            82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,
            189,0,83,188,0,78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,182,0,60,149,
            144,98,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,167,0,28,164,0,35,166,0,36,165,0,36,167,0,39,168,0,41,167,0,41,169,
            0,44,170,0,45,171,0,49,172,0,51,171,0,52,175,0,56,176,0,57,177,0,61,177,0,
            64,180,0,65,180,0,69,183,0,72,185,0,75,186,0,77,186,0,77,189,0,82,190,0,82,
            191,0,85,192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,192,
            0,86,192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,192,0,
            86,192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,
            192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,192,0,86,191,
            0,85,191,0,84,190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,
            68,182,0,60,152,128,94,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,134,215,113,169,0,22,164,0,35,166,0,36,165,0,36,167,0,39,168,0,
            41,167,0,41,169,0,44,170,0,45,171,0,49,172,0,51,171,0,52,175,0,56,176,0,57,
            177,0,61,177,0,64,180,0,65,180,0,69,183,0,72,185,0,75,186,0,77,186,0,77,189,
            0,82,190,0,82,190,0,84,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,
            87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,
            193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,
            0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,
            87,193,0,87,192,0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,
            182,0,70,181,0,68,182,0,60,152,128,94,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,160,32,45,167,0,29,166,0,36,165,0,36,
            167,0,39,168,0,41,167,0,41,169,0,44,170,0,45,171,0,49,172,0,51,171,0,52,175,
            0,56,176,0,57,177,0,61,177,0,64,180,0,65,180,0,69,183,0,72,185,0,75,186,0,
            77,186,0,77,189,0,82,190,0,82,190,0,84,194,0,88,195,0,89,195,0,91,195,0,90,
            195,0,90,195,0,90,195,0,90,195,0,90,195,0,90,195,0,90,195,0,90,195,0,90,195,
            0,90,195,0,90,195,0,90,195,0,90,195,0,90,195,0,90,195,0,90,195,0,90,195,0,
            90,195,0,90,195,0,90,195,0,90,195,0,90,195,0,90,195,0,90,195,0,90,195,0,90,
            195,0,90,195,0,90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,
            0,76,182,0,71,182,0,70,181,0,68,182,0,60,149,144,98,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,160,32,46,168,
            0,30,165,0,36,167,0,39,168,0,41,167,0,41,169,0,44,170,0,45,171,0,49,172,0,
            51,171,0,52,175,0,56,176,0,57,177,0,61,177,0,64,180,0,65,180,0,69,183,0,72,
            185,0,75,186,0,77,186,0,77,189,0,82,190,0,82,190,0,84,194,0,88,195,0,88,196,
            0,91,196,0,92,196,0,91,196,0,91,196,0,91,196,0,91,196,0,91,196,0,91,196,0,
            91,196,0,91,196,0,91,196,0,91,196,0,91,196,0,91,196,0,91,196,0,91,196,0,91,
            196,0,91,196,0,91,196,0,91,196,0,91,196,0,91,196,0,91,196,0,91,196,0,91,196,
            0,91,196,0,92,196,0,91,195,0,90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,
            78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,179,0,65,181,0,55,169,32,67,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,161,32,47,167,0,34,167,0,39,168,0,41,167,0,41,169,0,44,170,0,45,
            171,0,49,176,0,43,177,0,43,179,0,49,176,0,57,177,0,61,177,0,64,180,0,65,180,
            0,69,183,0,72,185,0,75,186,0,77,186,0,77,189,0,82,190,0,82,190,0,84,194,0,
            88,195,0,88,196,0,91,197,0,93,198,0,94,198,0,94,198,0,94,198,0,94,198,0,94,
            198,0,94,198,0,94,198,0,94,198,0,94,198,0,94,198,0,94,198,0,94,198,0,94,198,
            0,94,198,0,94,198,0,94,198,0,94,198,0,94,198,0,94,198,0,94,198,0,94,198,0,
            94,198,0,94,198,0,94,198,0,94,195,0,90,195,0,90,194,0,88,191,0,86,191,0,83,
            190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,
            0,62,178,0,54,167,40,68,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,174,0,16,167,0,39,168,0,41,167,0,41,169,
            0,44,172,0,40,180,0,32,133,223,119,135,207,163,134,223,119,183,0,46,177,0,61,177,0,
            64,180,0,65,180,0,69,183,0,72,185,0,75,186,0,77,186,0,77,189,0,82,190,0,82,
            190,0,84,194,0,88,195,0,88,196,0,91,197,0,93,198,0,94,199,0,95,199,0,95,199,
            0,95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,
            95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,95,
            199,0,95,199,0,95,199,0,95,199,0,95,198,0,94,195,0,90,195,0,90,194,0,88,191,
            0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,
            68,179,0,65,176,0,62,176,0,58,176,0,54,179,0,42,147,143,94,150,127,89,150,119,84,
            136,207,112,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,132,223,116,175,0,19,170,0,
            35,169,0,39,175,0,31,149,127,87,135,207,163,135,207,163,135,207,163,135,207,163,151,128,94,
            180,0,56,177,0,64,180,0,65,180,0,69,183,0,72,185,0,75,186,0,77,186,0,77,189,
            0,82,190,0,82,190,0,84,194,0,88,195,0,88,196,0,91,197,0,93,198,0,94,199,0,
            94,200,0,97,200,0,97,200,0,97,200,0,97,200,0,97,200,0,97,200,0,97,200,0,97,
            200,0,97,200,0,97,200,0,97,200,0,97,200,0,97,200,0,97,200,0,97,200,0,97,200,
            0,97,200,0,97,200,0,97,200,0,97,198,0,96,199,0,95,198,0,94,195,0,90,195,0,
            90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,
            182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,53,174,0,47,175,
            0,45,172,0,41,176,0,29,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,149,119,81,164,24,50,134,215,115,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,183,0,52,177,0,64,180,0,65,180,0,69,183,0,72,185,0,75,186,0,
            77,186,0,77,189,0,82,190,0,82,190,0,84,194,0,88,195,0,88,196,0,91,197,0,93,
            198,0,94,199,0,94,200,0,97,199,0,98,200,0,98,200,0,98,200,0,98,200,0,98,200,
            0,98,200,0,98,200,0,98,200,0,98,200,0,98,200,0,98,200,0,98,200,0,98,200,0,
            98,200,0,98,200,0,98,200,0,98,199,0,98,200,0,97,198,0,96,199,0,95,198,0,94,
            195,0,90,195,0,90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,
            0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,
            53,171,0,52,172,0,50,169,0,46,169,0,45,175,0,26,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,184,0,50,177,0,64,180,0,65,180,0,69,183,0,72,
            185,0,75,186,0,77,186,0,77,189,0,82,190,0,82,190,0,84,194,0,88,195,0,88,196,
            0,91,197,0,93,198,0,94,199,0,94,200,0,97,199,0,98,201,0,97,201,0,98,200,0,
            98,200,0,98,200,0,98,200,0,98,200,0,98,200,0,98,200,0,98,200,0,98,200,0,98,
            200,0,98,200,0,98,200,0,98,200,0,98,201,0,97,199,0,98,200,0,97,198,0,96,199,
            0,95,198,0,94,195,0,90,195,0,90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,
            78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,
            175,0,57,172,0,53,171,0,52,172,0,50,169,0,46,169,0,45,167,0,43,173,0,29,161,
            40,53,138,191,106,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,168,48,73,179,0,62,180,0,65,180,
            0,69,183,0,72,185,0,75,186,0,77,186,0,77,189,0,82,190,0,82,190,0,84,194,0,
            88,195,0,88,196,0,91,197,0,93,198,0,94,199,0,94,200,0,97,199,0,98,201,0,97,
            200,0,99,202,0,99,202,0,99,202,0,99,202,0,99,202,0,99,202,0,99,202,0,99,202,
            0,99,202,0,99,202,0,99,202,0,99,202,0,99,202,0,99,201,0,97,199,0,98,200,0,
            97,198,0,96,199,0,95,198,0,94,195,0,90,195,0,90,194,0,88,191,0,86,191,0,83,
            190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,
            0,62,176,0,58,175,0,57,172,0,53,171,0,52,172,0,50,169,0,46,169,0,45,167,0,
            43,168,0,40,171,0,28,136,199,108,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,151,136,96,180,0,
            59,180,0,65,180,0,69,183,0,72,185,0,75,186,0,77,186,0,77,189,0,82,190,0,82,
            190,0,84,194,0,88,195,0,88,196,0,91,197,0,93,198,0,94,199,0,94,200,0,97,199,
            0,98,201,0,97,200,0,99,202,0,98,201,0,100,202,0,99,202,0,99,202,0,99,202,0,
            99,202,0,99,202,0,99,202,0,99,202,0,99,202,0,100,201,0,100,202,0,99,201,0,97,
            199,0,98,200,0,97,198,0,96,199,0,95,198,0,94,195,0,90,195,0,90,194,0,88,191,
            0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,
            68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,53,171,0,52,172,0,50,169,0,46,
            169,0,45,167,0,43,168,0,40,171,0,28,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            153,128,94,180,0,59,180,0,65,180,0,69,183,0,72,185,0,75,186,0,77,186,0,77,189,
            0,82,190,0,82,190,0,84,194,0,88,195,0,88,196,0,91,197,0,93,198,0,94,199,0,
            94,200,0,97,199,0,98,201,0,97,200,0,99,202,0,98,201,0,100,203,0,101,203,0,101,
            203,0,101,203,0,101,203,0,101,203,0,101,203,0,101,203,0,101,203,0,99,201,0,100,202,
            0,99,201,0,97,199,0,98,200,0,97,198,0,96,199,0,95,198,0,94,195,0,90,195,0,
            90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,
            182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,53,171,0,52,172,
            0,50,169,0,46,169,0,45,167,0,43,168,0,40,174,0,23,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,156,112,90,184,0,55,180,0,65,184,0,65,186,0,68,188,0,71,186,0,
            77,186,0,77,189,0,82,190,0,82,190,0,84,194,0,88,195,0,88,196,0,91,197,0,93,
            198,0,94,199,0,94,200,0,97,199,0,98,201,0,97,200,0,99,202,0,98,201,0,100,203,
            0,101,203,0,101,203,0,101,202,0,100,202,0,100,203,0,101,203,0,101,203,0,101,203,0,
            99,201,0,100,202,0,99,201,0,97,199,0,98,200,0,97,198,0,96,199,0,95,198,0,94,
            195,0,90,195,0,90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,
            0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,
            53,171,0,52,172,0,50,169,0,46,169,0,45,167,0,43,170,0,35,143,160,94,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,152,127,95,193,0,50,151,143,102,155,127,100,
            152,143,104,195,0,69,186,0,77,189,0,82,190,0,82,190,0,84,194,0,88,195,0,88,196,
            0,91,197,0,93,198,0,94,199,0,94,200,0,97,199,0,98,201,0,97,200,0,99,202,0,
            98,201,0,100,203,0,101,203,0,101,202,0,100,204,0,102,204,0,102,202,0,100,203,0,101,
            203,0,101,203,0,99,201,0,100,202,0,99,201,0,97,199,0,98,200,0,97,198,0,96,199,
            0,95,198,0,94,195,0,90,195,0,90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,
            78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,
            175,0,57,172,0,53,171,0,52,172,0,50,169,0,46,169,0,45,167,0,43,168,0,40,170,
            0,31,162,32,49,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,197,0,68,189,0,82,190,0,82,190,0,84,194,0,
            88,195,0,88,196,0,91,197,0,93,198,0,94,199,0,94,200,0,97,199,0,98,201,0,97,
            200,0,99,202,0,98,201,0,100,203,0,101,203,0,101,202,0,100,203,0,101,203,0,101,202,
            0,100,203,0,101,203,0,101,203,0,99,201,0,100,202,0,99,201,0,97,199,0,98,200,0,
            97,198,0,96,199,0,95,198,0,94,195,0,90,195,0,90,194,0,88,191,0,86,191,0,83,
            190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,
            0,62,176,0,58,175,0,57,172,0,53,171,0,52,172,0,50,169,0,46,169,0,45,167,0,
            43,168,0,40,166,0,40,168,0,35,174,0,17,132,223,116,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,223,122,196,0,76,190,0,82,
            190,0,84,194,0,88,195,0,88,196,0,91,197,0,93,198,0,94,199,0,94,200,0,97,199,
            0,98,201,0,97,200,0,99,202,0,98,201,0,100,203,0,101,203,0,101,203,0,101,202,0,
            101,202,0,101,203,0,101,203,0,101,203,0,101,203,0,99,201,0,100,202,0,99,201,0,97,
            199,0,98,200,0,97,198,0,96,199,0,95,198,0,94,195,0,90,195,0,90,194,0,88,191,
            0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,
            68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,53,171,0,52,172,0,50,169,0,46,
            169,0,45,167,0,43,168,0,40,166,0,40,167,0,37,166,0,37,169,0,23,160,32,45,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,177,
            48,90,191,0,81,190,0,84,194,0,88,195,0,88,196,0,91,197,0,93,198,0,94,199,0,
            94,200,0,97,199,0,98,201,0,97,200,0,99,202,0,98,201,0,100,203,0,100,203,0,100,
            203,0,100,203,0,100,203,0,100,203,0,100,203,0,100,203,0,100,203,0,99,201,0,100,202,
            0,99,201,0,97,199,0,98,200,0,97,198,0,96,199,0,95,198,0,94,195,0,90,195,0,
            90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,
            182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,53,171,0,52,172,
            0,50,169,0,46,169,0,45,167,0,43,168,0,40,166,0,40,167,0,37,166,0,37,164,0,
            34,168,0,25,149,112,75,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,159,128,104,193,0,80,190,0,84,194,0,88,199,0,86,200,0,88,201,0,90,
            198,0,94,199,0,94,200,0,97,199,0,98,201,0,97,200,0,99,202,0,98,202,0,100,202,
            0,100,202,0,100,202,0,100,202,0,100,202,0,100,202,0,100,202,0,100,202,0,100,202,0,
            100,202,0,100,202,0,99,201,0,97,199,0,98,200,0,97,198,0,96,199,0,95,198,0,94,
            195,0,90,195,0,90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,
            0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,
            53,171,0,52,172,0,50,169,0,46,169,0,45,167,0,43,168,0,40,166,0,40,167,0,37,
            166,0,37,164,0,34,167,0,28,148,120,78,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,139,207,119,203,0,72,198,0,79,206,0,80,157,143,110,162,
            127,109,158,143,112,135,207,163,201,0,93,200,0,97,199,0,98,201,0,97,200,0,99,201,0,
            99,201,0,98,201,0,98,201,0,98,201,0,98,201,0,98,201,0,98,201,0,98,201,0,98,
            201,0,98,201,0,98,201,0,98,201,0,99,201,0,97,199,0,98,200,0,97,198,0,96,199,
            0,95,198,0,94,195,0,90,195,0,90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,
            78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,
            175,0,57,172,0,53,171,0,52,172,0,50,169,0,46,169,0,45,167,0,43,168,0,40,166,
            0,40,167,0,37,166,0,37,166,0,31,171,0,16,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,190,32,99,209,0,93,202,0,97,201,0,97,
            201,0,98,201,0,98,201,0,98,201,0,98,201,0,98,201,0,98,201,0,98,201,0,98,201,
            0,98,201,0,98,201,0,98,201,0,98,201,0,98,201,0,98,201,0,97,199,0,98,200,0,
            97,198,0,96,199,0,95,198,0,94,195,0,90,195,0,90,194,0,88,191,0,86,191,0,83,
            190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,
            0,62,176,0,58,175,0,57,172,0,53,171,0,52,172,0,50,169,0,46,169,0,45,167,0,
            43,168,0,40,166,0,40,167,0,37,168,0,31,159,40,49,134,215,113,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,139,215,123,188,
            40,102,204,0,96,199,0,98,199,0,98,199,0,98,199,0,98,199,0,98,199,0,98,199,0,
            98,199,0,98,199,0,98,199,0,98,199,0,98,199,0,98,199,0,98,199,0,98,199,0,98,
            200,0,98,200,0,97,198,0,96,199,0,95,198,0,94,195,0,90,195,0,90,194,0,88,191,
            0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,
            68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,53,171,0,52,172,0,50,169,0,46,
            169,0,45,167,0,43,168,0,40,166,0,40,169,0,32,161,32,48,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,188,40,101,201,0,95,199,0,96,199,0,96,199,0,96,199,0,96,
            199,0,96,199,0,96,199,0,96,199,0,96,199,0,96,199,0,96,199,0,96,199,0,96,199,
            0,96,199,0,96,199,0,96,199,0,96,198,0,96,199,0,95,198,0,94,195,0,90,195,0,
            90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,
            182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,53,171,0,52,172,
            0,50,169,0,46,169,0,45,167,0,43,168,0,40,168,0,37,161,40,52,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,139,215,123,205,0,91,199,0,95,199,0,95,199,
            0,95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,
            95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,95,199,0,95,198,0,94,
            195,0,90,195,0,90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,
            0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,
            53,171,0,52,172,0,50,169,0,46,169,0,45,167,0,43,168,0,40,174,0,23,134,215,114,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,208,0,88,197,0,
            93,197,0,93,197,0,93,197,0,93,197,0,93,197,0,93,197,0,93,197,0,93,197,0,93,
            197,0,93,197,0,93,197,0,93,197,0,93,197,0,93,197,0,93,197,0,93,197,0,93,197,
            0,93,197,0,93,195,0,90,195,0,90,194,0,88,191,0,86,191,0,83,190,0,83,188,0,
            78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,
            175,0,57,172,0,53,171,0,52,172,0,50,169,0,46,169,0,45,167,0,43,175,0,24,133,
            223,116,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            179,64,101,198,0,91,196,0,92,196,0,92,196,0,92,196,0,92,196,0,92,196,0,92,196,
            0,92,196,0,92,196,0,92,196,0,92,196,0,92,196,0,92,196,0,92,196,0,92,196,0,
            92,196,0,92,196,0,92,196,0,92,196,0,91,195,0,90,194,0,88,191,0,86,191,0,83,
            190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,
            0,62,176,0,58,175,0,57,172,0,53,171,0,52,172,0,50,171,0,44,172,0,37,176,0,
            24,133,223,117,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,204,0,82,194,0,88,194,0,88,194,0,88,194,0,88,194,0,88,194,0,
            88,194,0,88,194,0,88,194,0,88,194,0,88,194,0,88,196,0,87,194,0,88,194,0,88,
            194,0,88,194,0,88,194,0,88,194,0,88,194,0,88,194,0,88,194,0,89,194,0,88,191,
            0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,
            68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,53,171,0,52,176,0,42,163,40,59,
            134,215,115,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,201,0,82,193,0,87,193,0,87,193,0,87,193,0,87,
            193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,197,0,84,177,64,98,203,
            0,80,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,87,193,0,
            87,193,0,87,192,0,86,191,0,83,190,0,83,188,0,78,185,0,76,185,0,76,182,0,71,
            182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,53,174,0,47,150,
            128,90,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,198,0,79,190,0,85,190,0,85,190,
            0,85,190,0,85,190,0,85,190,0,85,190,0,85,190,0,85,190,0,85,192,0,83,181,40,
            91,135,207,163,135,207,163,198,0,79,190,0,85,190,0,85,190,0,85,190,0,85,190,0,85,
            190,0,85,190,0,85,190,0,85,191,0,85,191,0,84,190,0,83,188,0,78,185,0,76,185,
            0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,175,0,57,172,0,
            53,177,0,42,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,161,120,104,193,0,79,189,0,
            82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,
            199,0,75,135,207,163,135,207,163,135,207,163,197,0,76,189,0,82,189,0,82,189,0,82,189,
            0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,82,189,0,83,188,0,
            78,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,
            175,0,57,172,0,53,180,0,37,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,176,48,88,
            190,0,77,188,0,78,188,0,78,188,0,78,188,0,78,188,0,78,188,0,78,188,0,78,188,
            0,78,197,0,70,157,128,103,135,207,163,135,207,163,139,207,119,193,0,74,188,0,78,188,0,
            78,188,0,78,188,0,78,188,0,78,175,0,58,188,0,78,188,0,78,188,0,78,188,0,78,
            188,0,78,188,0,79,185,0,76,185,0,76,182,0,71,182,0,70,181,0,68,179,0,65,176,
            0,62,176,0,58,175,0,57,175,0,49,147,144,95,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,197,0,65,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,
            76,185,0,76,196,0,66,135,223,121,135,207,163,135,207,163,135,207,163,160,112,99,188,0,73,
            185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,
            0,76,185,0,76,185,0,76,185,0,76,185,0,76,185,0,76,182,0,71,182,0,70,181,0,
            68,179,0,65,176,0,62,176,0,58,175,0,57,175,0,49,152,112,86,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,190,0,65,187,0,69,187,0,69,187,0,69,184,0,72,
            185,0,71,187,0,69,196,0,60,134,223,121,135,207,163,135,207,163,135,207,163,135,207,163,138,
            207,117,189,0,67,184,0,72,184,0,72,184,0,72,184,0,72,184,0,72,184,0,72,184,0,
            72,184,0,72,184,0,72,184,0,72,184,0,72,184,0,72,184,0,72,184,0,73,183,0,72,
            182,0,70,181,0,68,179,0,65,176,0,62,176,0,58,175,0,57,181,0,39,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,158,111,95,154,127,99,154,127,99,151,
            143,102,192,0,56,171,48,81,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,188,0,62,181,0,69,181,0,69,181,0,69,181,0,69,181,0,69,
            181,0,69,181,0,69,181,0,69,181,0,69,181,0,69,181,0,69,181,0,69,181,0,69,181,
            0,69,181,0,70,181,0,69,181,0,68,179,0,65,176,0,62,176,0,58,179,0,50,151,128,
            92,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,187,0,60,180,0,67,180,0,67,180,0,67,180,
            0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,67,180,0,
            67,180,0,67,180,0,67,180,0,67,180,0,67,181,0,67,179,0,65,176,0,62,177,0,56,
            169,32,66,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,183,0,54,177,0,62,177,0,
            62,177,0,62,177,0,62,177,0,62,177,0,62,177,0,62,177,0,62,177,0,62,177,0,62,
            177,0,62,177,0,62,177,0,62,177,0,62,177,0,62,177,0,62,177,0,62,177,0,63,177,
            0,62,183,0,47,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,182,0,52,
            176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,
            0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,60,176,0,
            60,176,0,60,178,0,58,164,64,76,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,180,0,48,175,0,56,175,0,56,175,0,56,175,0,56,175,0,56,175,0,56,175,0,
            56,175,0,56,175,0,56,175,0,56,175,0,56,175,0,56,175,0,56,175,0,56,175,0,56,
            175,0,56,175,0,56,175,0,56,175,0,56,182,0,46,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,184,0,35,178,0,44,178,0,44,175,0,49,172,0,54,172,0,54,
            172,0,54,172,0,54,172,0,54,172,0,54,172,0,54,172,0,54,172,0,54,172,0,54,172,
            0,54,172,0,54,172,0,54,172,0,54,172,0,54,172,0,54,175,0,49,150,128,92,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,180,
            0,36,176,0,43,172,0,51,172,0,51,172,0,51,172,0,51,172,0,51,172,0,51,172,0,
            51,172,0,51,172,0,51,172,0,51,172,0,51,172,0,51,172,0,51,172,0,51,172,0,51,
            180,0,36,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,133,223,118,179,0,30,171,0,45,170,0,47,170,0,47,170,0,47,
            170,0,47,170,0,47,170,0,47,170,0,47,170,0,47,170,0,47,170,0,47,170,0,47,170,
            0,47,170,0,47,173,0,42,153,104,81,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,174,0,35,169,
            0,46,169,0,46,169,0,46,169,0,46,169,0,46,169,0,46,169,0,46,169,0,46,169,0,
            46,169,0,46,169,0,46,169,0,46,173,0,38,132,231,121,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,176,0,22,170,0,36,167,0,41,167,0,41,167,0,41,167,0,41,167,0,41,
            167,0,41,167,0,41,167,0,41,167,0,41,167,0,41,169,0,39,161,40,55,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,148,127,84,173,0,26,167,0,40,167,0,40,167,
            0,40,167,0,40,167,0,40,167,0,40,167,0,40,167,0,40,167,0,40,167,0,40,171,0,
            32,150,112,79,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,171,0,
            27,167,0,39,167,0,39,167,0,39,167,0,39,167,0,39,167,0,39,167,0,39,167,0,39,
            167,0,39,169,0,33,149,120,81,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,159,40,50,168,0,30,166,0,36,166,0,36,166,0,36,166,0,36,166,0,36,166,
            0,36,166,0,36,166,0,36,169,0,27,135,207,111,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,110,159,40,49,167,0,29,164,0,35,164,0,35,164,0,
            35,164,0,35,164,0,35,164,0,35,166,0,32,172,0,14,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,160,32,45,170,0,18,
            169,0,21,169,0,21,169,0,21,169,0,21,170,0,18,159,40,48,134,215,113,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163
        };
        wxImage image( 85, 68, (unsigned char*)data, TRUE );
#ifndef _WIN32	
        wxBitmap bitmap( image.Scale(90,85) );
	bitmap.SetMask(new wxMask(bitmap, wxColour(BACK_RCOLOR,BACK_GCOLOR,BACK_BCOLOR)));
#else	
        wxBitmap bitmap( image );
#endif	
        return bitmap;
    }
    if (index == 1)
    {
        static const unsigned char data[] = 
        {
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,217,249,242,
            217,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,217,249,242,217,242,242,230,242,
            242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,236,236,230,236,236,230,249,242,204,249,242,204,249,236,204,249,242,230,249,242,230,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,249,242,217,249,242,217,249,242,204,249,242,230,249,242,230,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,
            249,242,217,249,242,204,249,242,230,249,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,
            217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,217,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,217,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,236,236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,242,217,236,242,217,230,236,217,
            230,236,217,230,236,217,242,242,217,242,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,217,236,230,217,236,230,217,236,
            242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,217,236,230,217,236,230,217,236,242,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,236,236,230,236,236,230,236,236,230,242,242,217,242,242,217,242,236,
            217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,217,
            236,236,217,242,242,230,242,242,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,236,236,230,236,236,230,236,236,230,242,242,217,242,242,217,242,236,217,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,217,236,236,217,242,242,
            230,242,242,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,255,255,
            255,255,255,255,255,255,255,236,236,230,236,236,230,242,242,230,236,236,230,236,236,230,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,217,242,236,230,242,236,230,135,
            207,163,135,207,163,135,207,163,242,242,217,242,242,217,249,242,230,135,207,163,135,207,163,135,207,
            163,135,207,163,242,236,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,230,236,236,230,236,236,230,135,207,163,
            135,207,163,135,207,163,236,236,230,236,236,230,249,236,217,249,236,217,236,236,230,236,236,230,236,
            236,230,242,236,230,242,236,230,242,242,217,236,236,230,236,236,230,135,207,163,135,207,163,135,207,
            163,236,230,230,236,230,230,249,242,217,249,242,217,242,236,242,242,236,242,135,207,163,236,236,230,
            236,236,230,242,236,217,242,236,217,242,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,236,242,217,236,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,242,236,230,236,236,230,236,236,230,135,207,163,135,207,163,135,207,
            163,236,236,230,236,236,230,249,236,217,249,236,217,236,236,230,236,236,230,236,236,230,242,236,230,
            242,236,230,242,242,217,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,236,230,230,236,
            230,230,249,242,217,249,242,217,242,236,242,242,236,242,135,207,163,236,236,230,236,236,230,242,236,
            217,242,236,217,242,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,242,217,
            236,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,249,242,217,242,242,217,242,242,217,135,207,163,135,207,163,135,207,163,242,236,230,242,
            236,230,249,242,217,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,
            230,249,242,217,249,242,217,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,236,236,217,
            236,236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,
            242,217,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,242,242,217,242,242,217,242,242,
            230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,
            217,242,242,217,242,242,217,135,207,163,135,207,163,135,207,163,242,236,230,242,236,230,249,242,217,
            249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,249,242,217,249,
            242,217,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,236,236,217,236,236,217,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,236,236,230,
            236,236,230,135,207,163,135,207,163,135,207,163,242,242,217,242,242,217,242,242,230,242,242,230,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,242,230,242,242,230,236,236,230,236,236,230,230,236,217,236,242,217,236,
            242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,217,255,255,
            255,255,255,255,255,255,255,236,223,230,236,223,230,242,217,217,249,230,217,249,230,217,236,236,230,
            236,236,230,236,236,230,242,242,217,242,242,217,249,223,217,249,223,217,242,223,217,242,223,217,236,
            230,230,236,230,230,236,230,230,242,236,230,242,236,230,242,236,217,135,207,163,135,207,163,135,207,
            163,135,207,163,242,236,242,242,236,217,242,236,217,135,207,163,135,207,163,135,207,163,236,236,230,
            236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,242,236,230,
            242,236,230,135,207,163,135,207,163,135,207,163,249,236,217,249,236,217,249,217,217,242,217,217,242,
            217,217,242,217,217,242,217,217,249,210,217,249,223,204,249,223,204,249,242,204,249,242,204,249,242,
            217,249,236,217,249,236,217,242,210,217,242,210,217,249,217,204,249,217,204,249,217,217,242,210,217,
            242,210,217,249,230,204,249,230,204,249,242,217,236,236,230,236,236,230,135,207,163,135,207,163,242,
            242,217,236,236,217,236,236,217,135,207,163,135,207,163,135,207,163,236,242,217,236,242,217,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,242,236,230,242,236,230,135,207,
            163,135,207,163,135,207,163,249,236,217,249,236,217,249,217,217,242,217,217,242,217,217,242,217,217,
            242,217,217,249,210,217,249,223,204,249,223,204,249,242,204,249,242,204,249,242,217,249,236,217,249,
            236,217,242,210,217,242,210,217,249,217,204,249,217,204,249,217,217,242,210,217,242,210,217,249,230,
            204,249,230,204,249,242,217,236,236,230,236,236,230,135,207,163,135,207,163,242,242,217,236,236,217,
            236,236,217,135,207,163,135,207,163,135,207,163,236,242,217,236,242,217,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,217,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,249,236,217,249,236,217,242,236,230,242,236,230,135,207,163,242,242,217,242,
            242,217,249,230,204,249,230,204,249,210,217,242,210,204,242,210,204,242,217,217,242,217,217,249,210,
            217,249,217,204,249,217,204,249,242,204,249,242,204,249,242,204,249,236,217,249,236,217,242,210,217,
            242,210,217,242,210,217,242,210,217,249,210,217,242,210,217,242,210,217,249,230,204,249,230,204,249,
            242,204,242,242,217,242,242,217,236,236,230,236,236,230,249,230,217,242,230,217,242,230,217,135,207,
            163,135,207,163,135,207,163,236,242,217,236,242,217,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,236,236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,249,236,217,249,236,217,242,236,230,242,236,230,135,207,163,242,242,217,242,242,217,249,230,204,
            249,230,204,249,210,217,242,210,204,242,210,204,242,217,217,242,217,217,249,210,217,249,217,204,249,
            217,204,249,242,204,249,242,204,249,242,204,249,236,217,249,236,217,242,210,217,242,210,217,242,210,
            217,242,210,217,249,210,217,242,210,217,242,210,217,249,230,204,249,230,204,249,242,204,242,242,217,
            242,242,217,236,236,230,236,236,230,249,230,217,242,230,217,242,230,217,135,207,163,135,207,163,135,
            207,163,236,242,217,236,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,242,242,242,249,242,230,249,242,230,242,242,230,242,242,230,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,242,230,242,242,230,242,236,230,242,236,230,242,223,217,242,217,204,242,
            217,204,249,236,217,249,236,217,249,242,217,249,242,204,249,242,204,249,242,217,249,242,217,242,223,
            217,242,217,217,242,217,217,249,210,217,249,210,217,249,210,217,249,223,217,249,223,217,249,242,204,
            249,242,204,249,242,204,249,242,217,249,242,217,249,223,204,249,223,204,242,217,217,242,217,217,242,
            210,217,242,217,217,242,217,217,249,236,204,249,236,204,249,242,204,249,242,204,249,242,204,249,242,
            217,249,242,217,249,217,217,242,210,204,242,210,204,242,217,217,242,217,217,242,223,217,249,242,230,
            249,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,242,242,242,242,242,242,242,242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,242,236,217,249,242,204,249,242,204,249,242,204,249,242,204,249,236,217,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,249,230,217,249,230,217,249,217,217,249,217,217,249,210,204,242,210,217,242,210,217,249,223,204,
            249,223,204,249,236,204,249,242,204,249,242,204,249,242,204,249,242,204,249,236,217,242,223,217,242,
            223,217,242,223,230,242,223,230,242,230,217,249,236,217,249,236,217,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,204,249,242,217,249,242,217,255,255,255,255,255,255,242,230,230,242,236,204,
            242,236,204,249,242,217,249,242,217,249,242,217,249,242,204,249,242,204,249,236,217,249,236,217,242,
            217,217,249,210,217,249,210,217,249,210,217,249,210,217,242,217,204,242,236,217,242,236,217,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,255,255,
            255,255,255,255,242,236,230,242,236,230,242,242,230,242,242,230,242,242,230,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,217,
            249,242,204,249,242,204,249,242,204,249,242,204,249,236,217,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,230,217,249,
            230,217,249,217,217,249,217,217,249,210,204,242,210,217,242,210,217,249,223,204,249,223,204,249,236,
            204,249,242,204,249,242,204,249,242,204,249,242,204,249,236,217,242,223,217,242,223,217,242,223,230,
            242,223,230,242,230,217,249,236,217,249,236,217,249,242,204,249,242,204,249,242,204,249,242,204,249,
            242,204,249,242,217,249,242,217,255,255,255,255,255,255,242,230,230,242,236,204,242,236,204,249,242,
            217,249,242,217,249,242,217,249,242,204,249,242,204,249,236,217,249,236,217,242,217,217,249,210,217,
            249,210,217,249,210,217,249,210,217,242,217,204,242,236,217,242,236,217,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,255,255,255,255,255,255,242,
            236,230,242,236,230,242,242,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,
            217,249,242,204,249,242,204,249,242,204,249,242,217,249,242,217,249,242,204,249,242,204,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,249,236,217,249,236,217,242,217,204,
            242,217,204,242,210,217,242,217,230,242,217,230,249,230,217,249,230,217,249,242,204,249,249,204,249,
            249,204,249,242,204,249,242,204,249,242,204,249,236,230,249,236,230,255,255,255,255,255,255,236,223,
            230,249,223,204,249,223,204,249,236,217,249,236,217,249,236,217,249,236,204,249,236,204,242,236,230,
            242,236,230,255,255,255,255,255,255,242,230,230,249,230,217,249,230,217,249,242,217,249,242,217,249,
            242,204,249,236,204,249,236,204,255,255,255,255,255,255,255,255,255,242,223,217,242,223,217,249,223,
            204,249,223,204,249,236,204,249,242,217,249,242,217,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,204,249,242,204,249,236,204,249,236,204,
            249,242,204,242,242,217,242,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,217,249,242,204,249,
            242,204,249,242,204,249,242,217,249,242,217,249,242,204,249,242,204,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,236,236,230,249,236,217,249,236,217,242,217,204,242,217,204,242,210,
            217,242,217,230,242,217,230,249,230,217,249,230,217,249,242,204,249,249,204,249,249,204,249,242,204,
            249,242,204,249,242,204,249,236,230,249,236,230,255,255,255,255,255,255,236,223,230,249,223,204,249,
            223,204,249,236,217,249,236,217,249,236,217,249,236,204,249,236,204,242,236,230,242,236,230,255,255,
            255,255,255,255,242,230,230,249,230,217,249,230,217,249,242,217,249,242,217,249,242,204,249,236,204,
            249,236,204,255,255,255,255,255,255,255,255,255,242,223,217,242,223,217,249,223,204,249,223,204,249,
            236,204,249,242,217,249,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,249,242,217,249,242,204,249,242,204,249,236,204,249,236,204,249,242,204,242,242,
            217,242,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,249,236,217,249,236,217,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,204,242,236,217,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,249,242,204,249,242,204,249,236,204,249,236,204,242,236,230,255,255,255,255,
            255,255,242,236,230,242,236,230,249,236,204,249,236,217,249,236,217,249,242,204,249,242,204,249,236,
            204,242,223,217,242,223,217,242,236,230,242,236,230,249,230,217,242,217,204,242,217,204,249,230,204,
            249,230,204,249,236,217,249,223,217,249,223,217,242,223,217,242,223,217,242,230,217,242,230,217,242,
            230,217,242,217,204,242,217,204,249,230,204,249,230,204,249,236,204,249,236,217,249,236,217,236,236,
            230,236,236,230,242,230,230,242,223,204,242,223,204,249,236,204,249,236,204,249,242,217,242,236,230,
            242,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            242,236,217,249,242,217,249,242,217,249,242,217,249,242,217,242,242,217,236,236,230,236,236,230,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,204,249,242,217,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,242,242,230,242,242,230,249,242,204,249,242,204,242,242,217,255,255,255,255,255,255,242,223,230,
            242,223,230,249,217,204,249,223,204,249,223,204,249,242,217,249,242,217,249,236,204,249,236,204,249,
            236,204,249,242,204,249,242,204,249,236,204,249,236,204,249,236,204,249,242,204,249,242,204,249,242,
            204,249,236,204,249,236,204,249,236,217,249,236,217,249,242,204,249,242,204,249,242,204,249,236,204,
            249,236,204,249,242,204,249,242,204,249,236,204,249,236,204,249,236,204,242,236,217,242,236,217,249,
            223,204,249,223,204,249,223,204,249,236,217,249,236,217,242,242,230,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,242,242,242,242,242,230,242,242,230,242,242,217,242,242,217,249,242,217,249,242,
            217,249,242,217,242,242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,242,230,242,242,230,249,242,204,249,242,204,249,242,204,249,242,204,249,
            242,204,249,242,217,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,
            242,230,249,242,204,249,242,204,242,242,217,255,255,255,255,255,255,242,223,230,242,223,230,249,217,
            204,249,223,204,249,223,204,249,242,217,249,242,217,249,236,204,249,236,204,249,236,204,249,242,204,
            249,242,204,249,236,204,249,236,204,249,236,204,249,242,204,249,242,204,249,242,204,249,236,204,249,
            236,204,249,236,217,249,236,217,249,242,204,249,242,204,249,242,204,249,236,204,249,236,204,249,242,
            204,249,242,204,249,236,204,249,236,204,249,236,204,242,236,217,242,236,217,249,223,204,249,223,204,
            249,223,204,249,236,217,249,236,217,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            242,242,242,242,242,230,242,242,230,242,242,217,242,242,217,249,242,217,249,242,217,249,242,217,242,
            242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,236,236,230,236,236,230,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,217,249,242,217,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,210,230,230,210,230,230,135,207,163,
            135,207,163,242,236,217,242,223,217,242,223,217,249,230,217,249,230,217,249,242,204,249,242,204,249,
            242,204,249,236,204,249,236,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,
            204,249,242,217,249,242,217,249,242,217,249,242,217,249,242,204,249,249,204,249,249,204,249,242,217,
            249,242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,
            242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,236,204,242,236,217,242,236,217,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,
            204,249,242,204,249,242,217,249,242,217,249,242,217,242,242,217,242,242,217,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,
            236,230,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,249,242,
            217,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,210,230,230,210,230,230,135,207,163,135,207,163,242,236,
            217,242,223,217,242,223,217,249,230,217,249,230,217,249,242,204,249,242,204,249,242,204,249,236,204,
            249,236,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,249,
            242,217,249,242,217,249,242,217,249,242,204,249,249,204,249,249,204,249,242,217,249,242,217,249,242,
            204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,204,249,242,204,249,236,204,242,236,217,242,236,217,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,204,249,242,204,249,
            242,217,249,242,217,249,242,217,242,242,217,242,242,217,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,
            249,242,217,249,242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,249,
            242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,217,242,
            236,217,249,242,204,249,242,204,249,249,204,249,242,204,249,242,204,249,236,217,249,236,217,242,242,
            217,242,236,217,242,236,217,242,242,217,242,242,217,249,242,204,249,236,204,249,236,204,249,217,217,
            249,217,217,249,217,217,249,230,204,249,230,204,249,242,204,249,242,204,249,242,204,249,242,204,242,
            242,217,236,236,217,236,236,217,249,236,204,249,236,204,249,242,204,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,204,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,242,242,230,242,242,230,249,242,204,249,242,204,249,242,204,249,242,217,249,242,217,
            249,242,217,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,230,242,236,
            230,242,242,217,242,242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,242,242,217,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,217,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,204,249,236,217,249,236,217,210,230,217,204,223,217,204,
            223,217,223,236,217,223,236,217,242,249,204,249,236,204,249,236,204,242,210,217,242,210,217,242,210,
            217,249,217,217,249,217,217,249,242,204,249,242,204,242,236,217,242,236,217,210,230,217,204,230,217,
            204,230,217,223,236,217,223,236,217,242,242,204,249,242,204,249,242,204,249,236,217,249,236,217,249,
            242,204,249,242,217,249,242,217,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,
            242,217,242,242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,242,236,217,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,230,242,236,230,242,242,217,242,
            242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,242,242,217,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,242,236,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,204,249,236,217,249,236,217,210,230,217,204,223,217,204,223,217,223,236,217,
            223,236,217,242,249,204,249,236,204,249,236,204,242,210,217,242,210,217,242,210,217,249,217,217,249,
            217,217,249,242,204,249,242,204,242,236,217,242,236,217,210,230,217,204,230,217,204,230,217,223,236,
            217,223,236,217,242,242,204,249,242,204,249,242,204,249,236,217,249,236,217,249,242,204,249,242,217,
            249,242,217,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,217,242,242,217,
            249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,242,236,217,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,242,242,217,
            249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,242,242,230,242,242,230,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,
            236,236,230,249,242,217,249,223,204,249,223,204,249,217,204,249,217,204,242,223,217,249,236,204,249,
            236,204,249,242,217,249,242,217,217,236,217,210,230,217,210,230,217,230,236,217,230,236,217,249,249,
            204,249,242,204,249,242,204,249,230,217,249,230,217,249,230,204,249,236,217,249,236,217,249,242,204,
            249,242,204,249,242,217,249,242,217,223,236,217,210,230,217,210,230,217,230,236,204,230,236,204,249,
            242,204,249,230,204,249,230,204,249,217,204,249,217,204,249,217,217,242,230,217,242,230,217,242,242,
            230,242,242,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,242,242,217,242,242,217,249,242,204,249,242,204,249,242,204,249,242,
            217,249,242,217,249,242,230,249,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,242,242,217,249,242,204,249,242,
            204,249,242,204,249,242,204,249,242,204,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,249,242,
            217,249,223,204,249,223,204,249,217,204,249,217,204,242,223,217,249,236,204,249,236,204,249,242,217,
            249,242,217,217,236,217,210,230,217,210,230,217,230,236,217,230,236,217,249,249,204,249,242,204,249,
            242,204,249,230,217,249,230,217,249,230,204,249,236,217,249,236,217,249,242,204,249,242,204,249,242,
            217,249,242,217,223,236,217,210,230,217,210,230,217,230,236,204,230,236,204,249,242,204,249,230,204,
            249,230,204,249,217,204,249,217,204,249,217,217,242,230,217,242,230,217,242,242,230,242,242,230,236,
            236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,242,242,217,242,242,217,249,242,204,249,242,204,249,242,204,249,242,217,249,242,217,249,
            242,230,249,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,249,242,217,249,242,217,249,236,204,249,
            236,204,249,242,204,242,242,204,242,242,204,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,236,217,242,236,217,255,255,255,255,255,255,236,230,230,242,210,217,242,
            210,217,242,210,217,242,210,217,249,230,217,249,242,217,249,242,217,249,242,204,249,242,204,249,242,
            204,242,242,204,242,242,204,249,236,217,249,236,217,249,230,217,249,230,204,249,230,204,249,230,204,
            249,230,204,249,230,204,249,230,204,249,230,204,249,230,217,249,230,217,249,230,217,249,230,217,249,
            236,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,236,217,249,236,217,249,230,
            204,249,230,204,249,217,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,
            236,236,230,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,249,242,
            217,249,242,217,249,236,204,249,236,204,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,249,242,217,
            249,242,204,249,242,204,249,242,217,249,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,236,
            217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,249,236,204,
            249,236,204,249,236,204,249,230,217,249,230,217,242,223,217,242,223,217,249,217,217,249,217,217,249,
            217,217,249,217,217,249,217,217,242,210,217,249,210,217,249,210,217,249,210,217,249,210,217,242,210,
            204,249,210,217,249,210,217,242,210,217,242,210,217,242,210,217,242,210,217,249,210,217,249,217,217,
            249,217,217,249,223,217,249,223,217,249,217,217,249,230,204,249,230,204,249,236,204,249,236,204,249,
            242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,
            217,242,242,217,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,242,242,230,242,242,230,249,242,204,249,242,204,249,242,204,242,242,217,242,242,217,242,
            242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,249,242,217,249,242,204,249,242,
            204,249,242,217,249,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,236,217,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,249,236,204,249,236,204,249,236,
            204,249,230,217,249,230,217,242,223,217,242,223,217,249,217,217,249,217,217,249,217,217,249,217,217,
            249,217,217,242,210,217,249,210,217,249,210,217,249,210,217,249,210,217,242,210,204,249,210,217,249,
            210,217,242,210,217,242,210,217,242,210,217,242,210,217,249,210,217,249,217,217,249,217,217,249,223,
            217,249,223,217,249,217,217,249,230,204,249,230,204,249,236,204,249,236,204,249,242,217,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,217,242,242,217,242,
            242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,
            230,242,242,230,249,242,204,249,242,204,249,242,204,242,242,217,242,242,217,242,242,230,242,242,230,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,217,242,236,217,249,242,204,249,
            242,204,242,236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,242,236,217,242,236,217,249,242,217,249,242,217,249,242,217,242,236,230,
            242,236,230,242,236,217,249,242,217,249,242,217,249,242,204,249,242,204,249,230,204,249,223,204,249,
            223,204,249,223,217,249,223,217,249,230,217,249,230,217,249,230,217,249,230,217,249,230,217,249,230,
            217,242,230,217,242,230,217,249,230,217,249,230,217,249,230,217,242,230,217,242,230,217,249,230,204,
            249,230,204,249,230,217,249,230,217,249,230,204,242,223,204,242,223,204,242,223,217,242,223,217,242,
            230,217,249,230,217,249,230,217,249,236,204,249,236,204,249,242,217,249,242,217,249,242,217,249,242,
            217,249,242,217,249,236,217,242,242,217,242,242,217,249,242,204,249,242,204,249,242,204,242,242,230,
            242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,217,249,
            242,204,249,242,204,249,242,204,236,236,217,236,236,217,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,242,236,217,242,236,217,249,242,204,249,242,204,242,236,217,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,242,236,217,242,236,217,249,242,217,249,242,217,249,242,217,242,236,230,242,236,230,242,236,
            217,249,242,217,249,242,217,249,242,204,249,242,204,249,230,204,249,223,204,249,223,204,249,223,217,
            249,223,217,249,230,217,249,230,217,249,230,217,249,230,217,249,230,217,249,230,217,242,230,217,242,
            230,217,249,230,217,249,230,217,249,230,217,242,230,217,242,230,217,249,230,204,249,230,204,249,230,
            217,249,230,217,249,230,204,242,223,204,242,223,204,242,223,217,242,223,217,242,230,217,249,230,217,
            249,230,217,249,236,204,249,236,204,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,
            236,217,242,242,217,242,242,217,249,242,204,249,242,204,249,242,204,242,242,230,242,242,230,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,217,249,242,204,249,242,204,
            249,242,204,236,236,217,236,236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,236,236,230,236,236,230,242,242,230,242,242,230,249,242,204,249,242,204,249,242,
            204,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,236,236,230,
            236,236,230,249,242,217,223,217,204,223,217,204,217,217,204,217,217,204,217,217,204,217,217,204,217,
            217,204,217,217,204,217,217,204,223,217,204,217,223,204,217,223,204,217,217,204,217,217,204,210,217,
            204,217,217,204,217,217,204,217,217,204,217,217,204,217,217,204,217,217,204,217,217,204,217,217,204,
            217,217,204,217,210,204,217,223,204,217,223,204,242,236,204,242,236,204,249,242,204,249,242,204,242,
            242,204,223,223,204,223,223,204,217,210,204,217,210,204,217,217,204,217,210,204,217,210,204,217,217,
            204,217,217,204,217,210,204,217,210,204,217,210,204,217,210,204,217,210,204,217,210,204,217,217,204,
            217,217,204,223,223,204,223,223,204,242,236,217,242,236,230,242,236,230,242,242,230,242,242,230,135,
            207,163,242,242,230,242,242,230,249,242,204,249,242,204,249,242,217,242,242,230,242,242,230,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            236,236,230,236,236,230,242,242,230,242,242,230,249,242,204,249,242,204,249,242,204,242,242,230,242,
            242,230,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,236,236,230,236,236,230,249,242,
            217,223,217,204,223,217,204,217,217,204,217,217,204,217,217,204,217,217,204,217,217,204,217,217,204,
            217,217,204,223,217,204,217,223,204,217,223,204,217,217,204,217,217,204,210,217,204,217,217,204,217,
            217,204,217,217,204,217,217,204,217,217,204,217,217,204,217,217,204,217,217,204,217,217,204,217,210,
            204,217,223,204,217,223,204,242,236,204,242,236,204,249,242,204,249,242,204,242,242,204,223,223,204,
            223,223,204,217,210,204,217,210,204,217,217,204,217,210,204,217,210,204,217,217,204,217,217,204,217,
            210,204,217,210,204,217,210,204,217,210,204,217,210,204,217,210,204,217,217,204,217,217,204,223,223,
            204,223,223,204,242,236,217,242,236,230,242,236,230,242,242,230,242,242,230,135,207,163,242,242,230,
            242,242,230,249,242,204,249,242,204,249,242,217,242,242,230,242,242,230,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,242,242,204,249,242,204,249,242,204,249,242,217,249,242,217,242,242,217,
            242,242,217,236,236,217,255,255,255,255,255,255,255,255,255,255,255,255,242,236,217,217,210,204,217,
            210,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,217,210,204,217,210,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,210,204,217,
            210,204,217,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,217,210,204,242,230,217,242,
            230,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,242,236,204,242,236,204,230,223,
            204,230,223,204,204,204,204,204,204,204,204,204,204,230,230,217,230,230,217,242,236,204,230,230,204,
            230,230,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,217,210,217,217,210,217,242,
            236,230,223,223,217,223,223,217,242,236,230,242,236,230,249,242,204,249,242,204,249,242,204,236,236,
            230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,242,236,230,242,236,230,242,236,230,249,242,204,249,242,204,249,242,204,249,242,204,242,236,
            230,255,255,255,255,255,255,255,255,255,255,255,255,242,236,217,223,210,204,223,210,204,230,210,217,
            230,210,217,230,210,217,236,217,204,236,217,204,242,223,217,242,223,217,217,210,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,223,204,217,223,204,217,230,204,
            217,204,204,204,204,204,204,210,217,204,210,217,204,242,236,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,236,204,249,236,204,249,242,204,249,249,204,249,249,204,236,236,217,236,236,217,204,
            204,204,230,223,204,230,223,204,242,236,204,242,236,204,217,217,204,230,236,217,230,236,217,230,230,
            204,230,230,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,236,236,230,255,255,255,
            255,255,255,242,242,217,242,242,217,249,242,204,249,242,217,249,242,217,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,230,
            242,236,230,242,236,230,249,242,204,249,242,204,249,242,204,249,242,204,242,236,230,255,255,255,255,
            255,255,255,255,255,255,255,255,242,236,217,223,210,204,223,210,204,230,210,217,230,210,217,230,210,
            217,236,217,204,236,217,204,242,223,217,242,223,217,217,210,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,223,204,217,223,204,217,230,204,217,204,204,204,204,
            204,204,210,217,204,210,217,204,242,236,204,249,242,204,249,242,204,249,242,204,249,242,204,249,236,
            204,249,236,204,249,242,204,249,249,204,249,249,204,236,236,217,236,236,217,204,204,204,230,223,204,
            230,223,204,242,236,204,242,236,204,217,217,204,230,236,217,230,236,217,230,230,204,230,230,204,204,
            204,204,204,204,204,204,204,204,217,210,204,217,210,204,236,236,230,255,255,255,255,255,255,242,242,
            217,242,242,217,249,242,204,249,242,217,249,242,217,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,242,242,217,242,242,217,249,242,217,249,242,217,242,236,217,255,255,255,255,255,255,255,255,255,
            255,255,255,242,236,217,204,204,204,204,204,204,223,223,204,223,223,204,249,236,217,249,242,204,249,
            242,204,249,242,217,249,242,217,255,255,255,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,230,210,204,223,204,217,223,204,217,223,210,204,
            223,210,204,249,242,204,249,242,204,249,242,204,249,236,217,249,236,217,249,242,204,249,242,204,249,
            242,217,249,242,204,249,242,204,236,230,217,236,230,217,217,210,204,242,242,217,242,242,217,230,223,
            204,230,223,204,217,210,204,223,217,204,223,217,204,236,230,217,236,230,217,204,204,204,204,204,204,
            204,204,204,217,217,204,217,217,204,242,242,230,242,242,230,242,242,230,242,242,217,242,242,217,236,
            236,230,255,255,255,255,255,255,242,242,217,242,242,217,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,217,242,
            242,217,249,242,217,249,242,217,242,236,217,255,255,255,255,255,255,255,255,255,255,255,255,242,236,
            217,204,204,204,204,204,204,223,223,204,223,223,204,249,236,217,249,242,204,249,242,204,249,242,217,
            249,242,217,255,255,255,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,230,210,204,223,204,217,223,204,217,223,210,204,223,210,204,249,242,
            204,249,242,204,249,242,204,249,236,217,249,236,217,249,242,204,249,242,204,249,242,217,249,242,204,
            249,242,204,236,230,217,236,230,217,217,210,204,242,242,217,242,242,217,230,223,204,230,223,204,217,
            210,204,223,217,204,223,217,204,236,230,217,236,230,217,204,204,204,204,204,204,204,204,204,217,217,
            204,217,217,204,242,242,230,242,242,230,242,242,230,242,242,217,242,242,217,236,236,230,255,255,255,
            255,255,255,242,242,217,242,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,255,255,255,255,255,255,236,236,230,
            236,236,230,249,242,217,242,242,217,242,242,217,236,236,230,236,236,230,249,236,217,217,210,204,217,
            210,204,223,217,204,223,217,204,249,242,204,249,242,204,249,242,204,242,236,204,242,236,204,217,210,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,217,217,210,204,217,210,204,217,210,204,
            217,210,204,217,210,204,230,204,204,230,204,204,230,204,204,230,204,204,223,217,204,236,223,217,236,
            223,217,249,242,204,249,242,204,249,242,204,249,242,204,249,236,217,249,242,204,249,242,204,236,230,
            204,236,230,204,217,210,204,242,236,217,242,236,217,249,236,204,249,236,204,249,242,204,236,230,204,
            236,230,204,236,230,204,236,230,204,217,210,204,204,204,204,204,204,204,217,217,204,217,217,204,249,
            242,217,249,242,204,249,242,204,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,242,242,
            230,242,242,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,236,236,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,230,
            217,249,242,217,249,242,217,249,242,204,249,242,204,242,236,204,217,210,204,217,210,204,230,217,204,
            230,217,204,249,242,217,249,242,204,249,242,204,249,242,204,249,242,204,223,223,204,217,210,204,217,
            210,204,204,204,204,204,204,204,204,204,204,236,230,204,236,230,204,249,249,217,249,249,217,236,230,
            204,230,230,204,230,230,204,236,230,217,236,230,217,204,204,204,210,217,204,210,217,204,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,217,249,242,204,249,242,204,242,242,204,242,242,204,217,
            217,204,230,223,204,230,223,204,249,242,217,249,242,217,255,255,255,223,217,204,223,217,204,217,217,
            204,217,217,204,204,204,204,204,204,204,204,204,204,217,217,204,217,217,204,249,242,217,236,236,230,
            236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,
            236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,217,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,230,217,249,242,217,249,
            242,217,249,242,204,249,242,204,242,236,204,217,210,204,217,210,204,230,217,204,230,217,204,249,242,
            217,249,242,204,249,242,204,249,242,204,249,242,204,223,223,204,217,210,204,217,210,204,204,204,204,
            204,204,204,204,204,204,236,230,204,236,230,204,249,249,217,249,249,217,236,230,204,230,230,204,230,
            230,204,236,230,217,236,230,217,204,204,204,210,217,204,210,217,204,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,217,249,242,204,249,242,204,242,242,204,242,242,204,217,217,204,230,223,204,
            230,223,204,249,242,217,249,242,217,255,255,255,223,217,204,223,217,204,217,217,204,217,217,204,204,
            204,204,204,204,204,204,204,204,217,217,204,217,217,204,249,242,217,236,236,230,236,236,230,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,217,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,230,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,249,242,217,
            249,242,217,249,236,217,230,210,204,230,210,204,242,223,217,242,223,217,249,242,204,249,242,204,249,
            242,204,249,242,204,249,242,204,249,242,204,242,236,217,242,236,217,230,223,204,230,223,204,217,210,
            204,223,223,217,223,223,217,230,230,204,230,230,204,249,249,217,249,242,204,249,242,204,249,242,217,
            249,242,217,236,230,204,230,223,204,230,223,204,249,242,217,249,242,217,249,242,204,249,242,204,249,
            242,204,249,242,217,249,242,217,242,236,204,242,236,204,217,210,204,217,217,204,217,217,204,242,236,
            204,242,236,204,204,204,204,217,217,217,217,217,217,217,210,204,217,210,204,204,204,204,210,204,217,
            210,204,217,217,210,204,217,210,204,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,230,242,242,242,242,242,242,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,249,242,230,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,249,242,217,249,242,217,249,236,
            217,230,210,204,230,210,204,242,223,217,242,223,217,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,204,242,236,217,242,236,217,230,223,204,230,223,204,217,210,204,223,223,217,223,
            223,217,230,230,204,230,230,204,249,249,217,249,242,204,249,242,204,249,242,217,249,242,217,236,230,
            204,230,223,204,230,223,204,249,242,217,249,242,217,249,242,204,249,242,204,249,242,204,249,242,217,
            249,242,217,242,236,204,242,236,204,217,210,204,217,217,204,217,217,204,242,236,204,242,236,204,204,
            204,204,217,217,217,217,217,217,217,210,204,217,210,204,204,204,204,210,204,217,210,204,217,217,210,
            204,217,210,204,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,242,242,230,242,242,242,242,242,242,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,236,236,230,236,236,230,242,242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,242,236,230,242,236,230,249,242,217,249,242,217,249,236,204,217,210,204,217,
            210,204,217,210,204,217,210,204,230,223,204,249,242,217,249,242,217,249,242,204,249,242,204,249,242,
            204,249,242,217,249,242,217,249,249,217,249,249,217,242,242,204,230,223,204,230,223,204,223,210,204,
            223,210,204,242,236,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,249,
            242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,242,236,
            204,242,236,204,204,204,204,217,210,204,217,210,204,236,230,217,236,230,217,217,210,204,223,223,204,
            223,223,204,217,210,204,217,210,204,223,223,217,217,217,204,217,217,204,223,217,204,223,217,204,242,
            236,217,255,255,255,255,255,255,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,236,236,230,242,242,217,242,242,217,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,
            242,230,236,236,230,242,242,217,242,242,217,255,255,255,255,255,255,255,255,255,255,255,255,242,236,
            230,249,249,217,249,249,217,242,242,217,242,242,217,249,236,217,210,210,217,210,210,217,204,204,204,
            204,204,204,255,255,255,236,230,204,236,230,204,236,230,204,236,230,204,249,242,204,249,242,204,249,
            242,204,249,242,204,249,242,204,249,242,204,249,242,217,249,242,217,242,236,204,242,236,204,242,236,
            204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,236,204,249,236,204,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,242,236,217,242,236,217,217,
            210,204,217,210,204,217,210,204,255,255,255,255,255,255,223,223,204,217,210,204,217,210,204,223,223,
            204,223,223,204,217,217,204,204,204,204,204,204,204,217,217,204,217,217,204,242,236,217,255,255,255,
            255,255,255,249,249,230,249,249,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,249,
            242,230,249,249,230,249,249,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,236,236,230,
            242,242,217,242,242,217,255,255,255,255,255,255,255,255,255,255,255,255,242,236,230,249,249,217,249,
            249,217,242,242,217,242,242,217,249,236,217,210,210,217,210,210,217,204,204,204,204,204,204,255,255,
            255,236,230,204,236,230,204,236,230,204,236,230,204,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,204,249,242,217,249,242,217,242,236,204,242,236,204,242,236,204,249,242,204,249,
            242,204,249,242,204,249,242,204,249,242,204,249,236,204,249,236,204,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,204,249,242,204,249,242,204,242,236,217,242,236,217,217,210,204,217,210,204,
            217,210,204,255,255,255,255,255,255,223,223,204,217,210,204,217,210,204,223,223,204,223,223,204,217,
            217,204,204,204,204,204,204,204,217,217,204,217,217,204,242,236,217,255,255,255,255,255,255,249,249,
            230,249,249,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,249,242,230,249,249,230,
            249,249,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,242,236,217,249,242,217,249,242,
            217,236,236,230,236,236,230,255,255,255,255,255,255,236,242,217,236,236,230,236,236,230,255,255,255,
            255,255,255,242,236,217,204,204,204,204,204,204,204,204,204,204,204,204,223,217,204,223,217,204,223,
            217,204,236,230,204,236,230,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,236,204,249,236,204,249,
            242,204,242,236,204,242,236,204,223,223,204,223,223,204,217,210,204,204,204,204,204,204,204,255,255,
            255,255,255,255,223,223,217,217,210,204,217,210,204,236,230,217,236,230,217,204,204,204,204,204,204,
            204,204,204,217,217,204,217,217,204,242,236,230,255,255,255,255,255,255,242,242,230,242,242,230,242,
            236,230,255,255,255,255,255,255,255,255,255,255,255,255,249,242,217,249,249,217,249,249,217,242,242,
            217,242,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,242,230,242,242,230,242,236,217,249,242,217,249,242,217,236,236,230,236,
            236,230,255,255,255,255,255,255,236,242,217,236,236,230,236,236,230,255,255,255,255,255,255,242,236,
            217,204,204,204,204,204,204,204,204,204,204,204,204,223,217,204,223,217,204,223,217,204,236,230,204,
            236,230,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,
            242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,204,249,242,204,249,242,204,249,236,204,249,236,204,249,242,204,242,236,204,
            242,236,204,223,223,204,223,223,204,217,210,204,204,204,204,204,204,204,255,255,255,255,255,255,223,
            223,217,217,210,204,217,210,204,236,230,217,236,230,217,204,204,204,204,204,204,204,204,204,217,217,
            204,217,217,204,242,236,230,255,255,255,255,255,255,242,242,230,242,242,230,242,236,230,255,255,255,
            255,255,255,255,255,255,255,255,255,249,242,217,249,249,217,249,249,217,242,242,217,242,242,217,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,249,230,249,249,
            230,249,249,230,249,249,230,249,242,230,249,242,217,249,242,217,242,236,217,242,236,217,242,242,230,
            242,242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,217,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,223,223,217,223,223,217,236,230,204,236,230,204,236,230,
            204,249,242,217,249,242,217,249,242,204,249,242,204,249,242,204,249,242,217,249,242,217,249,242,217,
            249,242,217,249,242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,
            242,204,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,223,217,204,223,217,204,204,204,
            204,204,204,204,204,204,204,217,210,204,217,210,204,236,236,217,236,236,217,217,210,204,230,230,217,
            230,230,217,217,210,204,217,210,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,242,
            242,230,255,255,255,255,255,255,255,255,255,255,255,255,242,242,230,236,236,230,236,236,230,242,236,
            230,242,236,230,249,242,217,242,242,230,242,242,230,242,242,230,242,242,230,242,242,230,242,242,230,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,236,236,217,236,236,217,249,242,204,249,242,204,249,242,230,249,242,230,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,230,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,255,255,255,217,217,204,217,
            217,204,230,223,204,230,223,204,236,223,204,242,230,217,242,230,217,242,230,204,242,230,204,249,242,
            204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,217,249,242,217,249,242,204,223,217,204,223,217,204,255,255,255,255,255,255,230,
            223,204,230,230,217,230,230,217,230,230,204,230,230,204,217,210,204,230,223,204,230,223,204,217,210,
            204,217,210,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,236,236,217,255,255,255,
            255,255,255,255,255,255,255,255,255,236,236,230,242,242,230,242,242,230,242,242,204,242,242,204,242,
            242,217,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            236,236,217,236,236,217,249,242,204,249,242,204,249,242,230,249,242,230,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,242,236,230,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,255,255,255,217,217,204,217,217,204,230,223,204,
            230,223,204,236,223,204,242,230,217,242,230,217,242,230,204,242,230,204,249,242,204,249,242,204,249,
            242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,
            217,249,242,217,249,242,204,223,217,204,223,217,204,255,255,255,255,255,255,230,223,204,230,230,217,
            230,230,217,230,230,204,230,230,204,217,210,204,230,223,204,230,223,204,217,210,204,217,210,204,204,
            204,204,204,204,204,204,204,204,217,210,204,217,210,204,236,236,217,255,255,255,255,255,255,255,255,
            255,255,255,255,236,236,230,242,242,230,242,242,230,242,242,204,242,242,204,242,242,217,255,255,255,
            255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,242,242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,242,242,230,242,242,230,249,242,230,249,242,230,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,242,236,217,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,210,217,204,217,210,204,217,210,204,217,210,204,217,210,204,236,223,
            217,242,236,204,242,236,204,249,236,204,249,236,204,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,
            242,204,236,230,204,236,230,204,242,242,217,242,242,217,236,236,204,249,242,217,249,242,217,217,217,
            204,217,217,204,230,223,204,217,217,204,217,217,204,230,230,217,230,230,217,217,217,204,204,204,204,
            204,204,204,217,217,204,217,217,204,242,242,230,255,255,255,255,255,255,255,255,255,255,255,255,236,
            236,230,242,242,217,242,242,217,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            242,242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,
            242,230,249,242,230,249,242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,
            217,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,210,217,204,217,210,204,217,210,204,217,210,204,217,210,204,236,223,217,242,236,204,242,
            236,204,249,236,204,249,236,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,236,230,204,
            236,230,204,242,242,217,242,242,217,236,236,204,249,242,217,249,242,217,217,217,204,217,217,204,230,
            223,204,217,217,204,217,217,204,230,230,217,230,230,217,217,217,204,204,204,204,204,204,204,217,217,
            204,217,217,204,242,242,230,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,242,242,217,
            242,242,217,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,
            242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,236,236,230,236,236,
            230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,236,236,230,
            236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,217,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,255,255,255,255,255,255,249,249,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,204,249,242,217,249,242,217,249,242,217,249,242,217,249,242,204,249,242,204,249,
            242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,236,236,204,236,236,204,223,217,
            204,223,217,204,217,210,204,249,236,204,249,236,204,223,217,204,223,217,204,230,230,217,223,217,204,
            223,217,204,255,255,255,255,255,255,217,210,204,204,204,204,204,204,204,217,217,204,217,217,204,236,
            236,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,230,242,242,230,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,230,242,236,230,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,242,249,230,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,217,217,204,217,217,204,217,217,210,204,
            217,210,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,223,223,204,223,
            223,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,
            204,249,242,217,249,242,217,249,242,217,249,242,217,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,217,249,242,217,249,242,204,242,236,204,242,236,204,204,204,204,204,204,204,217,
            217,204,242,242,217,242,242,217,223,217,204,223,217,204,217,217,217,223,210,204,223,210,204,242,236,
            204,242,236,204,217,210,204,204,204,204,204,204,204,217,217,204,217,217,204,242,236,217,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,242,242,230,242,242,230,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,230,242,242,230,242,242,230,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,242,249,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,242,230,242,242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,242,236,217,217,204,217,217,204,217,217,210,204,217,210,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,223,223,204,223,223,204,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,249,
            242,217,249,242,217,249,242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,
            217,249,242,217,249,242,204,242,236,204,242,236,204,204,204,204,204,204,204,217,217,204,242,242,217,
            242,242,217,223,217,204,223,217,204,217,217,217,223,210,204,223,210,204,242,236,204,242,236,204,217,
            210,204,204,204,204,204,204,204,217,217,204,217,217,204,242,236,217,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,242,242,230,242,242,230,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,242,242,230,242,242,230,242,242,230,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,242,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,242,242,230,242,242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,242,236,217,223,210,204,223,210,204,255,255,255,255,255,255,242,230,217,210,217,204,210,
            217,204,204,204,204,204,204,204,236,223,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,249,242,217,249,
            242,204,236,230,217,236,230,217,204,204,204,204,204,204,217,217,204,249,249,217,249,249,217,242,230,
            204,242,230,204,255,255,255,217,210,204,217,210,204,242,242,204,242,242,204,217,217,204,204,204,204,
            204,204,204,223,217,204,223,217,204,242,236,217,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,242,236,230,242,236,230,242,236,217,242,236,217,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,242,236,230,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,230,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,
            242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,
            217,223,210,204,223,210,204,255,255,255,255,255,255,242,230,217,210,217,204,210,217,204,204,204,204,
            204,204,204,236,223,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,
            242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,249,242,217,249,242,204,236,230,217,
            236,230,217,204,204,204,204,204,204,217,217,204,249,249,217,249,249,217,242,230,204,242,230,204,255,
            255,255,217,210,204,217,210,204,242,242,204,242,242,204,217,217,204,204,204,204,204,204,204,223,217,
            204,223,217,204,242,236,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,230,
            242,236,230,242,236,217,242,236,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,242,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,236,236,230,236,236,
            230,242,249,230,242,249,230,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,217,217,210,204,217,
            210,204,230,217,204,230,217,204,249,249,217,230,223,204,230,223,204,223,217,204,223,217,204,249,242,
            217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,249,242,217,230,223,204,
            230,223,204,236,230,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,236,204,249,
            236,204,249,242,204,249,242,204,249,236,204,249,236,204,249,242,204,230,223,204,230,223,204,204,204,
            204,204,204,204,204,204,204,236,236,204,236,236,204,249,249,217,249,249,217,249,242,217,236,230,204,
            236,230,204,230,230,217,230,230,217,210,217,204,204,204,204,204,204,204,223,210,204,223,210,204,249,
            242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,
            230,242,242,230,255,255,255,242,242,230,242,242,230,236,236,230,236,236,230,242,242,230,242,242,230,
            249,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,242,242,217,242,242,217,242,242,217,242,242,217,242,
            242,217,236,242,217,236,236,230,236,236,230,242,236,230,242,236,230,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,217,236,210,204,236,210,204,249,236,217,
            249,236,217,249,242,204,249,236,204,249,236,204,249,236,217,249,236,217,249,242,204,249,242,204,249,
            242,204,249,242,204,249,242,204,249,242,204,223,223,204,223,223,204,204,204,204,204,204,204,204,204,
            204,230,223,204,230,223,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,236,204,
            249,236,204,249,242,217,249,242,217,249,242,204,242,242,217,242,242,217,217,217,204,217,217,204,204,
            204,204,204,204,204,204,204,204,255,255,255,255,255,255,249,242,204,249,236,217,249,236,217,217,210,
            204,217,210,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,249,242,217,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,236,
            236,230,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,249,230,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,242,242,217,242,242,217,242,242,217,242,242,217,242,242,217,236,242,217,
            236,236,230,236,236,230,242,236,230,242,236,230,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,242,236,217,236,210,204,236,210,204,249,236,217,249,236,217,249,242,
            204,249,236,204,249,236,204,249,236,217,249,236,217,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,204,223,223,204,223,223,204,204,204,204,204,204,204,204,204,204,230,223,204,230,
            223,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,236,204,249,236,204,249,242,
            217,249,242,217,249,242,204,242,242,217,242,242,217,217,217,204,217,217,204,204,204,204,204,204,204,
            204,204,204,255,255,255,255,255,255,249,242,204,249,236,217,249,236,217,217,210,204,217,210,204,204,
            204,204,204,204,204,204,204,204,217,210,204,217,210,204,249,242,217,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,236,236,230,249,242,217,
            249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,249,230,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,249,242,217,249,242,204,249,242,204,242,242,230,242,242,230,242,242,230,249,242,217,249,242,
            217,249,242,217,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,242,236,217,223,217,204,223,217,204,249,242,204,249,242,204,249,242,204,249,242,204,249,
            242,204,249,249,217,249,249,217,249,242,204,249,242,204,249,242,204,242,230,204,242,230,204,217,217,
            204,204,204,204,204,204,204,204,204,204,204,204,204,223,223,204,236,230,204,236,230,204,242,236,204,
            242,236,204,249,242,217,249,236,204,249,236,204,249,242,204,249,242,204,249,242,204,249,242,204,249,
            242,217,249,242,204,249,242,204,242,242,204,242,242,204,217,217,204,204,204,204,204,204,204,204,204,
            204,204,204,204,217,210,204,249,236,217,249,236,217,242,236,217,242,236,217,230,223,204,204,204,204,
            204,204,204,223,217,204,223,217,204,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,242,242,230,242,242,230,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,
            217,249,242,217,249,242,230,249,242,230,249,242,217,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,
            249,242,204,249,242,204,242,242,230,242,242,230,242,242,230,249,242,217,249,242,217,249,242,217,249,
            242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,
            217,223,217,204,223,217,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,249,217,
            249,249,217,249,242,204,249,242,204,249,242,204,242,230,204,242,230,204,217,217,204,204,204,204,204,
            204,204,204,204,204,204,204,204,223,223,204,236,230,204,236,230,204,242,236,204,242,236,204,249,242,
            217,249,236,204,249,236,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,249,242,204,
            249,242,204,242,242,204,242,242,204,217,217,204,204,204,204,204,204,204,204,204,204,204,204,204,217,
            210,204,249,236,217,249,236,217,242,236,217,242,236,217,230,223,204,204,204,204,204,204,204,223,217,
            204,223,217,204,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,230,
            242,242,230,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,
            242,230,249,242,230,249,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,249,230,249,249,217,249,249,
            217,242,242,217,242,242,217,242,242,217,249,242,217,249,242,217,249,242,217,249,242,217,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,217,217,210,204,217,
            210,204,230,217,204,230,217,204,242,223,204,249,242,204,249,242,204,242,230,204,242,230,204,236,230,
            217,236,230,204,236,230,204,217,217,204,217,217,204,230,223,204,217,210,204,217,210,204,236,230,217,
            236,230,217,249,249,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,249,
            242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,
            204,249,242,204,242,242,204,223,217,204,223,217,204,217,210,204,217,210,204,217,210,204,242,236,204,
            242,236,204,249,242,204,249,242,204,236,230,217,204,204,204,204,204,204,217,217,204,217,217,204,242,
            242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,217,242,236,217,242,249,
            217,242,249,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,
            242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,249,249,230,249,249,217,249,249,217,242,242,217,242,
            242,217,242,242,217,249,242,217,249,242,217,249,242,217,249,242,217,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,217,217,210,204,217,210,204,230,217,204,
            230,217,204,242,223,204,249,242,204,249,242,204,242,230,204,242,230,204,236,230,217,236,230,204,236,
            230,204,217,217,204,217,217,204,230,223,204,217,210,204,217,210,204,236,230,217,236,230,217,249,249,
            217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,249,242,217,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,242,
            242,204,223,217,204,223,217,204,217,210,204,217,210,204,217,210,204,242,236,204,242,236,204,249,242,
            204,249,242,204,236,230,217,204,204,204,204,204,204,217,217,204,217,217,204,242,242,217,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,242,236,217,242,236,217,242,249,217,242,249,217,249,
            242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,242,242,230,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,249,249,217,242,242,217,242,242,217,242,249,217,242,249,217,242,242,230,
            242,236,230,242,236,230,249,242,230,249,242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,242,236,217,217,210,204,217,210,204,204,204,204,204,204,204,204,204,
            204,217,217,204,217,217,204,204,204,204,204,204,204,204,204,204,236,230,204,236,230,204,236,230,217,
            236,230,217,249,242,204,242,236,204,242,236,204,242,236,217,242,236,217,249,242,217,249,242,204,249,
            242,204,249,236,204,249,236,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,204,249,236,204,249,236,204,249,242,204,249,242,204,249,242,204,249,242,217,
            249,242,217,242,236,217,242,236,217,236,230,204,249,242,217,249,242,217,249,236,204,249,236,204,223,
            223,217,204,204,204,204,204,204,217,210,204,217,210,204,249,242,217,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,236,236,230,236,236,230,242,242,230,242,242,230,255,255,255,249,249,217,
            249,249,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,230,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,230,242,242,230,242,242,230,242,242,230,
            242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,
            242,230,249,249,230,236,230,230,236,230,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,242,242,230,242,242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,249,242,217,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,217,210,204,236,230,204,236,230,204,242,236,204,242,236,204,249,242,
            204,249,249,204,249,249,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,
            249,242,217,249,236,217,249,242,204,249,242,204,249,242,217,249,242,217,249,242,204,249,242,204,249,
            242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,242,236,204,242,236,204,249,236,
            204,249,236,204,249,242,204,242,230,204,242,230,204,230,223,204,230,223,204,204,204,204,204,204,204,
            204,204,204,223,210,204,223,210,204,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,242,236,230,242,236,230,255,255,255,236,230,230,236,230,230,255,255,
            255,255,255,255,236,236,230,236,236,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,249,249,230,
            236,230,230,236,230,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,230,242,
            242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,249,242,
            217,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,217,210,204,236,230,204,236,230,204,242,236,204,242,236,204,249,242,204,249,249,204,249,
            249,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,249,242,217,249,236,
            217,249,242,204,249,242,204,249,242,217,249,242,217,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,217,242,236,204,242,236,204,249,236,204,249,236,204,249,
            242,204,242,230,204,242,230,204,230,223,204,230,223,204,204,204,204,204,204,204,204,204,204,223,210,
            204,223,210,204,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,242,236,230,242,236,230,255,255,255,236,230,230,236,230,230,255,255,255,255,255,255,236,
            236,230,236,236,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,236,249,230,242,242,230,242,242,230,242,242,230,242,242,230,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,217,242,242,217,242,242,230,
            242,242,230,255,255,255,217,236,242,217,236,242,255,255,255,255,255,255,242,242,217,217,210,204,217,
            210,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,230,223,204,230,223,204,249,242,204,249,236,217,249,236,217,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,230,223,204,236,236,217,236,
            236,217,249,249,217,249,249,217,242,236,204,242,236,204,249,236,204,249,242,204,249,242,204,249,242,
            217,249,242,217,249,242,204,242,236,204,242,236,204,223,210,204,223,210,204,242,236,217,230,223,204,
            230,223,204,255,255,255,255,255,255,204,204,204,204,204,204,204,204,204,217,217,204,217,217,204,242,
            242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,230,242,242,230,249,242,
            217,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,217,249,242,230,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,236,249,230,242,242,230,242,242,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,242,242,217,242,242,217,242,242,230,242,242,230,255,255,
            255,217,236,242,217,236,242,255,255,255,255,255,255,242,242,217,217,210,204,217,210,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,230,223,204,230,223,204,249,242,204,249,236,217,249,236,217,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,204,249,242,204,249,242,204,230,223,204,236,236,217,236,236,217,249,249,217,
            249,249,217,242,236,204,242,236,204,249,236,204,249,242,204,249,242,204,249,242,217,249,242,217,249,
            242,204,242,236,204,242,236,204,223,210,204,223,210,204,242,236,217,230,223,204,230,223,204,255,255,
            255,255,255,255,204,204,204,204,204,204,204,204,204,217,217,204,217,217,204,242,242,230,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,242,242,230,242,242,230,249,242,217,249,242,217,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,230,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,249,242,217,249,242,217,249,242,230,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,242,230,242,242,230,236,236,230,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,242,236,217,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,236,236,230,236,236,230,236,236,230,236,236,230,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,242,236,217,217,217,204,217,217,204,204,204,204,204,204,204,204,204,
            204,217,210,204,217,210,204,230,204,204,230,204,204,230,210,204,217,210,204,217,210,204,223,230,217,
            223,230,217,223,223,204,223,217,204,223,217,204,249,242,217,249,242,217,249,242,204,249,242,204,249,
            242,204,249,242,217,249,242,217,223,217,204,217,210,204,217,210,204,255,255,255,255,255,255,223,210,
            217,223,210,217,242,236,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,223,217,204,223,217,204,230,223,204,230,223,204,230,223,204,236,230,204,236,230,204,255,
            255,255,204,204,204,204,204,204,217,217,204,217,217,204,236,236,217,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,249,249,230,249,249,230,242,242,217,242,242,217,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,236,236,230,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,242,236,217,242,236,217,249,236,230,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,242,236,217,242,236,217,242,236,217,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,242,242,230,242,242,230,242,242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,242,236,230,223,217,204,223,217,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,230,204,204,230,204,204,249,236,204,242,236,217,242,236,217,217,217,204,217,217,204,210,217,
            204,204,204,204,204,204,204,236,230,204,236,230,204,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,230,230,204,204,204,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,249,
            242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,236,204,249,249,204,249,249,204,236,230,
            204,236,230,204,223,217,204,242,236,204,242,236,204,249,242,204,249,242,204,230,223,204,204,204,204,
            204,204,204,217,217,204,217,217,204,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,242,242,230,242,242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,242,242,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,
            230,217,249,230,217,249,236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,242,236,217,242,236,217,242,236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,
            242,242,230,242,242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,
            230,223,217,204,223,217,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,230,204,204,
            230,204,204,249,236,204,242,236,217,242,236,217,217,217,204,217,217,204,210,217,204,204,204,204,204,
            204,204,236,230,204,236,230,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,230,230,
            204,204,204,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,249,242,204,249,242,204,
            249,242,204,249,242,204,249,242,204,249,236,204,249,249,204,249,249,204,236,230,204,236,230,204,223,
            217,204,242,236,204,242,236,204,249,242,204,249,242,204,230,223,204,204,204,204,204,204,204,217,217,
            204,217,217,204,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,230,
            242,242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,
            242,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,230,217,249,230,217,
            249,236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,223,217,
            242,230,217,242,230,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,
            230,255,255,255,255,255,255,255,255,255,236,236,217,236,236,217,236,236,217,236,236,217,242,242,217,
            242,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,223,223,204,223,
            223,204,204,204,204,204,204,204,204,204,204,223,210,204,223,210,204,236,230,204,236,230,204,249,249,
            204,249,236,204,249,236,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,217,210,204,
            217,210,204,242,236,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,217,210,204,217,
            210,204,204,204,204,204,204,204,230,223,204,230,223,204,249,249,217,249,242,217,249,242,217,249,242,
            217,249,242,217,249,242,204,249,242,204,249,242,204,242,236,204,242,236,204,236,223,204,249,242,204,
            249,242,204,249,249,217,249,249,217,242,236,204,217,210,204,217,210,204,217,217,204,217,217,204,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,230,236,217,230,236,217,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,230,242,236,230,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,217,217,249,217,217,249,223,217,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,223,217,242,230,217,242,230,
            217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,255,255,255,255,
            255,255,255,255,255,236,236,217,236,236,217,236,236,217,236,236,217,242,242,217,242,242,217,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,223,223,204,223,223,204,204,204,204,
            204,204,204,204,204,204,223,210,204,223,210,204,236,230,204,236,230,204,249,249,204,249,236,204,249,
            236,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,242,236,
            204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,217,210,204,217,210,204,204,204,204,
            204,204,204,230,223,204,230,223,204,249,249,217,249,242,217,249,242,217,249,242,217,249,242,217,249,
            242,204,249,242,204,249,242,204,242,236,204,242,236,204,236,223,204,249,242,204,249,242,204,249,249,
            217,249,249,217,242,236,204,217,210,204,217,210,204,217,217,204,217,217,204,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,230,236,217,230,236,217,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,230,242,236,230,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,249,217,217,249,217,217,249,223,217,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,242,217,217,249,223,217,249,223,217,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,236,236,230,236,236,230,249,242,204,
            242,242,217,242,242,217,242,242,217,242,242,217,242,242,230,242,242,230,236,236,230,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,236,230,217,236,230,217,204,204,204,204,204,204,223,210,
            217,242,223,217,242,223,217,249,249,204,249,249,204,249,242,204,249,236,204,249,236,204,223,217,204,
            223,217,204,217,210,204,230,223,204,230,223,204,242,236,217,242,236,217,249,249,204,249,242,204,249,
            242,204,249,242,204,249,242,204,249,249,204,236,230,204,236,230,204,236,230,204,236,230,204,242,236,
            204,242,236,204,249,242,204,236,230,204,236,230,204,230,223,204,230,223,204,242,236,204,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,242,236,204,242,236,204,242,
            236,204,217,210,204,217,210,204,230,230,217,230,230,217,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,249,242,230,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,236,236,230,
            236,236,230,255,255,255,255,255,255,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,
            230,242,242,230,249,217,204,249,217,204,249,223,217,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,249,217,217,249,217,217,249,217,217,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,249,242,217,242,236,230,242,236,
            230,236,236,230,236,236,230,242,236,230,242,236,230,242,242,217,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,236,236,217,236,236,217,223,210,204,223,210,204,204,204,204,217,210,204,217,
            210,204,236,230,204,236,230,204,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,236,
            204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,236,204,249,236,204,249,242,217,
            249,242,217,249,242,204,230,217,204,230,217,204,242,236,217,242,236,217,236,236,204,236,236,204,217,
            217,204,217,217,204,217,217,204,204,204,204,204,204,204,217,217,204,223,217,204,223,217,204,249,242,
            217,249,242,217,249,242,204,249,242,204,249,242,204,236,230,204,236,230,204,217,217,204,217,210,204,
            217,210,204,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,
            242,230,236,236,230,236,236,230,236,230,230,236,230,230,242,242,217,242,236,230,242,236,230,236,236,
            230,236,236,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,230,217,242,230,217,249,
            210,217,249,210,217,242,217,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,249,217,217,249,217,217,249,217,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,242,230,242,242,230,249,242,217,242,236,230,242,236,230,236,236,230,236,
            236,230,242,236,230,242,236,230,242,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,236,236,217,236,236,217,223,210,204,223,210,204,204,204,204,217,210,204,217,210,204,236,230,204,
            236,230,204,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,236,204,249,242,204,249,
            242,204,249,242,204,249,242,204,249,242,204,249,236,204,249,236,204,249,242,217,249,242,217,249,242,
            204,230,217,204,230,217,204,242,236,217,242,236,217,236,236,204,236,236,204,217,217,204,217,217,204,
            217,217,204,204,204,204,204,204,204,217,217,204,223,217,204,223,217,204,249,242,217,249,242,217,249,
            242,204,249,242,204,249,242,204,236,230,204,236,230,204,217,217,204,217,210,204,217,210,204,236,236,
            230,236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,230,236,236,230,
            236,236,230,236,230,230,236,230,230,242,242,217,242,236,230,242,236,230,236,236,230,236,236,230,242,
            242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,242,230,217,242,230,217,249,210,217,249,210,217,
            242,217,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,242,217,217,
            249,217,217,249,217,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,
            230,249,242,217,249,242,217,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,242,242,230,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,230,230,204,230,230,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,249,236,
            217,249,242,217,249,242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,242,236,204,204,204,204,204,
            204,204,217,210,204,217,210,204,223,217,204,223,217,204,204,204,204,217,210,204,217,210,204,242,236,
            217,242,236,217,249,242,217,236,230,217,236,230,217,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,236,230,217,236,230,217,204,204,204,223,223,217,223,223,217,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,242,242,
            230,242,242,230,242,236,217,249,242,217,249,242,217,249,249,217,249,249,217,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,242,230,217,249,217,217,249,217,217,242,210,217,242,210,217,249,223,217,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,242,217,217,249,217,217,249,217,
            217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,249,242,217,249,
            242,217,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,
            230,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,230,230,204,
            230,230,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,249,236,217,249,242,217,249,
            242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,204,249,242,204,249,242,204,242,236,204,204,204,204,204,204,204,217,210,204,
            217,210,204,223,217,204,223,217,204,204,204,204,217,210,204,217,210,204,242,236,217,242,236,217,249,
            242,217,236,230,217,236,230,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,236,230,
            217,236,230,217,204,204,204,223,223,217,223,223,217,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,242,
            236,217,249,242,217,249,242,217,249,249,217,249,249,217,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            242,230,217,249,217,217,249,217,217,242,210,217,242,210,217,249,223,217,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,236,236,230,236,236,230,242,217,217,242,217,217,242,217,217,236,230,217,236,
            230,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,242,242,217,242,242,217,236,236,230,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,230,242,242,217,242,
            242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,223,217,
            204,204,204,204,204,204,204,223,210,204,223,210,204,242,217,217,249,236,204,249,236,204,249,242,204,
            249,242,204,249,236,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,
            242,204,249,242,204,249,242,204,230,230,217,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,217,210,204,230,217,204,230,217,204,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,217,236,230,204,236,230,204,217,210,204,217,210,204,217,
            210,204,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,249,242,
            217,249,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,217,
            242,242,217,242,242,217,242,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,242,223,204,249,204,
            217,249,204,217,249,210,217,249,210,217,249,223,217,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,242,223,204,249,210,217,249,210,217,242,217,217,242,217,217,249,230,230,
            242,236,230,242,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,242,242,230,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,242,217,217,217,204,217,
            217,204,204,204,204,204,204,204,217,210,204,255,255,255,255,255,255,236,236,204,236,236,204,230,223,
            204,242,242,204,242,242,204,242,236,204,242,236,204,249,249,217,242,236,204,242,236,204,236,230,204,
            236,230,204,236,236,217,217,210,204,217,210,204,204,204,204,204,204,204,204,204,204,204,204,204,210,
            204,217,223,210,204,223,210,204,236,217,204,236,217,204,249,236,217,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,217,230,223,204,230,223,204,204,204,204,204,204,204,230,230,217,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,236,236,217,236,236,217,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,249,236,217,249,236,217,242,217,217,242,217,217,242,210,217,242,210,217,242,210,217,249,
            210,217,249,210,217,249,230,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,242,223,204,249,210,217,249,210,217,242,217,217,242,217,217,249,230,230,242,236,230,242,236,
            230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,242,230,242,242,230,242,242,230,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,236,242,217,217,217,204,217,217,204,204,204,204,
            204,204,204,217,210,204,255,255,255,255,255,255,236,236,204,236,236,204,230,223,204,242,242,204,242,
            242,204,242,236,204,242,236,204,249,249,217,242,236,204,242,236,204,236,230,204,236,230,204,236,236,
            217,217,210,204,217,210,204,204,204,204,204,204,204,204,204,204,204,204,204,210,204,217,223,210,204,
            223,210,204,236,217,204,236,217,204,249,236,217,249,242,204,249,242,204,249,242,204,249,242,204,249,
            242,217,230,223,204,230,223,204,204,204,204,204,204,204,230,230,217,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,236,236,217,236,236,217,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,236,
            217,249,236,217,242,217,217,242,217,217,242,210,217,242,210,217,242,210,217,249,210,217,249,210,217,
            249,230,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,236,230,
            249,217,204,249,217,204,249,210,217,249,210,217,242,210,217,242,223,217,242,223,217,242,236,217,242,
            236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,236,236,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,242,236,230,242,236,230,242,242,217,242,242,217,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,249,236,230,242,236,204,242,236,204,223,217,204,223,217,204,204,204,
            204,210,217,204,210,217,204,217,217,204,217,217,204,223,223,204,255,255,255,255,255,255,217,210,204,
            217,210,204,236,230,204,230,223,204,230,223,204,204,204,204,204,204,204,217,210,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,223,210,
            204,223,210,204,242,217,217,249,236,217,249,236,217,242,242,204,242,242,204,236,230,204,217,217,204,
            217,217,204,230,223,204,230,223,204,236,236,217,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,249,242,230,249,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,236,236,230,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,230,230,242,217,217,242,217,217,249,
            210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,217,217,242,230,
            217,242,230,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,236,230,249,217,204,249,217,
            204,249,210,217,249,210,217,242,210,217,242,223,217,242,223,217,242,236,217,242,236,217,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,236,236,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,242,236,230,242,236,230,242,242,217,242,242,217,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,249,236,230,242,236,204,242,236,204,223,217,204,223,217,204,204,204,204,210,217,204,210,
            217,204,217,217,204,217,217,204,223,223,204,255,255,255,255,255,255,217,210,204,217,210,204,236,230,
            204,230,223,204,230,223,204,204,204,204,204,204,204,217,210,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,223,210,204,223,210,204,242,
            217,217,249,236,217,249,236,217,242,242,204,242,242,204,236,230,204,217,217,204,217,217,204,230,223,
            204,230,223,204,236,236,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,249,242,230,
            249,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,
            236,230,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,242,230,230,242,217,217,242,217,217,249,210,217,249,210,217,
            249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,217,217,242,230,217,242,230,217,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,249,236,230,249,223,204,249,223,204,249,210,217,249,
            210,217,249,210,217,242,210,204,242,210,204,242,217,217,242,217,217,242,236,217,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            242,242,230,242,242,230,249,242,230,249,242,230,249,249,230,249,249,230,242,242,230,249,242,230,249,
            242,230,249,242,217,249,242,217,249,242,204,236,236,230,236,236,230,236,236,230,236,236,230,242,242,
            217,249,242,217,249,242,217,242,236,217,242,236,217,223,217,204,204,204,204,204,204,204,204,204,204,
            204,204,204,217,210,204,230,230,217,230,230,217,217,210,204,217,210,204,204,204,204,217,210,204,217,
            210,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,223,210,204,217,210,204,
            217,210,204,217,210,204,217,210,204,223,217,204,242,236,217,242,236,217,242,236,230,242,236,230,242,
            242,217,242,242,230,242,242,230,242,242,217,242,242,217,242,242,204,249,249,230,249,249,230,242,242,
            230,242,242,230,242,242,230,242,242,230,242,242,230,249,242,230,249,242,230,242,242,230,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,
            236,230,242,236,230,249,217,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,
            217,249,210,217,249,210,217,249,210,217,249,210,217,242,217,217,242,217,217,242,236,230,242,236,230,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,236,236,230,236,236,230,242,223,217,249,217,217,249,217,217,249,210,217,249,210,217,249,210,217,
            249,210,217,249,210,217,249,210,217,249,210,217,249,217,204,242,236,230,242,236,230,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,217,242,242,
            217,249,236,230,249,236,230,242,242,217,242,242,217,249,249,204,249,242,217,249,242,217,249,242,217,
            249,242,217,249,242,204,249,242,204,249,242,204,249,242,217,249,242,217,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,242,242,217,230,223,204,230,223,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,217,
            204,204,217,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,217,210,
            204,217,210,204,236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,242,236,230,249,242,204,
            249,242,204,249,242,204,249,242,204,249,242,217,249,242,217,249,242,217,249,249,230,249,249,230,249,
            242,217,242,242,217,242,242,217,242,242,217,242,242,217,236,236,230,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,223,217,242,223,217,
            249,210,217,249,210,217,249,210,217,249,217,217,249,217,217,242,210,217,249,217,217,249,217,217,249,
            210,217,249,210,217,249,210,217,242,210,217,242,210,217,242,230,230,242,230,230,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,
            236,230,242,223,217,249,217,217,249,217,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,
            217,249,210,217,249,210,217,249,217,204,242,236,230,242,236,230,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,217,242,242,217,249,236,230,249,
            236,230,242,242,217,242,242,217,249,249,204,249,242,217,249,242,217,249,242,217,249,242,217,249,242,
            204,249,242,204,249,242,204,249,242,217,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,242,242,217,230,223,204,230,223,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,217,204,204,217,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,217,210,204,217,210,204,236,
            236,230,255,255,255,255,255,255,255,255,255,255,255,255,242,236,230,249,242,204,249,242,204,249,242,
            204,249,242,204,249,242,217,249,242,217,249,242,217,249,249,230,249,249,230,249,242,217,242,242,217,
            242,242,217,242,242,217,242,242,217,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,223,217,242,223,217,249,210,217,249,210,
            217,249,210,217,249,217,217,249,217,217,242,210,217,249,217,217,249,217,217,249,210,217,249,210,217,
            249,210,217,242,210,217,242,210,217,242,230,230,242,230,230,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,242,236,242,242,236,242,242,223,217,242,223,217,242,210,217,
            249,210,217,249,210,217,249,210,217,249,210,217,242,217,217,249,217,217,249,217,217,249,210,217,249,
            210,217,249,210,217,249,230,217,249,230,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,217,
            242,242,217,242,236,230,255,255,255,255,255,255,249,249,230,249,249,230,249,242,217,249,242,204,249,
            242,204,249,242,204,249,242,204,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,242,236,230,242,236,230,236,236,217,236,236,217,217,217,204,204,204,204,204,204,204,204,204,217,
            204,204,217,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,217,210,204,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,230,217,
            223,230,217,255,255,255,255,255,255,242,242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,
            242,204,249,249,217,249,249,217,255,255,255,255,255,255,242,242,217,249,242,217,249,242,217,242,242,
            230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,242,242,230,242,242,230,242,223,204,242,223,204,249,210,217,249,210,217,249,210,217,242,
            217,217,242,217,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,
            204,249,210,204,249,223,217,249,223,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,242,236,242,242,236,242,242,223,217,242,223,217,242,210,217,249,210,217,249,210,
            217,249,210,217,249,210,217,242,217,217,249,217,217,249,217,217,249,210,217,249,210,217,249,210,217,
            249,230,217,249,230,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,217,242,242,217,242,236,
            230,255,255,255,255,255,255,249,249,230,249,249,230,249,242,217,249,242,204,249,242,204,249,242,204,
            249,242,204,249,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,236,230,242,
            236,230,236,236,217,236,236,217,217,217,204,204,204,204,204,204,204,204,204,217,204,204,217,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,217,
            210,204,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,230,217,223,230,217,255,255,
            255,255,255,255,242,242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,249,249,217,
            249,249,217,255,255,255,255,255,255,242,242,217,249,242,217,249,242,217,242,242,230,242,242,230,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,
            230,242,242,230,242,223,204,242,223,204,249,210,217,249,210,217,249,210,217,242,217,217,242,217,217,
            249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,204,249,210,204,249,
            223,217,249,223,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            242,236,217,242,236,217,242,210,217,242,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,
            210,217,242,210,217,242,217,217,242,217,217,249,210,217,249,210,217,249,210,217,242,223,217,242,223,
            217,242,236,230,242,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,242,242,217,242,242,217,236,230,230,236,236,230,236,
            236,230,249,249,217,249,249,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,
            217,249,242,217,249,242,217,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,236,236,217,230,230,204,230,230,204,217,210,204,217,210,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,223,223,217,223,223,217,236,230,230,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,217,242,242,217,249,
            242,217,249,242,204,249,242,204,249,242,217,249,242,217,249,242,217,249,242,204,249,242,204,236,230,
            230,236,230,230,236,236,230,242,242,217,242,242,217,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,217,242,236,217,242,
            217,217,242,217,217,242,210,217,249,217,217,249,217,217,242,210,217,242,210,217,249,210,217,249,210,
            204,249,210,204,242,210,217,242,210,217,249,210,217,249,210,204,249,210,204,249,217,217,249,217,217,
            242,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,217,242,236,
            217,249,210,217,249,210,217,249,210,217,242,217,217,242,217,217,242,210,217,242,210,217,249,210,217,
            242,217,217,242,217,217,242,210,217,242,210,217,249,210,217,249,217,217,249,217,217,242,230,217,242,
            230,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,242,236,230,242,236,230,242,242,217,249,242,217,249,242,217,249,242,204,
            249,242,204,242,242,217,242,236,230,242,236,230,249,242,217,249,242,217,249,242,217,242,242,217,242,
            242,217,242,242,217,242,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,236,236,217,236,236,217,223,223,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,223,
            217,204,236,236,230,236,236,230,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,236,236,230,236,236,230,236,236,230,242,242,230,242,242,230,249,242,217,249,242,217,
            249,242,217,249,242,217,249,242,217,249,242,217,249,236,204,249,236,204,249,242,217,249,242,217,236,
            236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,249,236,217,249,236,217,242,210,204,242,210,204,
            249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,242,217,217,249,223,217,249,223,217,249,
            236,217,249,236,217,249,230,217,249,230,217,249,230,217,242,223,217,242,223,217,242,230,217,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,217,242,236,217,249,210,217,249,
            210,217,249,210,217,242,217,217,242,217,217,242,210,217,242,210,217,249,210,217,242,217,217,242,217,
            217,242,210,217,242,210,217,249,210,217,249,217,217,249,217,217,242,230,217,242,230,217,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,242,236,230,242,236,230,242,242,217,249,242,217,249,242,217,249,242,204,249,242,204,242,242,
            217,242,236,230,242,236,230,249,242,217,249,242,217,249,242,217,242,242,217,242,242,217,242,242,217,
            242,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,236,236,217,236,236,217,223,223,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,
            204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,204,223,217,204,236,236,230,
            236,236,230,236,236,230,236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,
            236,230,236,236,230,236,236,230,242,242,230,242,242,230,249,242,217,249,242,217,249,242,217,249,242,
            217,249,242,217,249,242,217,249,236,204,249,236,204,249,242,217,249,242,217,236,236,230,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,249,236,217,249,236,217,242,210,204,242,210,204,249,210,217,249,210,
            217,249,210,217,249,210,217,249,210,217,242,217,217,249,223,217,249,223,217,249,236,217,249,236,217,
            249,230,217,249,230,217,249,230,217,242,223,217,242,223,217,242,230,217,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,242,236,230,242,236,230,249,210,217,249,210,217,242,210,217,
            242,217,217,242,217,217,242,217,217,242,217,217,249,210,217,249,210,217,249,210,217,249,210,217,249,
            210,217,249,210,217,249,210,204,249,210,204,249,223,217,249,223,217,236,230,230,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,249,236,217,249,242,204,249,242,204,249,242,217,249,242,217,255,255,255,236,236,230,236,
            236,230,249,242,217,249,242,217,236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,242,236,
            217,249,236,217,249,236,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,236,236,217,236,236,217,223,223,204,223,223,204,204,204,204,204,204,204,204,
            204,204,223,217,204,223,217,204,236,230,230,236,230,230,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,236,236,230,236,236,230,255,255,255,255,255,255,236,236,230,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,249,249,217,249,249,217,249,249,230,249,249,230,249,
            242,230,249,242,217,249,242,217,249,242,204,249,242,204,242,242,217,135,207,163,135,207,163,236,236,
            230,236,236,230,249,236,217,242,230,204,242,230,204,242,236,230,242,236,230,135,207,163,135,207,163,
            135,207,163,249,230,217,249,230,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,242,
            217,217,242,217,217,242,236,217,236,230,230,236,230,230,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,242,236,230,242,236,230,249,230,204,242,236,217,242,236,217,135,207,163,135,207,163,
            242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,242,236,230,242,236,230,249,210,217,249,210,217,242,210,217,242,217,217,242,217,
            217,242,217,217,242,217,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,
            249,210,204,249,210,204,249,223,217,249,223,217,236,230,230,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,236,
            217,249,242,204,249,242,204,249,242,217,249,242,217,255,255,255,236,236,230,236,236,230,249,242,217,
            249,242,217,236,236,230,255,255,255,255,255,255,255,255,255,255,255,255,242,236,217,249,236,217,249,
            236,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,236,236,217,236,236,217,223,223,204,223,223,204,204,204,204,204,204,204,204,204,204,223,217,204,
            223,217,204,236,230,230,236,230,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,236,236,230,236,236,230,255,255,255,255,255,255,236,236,230,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,249,249,217,249,249,217,249,249,230,249,249,230,249,242,230,249,242,217,
            249,242,217,249,242,204,249,242,204,242,242,217,135,207,163,135,207,163,236,236,230,236,236,230,249,
            236,217,242,230,204,242,230,204,242,236,230,242,236,230,135,207,163,135,207,163,135,207,163,249,230,
            217,249,230,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,242,217,217,242,217,217,
            242,236,217,236,230,230,236,230,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,
            236,230,242,236,230,249,230,204,242,236,217,242,236,217,135,207,163,135,207,163,242,242,230,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            249,223,217,249,223,217,242,217,204,242,217,204,242,223,217,249,236,217,249,236,217,249,236,217,249,
            236,217,242,230,217,249,210,217,249,210,217,242,210,217,242,210,217,249,210,217,249,210,217,249,210,
            217,242,210,217,242,210,217,242,230,230,135,207,163,135,207,163,135,207,163,135,207,163,249,230,217,
            242,223,204,242,223,204,249,223,217,249,223,217,249,242,217,249,242,217,249,242,217,249,242,217,249,
            242,217,249,242,217,249,242,217,255,255,255,242,242,217,242,242,217,249,242,217,249,242,217,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,242,242,217,
            242,242,217,249,242,217,242,242,217,242,242,217,255,255,255,255,255,255,255,255,255,242,242,217,242,
            242,217,249,242,217,249,242,217,249,242,217,249,236,217,249,236,217,249,242,217,249,242,217,236,236,
            230,236,236,230,255,255,255,236,236,230,236,236,230,255,255,255,255,255,255,242,242,230,249,249,217,
            249,249,217,242,242,217,242,242,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,
            236,230,249,242,204,249,242,204,249,242,217,249,242,217,242,242,230,242,242,217,242,242,217,242,242,
            230,242,242,230,249,242,204,249,230,204,249,230,204,249,223,204,249,223,204,249,210,217,249,210,217,
            249,210,217,249,230,217,249,230,217,135,207,163,135,207,163,135,207,163,249,230,217,249,230,217,249,
            210,217,249,210,217,249,210,217,249,210,217,249,210,217,242,236,217,242,236,217,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,242,242,230,242,242,230,242,242,230,242,242,230,249,242,217,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,230,230,242,230,217,242,230,
            217,242,230,217,242,230,217,242,236,230,135,207,163,135,207,163,135,207,163,135,207,163,236,230,230,
            249,217,217,249,217,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,
            210,217,249,230,217,242,242,217,242,242,217,242,230,217,242,230,217,242,210,217,242,210,217,242,210,
            217,249,210,217,249,210,217,249,223,204,249,223,204,249,230,217,236,236,230,236,236,230,255,255,255,
            255,255,255,236,236,230,249,242,204,249,242,204,249,242,217,249,242,217,249,242,217,236,236,230,236,
            236,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,249,242,217,249,242,217,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,230,249,242,230,249,242,230,249,249,217,
            249,249,217,249,242,217,249,249,217,249,249,217,249,242,217,249,242,217,249,249,230,249,249,230,255,
            255,255,236,236,230,236,236,230,236,236,230,236,236,230,255,255,255,242,242,217,242,242,217,242,236,
            217,242,236,217,236,230,230,255,255,255,255,255,255,255,255,255,255,255,255,242,242,217,249,242,217,
            249,242,217,249,236,230,249,236,230,242,242,230,255,255,255,255,255,255,242,236,230,242,236,230,242,
            230,217,249,223,217,249,223,217,249,223,217,249,223,217,249,217,217,249,210,217,249,210,217,242,217,
            204,242,217,204,236,236,217,236,236,217,135,207,163,242,230,217,242,230,217,249,210,217,249,210,217,
            242,210,217,249,210,217,249,210,217,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,236,230,230,242,230,217,242,230,217,242,230,217,242,
            230,217,242,236,230,135,207,163,135,207,163,135,207,163,135,207,163,236,230,230,249,217,217,249,217,
            217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,230,217,
            242,242,217,242,242,217,242,230,217,242,230,217,242,210,217,242,210,217,242,210,217,249,210,217,249,
            210,217,249,223,204,249,223,204,249,230,217,236,236,230,236,236,230,255,255,255,255,255,255,236,236,
            230,249,242,204,249,242,204,249,242,217,249,242,217,249,242,217,236,236,230,236,236,230,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,249,242,217,249,242,217,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,242,242,230,249,242,230,249,242,230,249,249,217,249,249,217,249,242,
            217,249,249,217,249,249,217,249,242,217,249,242,217,249,249,230,249,249,230,255,255,255,236,236,230,
            236,236,230,236,236,230,236,236,230,255,255,255,242,242,217,242,242,217,242,236,217,242,236,217,236,
            230,230,255,255,255,255,255,255,255,255,255,255,255,255,242,242,217,249,242,217,249,242,217,249,236,
            230,249,236,230,242,242,230,255,255,255,255,255,255,242,236,230,242,236,230,242,230,217,249,223,217,
            249,223,217,249,223,217,249,223,217,249,217,217,249,210,217,249,210,217,242,217,204,242,217,204,236,
            236,217,236,236,217,135,207,163,242,230,217,242,230,217,249,210,217,249,210,217,242,210,217,249,210,
            217,249,210,217,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,248,242,242,248,
            242,242,242,217,242,242,217,242,242,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,230,230,249,230,230,249,210,217,249,
            210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,242,223,217,249,236,204,249,236,
            204,249,217,217,249,217,217,249,210,217,242,210,217,242,210,217,249,223,217,249,223,217,249,217,217,
            249,217,217,249,217,204,249,230,204,249,230,204,236,236,230,236,236,230,255,255,255,249,242,230,249,
            242,230,249,242,217,249,242,217,242,242,230,255,255,255,255,255,255,236,242,217,236,242,217,249,242,
            217,249,242,204,249,242,204,249,242,204,249,242,204,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,249,242,230,249,242,230,249,242,217,249,242,217,249,
            242,217,249,249,230,249,249,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,242,236,217,242,236,217,249,242,217,249,242,217,249,242,217,242,242,217,
            242,242,217,236,236,230,236,236,230,242,242,230,242,242,217,242,242,217,249,236,230,249,236,230,249,
            242,230,249,236,217,249,236,217,242,223,217,242,223,217,242,217,204,242,217,217,242,217,217,249,223,
            217,249,223,217,249,223,217,249,210,217,249,210,217,242,210,217,242,210,217,242,230,217,242,230,217,
            236,236,230,249,230,217,249,230,217,249,210,217,249,210,217,242,210,217,242,217,204,242,217,204,242,
            236,230,242,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,248,242,242,248,242,242,242,217,242,
            242,217,242,242,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,249,230,230,249,230,230,249,210,217,249,210,217,249,210,217,
            249,210,217,249,210,217,249,210,217,249,210,217,242,223,217,249,236,204,249,236,204,249,217,217,249,
            217,217,249,210,217,242,210,217,242,210,217,249,223,217,249,223,217,249,217,217,249,217,217,249,217,
            204,249,230,204,249,230,204,236,236,230,236,236,230,255,255,255,249,242,230,249,242,230,249,242,217,
            249,242,217,242,242,230,255,255,255,255,255,255,236,242,217,236,242,217,249,242,217,249,242,204,249,
            242,204,249,242,204,249,242,204,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,249,242,230,249,242,230,249,242,217,249,242,217,249,242,217,249,249,230,
            249,249,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,242,236,217,242,236,217,249,242,217,249,242,217,249,242,217,242,242,217,242,242,217,236,236,
            230,236,236,230,242,242,230,242,242,217,242,242,217,249,236,230,249,236,230,249,242,230,249,236,217,
            249,236,217,242,223,217,242,223,217,242,217,204,242,217,217,242,217,217,249,223,217,249,223,217,249,
            223,217,249,210,217,249,210,217,242,210,217,242,210,217,242,230,217,242,230,217,236,236,230,249,230,
            217,249,230,217,249,210,217,249,210,217,242,210,217,242,217,204,242,217,204,242,236,230,242,236,230,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,236,236,230,236,236,230,242,210,217,242,210,217,242,210,204,249,210,217,249,210,
            217,249,210,217,249,210,217,249,223,217,249,230,204,249,230,204,249,210,217,249,210,217,242,210,217,
            249,217,217,249,217,217,249,223,204,249,223,204,249,217,204,249,217,204,249,223,217,249,223,204,249,
            223,204,242,217,204,242,217,204,249,230,230,255,255,255,255,255,255,255,255,255,255,255,255,242,242,
            217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,242,236,230,242,236,230,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,236,
            236,230,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,236,236,230,236,236,230,249,242,217,242,242,217,242,242,217,236,236,217,236,236,217,249,
            249,217,249,249,217,249,249,217,249,236,217,249,236,217,249,230,217,249,217,204,249,217,204,249,217,
            217,249,217,217,249,223,217,249,223,204,249,223,204,249,217,217,249,217,217,249,217,217,242,210,217,
            242,210,217,242,210,217,242,210,217,249,210,217,249,210,217,242,236,217,249,230,217,249,230,217,249,
            210,217,249,210,217,249,210,217,242,217,204,242,217,204,236,236,230,236,236,230,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            236,236,230,236,236,230,242,210,217,242,210,217,242,210,204,249,210,217,249,210,217,249,210,217,249,
            210,217,249,223,217,249,230,204,249,230,204,249,210,217,249,210,217,242,210,217,249,217,217,249,217,
            217,249,223,204,249,223,204,249,217,204,249,217,204,249,223,217,249,223,204,249,223,204,242,217,204,
            242,217,204,249,230,230,255,255,255,255,255,255,255,255,255,255,255,255,242,242,217,249,242,217,249,
            242,217,249,242,217,249,242,217,249,242,217,242,236,230,242,236,230,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,249,242,217,
            249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,236,236,
            230,236,236,230,249,242,217,242,242,217,242,242,217,236,236,217,236,236,217,249,249,217,249,249,217,
            249,249,217,249,236,217,249,236,217,249,230,217,249,217,204,249,217,204,249,217,217,249,217,217,249,
            223,217,249,223,204,249,223,204,249,217,217,249,217,217,249,217,217,242,210,217,242,210,217,242,210,
            217,242,210,217,249,210,217,249,210,217,242,236,217,249,230,217,249,230,217,249,210,217,249,210,217,
            249,210,217,242,217,204,242,217,204,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,249,217,217,249,217,217,249,217,217,242,210,217,242,210,217,242,217,217,242,217,217,249,230,217,
            249,223,217,249,223,217,249,210,217,249,210,217,249,223,217,249,217,204,249,217,204,249,217,217,249,
            217,217,249,217,204,249,217,204,249,223,217,242,223,217,242,223,217,249,223,204,249,223,204,249,223,
            204,249,223,217,249,223,217,242,230,230,242,230,230,236,236,230,242,242,230,242,242,230,249,249,217,
            249,249,217,242,236,230,236,230,230,236,230,230,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,236,230,230,236,230,230,249,242,217,249,242,217,249,242,
            204,249,242,204,249,242,204,242,242,217,242,242,217,255,255,255,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,242,242,230,242,242,230,249,
            242,217,249,242,230,249,242,230,249,242,230,249,242,230,249,242,230,249,230,217,249,230,217,249,217,
            204,249,217,204,242,217,217,249,230,204,249,230,204,249,217,217,249,217,217,249,223,217,249,223,204,
            249,223,204,249,217,217,249,217,217,242,210,217,242,210,217,242,210,217,249,210,217,249,210,217,249,
            210,217,249,210,217,249,230,217,249,230,217,249,230,217,242,210,217,242,210,217,249,210,217,249,217,
            217,249,217,217,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,223,217,242,
            223,217,242,210,217,242,210,217,242,210,217,249,217,217,249,217,217,249,230,217,242,210,217,242,210,
            217,249,217,217,249,217,217,249,230,204,249,230,204,249,230,204,249,217,217,249,217,217,249,217,217,
            249,217,217,249,223,217,249,217,204,249,217,204,249,230,204,249,230,204,249,223,204,249,223,204,249,
            223,204,249,223,204,249,223,204,249,230,217,242,236,230,242,236,230,255,255,255,255,255,255,255,255,
            255,236,236,217,236,236,217,255,255,255,255,255,255,236,242,217,236,242,217,236,242,217,255,255,255,
            255,255,255,255,255,255,236,236,230,236,236,230,242,236,230,242,236,230,249,242,204,249,242,204,249,
            242,204,236,236,217,236,236,217,255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,255,255,
            255,255,255,255,255,255,255,242,236,230,242,236,230,249,236,230,249,236,230,236,236,230,249,242,230,
            249,242,230,249,230,217,249,230,217,242,217,217,249,217,204,249,217,204,249,223,204,249,223,204,242,
            210,217,249,223,217,249,223,217,249,217,217,249,217,217,242,217,217,249,223,217,249,223,217,249,223,
            217,249,223,217,242,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,
            242,217,204,249,230,217,249,230,217,249,217,217,249,217,217,242,210,217,249,217,217,249,217,217,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,223,217,242,223,217,242,210,217,
            242,210,217,242,210,217,249,217,217,249,217,217,249,230,217,242,210,217,242,210,217,249,217,217,249,
            217,217,249,230,204,249,230,204,249,230,204,249,217,217,249,217,217,249,217,217,249,217,217,249,223,
            217,249,217,204,249,217,204,249,230,204,249,230,204,249,223,204,249,223,204,249,223,204,249,223,204,
            249,223,204,249,230,217,242,236,230,242,236,230,255,255,255,255,255,255,255,255,255,236,236,217,236,
            236,217,255,255,255,255,255,255,236,242,217,236,242,217,236,242,217,255,255,255,255,255,255,255,255,
            255,236,236,230,236,236,230,242,236,230,242,236,230,249,242,204,249,242,204,249,242,204,236,236,217,
            236,236,217,255,255,255,255,255,255,255,255,255,236,236,230,236,236,230,255,255,255,255,255,255,255,
            255,255,242,236,230,242,236,230,249,236,230,249,236,230,236,236,230,249,242,230,249,242,230,249,230,
            217,249,230,217,242,217,217,249,217,204,249,217,204,249,223,204,249,223,204,242,210,217,249,223,217,
            249,223,217,249,217,217,249,217,217,242,217,217,249,223,217,249,223,217,249,223,217,249,223,217,242,
            210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,242,217,204,249,230,
            217,249,230,217,249,217,217,249,217,217,242,210,217,249,217,217,249,217,217,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,230,217,242,230,217,249,210,217,249,210,217,249,210,
            217,249,223,217,249,223,217,249,223,217,242,210,217,242,210,217,249,217,217,249,217,217,249,230,217,
            249,223,204,249,223,204,249,223,204,249,223,204,249,223,204,249,223,204,249,217,204,242,217,204,242,
            217,204,249,223,204,249,223,204,249,230,204,249,217,217,249,217,217,249,223,217,249,223,217,249,217,
            204,249,223,204,249,223,204,249,230,217,249,230,217,242,236,217,255,255,255,255,255,255,255,255,255,
            255,255,255,255,255,255,236,236,230,236,236,230,242,242,230,242,242,230,249,249,217,242,236,230,242,
            236,230,242,242,230,242,242,230,242,242,217,236,236,230,236,236,230,242,236,230,242,236,230,242,242,
            230,242,242,230,249,242,230,249,242,217,249,242,217,249,242,230,249,242,230,249,242,230,249,242,230,
            249,242,230,249,236,217,249,236,217,242,230,217,242,223,217,242,223,217,249,223,204,249,223,204,249,
            223,204,249,230,204,249,230,204,249,223,217,249,223,217,249,217,217,242,210,217,242,210,217,249,217,
            217,249,217,217,249,223,217,249,223,217,249,223,217,249,230,217,249,230,217,249,217,204,249,210,217,
            249,210,217,242,217,217,242,217,217,242,217,217,242,217,217,249,217,217,249,230,217,249,230,217,249,
            223,217,249,223,217,242,210,217,249,223,217,249,223,217,236,236,230,236,236,230,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,230,217,242,230,217,249,210,217,249,210,217,249,210,217,249,223,217,249,
            223,217,249,223,217,242,210,217,242,210,217,249,217,217,249,217,217,249,230,217,249,223,204,249,223,
            204,249,223,204,249,223,204,249,223,204,249,223,204,249,217,204,242,217,204,242,217,204,249,223,204,
            249,223,204,249,230,204,249,217,217,249,217,217,249,223,217,249,223,217,249,217,204,249,223,204,249,
            223,204,249,230,217,249,230,217,242,236,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
            255,236,236,230,236,236,230,242,242,230,242,242,230,249,249,217,242,236,230,242,236,230,242,242,230,
            242,242,230,242,242,217,236,236,230,236,236,230,242,236,230,242,236,230,242,242,230,242,242,230,249,
            242,230,249,242,217,249,242,217,249,242,230,249,242,230,249,242,230,249,242,230,249,242,230,249,236,
            217,249,236,217,242,230,217,242,223,217,242,223,217,249,223,204,249,223,204,249,223,204,249,230,204,
            249,230,204,249,223,217,249,223,217,249,217,217,242,210,217,242,210,217,249,217,217,249,217,217,249,
            223,217,249,223,217,249,223,217,249,230,217,249,230,217,249,217,204,249,210,217,249,210,217,242,217,
            217,242,217,217,242,217,217,242,217,217,249,217,217,249,230,217,249,230,217,249,223,217,249,223,217,
            242,210,217,249,223,217,249,223,217,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,242,236,230,242,236,230,242,210,217,242,210,217,242,210,217,249,230,204,249,230,204,249,223,204,
            249,230,217,249,230,217,249,230,204,249,230,204,249,217,217,242,217,217,242,217,217,249,230,217,249,
            230,217,249,223,217,249,223,217,242,217,204,249,230,217,249,230,217,242,217,217,242,217,217,249,217,
            217,249,230,204,249,230,204,249,223,204,249,223,204,249,223,217,249,223,204,249,223,204,242,217,217,
            242,217,217,242,217,217,249,217,217,249,217,217,249,223,217,249,223,217,242,236,217,242,236,230,242,
            236,230,242,242,230,242,242,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,242,242,
            230,249,242,230,249,242,230,255,255,255,255,255,255,242,242,242,242,242,242,249,242,230,249,242,204,
            249,242,204,249,230,217,249,230,217,242,223,217,242,217,204,242,217,204,242,217,204,242,217,204,249,
            217,204,249,223,204,249,223,204,249,223,204,249,223,204,249,223,217,242,223,217,242,223,217,249,217,
            217,249,217,217,249,217,217,249,223,217,249,223,217,249,217,217,249,217,217,249,223,204,242,217,217,
            242,217,217,249,230,217,249,230,217,249,223,204,249,217,217,249,217,217,249,230,204,249,230,204,249,
            242,217,249,242,217,249,217,217,242,223,204,242,223,204,249,230,204,249,230,204,242,210,217,242,217,
            204,242,217,204,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,230,242,
            236,230,249,217,217,249,210,217,249,210,217,249,217,217,249,217,217,249,223,204,249,242,204,249,242,
            204,249,236,204,249,236,204,249,223,217,242,217,217,242,217,217,249,210,217,249,210,217,249,217,204,
            249,217,204,249,230,204,242,230,204,242,230,204,249,223,217,249,223,217,249,223,217,249,217,204,249,
            217,204,249,217,217,249,217,217,249,217,204,249,223,204,249,223,204,249,223,217,249,223,217,249,223,
            217,242,217,204,242,217,204,249,230,217,249,230,217,249,217,217,249,217,204,249,217,204,242,217,217,
            242,217,217,249,223,217,249,223,217,249,223,217,249,223,217,249,223,217,249,223,217,249,223,217,249,
            223,217,242,223,217,242,223,217,249,217,204,249,217,204,242,217,217,249,217,217,249,217,217,249,210,
            217,249,210,217,249,217,204,249,223,204,249,223,204,249,223,217,249,223,217,249,223,204,249,223,217,
            249,223,217,249,223,204,249,223,204,249,223,217,242,217,204,242,217,204,249,217,217,249,217,217,249,
            223,217,249,223,217,249,223,217,249,223,204,249,223,204,249,223,204,249,230,217,249,230,217,242,217,
            204,242,217,204,249,223,217,249,223,217,249,223,217,242,217,217,242,217,217,249,230,217,249,230,217,
            249,236,217,242,230,204,242,230,204,249,236,217,249,236,217,249,223,204,242,230,217,242,230,217,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,230,242,236,230,249,217,217,
            249,210,217,249,210,217,249,217,217,249,217,217,249,223,204,249,242,204,249,242,204,249,236,204,249,
            236,204,249,223,217,242,217,217,242,217,217,249,210,217,249,210,217,249,217,204,249,217,204,249,230,
            204,242,230,204,242,230,204,249,223,217,249,223,217,249,223,217,249,217,204,249,217,204,249,217,217,
            249,217,217,249,217,204,249,223,204,249,223,204,249,223,217,249,223,217,249,223,217,242,217,204,242,
            217,204,249,230,217,249,230,217,249,217,217,249,217,204,249,217,204,242,217,217,242,217,217,249,223,
            217,249,223,217,249,223,217,249,223,217,249,223,217,249,223,217,249,223,217,249,223,217,242,223,217,
            242,223,217,249,217,204,249,217,204,242,217,217,249,217,217,249,217,217,249,210,217,249,210,217,249,
            217,204,249,223,204,249,223,204,249,223,217,249,223,217,249,223,204,249,223,217,249,223,217,249,223,
            204,249,223,204,249,223,217,242,217,204,242,217,204,249,217,217,249,217,217,249,223,217,249,223,217,
            249,223,217,249,223,204,249,223,204,249,223,204,249,230,217,249,230,217,242,217,204,242,217,204,249,
            223,217,249,223,217,249,223,217,242,217,217,242,217,217,249,230,217,249,230,217,249,236,217,242,230,
            204,242,230,204,249,236,217,249,236,217,249,223,204,242,230,217,242,230,217,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,230,217,249,236,204,249,236,
            204,249,236,204,249,236,204,249,236,204,249,242,217,249,242,217,249,223,217,249,223,217,249,210,217,
            249,217,204,249,217,204,249,230,217,249,230,217,242,217,204,242,217,204,242,210,204,249,223,217,249,
            223,217,249,223,217,249,223,217,249,223,217,242,223,217,242,223,217,249,223,217,249,223,217,249,217,
            204,249,217,217,249,217,217,249,223,217,249,223,217,249,223,204,249,217,217,249,217,217,249,217,217,
            249,217,217,249,217,217,249,223,217,249,223,217,249,217,217,249,217,217,249,223,217,249,223,217,249,
            223,217,242,217,217,242,217,217,242,210,217,242,210,217,242,210,217,249,210,217,249,210,217,249,210,
            217,249,210,217,249,217,217,249,217,217,249,217,217,249,217,217,249,217,217,249,223,217,249,223,204,
            249,223,204,249,223,217,249,223,217,249,223,204,249,217,217,249,217,217,242,217,217,242,217,217,249,
            223,217,242,223,217,242,223,217,249,223,217,249,223,217,249,223,217,249,223,217,249,223,217,249,210,
            204,249,210,204,242,217,204,249,230,217,249,230,217,249,223,217,249,223,217,242,210,217,242,210,217,
            242,210,217,242,210,217,242,210,217,249,217,204,249,217,204,249,242,204,249,242,204,249,242,204,249,
            242,204,249,242,204,249,242,204,242,236,217,242,236,217,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,242,230,217,249,236,204,249,236,204,249,236,204,249,
            236,204,249,236,204,249,242,217,249,242,217,249,223,217,249,223,217,249,210,217,249,217,204,249,217,
            204,249,230,217,249,230,217,242,217,204,242,217,204,242,210,204,249,223,217,249,223,217,249,223,217,
            249,223,217,249,223,217,242,223,217,242,223,217,249,223,217,249,223,217,249,217,204,249,217,217,249,
            217,217,249,223,217,249,223,217,249,223,204,249,217,217,249,217,217,249,217,217,249,217,217,249,217,
            217,249,223,217,249,223,217,249,217,217,249,217,217,249,223,217,249,223,217,249,223,217,242,217,217,
            242,217,217,242,210,217,242,210,217,242,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,
            217,217,249,217,217,249,217,217,249,217,217,249,217,217,249,223,217,249,223,204,249,223,204,249,223,
            217,249,223,217,249,223,204,249,217,217,249,217,217,242,217,217,242,217,217,249,223,217,242,223,217,
            242,223,217,249,223,217,249,223,217,249,223,217,249,223,217,249,223,217,249,210,204,249,210,204,242,
            217,204,249,230,217,249,230,217,249,223,217,249,223,217,242,210,217,242,210,217,242,210,217,242,210,
            217,242,210,217,249,217,204,249,217,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,
            249,242,204,242,236,217,242,236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,249,236,230,249,236,204,249,236,204,249,242,217,249,242,217,249,236,217,
            242,223,204,242,223,204,249,217,217,249,217,217,249,217,204,242,217,217,242,217,217,242,236,230,242,
            236,230,236,236,230,236,236,230,242,223,217,249,217,204,249,217,204,249,217,217,249,217,217,249,217,
            217,249,217,217,249,217,217,249,223,217,249,223,217,249,217,204,249,217,217,249,217,217,249,217,217,
            249,217,217,242,217,217,249,223,217,249,223,217,249,223,217,249,223,217,249,217,204,249,223,217,249,
            223,217,249,223,217,249,223,217,249,223,217,249,217,217,249,217,217,242,210,217,242,210,217,249,210,
            217,249,210,217,249,210,217,242,210,217,242,210,217,249,217,217,249,217,217,249,217,217,242,217,217,
            242,217,217,249,217,217,249,217,217,249,230,217,249,223,217,249,223,217,242,217,204,242,217,204,249,
            210,204,242,210,217,242,210,217,249,217,217,249,217,217,249,223,217,249,223,204,249,223,204,249,223,
            204,249,223,204,249,223,204,249,210,217,249,210,217,249,223,217,249,223,217,249,236,230,249,242,217,
            249,242,217,249,223,217,249,223,217,249,210,217,249,210,217,249,210,217,249,217,204,249,217,204,249,
            223,217,249,223,217,242,236,204,249,242,204,249,242,204,249,242,204,249,242,204,249,242,204,242,242,
            230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,249,242,217,249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,242,217,217,242,217,
            217,249,210,217,249,210,217,242,223,204,249,230,217,249,230,217,230,230,217,230,230,217,135,207,163,
            135,207,163,135,207,163,242,230,217,242,230,217,249,223,217,249,223,217,242,210,217,249,217,217,249,
            217,217,249,210,204,249,210,204,242,210,217,249,230,217,249,230,217,249,230,217,249,230,217,242,217,
            217,249,217,204,249,217,204,249,217,217,249,217,217,242,217,204,249,217,217,249,217,217,249,217,217,
            249,217,217,249,217,217,249,217,217,249,217,217,249,210,217,249,210,217,249,210,217,249,210,217,249,
            210,217,242,217,217,242,217,217,242,217,217,242,217,217,249,223,217,249,217,217,249,217,217,242,217,
            217,242,217,217,249,217,204,242,217,217,242,217,217,249,217,217,249,217,217,249,217,217,242,210,217,
            242,210,217,249,217,217,249,217,217,249,223,217,249,217,204,249,217,204,249,217,204,249,217,204,249,
            223,217,242,236,217,242,236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,
            217,242,236,217,242,217,217,249,217,204,249,217,204,249,223,217,249,223,217,255,255,255,255,255,255,
            249,230,217,249,236,217,249,236,217,249,242,204,249,242,204,249,242,204,242,236,230,242,236,230,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,
            249,242,204,249,242,204,249,242,204,249,242,204,249,242,217,242,217,217,242,217,217,249,210,217,249,
            210,217,242,223,204,249,230,217,249,230,217,230,230,217,230,230,217,135,207,163,135,207,163,135,207,
            163,242,230,217,242,230,217,249,223,217,249,223,217,242,210,217,249,217,217,249,217,217,249,210,204,
            249,210,204,242,210,217,249,230,217,249,230,217,249,230,217,249,230,217,242,217,217,249,217,204,249,
            217,204,249,217,217,249,217,217,242,217,204,249,217,217,249,217,217,249,217,217,249,217,217,249,217,
            217,249,217,217,249,217,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,242,217,217,
            242,217,217,242,217,217,242,217,217,249,223,217,249,217,217,249,217,217,242,217,217,242,217,217,249,
            217,204,242,217,217,242,217,217,249,217,217,249,217,217,249,217,217,242,210,217,242,210,217,249,217,
            217,249,217,217,249,223,217,249,217,204,249,217,204,249,217,204,249,217,204,249,223,217,242,236,217,
            242,236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,236,217,242,236,217,242,
            217,217,249,217,204,249,217,204,249,223,217,249,223,217,255,255,255,255,255,255,249,230,217,249,236,
            217,249,236,217,249,242,204,249,242,204,249,242,204,242,236,230,242,236,230,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,242,217,242,242,217,242,242,204,249,242,217,249,242,
            217,249,242,217,249,242,217,249,230,204,242,210,204,242,210,204,242,210,217,242,210,217,242,217,217,
            242,236,230,242,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,242,230,217,242,217,217,242,217,217,242,217,217,242,217,217,249,217,
            217,249,230,217,249,230,217,249,230,204,249,230,204,249,223,217,249,223,217,249,223,217,249,223,217,
            249,223,217,249,223,217,249,217,217,249,217,217,249,217,217,249,217,217,249,217,217,242,217,217,242,
            217,217,249,217,217,249,217,217,242,217,217,242,210,217,242,210,217,249,210,204,249,210,204,242,210,
            204,242,210,204,249,217,217,249,217,217,249,217,217,242,217,217,242,217,217,242,217,217,242,217,217,
            242,217,217,249,217,217,249,217,217,249,230,204,242,217,217,242,217,217,242,210,217,242,210,217,249,
            210,217,249,217,217,249,217,217,242,236,217,242,236,217,236,236,230,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,236,217,249,223,217,
            249,223,217,249,210,217,249,210,217,242,210,217,242,210,217,249,210,217,242,217,217,242,217,217,242,
            236,217,242,236,217,249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,236,236,230,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,242,217,242,242,217,242,242,204,249,242,217,249,242,217,249,242,217,249,
            242,217,249,230,204,242,210,204,242,210,204,242,210,217,242,210,217,242,217,217,242,236,230,242,236,
            230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,242,230,217,242,217,217,242,217,217,242,217,217,242,217,217,249,217,217,249,230,217,249,
            230,217,249,230,204,249,230,204,249,223,217,249,223,217,249,223,217,249,223,217,249,223,217,249,223,
            217,249,217,217,249,217,217,249,217,217,249,217,217,249,217,217,242,217,217,242,217,217,249,217,217,
            249,217,217,242,217,217,242,210,217,242,210,217,249,210,204,249,210,204,242,210,204,242,210,204,249,
            217,217,249,217,217,249,217,217,242,217,217,242,217,217,242,217,217,242,217,217,242,217,217,249,217,
            217,249,217,217,249,230,204,242,217,217,242,217,217,242,210,217,242,210,217,249,210,217,249,217,217,
            249,217,217,242,236,217,242,236,217,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,236,217,249,223,217,249,223,217,249,210,
            217,249,210,217,242,210,217,242,210,217,249,210,217,242,217,217,242,217,217,242,236,217,242,236,217,
            249,242,217,249,242,217,249,242,217,249,242,217,249,242,217,236,236,230,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,
            217,249,242,204,249,242,204,242,242,217,236,236,230,236,236,230,135,207,163,135,207,163,242,236,230,
            249,236,230,249,236,230,242,230,217,242,230,217,242,230,230,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,236,230,230,236,230,230,242,230,217,242,230,217,242,217,204,242,217,204,242,217,204,249,217,217,
            249,217,217,249,217,204,249,230,217,249,230,217,249,223,204,249,223,204,249,223,217,242,217,217,242,
            217,217,249,223,217,249,223,217,249,230,217,249,223,217,249,223,217,249,223,217,249,223,217,242,217,
            217,242,217,217,242,217,217,249,210,217,249,210,217,249,210,217,249,210,217,249,217,217,242,210,217,
            242,210,217,242,210,217,242,210,217,249,217,217,249,217,217,249,217,217,249,217,204,249,217,204,249,
            223,204,249,217,217,249,217,217,249,217,217,249,217,217,242,230,217,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,249,230,217,249,230,217,242,210,217,242,210,217,242,
            210,204,242,210,204,242,223,217,236,230,230,236,230,230,135,207,163,135,207,163,135,207,163,242,242,
            217,242,242,217,249,242,204,249,242,204,249,242,217,236,236,230,236,236,230,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,242,230,242,242,230,242,242,217,249,242,204,249,242,204,249,242,204,249,
            242,204,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,236,236,230,236,236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,242,236,230,242,230,230,242,230,230,242,223,217,242,223,217,242,217,
            204,249,217,217,249,217,217,249,210,217,249,210,217,249,223,217,242,217,217,242,217,217,249,223,204,
            249,223,204,249,223,204,249,217,204,249,217,204,249,217,217,249,217,217,242,210,217,249,210,217,249,
            210,217,249,210,217,249,210,217,242,210,217,242,210,217,242,210,217,249,210,217,249,210,217,242,210,
            217,242,210,217,242,217,217,249,217,204,249,217,204,249,217,217,249,217,217,249,223,217,242,230,230,
            242,230,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,242,230,217,242,230,217,242,236,230,242,236,230,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,249,
            242,217,249,242,217,249,242,204,249,242,204,249,242,204,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,242,242,230,242,242,230,242,242,217,249,242,204,249,242,204,249,242,204,249,242,204,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,
            236,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,242,236,230,242,230,230,242,230,230,242,223,217,242,223,217,242,217,204,249,217,217,249,
            217,217,249,210,217,249,210,217,249,223,217,242,217,217,242,217,217,249,223,204,249,223,204,249,223,
            204,249,217,204,249,217,204,249,217,217,249,217,217,242,210,217,249,210,217,249,210,217,249,210,217,
            249,210,217,242,210,217,242,210,217,242,210,217,249,210,217,249,210,217,242,210,217,242,210,217,242,
            217,217,249,217,204,249,217,204,249,217,217,249,217,217,249,223,217,242,230,230,242,230,230,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,242,230,217,242,230,217,242,236,230,242,236,230,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,249,242,217,249,242,217,
            249,242,204,249,242,204,249,242,204,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,223,217,236,223,217,249,236,217,249,
            236,217,249,236,204,249,242,204,249,242,204,249,236,217,249,236,217,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,223,223,217,223,223,217,135,207,163,135,207,163,236,230,230,236,223,230,236,223,230,242,230,217,
            242,230,217,249,223,217,242,217,217,242,217,217,242,217,204,242,217,204,242,217,217,242,217,217,242,
            217,217,249,217,217,249,217,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,
            204,249,210,204,249,210,217,249,217,217,249,217,217,249,217,217,249,217,217,249,223,217,249,230,217,
            249,230,217,236,223,217,236,223,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,223,223,217,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,230,217,242,230,217,249,242,217,249,242,
            204,249,242,204,249,236,217,249,236,217,242,230,217,236,223,217,236,223,217,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,236,223,217,236,223,217,249,236,217,249,236,217,249,236,204,
            249,242,204,249,242,204,249,236,217,249,236,217,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,223,223,217,223,
            223,217,135,207,163,135,207,163,236,230,230,236,223,230,236,223,230,242,230,217,242,230,217,249,223,
            217,242,217,217,242,217,217,242,217,204,242,217,204,242,217,217,242,217,217,242,217,217,249,217,217,
            249,217,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,217,249,210,204,249,210,204,249,
            210,217,249,217,217,249,217,217,249,217,217,249,217,217,249,223,217,249,230,217,249,230,217,236,223,
            217,236,223,217,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,223,223,217,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,242,230,217,242,230,217,249,242,217,249,242,204,249,242,204,249,
            236,217,249,236,217,242,230,217,236,223,217,236,223,217,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,
            242,242,242,242,242,249,242,217,249,242,217,249,242,204,249,242,204,249,242,204,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,236,230,242,236,230,249,236,217,249,236,217,249,236,
            204,249,230,204,249,230,204,249,236,217,249,236,217,242,236,230,242,236,230,236,236,230,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,242,249,242,204,249,242,204,
            249,242,217,242,242,230,242,242,230,242,242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,242,242,242,230,
            249,242,217,249,242,217,249,242,217,249,242,217,242,242,242,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,236,236,230,236,236,230,249,249,230,249,249,230,249,242,230,249,242,230,249,
            242,230,249,242,217,249,242,217,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,217,249,242,217,242,242,230,242,242,
            242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,242,242,242,230,249,242,217,249,242,
            217,249,242,217,249,242,217,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,236,236,230,236,236,230,249,249,230,249,249,230,249,242,230,249,242,230,249,242,230,249,242,217,
            249,242,217,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,249,242,217,249,242,217,242,242,230,242,242,242,242,242,242,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,242,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,242,242,230,242,242,230,242,
            242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,
            236,230,249,249,217,249,249,217,249,242,230,242,236,230,242,236,230,249,242,217,249,242,217,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,242,242,242,242,242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,242,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,242,242,230,242,242,230,242,242,230,242,242,230,242,242,230,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,249,249,217,
            249,249,217,249,242,230,242,236,230,242,236,230,249,242,217,249,242,217,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,
            242,242,242,242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,242,242,242,242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,242,242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,242,242,
            217,242,242,217,242,242,217,242,242,217,242,242,217,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,242,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,249,242,230,249,242,230,249,242,217,249,242,230,249,
            242,230,242,242,230,242,242,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,249,242,230,249,242,230,249,242,217,249,242,230,249,242,230,242,242,230,
            242,242,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,
            236,230,249,242,217,249,242,217,249,242,217,242,242,230,242,242,230,242,242,230,242,242,230,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,236,236,230,236,236,230,249,242,217,
            249,242,217,249,242,217,242,242,230,242,242,230,242,242,230,242,242,230,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,
            242,242,242,242,242,242,242,242,242,242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,242,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,230,242,242,230,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,242,242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,
            242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,242,242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,242,242,242,242,242,230,242,242,230,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,
            242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,242,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,242,242,242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,249,242,230,249,242,230,242,242,230,242,242,230,242,242,230,135,207,163,135,
            207,163,135,207,163,135,207,163,236,242,217,230,242,217,230,242,217,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,249,242,230,249,242,230,242,242,230,242,242,230,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,249,242,230,249,242,230,242,242,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,
            135,207,163,236,242,217,230,242,217,230,242,217,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,249,242,230,249,242,230,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,249,242,230,249,242,230,135,207,163,135,207,163,135,207,163,236,242,217,236,242,217,217,236,
            230,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,135,207,163,249,242,230,
            249,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,230,
            249,242,230,135,207,163,135,207,163,135,207,163,236,242,217,236,242,217,217,236,230,135,207,163,135,
            207,163,135,207,163,135,207,163,242,242,230,242,242,230,135,207,163,249,242,230,249,242,230,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,210,236,230,135,207,163,135,207,163,135,207,163,
            135,207,163,242,242,217,242,242,217,135,207,163,249,242,230,249,242,230,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,242,230,242,242,230,242,242,217,242,242,217,135,207,163,242,242,230,242,
            242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,
            230,242,242,230,135,207,163,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,242,242,230,242,242,230,242,242,217,242,242,217,135,207,163,242,242,230,242,242,230,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,135,
            207,163,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,230,242,
            242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,
            230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,242,242,230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,230,242,242,230,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,230,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,
            230,242,242,230,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,236,242,217,236,242,217,242,242,230,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,217,236,230,135,207,163,135,207,163,242,242,230,242,242,230,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,249,242,230,249,242,230,242,242,230,242,242,242,242,242,242,242,242,242,242,242,242,242,242,
            242,242,242,242,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,249,242,230,
            249,242,230,242,242,230,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,242,242,230,242,242,230,249,242,217,249,242,217,242,242,
            230,249,242,230,249,242,230,242,242,230,242,242,230,249,242,230,249,242,230,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,242,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,242,242,230,242,242,230,249,242,217,249,242,217,242,242,230,249,242,230,249,
            242,230,242,242,230,242,242,230,249,242,230,249,242,230,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,242,242,242,242,242,242,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163
        };

        wxImage image( 140, 175, (unsigned char*)data, TRUE );
#ifndef _WIN32	
        wxBitmap bitmap( image.Scale(90,90) );
	bitmap.SetMask(new wxMask(bitmap, wxColour(BACK_RCOLOR,BACK_GCOLOR,BACK_BCOLOR)));
#else
        wxBitmap bitmap( image );	
#endif		
        return bitmap;
    }
    if (index == 2)
    {
        static const unsigned char data[] = 
        {
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,
            255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,
            255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,
            0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,0,0,0,0,0,0,
            255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,0,0,0,0,0,0,0,
            0,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,
            0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,
            255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,
            255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,0,0,0,0,0,0,0,0,0,255,255,0,255,255,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,
            0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,0,
            0,0,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,
            0,255,254,0,255,255,0,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,0,0,0,0,0,0,255,255,0,255,255,0,255,254,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,254,0,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,0,0,0,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,254,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,255,255,0,
            0,0,0,0,0,0,0,0,0,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,0,0,0,0,0,0,255,255,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,
            253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,
            0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,
            255,253,0,255,253,0,255,253,0,255,253,0,0,0,0,0,0,0,255,253,0,255,253,0,255,
            253,0,255,253,0,255,253,0,255,253,0,0,0,0,0,0,0,0,0,0,255,253,0,255,253,
            0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,
            255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,
            253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,
            0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,255,0,255,255,0,0,0,0,0,0,0,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,0,0,0,0,0,0,255,255,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,
            255,253,0,255,253,0,255,253,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,
            252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,
            0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,
            255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,0,0,0,0,0,0,255,
            252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,0,0,0,0,0,0,0,0,
            0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,
            255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,
            252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,
            0,255,252,0,255,252,0,255,252,0,255,253,0,255,253,0,255,253,0,255,253,0,255,254,0,
            255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,255,255,0,0,0,0,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,0,0,0,0,0,
            0,0,0,0,255,255,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,253,0,
            255,253,0,255,253,0,255,253,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,
            252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,
            0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,
            255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,0,
            0,0,0,0,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,0,0,
            0,0,0,0,0,0,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,
            255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,
            252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,
            0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,253,0,
            255,253,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,255,
            255,0,0,0,0,0,0,0,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,0,0,0,0,0,0,255,255,0,255,254,0,255,254,0,255,254,0,255,254,0,255,253,0,
            255,253,0,255,253,0,255,252,0,255,252,0,255,252,0,255,251,0,255,251,0,255,251,0,255,
            251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,
            0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,
            255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,
            251,0,255,251,0,0,0,0,0,0,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,
            0,255,251,0,0,0,0,0,0,0,0,0,0,255,251,0,255,251,0,255,251,0,255,251,0,
            255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,
            251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,
            0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,
            255,252,0,255,252,0,255,252,0,255,252,0,255,253,0,255,253,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,255,0,0,0,0,0,0,0,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,0,0,0,255,255,0,255,255,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,252,0,255,251,0,255,251,0,255,
            251,0,255,251,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,
            0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,
            255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,
            250,0,255,250,0,255,250,0,255,250,0,0,0,0,0,0,0,255,250,0,255,250,0,255,250,
            0,255,250,0,255,250,0,255,250,0,0,0,0,0,0,0,0,0,0,255,250,0,255,250,0,
            255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,
            250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,
            0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,251,0,
            255,251,0,255,251,0,255,251,0,255,252,0,255,252,0,255,252,0,255,253,0,255,253,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,0,0,0,135,207,
            163,135,207,163,135,207,163,135,207,163,0,0,0,255,255,0,255,255,0,255,254,0,255,254,0,
            255,254,0,255,253,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,251,0,255,
            251,0,255,250,0,255,250,0,255,250,0,255,250,0,255,249,0,255,249,0,255,249,0,255,249,
            0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,
            255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,
            249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,0,0,0,0,0,0,255,249,
            0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,0,0,0,0,0,0,0,0,0,
            255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,
            249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,
            0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,
            255,250,0,255,250,0,255,250,0,255,250,0,255,251,0,255,251,0,255,251,0,255,252,0,255,
            252,0,255,252,0,255,253,0,255,253,0,255,254,0,255,254,0,255,254,0,255,255,0,255,255,
            0,0,0,0,135,207,163,135,207,163,135,207,163,135,207,163,0,0,0,255,255,0,255,254,0,
            255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,252,0,255,
            251,0,255,251,0,255,250,0,255,250,0,255,250,0,255,249,0,255,249,0,255,249,0,255,249,
            0,255,249,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,
            255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,
            248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,0,0,
            0,0,0,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,0,0,0,
            0,0,0,0,0,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,
            248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,
            0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,
            255,249,0,255,249,0,255,249,0,255,249,0,255,250,0,255,250,0,255,250,0,255,251,0,255,
            251,0,255,251,0,255,252,0,255,252,0,255,253,0,255,253,0,255,254,0,255,254,0,255,254,
            0,255,254,0,255,255,0,0,0,0,0,0,0,135,207,163,135,207,163,135,207,163,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,255,246,0,255,246,0,255,246,0,255,246,0,255,246,0,
            255,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,207,163,135,207,163,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,255,246,0,255,246,0,255,246,0,255,246,0,
            255,246,0,255,246,0,255,246,0,255,246,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            253,0,255,252,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,249,
            0,255,248,0,255,248,0,255,248,0,255,246,0,255,246,0,255,246,0,255,244,0,255,244,0,
            255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,
            244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,244,0,255,244,0,255,244,0,
            255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,
            244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,
            0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,
            255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,246,0,255,246,0,255,
            246,0,255,248,0,255,248,0,255,248,0,255,249,0,255,249,0,255,250,0,255,250,0,255,251,
            0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,253,0,255,252,0,255,252,0,255,251,0,255,251,0,255,250,0,255,250,
            0,255,249,0,255,249,0,255,248,0,255,248,0,255,246,0,255,246,0,255,246,0,255,244,0,
            255,244,0,255,244,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,
            242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,
            0,255,242,0,0,0,0,0,0,0,0,0,0,0,0,0,255,242,0,255,242,0,255,242,0,
            255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,
            242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,
            0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,
            255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,255,244,0,255,244,0,255,244,0,255,
            244,0,255,246,0,255,246,0,255,246,0,255,248,0,255,248,0,255,249,0,255,249,0,255,250,
            0,255,250,0,255,251,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,
            255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,
            254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,
            0,255,250,0,255,249,0,255,249,0,255,248,0,255,248,0,255,246,0,255,246,0,255,246,0,
            255,244,0,255,244,0,255,242,0,255,242,0,255,242,0,255,242,0,255,240,0,255,240,0,255,
            240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,
            0,255,240,0,0,0,0,0,0,0,0,0,0,255,240,0,255,240,0,255,240,0,255,240,0,
            255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,
            240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,
            0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,
            255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,242,0,255,
            242,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,246,0,255,248,0,255,248,
            0,255,249,0,255,249,0,255,250,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,
            255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,
            0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,
            0,255,251,0,255,250,0,255,250,0,255,249,0,255,249,0,255,248,0,255,248,0,255,246,0,
            255,246,0,255,244,0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,240,0,255,
            240,0,255,240,0,255,240,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,
            0,255,238,0,255,238,0,0,0,0,0,0,0,0,0,0,255,238,0,255,238,0,255,238,0,
            255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,
            238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,
            0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,
            255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,240,0,255,240,0,255,
            240,0,255,240,0,255,242,0,255,242,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,
            0,255,248,0,255,248,0,255,249,0,255,249,0,255,250,0,255,250,0,255,251,0,255,252,0,
            255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,
            207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,
            0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,
            255,246,0,255,246,0,255,244,0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,
            240,0,255,238,0,255,238,0,255,238,0,255,238,0,255,235,0,255,235,0,255,235,0,255,235,
            0,255,235,0,255,235,0,255,235,0,0,0,0,0,0,0,0,0,0,255,235,0,255,235,0,
            255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,
            235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,
            0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,
            255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,
            238,0,255,238,0,255,238,0,255,240,0,255,240,0,255,240,0,255,242,0,255,242,0,255,244,
            0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,249,0,255,250,0,
            255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,
            0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,
            255,248,0,255,248,0,255,246,0,255,246,0,255,244,0,255,244,0,255,242,0,255,242,0,255,
            240,0,255,240,0,255,238,0,255,238,0,255,238,0,255,238,0,255,235,0,255,235,0,255,235,
            0,255,235,0,255,235,0,255,235,0,255,235,0,0,0,0,0,0,0,0,0,0,255,235,0,
            255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,
            235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,
            0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,
            255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,
            235,0,255,235,0,255,235,0,255,238,0,255,238,0,255,238,0,255,240,0,255,240,0,255,242,
            0,255,242,0,255,244,0,255,244,0,255,244,0,255,246,0,255,248,0,255,248,0,255,249,0,
            255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,
            0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,
            255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,246,0,255,244,0,255,242,0,255,
            242,0,255,240,0,255,240,0,255,238,0,255,238,0,255,238,0,255,235,0,255,235,0,255,235,
            0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,0,0,0,0,0,0,255,230,0,
            255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,
            230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,
            0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,
            255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,233,0,255,
            233,0,255,233,0,255,233,0,255,233,0,255,235,0,255,235,0,255,235,0,255,238,0,255,238,
            0,255,240,0,255,240,0,255,242,0,255,242,0,255,244,0,255,244,0,255,246,0,255,248,0,
            255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,
            0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,
            255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,
            244,0,255,242,0,255,242,0,255,240,0,255,240,0,255,238,0,255,235,0,255,235,0,255,235,
            0,255,233,0,255,233,0,255,230,0,255,230,0,255,230,0,255,230,0,0,0,0,0,0,0,
            255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,
            228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,
            0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,
            255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,
            228,0,255,230,0,255,230,0,255,230,0,255,230,0,255,233,0,255,233,0,255,235,0,255,235,
            0,255,238,0,255,238,0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,
            255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,
            252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,
            163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,
            255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,
            246,0,255,244,0,255,244,0,255,242,0,255,242,0,255,240,0,255,238,0,255,238,0,255,235,
            0,255,235,0,255,233,0,255,233,0,255,233,0,255,230,0,255,230,0,255,228,0,255,228,0,
            0,0,0,0,0,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,
            228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,
            0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,
            255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,
            228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,230,0,255,230,0,255,230,0,255,233,
            0,255,233,0,255,235,0,255,235,0,255,238,0,255,238,0,255,240,0,255,240,0,255,242,0,
            255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,
            251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,
            0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,
            255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,
            248,0,255,248,0,255,246,0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,238,
            0,255,235,0,255,235,0,255,235,0,255,233,0,255,230,0,255,230,0,255,230,0,255,228,0,
            255,228,0,0,0,0,0,0,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,
            225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,
            0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,
            255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,
            225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,228,0,255,228,0,255,228,
            0,255,230,0,255,233,0,255,233,0,255,233,0,255,235,0,255,235,0,255,238,0,255,240,0,
            255,240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,
            249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,
            0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,
            255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,
            250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,242,0,255,242,0,255,242,
            0,255,240,0,255,238,0,255,235,0,255,235,0,255,233,0,255,233,0,255,230,0,255,230,0,
            255,228,0,255,228,0,255,225,0,0,0,0,0,0,0,255,222,0,255,222,0,255,222,0,255,
            222,0,255,222,0,255,222,0,255,222,0,255,222,0,255,222,0,255,222,0,255,222,0,255,222,
            0,255,222,0,255,222,0,255,222,0,255,222,0,255,222,0,255,222,0,255,222,0,255,222,0,
            255,222,0,255,222,0,255,222,0,255,222,0,255,222,0,255,222,0,255,222,0,255,222,0,255,
            222,0,255,222,0,255,222,0,255,222,0,255,222,0,255,222,0,255,225,0,255,225,0,255,225,
            0,255,228,0,255,228,0,255,230,0,255,230,0,255,233,0,255,233,0,255,235,0,255,235,0,
            255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,
            248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,
            0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,
            0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,
            251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,242,
            0,255,242,0,255,242,0,255,240,0,255,238,0,255,235,0,255,235,0,255,233,0,255,230,0,
            255,230,0,255,230,0,255,228,0,255,228,0,0,0,0,0,0,0,0,0,0,255,222,0,255,
            222,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,
            0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,
            255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,
            220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,222,0,255,222,
            0,255,222,0,255,225,0,255,225,0,255,228,0,255,228,0,255,230,0,255,230,0,255,233,0,
            255,235,0,255,235,0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,
            246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,
            0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,
            135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,
            252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,
            0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,238,0,255,235,0,255,235,0,
            255,233,0,255,230,0,255,230,0,255,228,0,255,228,0,255,225,0,0,0,0,0,0,0,0,
            0,0,255,222,0,255,220,0,255,220,0,255,220,0,255,220,0,255,217,0,255,217,0,255,217,
            0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,
            255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,
            217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,220,0,255,220,0,255,220,
            0,255,220,0,255,222,0,255,222,0,255,225,0,255,225,0,255,228,0,255,228,0,255,230,0,
            255,230,0,255,233,0,255,235,0,255,235,0,255,238,0,255,240,0,255,240,0,255,242,0,255,
            244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,
            0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,
            0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,
            253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,
            0,255,248,0,255,246,0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,238,0,
            255,235,0,255,235,0,255,233,0,255,230,0,255,230,0,255,228,0,255,228,0,255,225,0,0,
            0,0,0,0,0,0,0,0,255,220,0,255,220,0,255,217,0,255,217,0,255,217,0,255,215,
            0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,
            255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,
            215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,217,
            0,255,217,0,255,217,0,255,220,0,255,220,0,255,222,0,255,222,0,255,225,0,255,225,0,
            255,228,0,255,230,0,255,230,0,255,233,0,255,235,0,255,235,0,255,238,0,255,240,0,255,
            240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,
            0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,
            254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,
            0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,242,0,255,242,0,255,242,0,
            255,240,0,255,238,0,255,235,0,255,235,0,255,233,0,255,230,0,255,230,0,255,228,0,255,
            228,0,255,225,0,0,0,0,0,0,0,0,0,0,255,220,0,255,217,0,255,217,0,255,217,
            0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,
            255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,
            215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,
            0,255,215,0,255,215,0,255,217,0,255,217,0,255,220,0,255,220,0,255,222,0,255,222,0,
            255,225,0,255,225,0,255,228,0,255,230,0,255,230,0,255,233,0,255,235,0,255,235,0,255,
            238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,
            0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,
            255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,217,0,255,217,
            0,255,215,0,255,215,0,255,215,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,
            255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,
            213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,
            0,255,213,0,255,213,0,255,213,0,255,215,0,255,215,0,255,217,0,255,217,0,255,220,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,207,163,135,
            207,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,255,217,0,255,217,0,255,215,0,255,215,0,255,213,0,255,213,0,255,213,0,255,211,0,
            255,211,0,255,211,0,255,211,0,255,211,0,255,211,0,255,211,0,255,211,0,255,211,0,255,
            211,0,255,211,0,255,211,0,255,211,0,255,211,0,255,211,0,255,211,0,255,211,0,255,211,
            0,255,211,0,255,211,0,255,211,0,255,213,0,255,213,0,255,215,0,255,215,0,255,215,0,
            255,217,0,255,220,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,
            0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,
            255,248,0,255,246,0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,238,0,255,
            235,0,255,235,0,255,233,0,255,230,0,255,230,0,255,228,0,255,225,0,255,225,0,255,222,
            0,255,222,0,0,0,0,0,0,0,255,217,0,255,215,0,255,213,0,255,213,0,255,211,0,
            255,211,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,
            210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,
            0,255,210,0,255,210,0,255,210,0,255,210,0,255,211,0,255,211,0,255,213,0,255,213,0,
            255,215,0,255,215,0,255,217,0,255,220,0,0,0,0,0,0,0,255,222,0,255,225,0,255,
            228,0,255,230,0,255,230,0,255,233,0,255,235,0,255,235,0,255,238,0,255,240,0,255,240,
            0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,
            255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,
            0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,
            255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,242,0,255,242,0,255,242,0,255,
            240,0,255,238,0,255,235,0,255,235,0,255,233,0,255,230,0,255,230,0,255,228,0,255,225,
            0,255,225,0,255,222,0,255,222,0,0,0,0,0,0,0,255,217,0,255,215,0,255,213,0,
            255,213,0,255,211,0,255,211,0,255,210,0,255,210,0,255,210,0,255,208,0,255,208,0,255,
            208,0,255,208,0,255,208,0,255,208,0,255,208,0,255,208,0,255,208,0,255,208,0,255,208,
            0,255,208,0,255,208,0,255,208,0,255,208,0,255,210,0,255,210,0,255,210,0,255,211,0,
            255,211,0,255,213,0,255,215,0,255,215,0,255,217,0,0,0,0,0,0,0,255,222,0,255,
            222,0,255,225,0,255,228,0,255,230,0,255,230,0,255,233,0,255,235,0,255,235,0,255,238,
            0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,
            255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,
            0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,
            255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,242,0,255,
            242,0,255,242,0,255,240,0,255,238,0,255,235,0,255,235,0,255,233,0,255,230,0,255,230,
            0,255,228,0,255,225,0,255,225,0,255,222,0,255,222,0,255,220,0,0,0,0,0,0,0,
            255,215,0,255,213,0,255,213,0,255,211,0,255,210,0,255,210,0,255,208,0,255,208,0,255,
            207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,
            0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,208,0,255,208,0,255,210,0,
            255,210,0,255,211,0,255,211,0,255,213,0,255,215,0,255,215,0,0,0,0,0,0,0,255,
            222,0,255,222,0,255,222,0,255,225,0,255,228,0,255,230,0,255,230,0,255,233,0,255,235,
            0,255,235,0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,246,0,
            255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,
            253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,
            163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,
            255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,
            244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,238,0,255,235,0,255,235,0,255,233,
            0,255,230,0,255,230,0,255,228,0,255,225,0,255,225,0,255,222,0,255,222,0,255,220,0,
            0,0,0,0,0,0,0,0,0,255,213,0,255,213,0,255,211,0,255,210,0,255,210,0,255,
            208,0,255,208,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,
            0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,0,
            255,208,0,255,208,0,255,210,0,255,211,0,255,211,0,255,213,0,255,215,0,255,215,0,0,
            0,0,0,0,0,255,222,0,255,222,0,255,222,0,255,225,0,255,228,0,255,230,0,255,230,
            0,255,233,0,255,235,0,255,235,0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,
            255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,
            252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,
            0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,
            255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,
            248,0,255,246,0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,238,0,255,235,
            0,255,235,0,255,233,0,255,230,0,255,230,0,255,228,0,255,225,0,255,225,0,255,222,0,
            255,222,0,255,220,0,255,217,0,255,217,0,0,0,0,0,0,0,255,213,0,255,211,0,255,
            210,0,255,210,0,255,208,0,255,208,0,255,207,0,255,206,0,255,206,0,255,206,0,255,206,
            0,255,206,0,255,206,0,255,206,0,255,206,0,255,206,0,255,206,0,255,206,0,255,206,0,
            255,207,0,255,207,0,255,208,0,255,208,0,255,210,0,255,211,0,255,211,0,255,213,0,0,
            0,0,0,0,0,0,0,0,255,220,0,255,222,0,255,222,0,255,222,0,255,225,0,255,228,
            0,255,230,0,255,230,0,255,233,0,255,235,0,255,235,0,255,238,0,255,240,0,255,240,0,
            255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,
            250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,
            0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,
            255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,
            249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,
            0,255,238,0,255,235,0,255,235,0,255,233,0,255,230,0,255,230,0,255,228,0,255,225,0,
            255,225,0,255,222,0,255,222,0,255,220,0,255,217,0,255,217,0,0,0,0,0,0,0,0,
            0,0,255,211,0,255,210,0,255,210,0,255,208,0,255,208,0,255,207,0,255,206,0,255,206,
            0,255,205,0,255,205,0,255,205,0,255,205,0,255,205,0,255,205,0,255,205,0,255,205,0,
            255,205,0,255,206,0,255,207,0,255,207,0,255,208,0,255,208,0,255,210,0,255,211,0,255,
            211,0,255,213,0,0,0,0,0,0,0,255,217,0,255,220,0,255,222,0,255,222,0,255,222,
            0,255,225,0,255,228,0,255,230,0,255,230,0,255,233,0,255,235,0,255,235,0,255,238,0,
            255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,
            249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,
            0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,
            255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,
            250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,242,0,255,242,
            0,255,242,0,255,240,0,255,238,0,255,235,0,255,235,0,255,233,0,255,230,0,255,230,0,
            255,228,0,255,225,0,255,225,0,255,222,0,255,222,0,255,220,0,255,217,0,255,217,0,255,
            215,0,0,0,0,0,0,0,255,211,0,255,210,0,255,210,0,255,208,0,255,208,0,255,207,
            0,255,206,0,255,205,0,255,205,0,255,204,0,255,204,0,255,204,0,255,204,0,255,204,0,
            255,204,0,255,205,0,255,205,0,255,206,0,255,207,0,255,207,0,255,208,0,255,208,0,255,
            210,0,255,211,0,255,211,0,0,0,0,0,0,0,0,0,0,255,217,0,255,220,0,255,222,
            0,255,222,0,255,222,0,255,225,0,255,228,0,255,230,0,255,230,0,255,233,0,255,235,0,
            255,235,0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,
            246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,
            0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,
            252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,
            0,255,242,0,255,242,0,255,242,0,255,240,0,255,238,0,255,235,0,255,235,0,255,233,0,
            255,230,0,255,230,0,255,228,0,255,225,0,255,225,0,255,222,0,255,222,0,255,220,0,255,
            217,0,255,217,0,255,215,0,0,0,0,0,0,0,255,211,0,255,210,0,255,210,0,255,208,
            0,255,208,0,255,207,0,255,206,0,255,205,0,255,205,0,255,204,0,255,204,0,255,204,0,
            255,204,0,255,204,0,255,204,0,255,205,0,255,205,0,255,206,0,255,207,0,255,207,0,255,
            208,0,255,208,0,255,210,0,255,211,0,255,211,0,0,0,0,0,0,0,0,0,0,255,217,
            0,255,220,0,255,222,0,255,222,0,255,222,0,255,225,0,255,228,0,255,230,0,255,230,0,
            255,233,0,255,235,0,255,235,0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,
            244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,
            0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,
            135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,
            253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,
            0,255,246,0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,238,0,255,235,0,
            255,235,0,255,233,0,255,230,0,255,230,0,255,228,0,255,225,0,255,225,0,255,222,0,255,
            222,0,255,220,0,255,217,0,255,217,0,255,215,0,0,0,0,0,0,0,255,211,0,255,210,
            0,255,210,0,255,208,0,255,208,0,255,207,0,255,206,0,255,205,0,255,205,0,255,204,0,
            255,204,0,255,204,0,255,204,0,255,204,0,255,204,0,255,205,0,255,205,0,255,206,0,255,
            207,0,255,207,0,255,208,0,255,208,0,255,210,0,255,211,0,255,211,0,0,0,0,0,0,
            0,255,215,0,255,217,0,255,220,0,255,222,0,255,222,0,255,222,0,255,225,0,255,228,0,
            255,230,0,255,230,0,255,233,0,255,235,0,255,235,0,255,238,0,255,240,0,255,240,0,255,
            242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,
            0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,
            254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,
            0,255,248,0,255,248,0,255,246,0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,
            255,238,0,255,235,0,255,235,0,255,233,0,255,230,0,255,230,0,255,228,0,255,225,0,255,
            225,0,255,222,0,255,222,0,255,220,0,255,217,0,255,217,0,255,215,0,0,0,0,0,0,
            0,255,211,0,255,210,0,255,210,0,255,208,0,255,208,0,255,207,0,255,206,0,255,205,0,
            255,205,0,255,204,0,255,204,0,255,204,0,255,204,0,255,204,0,255,204,0,255,205,0,255,
            205,0,255,206,0,255,207,0,255,207,0,255,208,0,255,208,0,255,210,0,255,211,0,255,211,
            0,0,0,0,0,0,0,0,0,0,255,217,0,255,220,0,255,222,0,255,222,0,255,222,0,
            255,225,0,255,228,0,255,230,0,255,230,0,255,233,0,255,235,0,255,235,0,255,238,0,255,
            240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,
            0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,
            255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,
            254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,
            0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,242,0,255,242,0,
            255,242,0,255,240,0,255,238,0,255,235,0,255,235,0,255,233,0,255,230,0,255,230,0,255,
            228,0,255,225,0,255,225,0,255,222,0,255,222,0,255,220,0,255,217,0,255,217,0,0,0,
            0,0,0,0,0,0,0,255,211,0,255,210,0,255,210,0,255,208,0,255,208,0,255,207,0,
            255,206,0,255,205,0,255,205,0,255,204,0,255,204,0,255,204,0,255,204,0,255,204,0,255,
            204,0,255,205,0,255,205,0,255,206,0,255,207,0,255,207,0,255,208,0,255,208,0,255,210,
            0,255,211,0,255,211,0,0,0,0,0,0,0,0,0,0,255,217,0,255,220,0,255,222,0,
            255,222,0,255,222,0,255,225,0,255,228,0,255,230,0,255,230,0,255,233,0,255,235,0,255,
            235,0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,
            0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,
            255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,
            0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,
            0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,
            255,242,0,255,242,0,255,242,0,255,240,0,255,238,0,255,235,0,255,235,0,255,233,0,255,
            230,0,255,230,0,255,228,0,255,225,0,255,225,0,255,222,0,255,222,0,255,220,0,255,217,
            0,255,217,0,0,0,0,0,0,0,0,0,0,255,211,0,255,210,0,255,210,0,255,208,0,
            255,208,0,255,207,0,255,206,0,255,206,0,255,206,0,255,205,0,255,205,0,255,205,0,255,
            205,0,255,205,0,255,205,0,255,205,0,255,206,0,255,206,0,255,207,0,255,207,0,255,208,
            0,255,208,0,255,210,0,255,211,0,255,211,0,255,213,0,0,0,0,0,0,0,255,217,0,
            255,220,0,255,222,0,255,222,0,255,222,0,255,225,0,255,228,0,255,230,0,255,230,0,255,
            233,0,255,235,0,255,235,0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,
            0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,
            255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,
            207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,
            0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,
            255,246,0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,238,0,255,235,0,255,
            235,0,255,233,0,255,230,0,255,230,0,255,228,0,255,225,0,255,225,0,255,222,0,255,222,
            0,255,220,0,255,217,0,0,0,0,0,0,0,0,0,0,255,213,0,255,211,0,255,210,0,
            255,210,0,255,208,0,255,208,0,255,207,0,255,207,0,255,206,0,255,206,0,255,206,0,255,
            206,0,255,206,0,255,206,0,255,206,0,255,206,0,255,206,0,255,206,0,255,206,0,255,207,
            0,255,207,0,255,208,0,255,208,0,255,210,0,255,211,0,255,211,0,255,213,0,0,0,0,
            0,0,0,0,0,0,255,220,0,255,222,0,255,222,0,255,222,0,255,225,0,255,228,0,255,
            230,0,255,230,0,255,233,0,255,235,0,255,235,0,255,238,0,255,240,0,255,240,0,255,242,
            0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,
            255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,
            0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,
            255,248,0,255,248,0,255,246,0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,
            238,0,255,235,0,255,235,0,255,233,0,255,230,0,255,230,0,255,228,0,255,225,0,255,225,
            0,255,222,0,255,222,0,255,220,0,0,0,0,0,0,0,255,215,0,255,213,0,255,213,0,
            255,211,0,255,210,0,255,210,0,255,208,0,255,208,0,255,207,0,255,207,0,255,207,0,255,
            207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,0,255,207,
            0,255,207,0,255,207,0,255,208,0,255,208,0,255,210,0,255,210,0,255,211,0,255,211,0,
            255,213,0,255,215,0,255,215,0,0,0,0,0,0,0,255,222,0,255,222,0,255,222,0,255,
            225,0,255,228,0,255,230,0,255,230,0,255,233,0,255,235,0,255,235,0,255,238,0,255,240,
            0,255,240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,
            255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,
            0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,
            255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,242,0,255,242,0,255,
            242,0,255,240,0,255,238,0,255,235,0,255,235,0,255,233,0,255,230,0,255,230,0,255,228,
            0,255,225,0,255,225,0,255,222,0,255,222,0,255,220,0,0,0,0,0,0,0,255,215,0,
            255,213,0,255,213,0,255,211,0,255,211,0,255,210,0,255,208,0,255,208,0,255,208,0,255,
            208,0,255,208,0,255,208,0,255,208,0,255,208,0,255,208,0,255,208,0,255,208,0,255,208,
            0,255,208,0,255,208,0,255,208,0,255,208,0,255,208,0,255,208,0,255,210,0,255,210,0,
            255,211,0,255,211,0,255,213,0,255,215,0,255,215,0,0,0,0,0,0,0,255,222,0,255,
            222,0,255,222,0,255,225,0,255,228,0,255,230,0,255,230,0,255,233,0,255,235,0,255,235,
            0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,
            255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,
            0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,
            255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,
            242,0,255,242,0,255,242,0,255,240,0,255,238,0,255,235,0,255,235,0,255,233,0,255,230,
            0,255,230,0,255,228,0,255,225,0,255,225,0,255,222,0,255,222,0,0,0,0,0,0,0,
            255,217,0,255,215,0,255,213,0,255,213,0,255,211,0,255,211,0,255,210,0,255,210,0,255,
            210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,
            0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,
            255,210,0,255,210,0,255,211,0,255,211,0,255,213,0,255,215,0,255,215,0,255,217,0,0,
            0,0,0,0,0,0,0,0,255,222,0,255,225,0,255,228,0,255,230,0,255,230,0,255,233,
            0,255,235,0,255,235,0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,
            255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,
            252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,
            163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,
            255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,
            246,0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,238,0,255,235,0,255,235,
            0,255,233,0,255,230,0,255,230,0,255,228,0,255,225,0,255,225,0,255,222,0,0,0,0,
            0,0,0,0,0,0,255,217,0,255,215,0,255,215,0,255,213,0,255,211,0,255,211,0,255,
            211,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,
            0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,255,210,0,
            255,210,0,255,210,0,255,211,0,255,211,0,255,211,0,255,213,0,255,213,0,255,215,0,255,
            215,0,255,217,0,255,220,0,0,0,0,0,0,0,255,222,0,255,225,0,255,228,0,255,230,
            0,255,230,0,255,233,0,255,235,0,255,235,0,255,238,0,255,240,0,255,240,0,255,242,0,
            255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,
            251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,
            0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,255,217,0,255,217,0,255,215,0,255,215,0,255,215,0,255,
            213,0,255,213,0,255,213,0,255,211,0,255,211,0,255,211,0,255,211,0,255,211,0,255,211,
            0,255,211,0,255,211,0,255,211,0,255,211,0,255,211,0,255,211,0,255,211,0,255,211,0,
            255,211,0,255,211,0,255,211,0,255,211,0,255,211,0,255,213,0,255,213,0,255,213,0,255,
            215,0,255,215,0,255,215,0,255,217,0,255,220,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,217,0,255,217,0,255,215,0,255,
            215,0,255,215,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,
            0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,
            255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,213,0,255,
            213,0,255,215,0,255,215,0,255,215,0,255,217,0,255,217,0,255,220,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,207,163,135,207,163,0,0,0,
            0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,
            251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,242,
            0,255,242,0,255,242,0,255,240,0,255,238,0,255,235,0,255,235,0,255,233,0,255,230,0,
            255,230,0,255,228,0,255,228,0,255,225,0,0,0,0,0,0,0,0,0,0,255,220,0,255,
            220,0,255,217,0,255,217,0,255,217,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,
            0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,
            255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,215,0,255,
            215,0,255,215,0,255,215,0,255,215,0,255,217,0,255,217,0,255,217,0,255,220,0,255,220,
            0,255,222,0,0,0,0,0,0,0,255,225,0,255,228,0,255,230,0,255,230,0,255,233,0,
            255,235,0,255,235,0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,
            246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,
            0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,
            135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,
            252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,
            0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,238,0,255,235,0,255,235,0,
            255,233,0,255,230,0,255,230,0,255,228,0,255,228,0,255,225,0,0,0,0,0,0,0,0,
            0,0,255,220,0,255,220,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,
            0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,
            255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,
            217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,0,255,217,
            0,255,220,0,255,220,0,255,222,0,0,0,0,0,0,0,255,228,0,255,228,0,255,230,0,
            255,230,0,255,233,0,255,235,0,255,235,0,255,238,0,255,240,0,255,240,0,255,242,0,255,
            244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,
            0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,
            0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,
            253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,
            0,255,248,0,255,246,0,255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,238,0,
            255,235,0,255,235,0,255,233,0,255,230,0,255,230,0,255,230,0,255,228,0,255,228,0,0,
            0,0,0,0,0,0,0,0,255,222,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,
            0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,
            255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,
            220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,
            0,255,220,0,255,220,0,255,222,0,255,222,0,255,222,0,0,0,0,0,0,0,255,228,0,
            255,228,0,255,230,0,255,230,0,255,233,0,255,235,0,255,235,0,255,238,0,255,240,0,255,
            240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,
            0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,
            254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,
            0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,242,0,255,242,0,255,242,0,
            255,240,0,255,238,0,255,235,0,255,235,0,255,233,0,255,233,0,255,230,0,255,230,0,255,
            228,0,255,228,0,0,0,0,0,0,0,0,0,0,255,222,0,255,222,0,255,222,0,255,220,
            0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,
            255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,
            220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,0,255,220,
            0,255,220,0,255,220,0,255,222,0,255,222,0,255,222,0,255,222,0,255,225,0,0,0,0,
            0,0,0,255,228,0,255,228,0,255,230,0,255,233,0,255,233,0,255,235,0,255,235,0,255,
            238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,
            0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,
            255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,
            0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,
            0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,242,0,
            255,242,0,255,242,0,255,240,0,255,238,0,255,235,0,255,235,0,255,235,0,255,233,0,255,
            230,0,255,230,0,255,228,0,255,228,0,255,228,0,0,0,0,0,0,0,255,225,0,255,225,
            0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,
            255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,
            225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,
            0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,
            0,0,0,0,0,0,0,0,0,255,228,0,255,230,0,255,233,0,255,233,0,255,233,0,255,
            235,0,255,235,0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,246,
            0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,
            255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,
            207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,
            0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,
            255,244,0,255,242,0,255,242,0,255,242,0,255,240,0,255,238,0,255,235,0,255,235,0,255,
            235,0,255,233,0,255,233,0,255,230,0,255,230,0,255,228,0,255,228,0,0,0,0,0,0,
            0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,
            255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,
            225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,
            0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,255,225,0,
            255,225,0,255,225,0,0,0,0,0,0,0,0,0,0,255,230,0,255,230,0,255,233,0,255,
            233,0,255,233,0,255,235,0,255,235,0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,
            0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,
            255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,
            0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,
            0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,
            255,248,0,255,246,0,255,244,0,255,244,0,255,242,0,255,242,0,255,240,0,255,240,0,255,
            238,0,255,235,0,255,235,0,255,233,0,255,233,0,255,233,0,255,230,0,255,230,0,255,230,
            0,255,228,0,0,0,0,0,0,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,
            255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,
            228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,
            0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,255,228,0,
            255,228,0,255,228,0,255,228,0,255,228,0,0,0,0,0,0,0,255,230,0,255,230,0,255,
            233,0,255,233,0,255,233,0,255,235,0,255,235,0,255,238,0,255,238,0,255,240,0,255,240,
            0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,
            255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,
            0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,
            255,249,0,255,248,0,255,248,0,255,246,0,255,244,0,255,244,0,255,242,0,255,242,0,255,
            240,0,255,240,0,255,238,0,255,238,0,255,235,0,255,235,0,255,233,0,255,233,0,255,233,
            0,255,233,0,255,230,0,255,230,0,0,0,0,0,0,0,0,0,0,255,230,0,255,230,0,
            255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,
            230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,
            0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,
            255,230,0,255,230,0,255,230,0,255,230,0,255,230,0,0,0,0,0,0,0,0,0,0,255,
            230,0,255,233,0,255,233,0,255,233,0,255,235,0,255,235,0,255,238,0,255,238,0,255,238,
            0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,
            255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,
            0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,
            255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,246,0,255,244,0,255,
            242,0,255,242,0,255,240,0,255,240,0,255,238,0,255,238,0,255,238,0,255,235,0,255,235,
            0,255,235,0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,0,0,0,0,0,0,
            255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,255,
            233,0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,
            0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,
            255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,255,233,0,0,0,0,0,0,0,255,
            233,0,255,233,0,255,233,0,255,233,0,255,235,0,255,235,0,255,235,0,255,238,0,255,238,
            0,255,238,0,255,240,0,255,240,0,255,242,0,255,244,0,255,244,0,255,244,0,255,246,0,
            255,248,0,255,248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,252,0,255,252,0,255,
            253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,
            163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,
            255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,248,0,255,248,0,255,246,0,255,
            246,0,255,244,0,255,244,0,255,244,0,255,242,0,255,242,0,255,240,0,255,240,0,255,238,
            0,255,238,0,255,238,0,255,238,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,
            255,235,0,0,0,0,0,0,0,0,0,0,255,235,0,255,235,0,255,235,0,255,235,0,255,
            235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,
            0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,
            255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,0,0,0,0,
            0,0,0,0,0,255,235,0,255,235,0,255,235,0,255,235,0,255,235,0,255,238,0,255,238,
            0,255,238,0,255,240,0,255,240,0,255,240,0,255,242,0,255,242,0,255,244,0,255,244,0,
            255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,249,0,255,250,0,255,251,0,255,
            252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,
            0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,253,0,
            255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,249,0,255,
            248,0,255,246,0,255,246,0,255,244,0,255,244,0,255,244,0,255,242,0,255,242,0,255,240,
            0,255,240,0,255,240,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,
            255,238,0,255,238,0,255,238,0,255,238,0,0,0,0,0,0,0,0,0,0,255,238,0,255,
            238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,
            0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,
            255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,0,
            0,0,0,0,0,0,0,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,0,255,238,
            0,255,238,0,255,238,0,255,240,0,255,240,0,255,240,0,255,242,0,255,242,0,255,242,0,
            255,244,0,255,244,0,255,246,0,255,246,0,255,248,0,255,249,0,255,249,0,255,249,0,255,
            250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,
            0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,
            255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,
            249,0,255,249,0,255,248,0,255,248,0,255,246,0,255,246,0,255,246,0,255,244,0,255,244,
            0,255,242,0,255,242,0,255,242,0,255,242,0,255,240,0,255,240,0,255,240,0,255,240,0,
            255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,0,0,0,0,
            0,0,0,0,0,0,0,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,
            0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,
            255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,
            240,0,0,0,0,0,0,0,0,0,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,
            0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,242,0,255,242,0,255,242,0,
            255,244,0,255,244,0,255,246,0,255,246,0,255,246,0,255,248,0,255,248,0,255,249,0,255,
            249,0,255,250,0,255,250,0,255,251,0,255,252,0,255,252,0,255,253,0,255,254,0,255,254,
            0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,
            255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,251,0,255,
            251,0,255,250,0,255,249,0,255,249,0,255,249,0,255,248,0,255,248,0,255,246,0,255,246,
            0,255,244,0,255,244,0,255,244,0,255,242,0,255,242,0,255,242,0,255,242,0,255,242,0,
            255,242,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,
            240,0,255,240,0,0,0,0,0,0,0,0,0,0,255,240,0,255,240,0,255,240,0,255,240,
            0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,
            255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,240,0,255,
            240,0,0,0,0,0,0,0,0,0,0,0,0,0,255,240,0,255,240,0,255,240,0,255,240,
            0,255,240,0,255,240,0,255,240,0,255,240,0,255,242,0,255,242,0,255,242,0,255,242,0,
            255,242,0,255,244,0,255,244,0,255,244,0,255,246,0,255,246,0,255,246,0,255,248,0,255,
            248,0,255,249,0,255,249,0,255,250,0,255,251,0,255,251,0,255,252,0,255,252,0,255,253,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,135,207,163,135,207,163,
            0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,254,0,255,253,0,255,252,0,255,
            252,0,255,252,0,255,251,0,255,250,0,255,250,0,255,249,0,255,249,0,255,248,0,255,248,
            0,255,248,0,255,246,0,255,246,0,255,246,0,255,244,0,255,244,0,255,244,0,255,244,0,
            255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,
            244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,0,0,0,0,0,0,0,0,
            0,0,0,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,
            255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,
            244,0,0,0,0,0,0,0,0,0,0,0,0,0,255,244,0,255,244,0,255,244,0,255,244,
            0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,
            255,244,0,255,244,0,255,244,0,255,244,0,255,246,0,255,246,0,255,246,0,255,248,0,255,
            248,0,255,249,0,255,249,0,255,249,0,255,250,0,255,250,0,255,251,0,255,251,0,255,252,
            0,255,252,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,0,0,0,
            135,207,163,135,207,163,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            253,0,255,252,0,255,252,0,255,252,0,255,251,0,255,251,0,255,250,0,255,250,0,255,249,
            0,255,249,0,255,248,0,255,248,0,255,248,0,255,246,0,255,246,0,255,246,0,255,246,0,
            255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,
            244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,244,0,255,244,0,255,244,0,
            255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,
            244,0,0,0,0,0,0,0,0,0,0,0,0,0,255,244,0,255,244,0,255,244,0,255,244,
            0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,255,244,0,
            255,244,0,255,244,0,255,244,0,255,244,0,255,246,0,255,246,0,255,246,0,255,246,0,255,
            248,0,255,248,0,255,248,0,255,249,0,255,249,0,255,250,0,255,250,0,255,250,0,255,251,
            0,255,251,0,255,252,0,255,253,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,255,0,0,0,0,135,207,163,135,207,163,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,255,246,0,255,246,0,255,246,0,255,246,0,255,246,0,255,246,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,135,207,163,135,207,163,135,207,163,0,0,0,255,
            255,0,255,254,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,
            0,255,251,0,255,251,0,255,250,0,255,250,0,255,250,0,255,249,0,255,249,0,255,249,0,
            255,249,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,
            248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,
            0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,
            255,248,0,0,0,0,0,0,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,
            248,0,0,0,0,0,0,0,0,0,0,0,0,0,255,248,0,255,248,0,255,248,0,255,248,
            0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,
            255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,248,0,255,
            248,0,255,248,0,255,248,0,255,248,0,255,249,0,255,249,0,255,249,0,255,250,0,255,250,
            0,255,250,0,255,251,0,255,251,0,255,252,0,255,252,0,255,253,0,255,253,0,255,253,0,
            255,254,0,255,254,0,255,254,0,255,255,0,255,255,0,0,0,0,135,207,163,135,207,163,135,
            207,163,0,0,0,255,255,0,255,255,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,
            0,255,253,0,255,252,0,255,252,0,255,251,0,255,251,0,255,251,0,255,250,0,255,250,0,
            255,250,0,255,250,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,
            249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,
            0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,
            255,249,0,255,249,0,255,249,0,0,0,0,0,0,0,255,249,0,255,249,0,255,249,0,255,
            249,0,255,249,0,255,249,0,0,0,0,0,0,0,0,0,0,255,249,0,255,249,0,255,249,
            0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,
            255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,
            249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,249,0,255,250,0,255,250,0,255,250,
            0,255,250,0,255,251,0,255,251,0,255,251,0,255,252,0,255,252,0,255,252,0,255,253,0,
            255,253,0,255,254,0,255,254,0,255,254,0,255,255,0,255,255,0,0,0,0,0,0,0,135,
            207,163,135,207,163,135,207,163,0,0,0,0,0,0,255,255,0,255,254,0,255,254,0,255,254,
            0,255,254,0,255,253,0,255,253,0,255,252,0,255,252,0,255,252,0,255,251,0,255,251,0,
            255,251,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,
            250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,
            0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,
            255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,0,0,0,0,0,0,255,250,0,255,
            250,0,255,250,0,255,250,0,255,250,0,255,250,0,0,0,0,0,0,0,0,0,0,255,250,
            0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,
            255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,
            250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,0,255,250,
            0,255,250,0,255,250,0,255,251,0,255,251,0,255,251,0,255,252,0,255,252,0,255,252,0,
            255,253,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,255,0,255,255,0,0,
            0,0,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,0,0,0,255,255,0,255,255,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,253,0,255,252,0,
            255,252,0,255,252,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,
            251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,
            0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,
            255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,0,0,0,0,
            0,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,0,0,0,0,0,
            0,0,0,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,
            255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,
            251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,
            0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,252,0,255,252,0,255,252,0,
            255,252,0,255,253,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            255,0,0,0,0,0,0,0,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,0,0,
            0,0,0,0,255,255,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,253,0,
            255,253,0,255,253,0,255,252,0,255,252,0,255,252,0,255,252,0,255,251,0,255,251,0,255,
            251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,
            0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,
            255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,
            251,0,0,0,0,0,0,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,
            0,0,0,0,0,0,0,0,0,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,
            255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,
            251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,
            0,255,251,0,255,251,0,255,251,0,255,251,0,255,251,0,255,252,0,255,252,0,255,252,0,
            255,252,0,255,253,0,255,253,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,255,0,255,255,0,0,0,0,0,0,0,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,0,0,0,0,0,0,255,255,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,254,0,255,254,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,
            252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,
            0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,
            255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,
            252,0,255,252,0,255,252,0,0,0,0,0,0,0,255,252,0,255,252,0,255,252,0,255,252,
            0,255,252,0,255,252,0,0,0,0,0,0,0,0,0,0,255,252,0,255,252,0,255,252,0,
            255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,
            252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,
            0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,255,252,0,
            255,253,0,255,253,0,255,253,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,255,0,255,255,0,0,0,0,0,0,0,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,0,0,0,0,0,0,255,255,0,255,255,0,
            255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,253,0,255,
            253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,
            0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,
            255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,
            253,0,255,253,0,255,253,0,255,253,0,255,253,0,0,0,0,0,0,0,255,253,0,255,253,
            0,255,253,0,255,253,0,255,253,0,255,253,0,0,0,0,0,0,0,0,0,0,255,253,0,
            255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,
            253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,
            0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,255,253,0,
            255,253,0,255,253,0,255,253,0,255,253,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,255,0,255,255,0,0,0,0,0,0,0,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            0,0,0,0,0,0,255,255,0,255,255,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,0,0,0,0,0,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,0,0,0,0,0,0,
            0,0,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,255,0,255,255,0,255,255,0,0,0,0,0,0,0,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,0,0,0,0,0,0,0,0,0,255,255,0,255,255,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,
            0,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,
            0,0,0,0,0,0,0,0,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,
            0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,
            255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,254,0,255,
            254,0,255,254,0,255,254,0,255,254,0,255,255,0,255,255,0,255,255,0,0,0,0,0,0,
            0,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,0,0,0,0,0,0,0,
            0,0,0,0,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,
            0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,
            255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,
            255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,
            0,255,255,0,255,255,0,0,0,0,0,0,0,255,255,0,255,255,0,255,255,0,255,255,0,
            255,255,0,255,255,0,0,0,0,0,0,0,0,0,0,255,255,0,255,255,0,255,255,0,255,
            255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,
            0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,
            255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,255,0,255,
            255,0,255,255,0,255,255,0,255,255,0,255,255,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163
        };
        wxImage image( 102, 78, (unsigned char*)data, TRUE );
        wxBitmap bitmap( image );
#ifndef _WIN32	
	bitmap.SetMask(new wxMask(bitmap, wxColour(BACK_RCOLOR,BACK_GCOLOR,BACK_BCOLOR)));
#endif		
        return bitmap;
    }
    if (index == 3)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "40 76 2 1",
        "a c #00CC99",
        "b c #87CFA3",
        /* pixels */
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbba",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "baaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "baaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaa",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbba",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb"
        };
        wxBitmap bitmap( xpm_data );
#ifndef _WIN32	
	bitmap.SetMask(new wxMask(bitmap, wxColour(BACK_RCOLOR,BACK_GCOLOR,BACK_BCOLOR)));
#endif	        
	return bitmap;
    }
    if (index == 4)
    {
        static const unsigned char data[] = 
        {
            135,207,163,135,207,163,135,207,163,135,207,163,179,179,204,179,179,204,179,179,204,179,179,204,179,
            179,204,179,179,204,179,179,204,179,179,204,179,179,204,179,179,204,179,179,204,174,174,198,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,143,143,178,223,225,236,251,253,255,251,253,255,251,253,255,251,253,
            255,251,253,255,251,253,255,251,253,255,251,253,255,251,253,255,251,253,255,144,144,173,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,123,124,167,241,248,255,241,248,255,241,248,255,241,248,255,241,248,255,
            241,248,255,241,248,255,241,248,255,241,248,255,241,248,255,223,230,242,118,118,138,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,139,149,191,184,191,217,234,245,255,234,245,255,234,245,255,234,245,255,234,245,255,234,
            245,255,234,245,255,234,245,255,234,245,255,234,245,255,131,135,165,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,125,128,172,224,240,255,224,240,255,224,240,255,224,240,255,224,240,255,224,240,255,224,240,
            255,224,240,255,224,240,255,224,240,255,178,188,217,117,117,127,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,137,137,
            172,202,219,242,217,236,255,217,236,255,217,236,255,217,236,255,217,236,255,217,236,255,217,236,255,
            217,236,255,217,236,255,202,219,242,94,94,116,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,139,149,191,168,183,217,
            207,231,255,207,231,255,207,231,255,207,231,255,207,231,255,207,231,255,207,231,255,207,231,255,207,
            231,255,207,231,255,108,111,146,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,139,149,191,200,228,255,200,
            228,255,200,228,255,200,228,255,200,228,255,200,228,255,200,228,255,200,228,255,200,228,255,200,228,
            255,138,149,191,125,125,125,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,127,130,172,190,223,255,190,223,255,190,223,
            255,190,223,255,190,223,255,190,223,255,190,223,255,190,223,255,190,223,255,190,223,255,146,162,204,
            95,95,105,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,142,142,177,178,212,249,183,219,255,183,219,255,183,219,255,
            183,219,255,183,219,255,183,219,255,183,219,255,181,218,255,176,215,255,155,186,230,89,89,105,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,139,149,191,155,186,230,173,214,255,170,208,255,168,204,255,165,200,255,162,
            197,255,159,194,255,153,188,255,172,202,255,185,211,255,198,212,242,204,204,214,133,133,133,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,150,
            150,150,179,179,185,173,182,230,166,179,255,166,179,255,185,197,255,204,214,255,223,230,255,222,227,
            241,234,234,234,224,224,224,213,213,213,211,211,211,213,213,213,160,160,160,110,110,110,169,169,169,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,154,154,154,247,247,
            247,248,248,248,250,250,250,218,218,218,199,199,199,193,193,193,178,178,178,185,185,185,191,191,191,
            198,198,198,205,205,205,211,211,211,211,211,211,162,162,162,171,171,171,177,177,177,162,162,162,135,
            135,135,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,159,159,159,234,234,234,234,234,234,
            234,234,234,182,182,182,171,171,171,178,178,178,185,185,185,191,191,191,173,173,173,159,159,159,142,
            142,142,157,157,157,161,161,161,193,193,193,226,226,226,222,222,222,182,182,182,197,197,197,124,124,
            124,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,127,127,127,150,150,150,151,151,151,170,170,170,155,155,155,176,176,176,175,
            175,175,148,148,148,138,138,138,150,150,150,163,163,163,189,189,189,213,213,213,238,238,238,237,237,
            237,235,235,235,234,234,234,232,232,232,231,231,231,230,230,230,181,181,181,200,200,200,121,121,121,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,141,
            141,141,218,218,218,214,214,214,209,209,209,214,214,214,223,223,223,176,176,176,154,154,154,209,209,
            209,244,244,244,242,242,242,241,241,241,239,239,239,238,238,238,237,237,237,235,235,235,234,234,234,
            232,232,232,231,231,231,230,230,230,219,219,219,190,190,190,171,171,171,208,208,208,96,96,96,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,139,139,139,217,217,217,222,222,
            222,218,218,218,214,214,214,209,209,209,208,208,208,239,239,239,211,211,211,187,187,187,242,242,242,
            241,241,241,239,239,239,238,238,238,237,237,237,235,235,235,234,234,234,223,223,223,202,202,202,182,
            182,182,177,177,177,190,190,190,207,207,207,224,224,224,222,222,222,136,136,136,111,111,111,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,125,125,125,230,230,230,226,226,226,222,222,222,
            218,218,218,214,214,214,209,209,209,207,207,207,239,239,239,209,209,209,197,197,197,239,239,239,238,
            238,238,232,232,232,210,210,210,189,189,189,178,178,178,187,187,187,206,206,206,224,224,224,227,227,
            227,225,225,225,216,216,216,205,205,205,195,195,195,137,137,137,85,85,85,139,139,139,135,207,163,
            135,207,163,135,207,163,135,207,163,122,122,122,215,215,215,230,230,230,226,226,226,222,222,222,218,
            218,218,214,214,214,209,209,209,212,212,212,241,241,241,191,191,191,185,185,185,179,179,179,184,184,
            184,209,209,209,227,227,227,231,231,231,230,230,230,225,225,225,207,207,207,195,195,195,182,182,182,
            182,182,182,180,180,180,161,161,161,115,115,115,80,80,80,139,139,139,135,207,163,135,207,163,135,
            207,163,135,207,163,120,120,120,119,119,119,184,184,184,230,230,230,226,226,226,222,222,222,218,218,
            218,214,214,214,209,209,209,222,222,222,238,238,238,226,226,226,235,235,235,234,234,234,232,232,232,
            218,218,218,199,199,199,181,181,181,173,173,173,176,176,176,174,174,174,151,151,151,128,128,128,99,
            99,99,101,101,101,121,121,121,79,79,79,139,139,139,135,207,163,135,207,163,135,207,163,135,207,
            163,128,128,128,183,183,183,153,153,153,110,110,110,165,165,165,218,218,218,222,222,222,218,218,218,
            214,214,214,211,211,211,235,235,235,225,225,225,206,206,206,184,184,184,168,168,168,167,167,167,170,
            170,170,164,164,164,143,143,143,116,116,116,112,112,112,139,139,139,172,172,172,126,158,110,121,191,
            86,101,101,101,77,77,77,139,139,139,135,207,163,135,207,163,135,207,163,135,207,163,157,157,157,
            203,203,203,242,242,242,229,229,229,169,169,169,118,118,118,148,148,148,206,206,206,218,218,218,214,
            214,214,179,179,179,158,158,158,162,162,162,164,164,164,154,154,154,131,131,131,115,115,115,116,116,
            116,136,136,136,167,167,167,185,185,185,188,188,188,191,191,191,128,160,112,118,175,89,119,119,119,
            76,76,76,139,139,139,135,207,163,135,207,163,135,207,163,135,207,163,158,158,158,206,206,206,246,
            246,246,242,242,242,238,238,238,225,225,225,167,167,167,118,118,118,146,146,146,195,195,195,173,173,
            173,143,143,143,129,129,129,110,110,110,115,115,115,143,143,143,167,167,167,179,179,179,182,182,182,
            185,185,185,188,188,188,191,191,191,195,195,195,161,161,161,200,200,200,137,137,137,75,75,75,139,
            139,139,135,207,163,135,207,163,135,207,163,135,207,163,156,156,156,208,208,208,251,251,251,246,246,
            246,242,242,242,238,238,238,234,234,234,230,230,230,180,180,180,117,117,117,102,102,102,122,122,122,
            139,139,139,162,162,162,173,173,173,176,176,176,179,179,179,182,182,182,185,185,185,183,183,183,162,
            162,162,144,144,144,78,78,78,51,51,51,185,185,185,120,120,120,73,73,73,139,139,139,135,207,
            163,135,207,163,135,207,163,135,207,163,155,155,155,161,161,161,254,254,254,251,251,251,246,246,246,
            242,242,242,238,238,238,234,234,234,230,230,230,226,226,226,171,171,171,167,167,167,170,170,170,173,
            173,173,176,176,176,179,179,179,182,182,182,153,153,153,132,132,132,117,117,117,126,126,126,142,142,
            142,157,157,157,167,167,167,141,141,141,113,113,113,73,73,73,139,139,139,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,118,118,118,90,90,90,195,195,195,251,251,251,246,246,246,242,
            242,242,238,238,238,234,234,234,230,230,230,182,182,182,170,170,170,173,173,173,176,176,176,139,139,
            139,109,109,109,87,87,87,95,95,95,111,111,111,126,126,126,142,142,142,157,157,157,175,175,175,
            198,198,198,230,230,230,250,250,250,107,107,107,139,139,139,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,119,119,119,74,74,74,109,109,109,214,214,214,246,246,246,242,242,
            242,238,238,238,234,234,234,186,186,186,173,173,173,176,176,176,171,171,171,61,61,61,80,80,80,
            95,95,95,111,111,111,126,126,126,142,142,142,157,157,157,197,197,197,234,234,234,255,255,255,204,
            204,204,118,118,118,69,69,69,139,139,139,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,119,119,119,65,65,65,130,130,130,234,234,234,242,242,242,
            238,238,238,189,189,189,176,176,176,179,179,179,174,174,187,134,134,173,109,109,122,111,111,111,126,
            126,126,155,155,155,210,210,210,243,243,243,242,242,242,166,166,166,81,81,81,68,68,68,89,89,
            89,130,130,130,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,95,95,95,69,69,69,150,150,150,242,242,242,192,
            192,192,163,163,163,110,110,110,77,77,80,102,102,128,147,147,194,146,146,184,212,212,218,255,255,
            255,230,230,230,129,129,129,71,71,71,72,72,72,94,94,94,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,119,119,119,77,77,77,77,77,77,92,92,92,53,53,
            53,58,58,58,68,68,68,75,75,75,66,66,69,102,102,128,166,166,176,103,103,103,60,60,60,
            78,78,78,103,103,103,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,133,133,133,75,75,75,75,75,75,95,95,95,
            140,140,140,119,119,119,119,119,119,111,111,111,74,74,74,82,82,82,113,113,113,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,
            135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,
            207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,
            163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163,135,207,163
        };
        wxImage image( 32, 32, (unsigned char*)data, TRUE );
        wxBitmap bitmap( image );
#ifndef _WIN32	
	bitmap.SetMask(new wxMask(bitmap, wxColour(BACK_RCOLOR,BACK_GCOLOR,BACK_BCOLOR)));
#endif		
        return bitmap;
    }
    if (index == 5)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "48 48 1 1",
        "a c #87CFA3",
        /* pixels */
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
        };
        wxBitmap bitmap( xpm_data );
#ifndef _WIN32	
	bitmap.SetMask(new wxMask(bitmap, wxColour(BACK_RCOLOR,BACK_GCOLOR,BACK_BCOLOR)));
#endif		
        return bitmap;
    }
    if (index == 6)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "16 16 6 1",
        "a c Black",
        "b c #80FF80",
        "c c #2F0000",
        "d c #FFFFFF",
        "e c #3F0000",
        "f c #7F7F7F",
        /* pixels */
        "bbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbb",
        "bbbbbbffffbbbbbb",
        "bbbbfceeeecfbbbb",
        "bbbfeeaaaaaefbbb",
        "bbbcefdaaaaacbbb",
        "bbfeadfaaaaaebbb",
        "bbfeaaaaaaaaebbb",
        "bbfeaaaaaafaecbb",
        "bbfeaaaaaffaecbb",
        "bbbcaaaaffaeccbb",
        "bbbfeaaaaaeeccbb",
        "bbbbfceeeeccccbb",
        "bbbbbbbbcccccbbb",
        "bbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbb"
        };
        wxBitmap bitmap( xpm_data );
#ifndef _WIN32	
	bitmap.SetMask(new wxMask(bitmap, wxColour(BACK_RCOLOR,BACK_GCOLOR,BACK_BCOLOR)));
#endif		
        return bitmap;
    }
    if (index == 7)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "16 16 7 1",
        "a c Black",
        "b c #80FF80",
        "c c #00BF00",
        "d c #3F3F3F",
        "e c #FFFFFF",
        "f c #7FFF7F",
        "g c #7F7F7F",
        /* pixels */
        "bbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbb",
        "bbbbbbggggbbbbbb",
        "bbbbgaaaaaagbbbb",
        "bbbgaacccccagbbb",
        "bbbaafecccccabbb",
        "bbgacefcccccabbb",
        "bbgaccccccccabbb",
        "bbgaccccccfcadbb",
        "bbgacccccffcadbb",
        "bbbaccccffcaddbb",
        "bbbgacccccaaddbb",
        "bbbbgaaaaaddddbb",
        "bbbbbbbbdddddbbb",
        "bbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbb"
        };
        wxBitmap bitmap( xpm_data );
#ifndef _WIN32	
	bitmap.SetMask(new wxMask(bitmap, wxColour(BACK_RCOLOR,BACK_GCOLOR,BACK_BCOLOR)));
#endif		
        return bitmap;
    }
    if (index == 8)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "16 16 7 1",
        "a c Black",
        "b c #FFF0A0",
        "c c #80FF80",
        "d c #FFFF00",
        "e c #3F3F3F",
        "f c #FFFFFF",
        "g c #7F7F7F",
        /* pixels */
        "cccccccccccccccc",
        "cccccccccccccccc",
        "ccccccggggcccccc",
        "ccccgaaaaaagcccc",
        "cccgaadddddagccc",
        "cccaabfdddddaccc",
        "ccgadfbdddddaccc",
        "ccgaddddddddaccc",
        "ccgaddddddbdaecc",
        "ccgadddddbbdaecc",
        "cccaddddbbdaeecc",
        "cccgadddddaaeecc",
        "ccccgaaaaaeeeecc",
        "cccccccceeeeeccc",
        "cccccccccccccccc",
        "cccccccccccccccc"
        };
        wxBitmap bitmap( xpm_data );
#ifndef _WIN32	
	bitmap.SetMask(new wxMask(bitmap, wxColour(BACK_RCOLOR,BACK_GCOLOR,BACK_BCOLOR)));
#endif		
        return bitmap;
    }
    if (index == 9)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "16 16 7 1",
        "a c #80FF80",
        "b c #2F0000",
        "c c #FFFFFF",
        "d c #3F0000",
        "e c #FF6F6F",
        "f c #7F7F7F",
        "g c #EF0000",
        /* pixels */
        "aaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaa",
        "aaaaaaffffaaaaaa",
        "aaaafbddddbfaaaa",
        "aaafddgggggdfaaa",
        "aaabdecgggggbaaa",
        "aafdgcegggggdaaa",
        "aafdggggggggdaaa",
        "aafdggggggegdbaa",
        "aafdgggggeegdbaa",
        "aaabggggeegdbbaa",
        "aaafdgggggddbbaa",
        "aaaafbddddbbbbaa",
        "aaaaaaaabbbbbaaa",
        "aaaaaaaaaaaaaaaa",
        "aaaaaaaaaaaaaaaa"
        };
        wxBitmap bitmap( xpm_data );
#ifndef _WIN32	
	bitmap.SetMask(new wxMask(bitmap, wxColour(BACK_RCOLOR,BACK_GCOLOR,BACK_BCOLOR)));
#endif		
        return bitmap;
    }
    if (index == 10)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "32 32 5 1",
        "  c None",
        "a c Black",
        "b c #FF0000",
        "c c #FFFF00",
        "d c #800000",
        /* pixels */
        "                d               ",
        "               ddddd            ",
        "     dd       ddddddd           ",
        "   dddddddddddddddddddddd       ",
        "  dddddddddddddddddddddddd      ",
        "ddddddddddddddddddddddddddd     ",
        "ddddddddddddddddddddddddddd     ",
        "dddddddddddddddddddddddddd      ",
        "ddddddddddddddddacccacdddd      ",
        " ddddddddddddddcacccaaadddd     ",
        "  dd ddddddddddccaccaccddddd    ",
        "     ddddddddddcaaaaaacddddddd  ",
        "      dddddddddacaccacadddddd   ",
        "        ddddddddcaccacddddddddd ",
        "         dddddddddddddddddddddd ",
        "            ddddddddddddddddddd ",
        "             ddddddddddddddddd  ",
        "             dddddddddddddddd   ",
        "             ddddddddddddddd    ",
        "             dddd dddddddddd    ",
        "             ddd  dddddddddd    ",
        "                  dddddddddd    ",
        "                  ddddddddddd   ",
        "                   dddddddddd   ",
        "aaaaccccbbbb           dddddd   ",
        "aaaaccccbbbb           ddddd    ",
        "aaaaccccbbbb            ddd     ",
        "aaaaccccbbbb                    ",
        "aaaaccccbbbb                    ",
        "aaaaccccbbbb                    ",
        "aaaaccccbbbb                    ",
        "aaaaccccbbbb                    "
        };
        wxBitmap bitmap( xpm_data );
        return bitmap;
    }
    if (index == 11)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "11 11 3 1",
        "a c Black",
        "b c #FFFFFF",
        "c c #808080",
        /* pixels */
        "ccccccccccc",
        "cbbbbbbbbbc",
        "cbbbbbbbabc",
        "cbbbbbbaabc",
        "cbabbbaaabc",
        "cbaabaaabbc",
        "cbaaaaabbbc",
        "cbbaaabbbbc",
        "cbbbabbbbbc",
        "cbbbbbbbbbc",
        "ccccccccccc"
        };
        wxBitmap bitmap( xpm_data );
        return bitmap;
    }
    if (index == 12)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "11 11 2 1",
        "a c #FFFFFF",
        "b c #808080",
        /* pixels */
        "bbbbbbbbbbb",
        "baaaaaaaaab",
        "baaaaaaaaab",
        "baaaaaaaaab",
        "baaaaaaaaab",
        "baaaaaaaaab",
        "baaaaaaaaab",
        "baaaaaaaaab",
        "baaaaaaaaab",
        "baaaaaaaaab",
        "bbbbbbbbbbb"
        };
        wxBitmap bitmap( xpm_data );
        return bitmap;
    }
    if (index == 13)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "284 314 2 1",
        "a c Black",
        "b c #FFFFFF",
        /* pixels */
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbabbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaabbbbaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaabbbbaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaabbbbabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaaabbbbaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbabaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabaaaabaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaababbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbabbbabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbabbbabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbabbbabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbabbbabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaaaabbbaaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbaabbbaaaaaaaaaaabbbbabbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaabbbaabaaaabbbbbbbbbbbaaaaaaabbbbbbbaaaaaaabbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbaaaabaaabbbbbbbbbaaabbbbaaaaaabbbbbbaabbbbbbbbbaaaaaaaabbbbbaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbaabbbbbbabbbbbaaaaabbbbbbabbbbbaabbbaabbbbbaabbbbbbbbbaabbbaaabbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbabbbbbbaabbbbaaaaaabbbbbabbbbbaaaaaaabbbbbabbbbbaaaaaabbbbbabbbbbbaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbbbbbbbabbbbbbabbbbbbabbbaaaaaaaabbbbabbbbaabbbbaabbbbaabbbabbbbbbabbbbbbabbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbaabbbbbbbabbbbbaabbbbbaabbbbabbbaaaabbaaaaaababbbaaaaaaaabbbbabbbbbbaabbbbbabbbbbbbaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbbbbbaabbbbbbbaaaaaaaaaabbaaabbbbabbaabbaabaaaaaaaabaaabaabbbabbbbaabbbbbaaaabbaabbbbbbbaabbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaabbbbaaaaabbbbaaaaabbbbaaaaaaabbbaabbabbbbaaaabbbbbaaabbbbabbbaabbbaaaaaaaaaaaaaaabbbbbbbabbbbbaaabbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbaabaaabbbaaaaaabbbbbbbbbbbbbaaaaaaabbabbbbbaabaaaabaaabbbbabbbbabbbaaaaabbbbbbbbbaabbbaaaabbbbbabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbaaaaabbbbbbaaabbbaaaaaaaaaabbbbbbaaaaabbbbbaaaaaaaaaaabbbbabaaaaaaaaabbbbbbbbbbbbbaaaaaabaaabbbabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbaaaabbbbbbbaabbaaabbbbbbbaaaaaabbbbbbabbbbbaabbbbbbaaabbbbaaaabbbbbbbbaaaaaaaaabbbbaaabbbbbabbaabbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaabbbbaaaaabbbbbbbabbbaabbbbbbbbbbbbaaaaaaababbbbbaabbbbbbaaabbbbabbbbbbaaaaaaaabbbbbaabbbaabbbbbbaaaaabbbbbbaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbaabaaabbabbbbbbbbabbaabaaaaaaaaaaabbbbbbaaaabbbbbaabbbbbbbaabbbbaaaaaaaaabbbbaaaaaabbaabbaabbbbbbbaaaaaabbbaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaaabbbaaabbbbbbbabbabbabbbbbbbaaaaaaaabbbbabbbbbaabaaaabaaabbbbaaaaaaaaaaaaaaaaaaaaabaabaabbbbbbbaaabbaaaaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaabbbaaaabaaabbaabbabbaaaaaaaaaaaaaaaaaaaaabbbbbaaaaabaaaaabbbbaaaaaaaaaaabbbbbbbbbaababaabbbbbbbabaabbbaaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabbabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbaabbbbaabaaaaaaaaabbabbabbbbbbbbaaaaaaaaaaaabbbbbaabbbbbbaaabbbbaaaaaaaaaaaaaaaaaaaabababbaabbbbbaabbabbbbbaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaabaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaabbbbaabaabbbbbaaabbabbabbbbbbbbbbbbbbbbbbbabbbbbaabbbbbbaaabbbbabbbaaabbbbbbbbbbbbaaababaaaaaaaaabbbaaabbbbaabbbbaabbbbbbbbbbbbbbbbbbbbbaaabbbabaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbaabbbababbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaabbbbbaababbbbbbbbabbabbabbbbbbbbbbbbbbbbbbbabbbbbabbbbbbbbaabbbbabbbbbbbbbbbbbbbbbbbaababaaabbbbbaabbabaaabbbabbbbabbbbbbbbbbbbbbbbbbbbbbaaabbbabaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbaabaababbbbbbbbbbbbbbbbbbbbbbaaabbbaaaabbbbbbabaabbbbbbbbabbaababbbbbbbbaaaaaaaaaaaabbbbbaabbbbbbbaabbbbaaaaaaaaaaaabbbbbbbbaababaabbbbbbbaabaabbaabbaaaaaaaabbbbbbbbbbbbbbbbbbbaaaaaaaabaaaaabbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbbaaaabaabbbbbbbbbbbbbbbbbbbbbabbbbbbbaabbbbbbababbbbbbbbbaabbababbbaaaaaaaaabbbbbbbabbbbbaaaaaaabaaabbbbabbbbbbbaaaaaaaaabbbaabababbbbbbbbbabaaabbabbbaaabbbaabbbbbbbbbbbbbbbbbbbaabbaabbabaaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbbaaabbaabbbbbbbbbbbbbbbbbbbbabbbbbbbabbbbbbbababbbbbbbbbaabbabaaaaaabbbbbbbbbbbbbbabbbbbaaaaabaaaaabbbbabbbbbbbbbbbbbbaaaaaabaababbbbbbbbbababaabaabbaabbbbbabbbbbbbbbbbbbbbbbbbbaaabaaaaaaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbbaabbaabbbbbbbbbbbbbbbbbbbaabbbbbbbabbbbbbbaaaabbbbbbbbaabbabaabbbbbbbbbbbbbbbbbbabbbbbaabbbbbbaaabbbbabbbbbbbbbbbbbbbbbbbabaababbbbbbbbbababbaababbaabbbbbabbbbbbbbbbbbbbbbbbbbbbabbbbbaaaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbaabbbabbbabbbbbbbbbbbbbbbbbbbaabbbbbbbabbbbbbbaabaabbbbbbaaaabaaaabbbbbbbbbbbbbbbbbbabbbbbaabbbbbbaaabbbbabbbbbbbbbbbbbbbbbbaababaaabbbbbbbbababbbababbaabbbbbabbbbbbbbbbbbbbbbbbbbbbaaabaabbabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbaabbaabbbbbbbbbbbbbbbbbbbabbbbbbbabbbbbbbbabbaabbbbaaaaabaababbbbbbbbbbbbbbbbbbabbbbbabbbbbbbbaabbbbabbbbbbbbbbbbbbbbbbabaabaaaabbbbbbaababbbaaabbaabbbbbabbbbbbbbbbbbbbbbbbbbbbbaaabaabbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaaaaabbbaabbbbbbbbbbbbbbbbbbaaabbaaaabbbbbbbbaabaaaaaaaaaaabbabaabbbbbbbbbbbbbbbbbabbbbbabbbbbbbbaabbbbabbbbbbbbbbbbbbbbbbabaababbaaabbbaabbabbbbaabbaabbbbbabbbbbbbbbbbbbbbbbbbbbbbabaaaaabbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabaabbabbbaabbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbaabbbaabbbbaaabbabbabbbbbbbbbbbbbbbbbabbbbbaabaaaabaaabbbbabbbbbbbbbbbbbbbbbbababaabaaaaaaaabbaaaabbaabaaaaabaaabbbbbbbbbbbbbbbbbbbbbbbabbbaaabaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaabbbbbbbbabbbbbbbbbbbbbbbbbbbbaabbbbaabbbbbbbbabbaabbbbbbaaabaababbbbbbbbbbbbbbbbbabbbbbaaaaaaaaaaabbbbabbbbbbbbbbbbbbbbbaabababaabbbbaaabbaaaaaaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbabbbbaaaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaabbbbbbbbaabbbbbbbbbbbbbbbbbbbabbbbbbabbbbbbbbabaabbbbbbbbaabbababbbbbbbbbbbbbbbbbabbbbbaaaabbbaaaabbbbabbbbbbbbbbbbbbbbbabaabaaabbbbbbbabbabbbbaabbaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbabbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaabaabbbbbbbaabbbbbbbbbbbbbbbbbbabbbbbbbaabbbbbbbaaaabbbbbbbbaabbabaabbbbbbbbbbbbbbbbabbbaaaaaaaaaaaaaabbbabbbbbbbbbbbbbbbbaababbaabbbbbbbbabaabbbbaabbabbbbbbabbbbbbbbbbbbbbbbbbbbaaaaaaabaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbaababbbbbbbbabbbbbbbbbbbbbbbbbbabbbbbbbbabbbbbbbbaaabbbbbbbbaaabaaaabbbbbbbbaabbbbbbabbbabbbabbbbaabbabbbabbbbbbbbbbbbbbbbaababaaabbbbbbbbababbbbbabbaabbbbbbaabbbbbbbbbbbbbbbbbbbaabbbbabbabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaaabbbbbbbbaabbbbbbbbbbbbbbbbbaabbbbbbaabbbbbbbbaaabbbbbbbbaaabaababbbbbaaaaaaaabbbabaaaabbabbbbabbaaaaaabbbbaaaaaaabbbbbabaababaabbbbbbbababbbbaabbaabbbbbbaabbbbbbbbbbbbbbbbbbbaabbbbabaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbaabbbbbbbbbbbbbbbbbaabbbbbbaaabbbbbbbbaaabbbbaaaaaabbabaabbbaabbbbbbabbbaaabaaabaabbbabaaaaaaabbbaabbbbbabbbbbababaabbabbbbbbbaaabbbbaabbaabbbbbbaabbbbbbbbbbbbbbbbaaabaaaaaababbbaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaabbbbbbbbbbaabbbbbbbbbbbbbbbbbbaaabaaaaaabbbbbbbbaaaaabaabbaaaabaababbaabbbbbbbabbbaaabaaabbaaaaabaaabbaabbaabbbbbbbaabbaaaabaabaaaabbbbaaabbbbbaabaaaabbbbaabbbbbbbbbbbbbbbbbaaaaaabbaabaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbaaaabbbbaabbbbbbbaabbaaabbbbabaabababbaabbbbbbbabbbababbbbbbabbbabbbbbbaaababbbbbbbbbabbaaaaaabaabbaaaaaaaabbbbaabbaaaaabbaabbbbbbbbbbbbbbbbbaabbaaabbabbbababaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbabbbbbbabbbbbbbbaabaaabaaaabaaaababbaabbbbbbbaabaabaaaaaaaabbbaaabaaaabababbbbbbbbbabbababaababaaaaaaababbbbbaabbabbbaaaabbbbbbbbbbbbbbbbbaabbbbaaababbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbaababbbbbbbbbbbbbbbbbbbaabbbbbbabbbbbbbbaababbbaaaabaabaaaabaabbbbbbbaabaababaaaaabbbbbaaaababbababbbbbbbbbabaaaabaabbbabbaaaababbbbbabbaabbbbbabbbbbbbbbbbbbbbbbaaaabbaabababbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaabbaaaaabbbbbbbbbbbbbbbaabbbbbbaabbbbbbbbabaabbbaaabaababaabbabbbbbbaaabaaaabaaababbbbbaaaabaababaaabbbbbbaabaaabbbabbbaaaaabaaabbbbaabaabbbbbbabbbbbbbbbbbbbbbbbaabaaaaaaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaabbbbbaabaabbbbbbbbbbbbbbaabbbbbbbabbbbbbbbabaaabbabaabbbabbabbaabaaaaaabbbaabbbbbbaabbbaabaaabaaabaaaaabbbbabbabababbbaaaabbbaaabbbbbabbaabbbbbbabbbbbbbbbbbbbbaaaaaaabbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbaaabbaabbbbbbbbbbbbbbbaabbbbbaaabbbbbbbaaaaabaabbaaaaabbaabbaaabbbbabbbaaabaaaabaabaaaaabaaaabbaabbaaaaabbbababaaaaaaabbbaaaaabbbaabbaabbbbbbabbbbbbbbbbbbbaabbaaaaabbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaaabaaabbbbbbbbbbbbbbbaaabaaaaaabbbbbaaaabbbbaabbaaabaabaabbaabaaaaabbbbaaaaaabbaaaaababaaaabbbbaaabbbbabbbaaaaababbbabbbbbbaaabbabbaaaabbbbbabbbbbbbbbbbbbaaaababbaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbaababbaabbbbbbbbbbbbbbbbbbaaaabbaaaabbbbabaaabbbbabbbabbaaaaabbbaaaaabaabbbaaabaabbbaaabbaabbbabbbbaaaaaaaabbaaaaaaaabbbabbbbbaabaaaaaaaaaaaaaaaabbbbbbbbbbbbbbaaabaaaaaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabbabbbabbbbbbbbbbbbbbbbbbbbabbaaaaabbbbababaabbbaabaabbaaababbbabbaabbaabbabaaabbbaaaabbbaaababbbaababbaabbbaaaabbaabbbabbbbbbabbaaaabaabbbaabbbbbbbbbbbbbbbbbaaaaaaaabaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbabbbaabbbbbbbbbbbbbbbbbbbaaabaaaaaaaaababbabbbbaaaaaaaaababbaabbaaaabaaaaaaabbbaabaaabbbbaaaaaaabaaabaaabbabaabaaaabaabbbbbbabbaaaabbaaabaabbbbbbbbbbbbbbbbbaabaaababbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbabbaabbbaabbbbbbbbbbbbbbbbbbbbaabbbaaaaaabaabbbbbaabbaaaaabbaaaabbaabaaaabbbbbaaaaaaaaaaabbbbbbbbbbaaaabbaabaabaabaabaaabbbbbbbabaaababbbaaaabbbbbbbbbbbbbbbbbaabaaaaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabaaabbaabbbbbbbbbbbbbbbbbbbbaabbabbbbaaaaaabbaaabbbaaaaaaaaabbbabbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbaaaabbaaaabbbaabbbbbaaaaabbabbaabaabbbbbbbbbbbbbbbbaabbbbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaabaaaababbaabbbbbbbbbbbbbbbbbbbbaaabbbbbaaaabaaaaaabbabbbbaabbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbaaaaaaababbaabbbbaaaaabbbbbbaabbbbbbbbbbbbbbbbbbaabbbaaabaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaabbbbbaabbbbbbbbbbbbbbbbbbbaabaabbaaaabaaaaaaabaaaabbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbaaabaaaaaaabaaaabbaaaabbbbbbbbbbbbbbbbbbaabbaaaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaabbbbaabbbbbbbbbbbbbbbbbbaabbabbbaaaaabbaaabbabaaaaaabbbbbbbbbbbbbbbbbaaaaaaaaaaaaaabbbbbbbbbbbbbbbbaaaaaaaabaabbaaaaaaabaaaaaabaabbbbbbbbbbbbbbbbbaabbbbaababaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaaaaabaabbbbbbbbbbbbbbbbbbaababbaaaaaabbbbbbaaaaaabbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbaaaaaaaaabbaaabbaaaaaaabbaabbbbbbbbbbbbbbbbaaabaaaaabaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabbabbabbbbbbbbbbbbbbbbbbbaaabaaaaaabbbbbaaaabbbbbbbbbbbaaaaaabbaaaabbbaaaaaaaaaaabbbbbbaaaaaaaaabbbbbbbbbbaaaabbbbbbaabaabaabbabbbbbbbbbbbbbbbbbabbbaaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaaaabbbbbbbbbbbbbbbbbbbbbaaaaaaaabbaaaaabbbbbbbaaaaaaabbaaabbabbaaaaaaaaaaaaaaaaaabbaababbaaaaaaaaabbbbbbbaaaaaaaababbaaaaaaabbbbbbbbbbbbbbbbaabbbaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababaaabbabbbbbbbbbbbbbbbbbbbbaaaaabbbbaaabbbbbbbbbaaaaabaaabaababbaaaaaaaaaabbaabbaaaaaabaababbabaabaaaaaaabbbbbbbaaaaabaaaaabbabbbbbbbbbbbbbbbbbbabbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaababaaabbbbbbbbbbbbbbaaaaaaaabaaabbbbbbbaaaaaaaaaaaaaaaaaaaaabaaaaaaaaaaaaaaaaabaaabaaaaaaaaaaaaaaaaaaaaabbbbbaaaabbbbbaabbbbbbbbbbbbbbbbbabaabbabaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaabaaaababbbbbbbbbbbbbaaaaaaaaaaabbbbbbbaaabaaaabbbaaaaabaababaabbaaaaaaabaabbaaaaaaabbbabaaaaaaaabbbaabaaaaabbbbbbaabbbaaaabbbbbbbbbbbbbbbaaaaabbaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaabbbaabbbbbbbbbbbbbaaaaaaaaabbbbbbaaaaaabaaaaabaabbaaabbbaaaaaaaaaaaaaaaaaaaaaaabbaabababbaaaaaaabbaaaabbaaabbbbbaaaaaaaaaabbbbbbbbbbbbbaaabaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbabbbbbbbbbbbaaaaaaaabbbabbbbaaabbabaaaabbaaaabbaabbaaabbbabaabbaaaaaaaaaabbbbaabaaaabaababbbaaaaaaaaaabaaabbbbbabaaaaababbbbbbbbbbbbbabbbbaabbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaabbbbbbbbaaaaaaaaabbbbaabaaabaaaaaaaaabbaabaaaaabaababbbaaaabbbaaaaaaabbbbbbaaaabbaaaaaaaaaaaabbabaaabaaaaaabbabbaaaaaabbbbbbbbbbbbaabbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaabbbbbbbaaaaaaaaabbbbbbaaaaaaabaaabaaabaabbaabaabaaaabaaaaaaaaaaaaaaaaaaaaaaaaabbbabaaaaabbbbaabaaabbbaaaabaaaabbbbaaaaaaabbbbbbbbbbaabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababbbaabaabbbbaaaaaaaaaaaaabbbbbbaaaaaabaaabaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbaaaaaaaaaaaabaaaaaaaaaaaabaaaaaaaaaaabbbaaaaaaaaaaabbbbbbaaaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbaabbbaaaaaaaaabaaabbbbbbabbaaabaaaaaaaabbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabaaaaabaabaabaaaaaaabbbaaaaabaaaaaaabbbbbabbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbabbbbbabbbaaaaaaaaaaaaaabbbbbabaaaabaaaaaaaaaaaaaabbbbbbbaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbaaaaaaaaaaaaaaaaaaaaababbbaaaaaaaaaaaaaabbbaabbbbaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaaaaaabaaaaabbaaaabbbaaaaaaaaaaaaaaaabbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbbbbaaaababababababbbabbbaaaaabbaaaaaaabbaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaaaaaaaaaaaaaaaaaaaabaaaaaaaaaaaaabbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbaaaaaaaaaababbaaaaaaaaaaaabaaaaaaaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbaaaaaaabaabbbbbbbaaaaabbaaaaaaaabbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbaaaaaabaaaaaabbbbbbbbaaabaaaaaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaaaaaaabbbbbbbbbbaaaaaaaaaaabbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbaaaaaaaaaabbbbbbbbbbbbaaabbaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaabababbbbbbbbbbbbbbaaaaaaabbbaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaabbbbaaaaabbbbbbbbbbbbbbbaabbbabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbaaaaabbbbbbbbbbbbbbbaaaaaaaaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaaaabbbbbbbbbbbbbbbbbbaaaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbaababbbbbbbbbbbbbbbbbbbbaaaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbaaabbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbaabbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaabbbaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbabbbbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbbbabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaabaabbbbaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabbbbaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaaabbaabbbbabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababbbbbaaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabaabbbbbabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbaababaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaabaaaaaaabaaabbbbaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbaaaaaabbaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabaaabaaaabaabbbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbaabaaaaaaabbabbbbbababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbaaaabaabbbaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaababaabaabaaaabbbaabbbbaaabbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbabbbaabaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabaaaaaaaabbbbaabbbbaabbbbbbbbbbbbbaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbbabbbbaaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaabbbbbbaabbbbabbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabbbbbabbbaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaababbbabaaaaabbbbbbbabbbbabbbbbbbbbbbbbbbbaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababbbbbbaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaabbbbbbbbaabbbabbbbbbbaaaaaaaaabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbaaaabbbbbbbbbaaaaaaaabbbbbbbbbbbbbbbbbbbaaaabbbbbbbaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaabaabaaaaabbbbbbbaaaabbabbbbbbaabbaabaaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbaababbabbbbbaabbbbbbaaabbbbbbbbbbbbbbbbbaabbbbbbbbbaaabbbbbbabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbabaaaaaabbbbbbbbaaaaababbbbbaaaabaabbaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbaaabbbbaaaaaabbbbaabbaaaaabbaabbbbbbbbbbbbbbbbaaabbbbbbbbaaabbbbbbabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaaaabaaaabbbbbbbaaaaaababbbbbaabaaabbbbabbaababbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaaaabbbbbbababbbbaabaaabbbaaabaabbbbbbbbbbbbbbbaababbbbbbbbaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaabaaaaaabbababbbbbbbaaaaaaaaabbbbbbbbbabbbbbbbaabaabbbbbbbbbbbbbbbbaaaabbbbaaaaabbaaaaabbbbbaaaabababbaabbbbbbaabaabbbbbbbbbbbbbbaaaaabbbbbbbaaaaaabaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaaaaaaabbbbaaabbbbbbaaaaaabbaabbbbbbbbbaabbbbaaabbaabbbbbbbbbbbbbbbbbabaaabbaaaaabbbbaaabbbbbbaaaaaaabaabbbbbbbaabbabbbbbbbbbbbbbbaaaaaabbbbbbbaaaaaaaaaabaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaaabbbbbbbaabbbbbbaaaaabbbbabbbbbbbbbbaaaabbaabbbabbbbbbbbbbbbbbbbbabbbabbaaabbbbbbaabaaaaaababaaaababbbbbbbbbaabaabbbbbbbbbbbbbaaaaaabbbbbbbaaaaabaaaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaabbbbbbbbbabbbbbbbaaaabbbbbabbbbbbbbbbbbbabbbabbbabbbbbbbbbbbbbbbbbabbbaabaabbbbbbbbbbbbbbbabaaababbabaaaabbbbbabbabbbbbbbbbbbbbabaababbbbbbbaabbbbaababaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbabbbbbbbaaaabbbbbabbbbbbbbbbbaaabbaabbbabbbbbbbbbbbbbbbbbabbbbabbabbbbbbbbbbbbbbbabbaababbabbababbbbbabbabbbbbbbbbbbbbabbaaabbbbbbbaabbbbaaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbabbbbaaaaabbbbbbbabbbbbbbbaaaabbbaabbbbaabbbbbbbbbbbbbbbbabbbbaababbbbbbbbbbbbbbbabbbababbabbabaabbbbabbabbbbbbbbbbbbbabbbaaaaabbbbaabbbbbaaaaaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbabbbbaaaabbbbbbbbabbbbbbbaabbabbbbabbbbbaabbbbbbbbbbbbbbbabbbbbababbbbbbbbbbbbbbbabbbaaabbaababbabbbbabbabbbbbbbbbbbbbabbbbaaaabbbbbabbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbabbbaaaaabbbbbbaaabbbbbbbabbaabbbbaabbbbbaabbbbbbbbbbbbbbaabbbbbaaaaaaabbbbbbbbbbaabbaaabbbaaabbabbbbabbaabbbbbbbbbbbbabbbbaaaaabbbbabbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbabbbaaaaabbbbbbababbbbbbbabaaabbbbaabbbbbbaabbbbbbbbbbbabbaabbbbbaaabbaabbbbbbbbbaabaaaabbbbbbbaabbbbabbaaabbbabbbbbbbabbbbaaaaabbbbabbbbbbbbbbbbbbbaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaababbbbbbbbbbbbbbbabbaaaaabbbbbbaababbbbbbbaaabaabbbbbbbbbbbbaaaabbbbbbaaaaabaaabbbbbaaababbbbbbbbbbaaaababbbbbaaabbbbbabbaaaaaaaaabbbbbabbbbbaaaaabbbabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbaabaaaaabbbbbbaababbbbbbbaabbbaaaabbbbbbbbbbbbaabbbbbbaabaabbaaaaabbbababbbbbbbbbbbbaabaaabbbabbbbbbaabbabaabbbbbabbbbabbbbbbaaababbabbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabaaabbbbbaaaaaaabbbbbbbabbabbbbbbbbbbbbbbbabbbbbbbbbbbbbaaabbbbbabbaabbabaaaaaaaabbbbbbbbbbbbaaaaaaabbaabbbbbaabaabaabaaaaabbbbabbbbbbaaaaabbabbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaababbaaaaaaaaabbbbbbabaaabbbbbbbbabbabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaabbbabbbaababbbbbabaabbbbbbbbbbbbbaaabbabbaabbbbbabbabbaababbaabbbbabbbbbbbaaaabaabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaababbbaabaaaaabbbbbbaaaaabbbbbbbbabbabbbbbbbbbbbbbbaabbabbbbbbbbbbbbbbaaaaababbaaaaabbbabaabbbbbbbbbbbbbaaabbbabbabbaaaabaabaabbabbbabbbbabbbbbbbbaaababbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbabbbabbbaaaabbbbbaaaabbbbbbbbbbabbabbbbbbbbbbbbbbaabbaabbbbbbbbbbbbbbbbbababbbaaaaabbaaaabbbbbbbbbbbbabbabbbabbaaaaaabbaabaabbababbbbbbabbbbbbbbbaaaabbbbbbbaabbaaaabaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaabbaabaaaaabbaaaaaaabbbbbbbbbbaababbbbbbbbbbbbbbabbbaabbbbbbbbbbbbbbbaaaaaabbbbaabbbbaabbbbbbbbbbbbbaaaabaaaabaaabaabaabbabbaaaaabbbbbabbbbbbbbbaaaabbbbbbaaabaaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaaabbaaaaaaaaaaaabaaabbbbbbbbbbbababbbbbbbbbbbbbbabbbbabbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbabbbbaabbaaababaaabbababbaabbaabaabbbbbabbbbbbbbbaaaaabbbbbabaaaabaabbabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbabaabaaaabaabbaaaaaaabbbbbbbbbbbababbbbbbbbbbbbbbaabbbabbbbbbbabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaabaabababaabbbaaabaabbaaaaabbbbbbabbbbbbbbbbaaaabbbbbaaaaabbabbbabbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbabbaabbbaaaaaaaaaabbbbbbbbbbbababbbbbbbbbbbbbbaababbbbbbbbbaaaabbbbbbaaabbbbbbbbbbbbbbbbbbbbbabbbbbababbaaabaabbaaabaabbbaaaabbbbbbbabbbbbbbbbbaaaaabbbbaaaaababbbaabbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaaaaaabbaabbbaaabbbaaaaaaaabbbbbbbbbbbaaabbbbbbbbbbbbbbbababbbbbbbbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbabbbabbaabababbbaaaaabbaabaaabbaaaabbbbbbbbabbbbbbbbbbaaaaabbbbbbbabaabbaabbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaaaabbbbbaaabbaaabbaaaaaaababbbbbbbbbbbbaabbbbbbbbbbbbbbbaaabbbbbbbbbbbabaabbbaabbbbbbbbbbbbbbbbbbaabbbaabaabaaaabbbbaabbaaaaabbbaaaaabbbbbbbbabbbbbbbbbbaaaaabbbaaaaaaaaabaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbaaaaabaaabaaaabbaaaaabaaaaaabaabbbbbbbbbbbaabbbbbbbbbbbbbbbaaabbbaabaabbbabbaaaaabbaaaaaaaaaaaaaaabaaabbaaaaaaabaaaaaaaabbbaaaabbaaaaaabbbbbbbbbabbbbbbbbbaaaaaaaaaaaaabaaaabababaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbabaaaaabaaababbaabaaababaabbbbabbbbbbbbbbbbabbbbbbbbbbbbbbbbbabbbabbaabbbabbaabbbaaaabbbbbbbbbbbbbbababbabaabbaaaabbbbbabbbaaabbbabaaabbbbbbbbbbabbbbbbbbbabbbaaababbaabaaaaaabaabbbaaabbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbaaabaabbbbbbabaaabaaabaaaaabbbaabbbbbbbbbbbabbbbbbbbbbbbbbbbaabbaabaaaabbaaaabbaaabbbbbbbbbbbbbbbaaabaaaabbaaaaabbbbbbbabbaaabbaaaaabbbbbbbbbbbbabbbbbbbbaabbbaaaaaaababaaaaaabbbaaaaaaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaaaaabbbbbbabaaaabbaaaaaaabbbaabbbbbbbbbbbabbbbbbbbbbbbbbbbbaaaaababaabbaaabbaaabbaaaaaaabbbbbaaabbbbaabbbaaaaabbbbbbbabbaabbaaaaaaabbbbbbbbbbbabbbbbbbbabbbbbaaaaaabbabaaaaaabaaaaaaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaaaabbbbbbbaaaaaaaabaaaaaaaabbbabbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbaaabbabbababaaaaaaaaaaaaaaaaaaabbbbabbbbbbaabbbbbbbbbbabbabbaaaabbbaabbbbbbbbbbabbbbbbbbabbbbaaaaaaaaaaaaaaaaaaabbaaaaaabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbaaaabbbbbbbabaabababbbaaaababbbabbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbaabbabbabababababbbbbbbbbbbbbbbbbbababbbbabbbbaaaabbbabbabbaabbbbbbaabbbbbbbbbabbbbbbbaabbbbaaaaaaaaaaaaaaabbbbbbaaaababbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbaaabbbbbbbbaaaababaabaaaaabaabbaabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbaababaaaabaaaaabbbbbbbbbbbbbbbabbabaabbbaabaaaaaaaaaabaabbabaaaabbbaabbbbbbbbabbbbbbbabbbbbaaaaabaaaaaabaabbbbbbbabaaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbaabbbbbbbbbbbabbaaabbaaababbabbaabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaabaaabbbbbbbbbbbbabbbabbaababbbaababbbbbbbaabbabbbbaaaaabbaabbbbbbbbabbbbbbbabbbbbaaaaaabaaabaababbbbbbbaaaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaaaabbaaaaaabbbbbbbbbbaaaaabbabbbabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaaabbbbbbbbbbbbabbaabbbabaabbaaaabaaabbbbbbbbbbbaaaaaabbbabbbbbbbbabbbbbbaabbbbaaaaababbabaaababbbbbbbaaaaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbabaaaaaaabbbaaabbbbbbbbbaaabbbabbbaabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbabbaaabbabaaaaaaabaabaabbbbbbbbbbaabbaabbbabbbbbbbbabbbbbbabbbbbabaaababbaaabaaaabbbbbbbaaaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbabaaaabbbbbaaaaaaaaabbbaaabbbbabbbaabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbabbbbbabbaaabbaabaabbaababaaabbbbbbbbbbaaaaaabbbabbbbbbbbabbbbbbabbbbaabaaaaabaaabbaaaabbbbbbbaaaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaaaaaaaaaaabbbbaaaaabbbbbaabbababbbbabbbbabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbabbbbbbbabbbbbaabbaaabbaabaaaaaaabaaaabbbbbbbbbaaaaaaabbabbbbbbbbabbbbbbabbbbaabbaaabbaaabbbaaaaaaabbbbababbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaaaaaaaabaaaaabbbaaaaaaabbbbbabaaaabbbbabbbbabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbaabbbbbaabbbbbbaabaaabbbabbaaabaaaaaaabbbbbbbbbbabaaaabbaabbbbbbbabbbbbbabbbbabbbbaabbbaaaaaaaaabbaaaaaaaaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbabbbbbbabaaaabbaaaaaaaaaabbbbaaaaaabbbaabbbbabbbbbbbbbabbbbbbbaaaaaabbbbbbbbbbbbbaabbbbbbbbabbbbbaabbbbbbbabaaaabbaabaaabbaaabbaabbbbbbbbbaaabaaabbabbbbbbbabbbbbbabbbbabbbbaabbbbaabbbbbbbbbbbaaaaaabbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbaabbbbaabaaaaaaaaaabbaaaabbbbbaaaaabbbaabbbbabbbbbbbbbabbbbbbaabbaaaaabbbbbbbbaaaabbbbbbbbbaabbbbaabbbbbabaabaaaabbaabaabbbbbbbbabbbbbbbbbaaaaababbaabbbbbbabbbbbaabbbbabbbbaaaaaaabbbbbbbbbbbbbbaaaaaaabbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbabbbbaaaaaaabaaabbbbbaaabbbbbaaaaabbbabbbbbabbbbbbbbbabbbbbbaaaaabbbbabbbbbbaabbbbbbbbbbbbbabbbbaabbbbbabbaababaabbabaabbbbbbbbabbbbbbbbbaabaaaaabbaaabbbbabbbbbaabbbbaabbbaaaaabbbbbbaabbbbbbbbaaaaabaaaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbbbbaaabbaabaaaabbaaaabbaaaabbbbbaaaaabbbabbbaaabbbbbbbbbabbbbbbbbbabbbbbabbbbbaabbbbbbbbbbbbbbaabbbaabbbbbaabbabaaaaabaaaabbbbbbbbaabbbbbbbbaabaaaaaaaaaabbbbabbbbbaabbbbbabbbaaaabbbbbaaaaaaabbbbbaaaaabbbbbaaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbaaaabbaaaabbaaaaaaaaaaabbbbaaababbbaaaaababbbbbbbbbabbbbbbbbbaabbbaabbbbaabbbbbbbbbbbbbbbbaabbbaabbbbaaabbbbaabaabaaabbbbbbbbbaabbbbbbbaabbbaabbbbbbbbbbabbbbbaabbbbbabbbaaaabbbbbabaaaaabbbbbaaababbbbbbbabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbaabbbbbaaabbbbbbbbbbbbbaaaaaaaabbaaaaaaaaaaabbbbaaaaabbaabbbbbabbbbbbbbbabbbbbbbbbbabbbabbbbaabbbbbbbbbbbbbbbbbbabbbaaabbbabaaabbbaababaaabbbbbbbbbbaabbbbbbaabbbbbbbbbbbbbbbabbbbbaabbbbbabbbaaaabbbbbaaaaaaaaabbbaaaaabbbbbaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbbbbbbbbbbbaaaaaaaabbaaaabbbaaaabbbaaaaabbabbbbbbabbbbbbbbaabbbbbbbaaaabbbaabbaabbbbbbbbbbbbbbbbbbbabbbababbaabbbaabbaabaaabaabbbbbbbbbaaabbbbbabbbbbbbbbbbbbbbbabbbbbaaaabbbabbbaaaabbbbaaaabaaaaaaaaaaaaabbbbaabbbbbbbbabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbaaabbbaaabbbbbbbbbbbbbbbaaaaaaaabbaaaabbbaaaabbbbaaaabbabbbbbaabbbbbbbbaabbbbbbaabbbbbbbaaaabbbbbbbbbbbbbbbbbbbbabbaababbaabbbaaabbabaaabaabbbbbbbbbbaaabbbbabbbbbbbbbbbbbbbbabbbbbbabaaaaaabbaaaaabbbaaaabbbaaaaaaababbbbaabbbbbbbbbbaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbabaaaababbaaaabbbaaabbbbbaababbabbbbbaabbbbbbbababbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbabbabaabbbbbbaababaabbbaabbbbbbbbbbbaabbbabbbbbbbbbbbbbbbbabbbbbbabbbbbbabbaabaabbbaaaaaabaaaabbaaaaabaabbbbbbbbbbbabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaaaabaaaabbbbbaaaaaaaaaabaaaababbaaaaaaaaaaaaabbaababbabaaaaabbbbbbbaababbbaababbbbbbbbbbbbbbbbbbbbbbbbbaababaaabaabbababbbbbbbbababaabbbbaabbbbbbbbbbbaaabaabbbbbbbbbbbbbbbabbbbbbabbbbbbaabaababbbaaaaaaaaaaabbbaaaaababbbbbbbbbbbbaaaaaaabbbabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbaaabaaaaaabbaaaababbaaaaabbaabbaaaaaaaaabaaaaaaabbbbbbbabbabbbabaabbbbbbbbbbbbbbbbbbbbbbbbaabaaaabaaabbabaabbbbbbbbaaabbbbbbbbabbbbbbbbbbbbaabaabbbbbbbbbbbbbbbabbbbbbabbbbbbbabbababbbaaaaaaabaaabbaabaaababbbbbbbbbbbbabbbbbbbbaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbaaabbbbbbbbbbaaaababbaaaaabbaabbabaaaaabaaaabbbabbbbbbbaabbabbbaaaaabbbbbbbbbbbbbbbbbaabbaaabbbbaaaaaaaaaaabbbbbbbbbaaabbbbbbbbaabbbbbbbbbbbaabaabbbbbbbbbbbbbbbabbbbbbaabbbbbbabbababbbaaaabbaaaaabbaabaaababbbbbbbbbbbbaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbaabbbbbbbbbbbbaaaababbaaaaaaabaaaaaaaaaabbaaaaaaabbbbbaaabbbabbbaabbaaaaabbbbbabbbbaabaaaaaabbbaaaabbbbbbaaabbbbbbbbbbabbbbbbbbbbaabbbbbbbbbbbabbaaabbbbbbbbbbbbbabbbbbbbabbbbbbabaabaabbaaaabbbaaaabbaabaaababbbbbbbbbbbaabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbaaaabbbbbbaaabbbbbbbbbbbbbbaaababbaaaabaaaaaaaaaaaaabbbaaaabbbbbaaaabbbbabbbabbbbbbaabbbaaabbbaaabaaaabbbbaaabbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbaabbbbbbbbbbabbaaaabbbbbbbbbbbbaabbbbbbaabbbbbaaaaaaabbaaaabbaaaaabbaabaaabaaaaaaaaaabbbaaaaaaabbbabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbaababbaaaaaabbbbbbbbbbbbbbbaaababbaaaabbbaaabbbaaaaabbbbaaaaaaaaabbbbbbbabbbbbbbbbbaaabbababbaabaaaabbbbbaabbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbaabbbbbbbbaabaaabbbbbbbbbbbbbbaabbbbbbbaabbbaaaaabaaaaaaaaaaaaababaaabaaabbbaaabbbbaabbabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbaaaaaabaaaaabbbaaabbbaaaaabbbbbbbaaabbbbbbbbbbabbbbbbbbbbaaaaaabaaaabbaaaaabbbaabbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbaaabbbbbaabbaaaabbbbbbbbbbbbbabaabbbbbbaaaaaabaaaaaabbbaaaaabaaabaaaaaaabbbbbbbbbbbaabaaaaaaaabaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaaaaabaaaabbbaaaaabbbbbbbbbbbbbbbbbbbbabbbbbbbbbbaabbbbbbbbbbbbaababbaabbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbaaabbbaabbbaaaabbbbbbbbbbbbbabbaaabbbbbbaaabbaaaaaaabbaaaaaaaaabaabbaabbbbbbbbbbbbbaaabbbbbbaababbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaaaaaaababbbbbaabbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbaabbbbbbbbbbbbbabaaaabbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbaaaaaabbaaaabbbbbbbbbbbbbbabbbbaaaaaaaabbbbaaaaaaaaaaaaaaaaaabaabbaabbbbbbbbbbbbbbaaaabbbbbbaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabbaaaaaaaaaaabbbbbaabbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbabbbbbbbbbbbbbabbaabbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbabbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbaaaabbbaaabbbaaaaabaaaaaabbbbbbbbbbbbbbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaabaaaaaabbbbbaaaabbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbaaabbbbbbbaaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbaaaabbbaaabbbaaaaabaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaababaaabbbbbbaaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabaabbbbbaaaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbaabbbbaaabbbaaaaabbaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaaaaaaabbbbbbaaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbaabaaaaabaabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbaaabbbbaaaaaaabaaabbaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbaaaabaaabbbbbbaaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbaaababababbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbaaabbbbaaaaaaaaaaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaaaaabbbbbbbaaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbaabaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaaabbaabbaabbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaabaabbbaaaaaaaaaaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaaabbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbaaabbaabbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbaabbabbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaababbbaaaaabbbabaabbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbaaaaabbbbbabaaaabbbbbbbbbbbbbbbbbbaababbabbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaababbbbaaaabaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaabbbaabbbbababaabbbbbbbbbbbbbbbbaaaaaabbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaaaaaabbbbaaaaaaaaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaaaaaaabbbaaabbabbbbbbbbbbbbbbbaaaaaaabaabbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabaaabbbbbbaaaaaaaabbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaabbbbbbbbaabbbbaabbaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbaaabbbabbbaaabaabbbbbbbbbbbbbbaaaabaababbbbbbbbbbbbbbbaaabaaaabbbaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabaaabbbbbbbaaaaabbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbaaaabbaaaabbaaabbbbbbbbbbbbbbbbbbabbbbbbbbbbaaaabbbaabbbbaabbaaabbaabbbbbbbbbbbaaabaabaababbbbbbbbbbbbbbbaaabaabaaaaaaaabbbbbbbbbbbbbbabbbbbbbbbbbbbbaaaaabbbbbbbaabbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbaaaabaabaabaaaabbbbbbbbbbbbbbbbbbabbbbbbbbbaabbaaabbabbbbaabbbbbbbbabbbbbbbbbbbaaaaaabbababbbbbbbbbbbbbbbaaaaaaabaabbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbaaaaabaaabaaaaabbbbbbbbbbbbbbbbbabbbbbbbbbabaaaaaaaaabbbaabbbbbbbbabbbbbbbbbbbabaaaaabbbabbbbbbbbbbbbbbbaaabaabbabbaaaabbbbbbbbbbbbbbabbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababbbbbbbbabaabaaaaaaaaaabbbbbbbbbbbbbbbbbabbbbbbbbbaaaaabbbaabbbbabbbbbbbbbaabbbbbbbbbbabbaabbbbbabbbbbbbbbbbbbbbaaababbbbbaabaabbbbbbbbbbbbbbabbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaababbbbbbaababaaaaaaaaaabbbbbbbbbbbbbbbbbabbbbbbbbbaababbbbbbbbbbabbbbbbbbbbaabbbbbbbbbabbbbbbbbbaabbbbbbbbbbbbbbaaaaabbbbbabbbabbbbbbbbbbbbbbabbbbbbbbbbbbbaaaabaaabbbaabbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbaabaaaaaaaaaaaabbbbbbbbbbbbbbbbbabbbbbbbbbbbbabbbbbbbbbbaabbbbbbbbbbabbbbbbbbbaabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbaaaaaaaabbbaaabbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaababbaaaaaaaaaaaaabbbbbbbbbbbbbbbbabbbbbbbbbbbbaabbbbbbbbbbaaaabbbbbbaabbbbbbbbbbaaaabbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbabbbbbbbbbbbbaaaaaaaaaabaaaabbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbaaabaaaabbbaaaaaabbbbbbbbbbbbbbbbbabbbbbbbbbbbbbabbbbbbbbbbbbaaaabbaaabbbbbbbbbbbbbbabbbaaababbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbabbbbbbbbbbbbaaabaabababababbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaabaaababbaabbbbaaaaaaaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbaaaabbbbbbbbbbbaaaaaabbbbbbbbbbbbbbaabbbabababbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbabbbbbbbbbbbaaaaaaaaaaaaababbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabababbaaaaabbaababaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbabbbbbbbbbbbaaaaaaaaaaaabaabbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbababbaaaaaaaaaaabaaaabbbbbbbbbbbbbbabbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbabbbbbbbbbbbaaaaabaaaaaababbaaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaabaabaaababbbbaaaaabbbbbbbbbbbbbbabbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbbbbbbabaabbbbbbbbbbbbbbbbbbbbabaabbbbbbbbbbbbbabbbbbbbbbbbaaaaabaabbbbbabbabaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaabbabbaaaabbbbbaaaaaabbbbbbbbbbbbbabbbbbbbbbbbbaababbbbaabbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaaaaaaaaaaabbaabbbbbbbbbbbbbbaaaaabbbbbbbbbbbbabbbbbbbbbbbaabaaaaababaaaaaababbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaabbabaaaaabbbbbbabaaabbbbbbbbbbbbbabbbbbbbbbbbbabbabbbaaaabbbbbbbbbbbbbbbbbbbbbbbabbaabbbbaaabaababaaaaaaabbbbbbbbbbbbbaabbbbbbbbbbbbbbabbbbbbbbbaaaababbaaaaaaaaabbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbabaaaaaaaaabbbbbbaaaaabbbbbbbbbbbbbabbbbbbbbbbbbabaaaaaababbbbbbbbbbbbbbbbbbbbbaababaaaaaaabbabaaaaabbbbbbabbbbbbbbbbbaabaabbbbbbbbbbbbbabbbbbbbbbaaaaaaaaaaabaaabbbaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaaaabaabbbbbbbbaaaaabbbbbbbbbbbbabbbbbbbbbbbbaaabbbbbbabbbbbabbbabbbbbbbbaabaaaaaaabaaaaabaabbaaabbbbbbaabbbbbbbbbbaaaabbbbbbbbbbbbbbabbbbbbbbaaaaaaaaaaaaaaabbbbabbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbabbbbbbbbbbbbaabbbbbbbabbbbbaabaabbaabbbaaababaaaaabaaaabbbaaaaabbbbbbbbabbbbbbbbbbbaaaabbbbbbbbbbbbaabbbbbbbbaaaaabbbbbaaabaabbaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaabbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbabbbbbbbbbbbbbabbbbbbbaaabbbaaaabbaaabbbaaaaabbbabaaabbbbbbbaaaaaaaabbbaabbbbbbbbbaabbaabbbbbbbbbbbbaabbbbbbbaaaaabbbbbaaaabbabbbabbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbabbbbbbbbbbbbbbbbbbbabaaaabaaaaabbababababbaaabbbbbbbbbbbbbaaaaabbbabbbaabbbbbbbbbaaaaabbbbbbbbbbbbbaabbbbbbbaaaaabbbbbaaaaababbbabbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbabbbbbbbbbbbbbbbbbbbaaabbaaaaaaabaaaaaababbbaabbbbbbbbbbbbaaaaaabbbbabaabbbbbbbbbbbaabbbbbbbbbbbbbbbaabbbbbbbaaaabbbbbbaaaaaaaaababaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbabbbbbbbbbbbbbbbbbbbbaaaabbbabaaaababaaaabbbbbbbbbbbbbbbbbbbbbabbbbbaaabbbbbbbbabaabaabbbbbbbbbbbbbbaabbbbbbbaaaabbbbbbbbabaaaaababaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabaaabaaabbbbbbbbbbbbbbbbbbaaabbbbbabbbbbbbbaaaaaaaabbbbbbbbbbbbbbbaabbbbbaaaabbbbbbbbbbbbbaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabaaabbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbaabbbbaaaabbbbbbbbbbbbbbbbbbaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbaaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaabbbaaaaaabbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbababbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbabbbbbabbbbbbbbbbbbbbbbbbbbbaabbaaaaaabbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaabbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbaaaaaaaaaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababbbbbbbbbbaaaaabbabbbbbbbbbbbbbbbbbbbbbaabbabaaaabbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbabbbbbbbbbbbbbbbbb",
        "bbaabbbbbbbbbbabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaaabbbbbbbbaaaabaabaaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaabbbaabbbbbabbaaaaabbbbbbbbbbbbbbbbbbbbbaabaaaaaabbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbabbbbbbbbbbbbbbbbb",
        "bbaaabbbbbbbbbabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbbbabaaaaaaaaaaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaaaaabbbabbaaabbbbbbbbbbbbbbbbbbbbbbbaabaaaaaabbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbabbbbbbbbbbbbbbbbb",
        "bbabaabbbbbbbbabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbbaaaababbaabaaaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaabababbbabaaabbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaaaabbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbabbbbbbbbbbbabbbbb",
        "bbaabaaabbbbbbabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbaabaaabbaaaaaaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbaaaaaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaaaabbbbbbbbaaaabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbabbbbbbbbbbaabbbbb",
        "bbaabbbaaabbbbabbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaababbbbbaaaaaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbabbbbbbbbbaaabbbbb",
        "bbbabbbbaaaabbaabbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabababaabbaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbabbbbbbbaaababbbbb",
        "bbbaabbbbbbaaababbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbaaaaabbbaaaaabaaaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaaaaaaaaaaabaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbabbbbbbaabbbabbbbb",
        "bbbbabbbbbbbbaaaabbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaababaaaaaaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbabbbaaaabbbaabbbbb",
        "bbbbaabbbbbbbbbaabbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbabbaaabaaaabaaabbaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaaabaaaaaaaabbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbabaaaabbbbbabbbbbb",
        "bbbbbaabbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaababaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbaaaabbbbbbbaabbbbbb",
        "bbbbbbaabbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaaaaaaaaaaaababaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaaaaaaaaaaaabaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbabbbbbbb",
        "bbbbbbaaaabbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaabaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbaabbbbbbb",
        "bbbbbbbbaaabbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbaaaaaaaababbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaaaabbaaaabaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbb",
        "bbbbbbbbbbaaabbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbaababaaaaaaaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabaaaabaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbb",
        "bbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaabaaaabaabaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbaabaaaaabbabbaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbb",
        "bbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaababaaaaaaaaaaaaaaaaaabaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbb",
        "bbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaababaaaaabaaaabaaaaaaaaaabbaaaaaabaabbbbaabbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbabbbbaabbbbbaaaaaaaabaaaaaaaababbaaabaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaabaaabbbaaaaaaabbbbaabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbaabbbbabbbbaaaaaaabaaaaaaaaaaaaaabababaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbbbabaaaaaababbbbaaaaaaaabbbabbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbaabbbaaaaaaaaaabaabaaaaaaaaaaabaaaaabbbabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaababbbbaaaaaabaaaabbbbbbaaaaaaabaabbbbbbbbbbbbbbbbbbbbbaaabbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbabbaaaaaaaababbaaaaaaaabaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbaaaaaaaaaabbbbbbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbaaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbabaaaaaaaaaaabaaaaabaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaaaaaaaaaaaaaabbbbbbbbaabbabaaaaaaaabbbbbbbbbbbbbbbbbbbaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbaaaaaaaaaaabbbaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaabbbbbbbbbbbabbbbbabaaaaaaaabbbbbbbbbbbbbbbbbbaabbaabbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbbbbbbabbaaaaaaabbaaaaaaababaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaabaaabbbbbbbbbbaabbbbaaaaaaaaaaabbabbbbbbbbbbbbbbbbaababbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbaabbbbbbaaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbaaaaaaababaaabaabbbbbbbbabbbbbaabbaaaabaaaaaaaaaabbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaaaaaaaabbbaabbbbabbbbbbbbbbaaababaaaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabaaabbbbbbaabbbbaabbbaaaaaaaaaaaaaaaaabbbbbbbbbbbaabbbbbbbbbbbbaaaaaaaaaaaaaaaabbbbabbbbaabbbbbbbbbaaaaabaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaaabbbbbbaabbbbbbbbbbbbbbbbbbbaabaaabaaababaaaabbbbaabbbbbabbbbaaaaaaaabbaaaaaaaabbaaaaabbbbbbbbbbbbabbaaabaaaabaaaaaabaabbbbbabbbbabbbbbbbbbaaaaaaabaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbaaaabbbbbbbbbaaabbbbbbbbbbbbbbbbbbaaaaaaaaaaabaaaabbbbabbbbbaabbbbabaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabaaaabaaaaabaabbbbaabbbaabbbbbbbaaaaaaaabaaaaaaaaabbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbaaabbbbbaaabbbbbaabbbbbbbbbbbbbbbbbbaaaaaaaababaaaabbbaabbbbaabbbbbaaabaaaaabbaabaaabbaaaaaaaaaaaaaabbbaaaaaaabaaaaabbbaaaaabaabaababbbbaabbbbbaaaaaaaaaaaabaaaaabbbbbbbbbbbbbbbbbbaaabbabbaaabbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbaaabbbbbbaaaaabbbbbaabbbbbbbbbbbbbbbbbbaaaaabaaabaaaaabaabbbbaabbbbabaaaaaaaaaaaaabbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaabbaaaaaaaabaaaaaaaaaabbbbaabbbbaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbaaabbbaaaabbaaabbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbabbbbbbbaaabbbbbbbaaabbaabbbbbaabbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaabbbbbabbbaaaaaabbaaaaaabbabbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbaaaaabaaabaaaaaaaaaaabbbbabbbaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbaaabbbaabbabbbbaaabbbbbbbbbbabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaaaaaaaabbbbbbbbaaabaabaabbbbbaabbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbbbaabbbaaaaaaaabaaabaaaabbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbaaabaaaaabaaaaaaaaabaabbbaabaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbaabbbaaabbaabbbbbaaaabbbbbbbbabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbaaabaaaabaabbbbbaabbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbaabbbbbbaaaaaababbaabbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbaabbaaababaaaaaabbbabbbbaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbaabbbbaabbbaabbbbbbbbaabbbbbbaabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaaabbaaaabbbbbbbaabbaaaaaaaabbbbbbaabbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbaabbbbaaaaaaaaaaabaabbbbbbbbbbbbbbaaaaaaaaaaaabbbbbbbbbbbbbbaabaaaaaaaabbaaabbaabbbbaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbaaabbbaaaaaaabaabbbbbbbbaaaaabaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbaaabbbbbaabbaaabaaaabbbbbbbbaabbbbbbbbbbbbbbbbbbbaaaaaaaabbbbaabbbbbaaaaabbbbbbbbabbbbbbbbbbbaaaaaaaaaaaaaaaaabbbbbbbbbbbbbaabbaaaaaabbbaabbbabbbbbaabaaaaaaaaaabbbbbbbbbbbbbbbbbbaabbbbaaaaabaabaabbbbbbbbbbaaaaaabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbaabbbbbbbbbbbbbabbbbbbbbaaabbbbaabaaaaaaabbaaabbbbbaabbbbbbbbbbbbbbbbbbbaaaaaaaaabbaabbbbbaaaabbaaaaaaaaaaabbbbbbaaaaaaaaaaaaaaaaaaaaaabbbbbbbbaaaababbbabaaaaaabbbbabbbbaaaaaaaaaaabbbbbbbbbbbbbbbbbbaaabbbbaabaabbaaabaabbbbbbbbaaaaaaaabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbaabbbbbbbbbbbbaabbbbbbbbbaaabbbbaabaaaaabbaabaabbbbbaabbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbbabbbbaaaaabbaaaaabbbbaaaaaaaaaaaaabaaaaabaaaaaabbbbbaaaaaaaaaabbbbaaaabbbbbabbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbabbbbbbbaabaabbbabbaabbbbbbaaabbbbbaabbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbaabbbbbbbbbbbaabbbbbbbbbbaaabbbaaabaabbbaababaaabbbbaabbbbbbbbbbbbbbbbbbbbabaaaaaaaabbaaaaabbaabbaaabbbaaabbbbaaaaaaaabbbaabaaaaaaaaaaaaabbbbaaaabbbaaaaaabbbaaaabbbaabaaaaaaaabbbbbbbbbbbbbbbbbbbbaaabbbaaabbaabaaabaaaaabbbbaaaabbbbbbbabbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbaabbbbbbbbbbbbaabbbbbbbbbbbaabbbbabaabbaabaaabaabbbbbaabbbbbbbbbbbbbbbbbbaabbaaaaaaaababbbaaaaaabbbabbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbaaabbbaabbbbaabbbbabaaaaaaabbbbbbbbbbbbbbbbbbbbaabbbbbaaaaaabbbaabbaabbbbbaaabbbbbbbbbaabbbbbbbbbbbabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbaabbbbbbbbbbbbaaabbbbbbbbbbaaabbbaaabbaabbaaaaaaabbbbbaaabbbbbbbbbbbbbbbaabbbbaaaaaaaaaaaaabbbbaabbabbbbbbbbbbaaaaaaaaabbbaaabbbaaaaaaaaaabbbbbbbbbabbbaaaaaaaaaabaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbaabbbbbbaaaaabaaabaaabbbbbbaaabbbbbbbbbbbabbbbbbbbbbbabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbaaabbbbbbbbbbbaabbbbbbaabbabaaaaabaabbbbaabbbbbbbbbbbbbbbabbbbbaaaaaaaaaaaabbbbbbabaabbbbbbbbbbabaabbaaaaaaabaaaaaaabbaaaaabbbbbbbbbaabaabbbbbbaaaaaaaaaabaababbbbbbbbbbbbbbbbbbbaabbbbaaaababbbabaabaabbbbbaabbbbbbbbbbbbbabbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaaaabbbbbbbbbbaabbbbbabbaaaaaabbaaaabbbbaaabbbbbbbbbaaaaabbbbaabbaabaaaaaaaaabbbababbbbbbbbbbbbaaaaaaaaaaaabaaaaaaaaaaaaabbbbbbbbbbbaaaaabbbbbaaaaaaaaaaabbbaabbbbbbbbbbbbbbbbbaabbbbaaabaaaaabaabaaaabbbaaabbbbbbbbbbbbbaabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbaaaabbbbbbbbbaabbbbaabaabaaabaaababbbbbaabbbbbbbbbabbbabbbbabbbbbbbbaaaaaaaabbabaabbbbbbbbbbbbaaaaaaaaaaabaaaaabaaabaabbbbbbbbbbbbbaababbbbbaaaaabaabbabbbbaabbbbbbbbbbbbbbbaabbbbaabaaaabbabbaababbbbbaabbbbbbbbbbbbbbabbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbaaaaabbbbbbbaabbbbaabaaaabbaabbabbbbbbaaabbbbbbaabbbbaababbbbbbbbbaaaaaaaaaaaaaaaaabbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbaaaaaaaaaaaaaaaaabbbaabbaaaaaabbbbbbbbbbaaabbbbbaabaaabaaaaabaabbbbaaabbbbbbbbbbbbbaaabbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbaaaabbbbbbaabbbbaaaaabbaabbbabaaabbbbaabbbbbbabbbbbbaabbbbbbbbbbbaaaaaaaaaaaaaaabbbbbbbbbbbaaaaaaabaaabaaabaaaabbbbbbbbbbbbbaaaabaaabaaaaabbbbbbbbaaaabbbbabbbbbbbbbaaabbbbbbaababbbaaaaaaabbbbaabbbbbbbbbbbbbbaabbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaaaabbbbbaabbbbaaaabaabaabaaaaaabbbbaabbbbbaabbbbbaabbbbbbbbbbbbbaaaaaaaaaaaaabbaabbbbbbbaabaaaabaaabaaaaaaabbbbbbbbbbaaabaaaaaaaaaabbbbbbbbbbbbaabbbbbbabbbbbbbbaaabbbaabbaabaabbabaaaabbbbaabbbbbbbbbbbbaaaabbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbaaabbbbbaabbbbaabaabaaaaaabbaabbbbbaaabbaaaabbbbbabbbbbbbbbbbbbbbbbbaabaaabaaaaaaaaabbbaabaaaaaaaaaaaabbaabbbbbbaaaaabaaaaaaaaaaabbbbbbbbbbbbbaabbbbbbabbbbbbaaabbbbaaaabbabbaababaabbbbbaabbbbbbbbbbbaaaabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbaaabbbbaabbbbbaabaaaaaabaaabaaabbbbaaaabbaaabbaabbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaabbaaaaaaaaaaaabaaaaaaaaabaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbaabbbbaaabbbbbaaabbbbaabbaaaaaabaaabaabbbbaaabbbbbbbaaaaaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbaabbbbbaabbbbbaaababaabaabaaaaabbbbaaabbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaaaaaaaaaaaaaaaaaaaaaaabaaaaaaabaaaaababbbbbbbbbbbbbbbbbbbbbbabbbbaabbabbbaabbbbbbaababbaaaaabbbaabbbbaababbbbbbaaabbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbaabbbbbaabbbbbaababbbaabaabbbaabbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbaaabbbbbaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbaaaaaabbbaaaaabbbaaabaabaaabaaaaaaaabbbbaabbabbbbaaabbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbaabbbbbaabbbbbbaabbaabbaabaabaabbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbaaabbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaaabbbbbaaabbaaaaabbbaaabbbbbaaabbbabbbaabbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbaabbbbbbaabbbbbaaaaabbaabaaaababbaabbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbaaaaaabaabbbbbbbbbbbbababbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbabaabaababaaabaabbbbaaabbbbabaaabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbabbbbbbbaabbbbbbaabbaabaabaababaaaabbbbbbaaaaabbbbbbbbbbbbbbbbaaaaaabaaaaaabbbbbbbbbbbbaaabbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbaabbabbaababbaaaaaabbbbaaabbbbbaaabbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbabbbbbbbbaabbbbbabbaabbabaaabababaaaabbbbbbbbaaaaaaaaaaaaaaaaaaababaaaaabaaabbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbbbbbbbbbbbaaaaaaabbbbbbbaaaababbbabaaaabbbabbbbaabbbbbbbaaabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbabbbbbbbbbaabbbbbbbabbaabaabaaaabaabaabbbbbbbbbbbbbbbbbbbbbbbbaaaabaaaabaaabbbbbbbbbbbbbaaabbbbbbbbbbbbbbbaabbbbbbbbbbaaaaaaaaaaaaaaaaaaabbbbbbaabbbabbaaabbbaaaababbbbbbbaabbbbbbbbabbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbabbbbbbbbbbaaabbbbbaaabaaabaabaabaaabaabbaabbbbbbbbaaabbbaaaabaababaaaabaabbbbbbbbbbbaaaaaaaaaaabbbbbbbbbaaaabaaabbbbbbbbbbbbbbbbabbbbbbbbaaaaaaabbbaabbaaaaabaaaaaabbbbbaabbbbbbbbbabbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbabbbbbbbbbbbaaabbbbbbaabbbbabaabaababaabbaaaabbbbaaaaaabbabbabbababbbbabaabbbbbbbbbaaaaabaaaaabaaabbbbbbbaabaaaaaabbbbbbbbbbbbbbbbbaabaaaaaabbbaabbbbabbbabaaabaaaaabbbbaabbbbbbbbbbabbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbaabbbbbbbbbbbbbaabbbbbbaaaaaababbbaaabaabbabbaabbaabbabaabaabaaaabaabbbaaaabbbbbbaaaabbbabaaaaabbbaaaabbbbaaaaaabaabaaaaabbbaaaaabaaaabaaaabbabaabbbbbabbaabaaabaaabbbbaaabbbbbbbbbbbabbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbaabbbbbbbbbbbbbbbaabbbbbbbbbbbaabaaabbbabbaabababbabbaaaaabaabaaabbaabbbaababbbbbaaabbbbbababaaabbbbbbaaabbaaaaaaaabbaaababbbabbbabaabaaaaaaaaabaabbbbbaabaabbaaaabbbbbaaabbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaabbbbbbbbbbbbbbbbbaaabbbbbbbbbaabaaaaaaabaabaababbabaabaabbbabbbaabbabbbaaaabbbaaabbbbbbbaaabaaabbbbbbbaaaaaaaaaaaabaaaababbaabababaabaabababbaababbbbbbabaaaaababbbbbaaabbbbbbbbbbbbbaabbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbaaaaaaababbbaaaaababbabaabbbbbbabbaaaababbbaabbbaaabbbbbbbaaabaaaaaaabbbbbbbaaabbbaaabaaaaababbaabababaabaababbbbaababbbbbbaababaabbbbbaaabbbbbbbbbbbbbbbaaabbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbaaaaaababbbabaaabaababaabaaaabaababaabaabbbbbaaabbbbbbbaaaaaaaaaaaaaabbbbbbbbaaabaaaaabaaababaabaababaabaababbbbbabaabbbbbaababbbbbbbaaabbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbabaababbaabbbabaababbabaaaabaababbaaaabbbaaabbbbbbbbbaaaaabaaaaaaaaabbbbbbbbbaaabbaaaaaababaaaaaaaaaabbabaabbbbabaabbbbbbaaabbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbaaaabbaaaaaaababaabaaabaabbababbaaabbaaabbbbbbbbbbaaaaaabaaaaaaaaabbbbbbbbbbaaaaaaabbabababaaaaaaaabbaabaabbbaabaabbbbbaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbaaabbbbbbaabaabaabaababbaabbbaabbbaaabbbbbaaabbbbbbbbbbbbbaaaaaaaaaaaaaaabbbbbbbbbbbbaaabbbbaaaaabaaabbababbaabbabbbaabaabbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababbbbbbaaaabbbbbbaaaaabaaaaabbaaaaaabbbbbbbbaaaaabbbbbbbbbbbbbbaaabaaaaaaabaaabbbbbbbbbbbbbbaaaabbaaaaaaaaabababbaaabaabbbaaaabbbbbbbaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaabbbbbaabaaaabbbbbbbbbbbaaaabbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbaaabaaaaaaabaaabbbbbbbbbbbbbbbbbaaabbbaaabaaaaaabbababaaabbbbbbbbbbbaaaabbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbaabbbbaaaaabbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbaaaaabbbbbaaaaaaaabaaaaabbbbbbbbbaaaabbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaababbabbbbbbbbbaaaaabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbaaaaaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbaaaabbaababbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaaaaabbbbbbbbbbbaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbaaaaaabbbbbbabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaabaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaabbbbbbbbaaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabbabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaababaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbabaaaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbabbbaabaaababbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabaabaaaabaabaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbaabaababaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaaaabaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbaaaaaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaababaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaabaaabaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaababbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababbababaaabaaabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaabaabbaaababaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaabaababbaaaaababaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabaaaaaaaaaaaaaaaababaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaababaaaaaabaabbbbbbbbaaaaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaabaaababaabbbaaaabbbaaaaaaaabaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaaaabbaaaabbaaaaaaaabbbaabbaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaaaaaabbaaabaaaaaaabaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbabbaababbaaaaaaababbabbaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaabbaabbaaaaaabaaaaaabbabaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabababaaaaabaaaaaaabaaaaaabbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaabbaabbaaaaaaaaabaaaabbabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaabbabbabaaaaabaaaababbabababbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaabbabbabbbaaaaaaaababbabababaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaababbbaabaabaaaaaababaabbabababaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaababaaaaabbaaaaabbaaabaabbabaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaabbaabbaaaaabbaaaaabbaaaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbabaaaaaabbaaabbbaaaaabaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaaaabaaaabbbaaaaaaabbbaaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaaaaaaabaaaabbbbbbbbbbaaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaababbbabaabaabbbbbbbbaaaaabaaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaaabaaabaaaaaaaaaaaaaaaaaabbaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaaaabaababbaaaaababaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbbababaaaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbababbaaaabaaaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbaabbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaaaaaaaaabbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaaaabababbaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaabaaaaaaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbaabaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb"
        };
        wxBitmap bitmap( xpm_data );
        return bitmap;
    }
    if (index == 14)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "284 314 2 1",
        "a c Black",
        "b c #FFFFFF",
        /* pixels */
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaabbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaaabbbbaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaabbbaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaabbbabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaaabbbaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbabbbbbbaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaababbbabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbabbbabbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbabbbabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbabbbabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbabbbabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbaabbaaaaaaaaaaaabbbaabbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbaaaaaaaabbbbbbbbbaaaaaaabbbbbbbaaaaaaabbbbbbbbbbbabbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaabbbbbbaabbbbabbbbbbbbbaabbbbbaaaaaabbbbbbaabbbbbbbbbaaaaababbbbbaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaabbbbbaabbbbaaaaaabbbbaabbbbbaaaababbbbbbabbbbbaaaaaabbbaaabbbbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbaabbbbbbabbbbbaabbaababbaabbbbaaaaaaabbbbaabbbbaabaaabbbbbabbbbbbaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaabbbbbbbbabbbbbaabbbbbabbbbaaaaaaabbbaabbbbaabbbbabaaaaabbbabbbbbbaabbbbbabbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbaabbbbbbbabbbbaaabbbbaabbbbabbbaaaabbabaaaaaabbaaaaaabaabbbaabbbbbbabbbbbabbbbbbbaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaabbbbbaaabbbbbaaaaaaaaaaaaaaabbbbabbaabbaaaaaaaaaaaaaabbaabbaabbbaaabbbbaaaaaaaabbbbbbbabbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbabbbbaaaaaabbaaabbbbbbbbbaaaaabbaabbaabbbbaabbbbbbaabbbbaabbbabbbbaaaaaaaaaaaaaabbbbbbaabbbbbaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbaabaaabbbaaaaaabbbaaaaaabbbbbaaaaaaaaabbbbaaaaaaaaaabbbbaabbbaaaaaaaaabbbbbbbbbaaaaaaaaaabbbaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbaaaabbbbbbbaaabbaaaaaaaaaaaabbbbbbbaaabbbbaaabbbbaaabbbbaaaaaaaabbbbbbbbbbbbbbbbaaaabbbbaabbaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbaaaabbbbbbbaabbaaabbbbbbbaaaaaaaaabbaabbbbaabbbbbbaabbbbaabbbbbbaaaaaaaaaaaaaabbbaabbbbbbaaaaabbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaabbaaabaabbbbbbbabbaabbaaaaaabbbbbbbbaaaaaabbbbaabbbbbbbabbbbaaaaaaaaaabbbbbbbbbbbaabbabbbbbbbaaaaabbbbbaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbaaaaabaaabbbbbbbabbaabaabbbaaaaaaaaaabbbbaabbbbaabaaabbaabbbbaaaaaaaaaaaaaaaaaaaaabaababbbbbbbbaabaaaaaaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbaaabbbaaabbbbbbbabbabaaaaaaaaaaabbaaaaaaaaabbbbaaaaaaaaaabbbbaaaaaaaaaaaabbbbbbbbabaabaabbbbbbbaaabbbaaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbaabbbbaabaaaaaaaaabbabaaaabaaaaaaaaaaaabbbaabbbbaaabbbbaaabbbbaabbbbbbbbbbaaaaaaabaababaabbbbbbabbabbbbbaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaabaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaabbbbaabaaabbaaaabbabaabbbbbbbbbaaaaaaaaaabbbbbaabbbbbbaabbbbaaaaaaaaaaaaaaaaaaaaaababaaaaaaaaabbaaabbbbaabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbabaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabbaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbaaaabbbabbbbbbabaabbbbbbaabbabaabbbbbbbbbbbbbbbbbbabbbbbaabbbbbbaabbbbaabbbbbbbbbbbbbbbbbbaababaaaabbaaabbbaaabbbbabbbbaabbbbbbbbbbbbbbbbbbbbbaaabbaabaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbaabbabaabbbbbbbbbbbbbbbbbbbbbaaabbaaaaabbbbbaaaabbbbbbbbabbaaaabbbbbbbbbbbbaaaaaaabbbbaaabbbbbbbabbbbaaaaaaaabbbbbbbbbbbbaababaabbbbbbaabbabaaabbaaaaaaaabbbbbbbbbbbbbbbbbbbaabaabaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbabbbaababaabbbbbbbbbbbbbbbbbbbbbaabbbbbaabbbbbbabaabbbbbbbbabbaaaabbbbbbbaaaaaaaaaababbbbaaabaabbbaabbbbaaaaaaaaaaaaaabbbbbbaabababbbbbbbbaabaabbabbbaaaabaaabbbbbbbbbbbbbbbbbbaabbaaabaabaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbaaaabbabbbbbbbbbbbbbbbbbbbbaabbbbbbaabbbbbbaaaabbbbbbbbaabaabaaaaaaaaabbbbbbbbbbabbbbaaaaaaaaaaabbbbaabbbbbbbbbbaaaaaaaaabaababbbbbbbbaabaaabaabbaaabbbaabbbbbbbbbbbbbbbbbbaaaabaaaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbbaabbaabbbbbbbbbbbbbbbbbbbabbbbbbbaabbbbbbaaaabbbbbbbbaabbabaabbbbbbbbbbbbbbbbbabbbbaaaabbbbaaabbbbaabbbbbbbbbbbbbbbbaaabaababbbbbbbbbababaababbaabbbbbaabbbbbbbbbbbbbbbbbbbbaabbbaaaaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbaaabaaabbbbbbbbbbbbbbbbbbabbbbbbbaabbbbbbaababbbbbbbbaabbabaabbbbbbbbbbbbbbbbbabbbbaaabbbbbbaabbbbaabbbbbbbbbbbbbbbbbaababaaabbbbbbbaaaabbaaaabaabbbbbaabbbbbbbbbbbbbbbbbbbbbaabaaaaaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbaabbaabbbbbbbbbbbbbbbbbbaabbbbbbaabbbbbbbabaabbbbbaaaaababaabbbbbbbbbbbbbbbbbabbbbaabbbbbbbbabbbbaabbbbbbbbbbbbbbbbbabaabaaabbbbbbbabaabbbaaabaabbbbbbabbbbbbbbbbbbbbbbbbbbbbaabaabbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbaaaaabbbabbbbbbbbbbbbbbbbbbaaabbbaaaabbbbbbbaabaaaaaaaaaaabaaaabbbbbbbbbbbbbbbbbabbbbaabbbbbbbbabbbbaabbbbbbbbbbbbbbbbbabaababaaabbbbaababbbbaabbaabbbbbaabbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaababbbaabbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbbbabbbaaabbaaaabaabaabbbbbbbbbbbbbbbbabbbbaaabbbbbbaabbbbaabbbbbbbbbbbbbbbbbababaabaaaaaaaabbaabbbaabbaaabbbaabbbbbbbbbbbbbbbbbbbbbbbabbaaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaabbbbbbaaabbbbbbbbbbbbbbbbbbaaabbbaabbbbbbbbabbaabbbbbbaabbaaaabbbbbbbbbbbbbbbbabbbbaaaaaaaaaaabbbbaabbbbbbbbbbbbbbbbaabababaabbbbaabbaaaaaaaabbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbabbbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbabbbbbbbbaabbbbbbbbbbbbbbbbbbabbbbbbaabbbbbbbaababbbbbbbbaabaababbbbbbbbbbbbbbbbabbbbaaaaabbbbaabbbbaabbbbbbbbbbbbbbbbabaabaaabbbbbbaabaabbbaaabaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbabbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaabaabbbbbbbbabbbbbbbbbbbbbbbbbbabbbbbbbabbbbbbbaaaabbbbbbbbaabaababbbbbbbbbbbbbbbbabbbaaaaaaaaaaaaaabbaabbbbbbbbbbbbbbbaabaabaabbbbbbbbababbbbbabbaabbbbbabbbbbbbbbbbbbbbbbbbbaaaaaabbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbaabaabbbbbbbabbbbbbbbbbbbbbbbbbabbbbbbbabbbbbbbbaaabbbbbbbbaabbabaabbbbbbbbbbbbbbbabbbabbabbbbbaabbabbaabbbbbbbbbbbbbbbaababaaabbbbbbbbababbbbaabbabbbbbbaabbbbbbbbbbbbbbbbbbbabbbbabbabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbaaaabbbbbbbaabbbbbbbbbbbbbbbbbabbbbbbbaabbbbbbbaaabbbbbbbbaaabaaaabbbbaaaaaaaabbbabaaaabbabbbbabbaaaaaabbbaaaaaabbbbbbabaababaabbbbbbbaaabbbbaabaabbbbbbaabbbbbbbbbbbbbbbbbbbaabbbaababaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaabbbbbbbbaabbbbbbbbbbbbbbbbbabbbbbbaaabbbbbbbbaaabbbbaaaaaabaababbbaabbbbbaaabbaaaaaabbaabbbabaaaaaaabbaaabbbbaabbbbababaabaabbbbbbaaabbbbaabbaabbbbbbaabbbbbbbbbbbbbbbbaabaaaaaaababbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaabbbbbbbbbaabbbbbbbbbbbbbbbbbaaabbaaaaaabbbbbbbaaaaabaabbaaaababaabbaabbbbbbaabbaaabaaabbaaaaabaaabaaabaaabbbbbbaabbbababaabaaabbbbaaaabbbbaabbaaabbbbbabbbbbbbbbbbbbbbbbaaaaaabbaababbaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbaaaabbbaabbbbbbbaabaaaabbbaababaaaabbabbbbbbbbabbaaabbbbbbabbaabbbbbbaabaabbbbbbbbabbaaaaaaaaabaaaaaaaabbbbbabbbaaaabbaaabbbbbbbbbbbbbbbbaaaaababaabbabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaabbbbbabbbbbbbbaabaaabaaaaaaaaababbabbbbbbbbabaabaaaaaaaabbbaaaaaaabaaaabbbbbbbbabbababaababaaaaaabbabbbbbabbaabbaaaaabbbbbbbbbbbbbbbaaabbbaaababbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbaaababbbbbbbbbbbbbbbbbbbabbbbbbaabbbbbbbaababbbabaaaaaaaaabbabbbbbbbbabaababbaaaabbbbabaaababaaaabbbbbbbbabaaaabaabbbabbaaaaaabbbbaabaabbbbbaabbbbbbbbbbbbbbbbaaaabbabaaabbaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaabbbaaaaabbbbbbbbbbbbbbbaabbbbbbabbbbbbbbabaabbaaaaaabbabaabaabbbbaaaabaaaabaabbabbbbaaaaababaabaabbbbbbaabaaaabbabbbaaaaabaabbbbbabbaabbbbbbabbbbbbbbbbbbbbbbaabaaaaaaaabaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaabbbbbaabaabbbbbbbbbbbbbbaabbbbbbaabbbbbbbabaaabaabaabbaabaabbaaaaaaababbaabbbbabaabbbaabaabaaabbaaaaaabbabbabababbbaaaabbaaaabbbbaabbabbbbbbbabbbbbbbbbbbbaaaaaaabbbbaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbaaabbaabbbbbbbbbbbbbbaabbbbaaaabbbbbbbaaaaababbbaaaaabbabbaaabbbbaabbaaabaaaababbaabaaabaaabbabbaaaaaabbababaaaabaabbbaaaabbbbabbaaabbbbbaabbbbbbbbbbbbabbbabaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbaaabbaaabbbbbbbbbbbbbbbaaaaaaaaabbbbbaaaaabbbabbbaabbaaaaabbabaaaaabbbbaaaaaabbaaaabbabaaaabbbaaaabbbabbbaaaaaaabbbabbbbbbaaabaabbaaaabbbaabbbbbbbbbbbbbaaabaabaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaabbaabbbbbbbbbbbbbbbbbbaaabbbaaabbbbabaaaabbaabbaabbaaaaabbaaaaabaaabbaaabaabbbaaabbaabbbabbbaabaaaaabbaaaaaaaabbbabbbbbaabaaaaaaaabaaaaabbbbbbbbbbbbbbbbaabaaaaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaabaabbaaabbbbbbbbbbbbbbbbbbaaaaaaaaaabbababaabbbaaaabbbaabbabbaabaaabaaababaaabbbaaaaabbaaababbaabbabbabbbaaaabaaabbbabbbbbaabaaaaaaaabbbabbbbbbbbbbbbbbbbbaaaaaababaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaaabbaaabbbbbbbbbbbbbbbbbaaaabaaaaaaaabaababbbabaaaaaaabbabaabbaaaaabaaaaabbbaaabaaabbbbaaaaaabaaabbaabbaaaabbbaaaaabbbbbbabaaaaabaaaababbbbbbbbbbbbbbbbaaabaaababaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabaaabbaabbbbbbbbbbbbbbbbbbbbaabbaabbaaaaabbbbaaabbaabbbbbaaabbbabaaaabbaaaaaaaaaaaaaaaaabbbbbbaaaaabbaaaabbaaaaaaabbbbbbbaabaaaaabbaaaaabbbbbbbbbbbbbbbbabbabaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaabaaaabaaabbbbbbbbbbbbbbbbbbbabbbbbbbaaaaaabbaaabbbaaaaaaaabbaaaaaaaaaaaaabbbbbbbbbbaaaaaaaaaaaabaaabaaaabbaaaabbbaabbbbbaaaabbbabbabbbbbbbbbbbbbbbbbbaaabbbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaaabaabbabbbbbbbbbbbbbbbbbbbbaaabbbbaaabbaaaaaabaabbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbaaaaaabbabbaaabaaaaaabbbbbbbabbbbbbbbbbbbbbbbbbaabaaaaaaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbaaabbbbbbbbbbbbbbbbbbabaabbaaaaaaaaaaaabaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbaaaabaaaaaaabaababaaaaabbbbbbbbbbbbbbbbbaabbaaaaabaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbababaaaabbbabbbbbbbbbbbbbbbbbbabbabbbaaaaabbbbbbbabaaaabbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbaaaaaabaabbaaaabaaaaaaaabbabbbbbbbbbbbbbbbbbaabbbbaaaabaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaababbbbbbbbbbbbbbbbbbaaaabaaaaaaabbbbbaaaaabbbbbbbbbbaaaaaaaaaaabbaaaaaaaaaabbaaaaaaaaaaabbbbbbbbbaaaaaaabbbabbaaaaaaaabaabbbbbbbbbbbbbbbbaabaaaaabbaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaabaaaabbbbbbbbbbbbbbbbbbaaabaaaaaabbbbaaabbbbbbbbbbaaaaaabbbbbaaabaaaaaaaaaaaaaabbbbaaabbaaaaaabbbbbbbbbaaaabbbbbabbaaaaababbbbbbbbbbbbbbbbbaabaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaabaaaaaabbbbbbbbbbbbbbbbbbbbaaaaaaabbaaaabbbbbbbaaaaaaaabbaaabbbaaaaaaaaaabaaaaaaaaabbababbaaaaaaaaaaabbbbbbaaaaaabaaabaaaaaabbbbbbbbbbbbbbbbaabbaaababaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabaaababbaabbbbbbbbbbbbbbbaaaaabbbaaabbbbbbbbaaaaaaaabaabababaaaaaaabaaaaaaaaaaaaaaaaaaabbabbaaaabaaaaaabbbbbbaaaabbaaabbabbbbbbbbbbbbbbbbbbaabbababbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaaaaaabbbbbbbbbbbbbaaaaaaaaaaabbbbbbaaaaaaaaabbaaaaaaaaaaaabaaaaaaabbaabbaaaaaaabbaaaaaaaaaaaaaaaaaaaabbbbbaaaabbbaaabbbbbbbbbbbbbbbaaaaabbaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaababaabbbbbbbbbbbbbaaaaaaaaabbbbbbaaabbbaaabbbaabaaabbbaababbbaaaaaaaaaaaaaaaabbbbabaaaaaaaaabbbaaaabaaabbbbbbaaaaaaaaabbbbbbbbbbbbbababaabaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbabbbbbbbbbbbaaaaaaaabaabbbbbaaabaaaaaaaaaaabbaaabaaaaaaaaaaaaaaaaaaaaaaabbbaaaaaaabbaaabaaabaaaaaaaaaaabbbbaaaaaaaaaabbbbbbbbbbbaabbbaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbabbbbbbbbbaaaaaaaabbbbaabbaaaaababaaabbbaaaaaaaaaababbbabbabbbaaaaaaabbbbbbababbbaaaaaaaaaaaaaabaaabbbaaabbbabaaaaaaabbbbbbbbbbbaabbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaabbbbbbbaaaaaaaaabbbbbbaaaaaaaaaaaaaaabaabaaaaabaaaabbaaaaaaaaaaaaaaaaaaaabaaabbaabaaaabbbbaabaaaaabaaaaaaaaabbaaaaaaaabbbbbbbbbaaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbaaaabbbbbbaaaaaaaaaaabbbbbaaaaaaabaaaaaaaaaaaaaaabbaaaaaaaaabbbbbbbbbbaaaaaaaaaaaabaaaaaaaabbbaaaabaaaabaaaaaabbbaaaaaaaaaabbbbbbbaaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbaabbbaaaaaaaaaaaaabbbbbbaaaaaaaaaabaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaabaaaaaaaaaabbbaaaaaaaaaaaabbbbbaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbbbaabbaaaaaaaaabaaabbbbbbabaaaabaaaaaaaaaaaaaabbbbbbbbbbaaaaaaaaaaaaaaabbbbbbbbbbbbbaaaaaaaaaaaabaaaaaaaababbbaaabaaaaaaaaabbbbabbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaaaaaaaaaaaaaaaaaaaabbbaaaaaaaaaaaaaaaaaabbbbbaaaaaaaaaaabbbbbbbaaaaaaaaaaaaaaabbbbbbaaaaaabaaaaaaaaaabbabbaaaaaaaaaaaaaaabbaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaaaaaaaaaabaaaaaaaaaabaaaaaaaaaaaaaabbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbaaaaaaaaaaaabbbabaaaaaaabbaaaaaaaaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaaaaaaaaabbbbbaaaaaaaaaaaaaaaaabbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbaaaaaaaaaaaaaaaabbbbbaaaaaaaaaaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaaabaabbbbbbbbbbaaaaabaaaaabbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbaaabaaaaaabbbbbbbbbbbaaabbaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabaaaabbbbbbbbbbbbaaaaaaaabbbaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbaaaaaabbbbbbbbbbbbbbaabbaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbaaababbbbbbbbbbbbbbbaaaaaaaaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaabaaaabbbbbbbbbbbbbbbbbaaaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbaaaabbbbbbbbbbbbbbbbbaaaaaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaaaabbbbbbbbbbbbbbbbbbbbaaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbaaabbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbaabbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaabbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbaabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaabbbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbbabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabaaabbbaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbabbbbaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabaabbbbaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaabbbaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbaabbbbabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbababaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaabbbaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaaaabaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaababbbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaaaaaaaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbaaaaaaaaabbaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbabbaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaababaaaabaaaaabbbaabbbbaabbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbaabbbaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaabbbbbabbbbaabbbbbbbbbbbbbaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbbbabbbaaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaabaabbbbbaabbbbabbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabbbbbabbbaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabaaaaaaabbbbbbbaabbbabbbbbbbbbbbaabbaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbaaaaaaaaaaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbaaabaaaaabbbbbbbbabbbabbbbbbbaaaaaaababbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaaabbbbbbbbbaaaaaaaabbbbbbbbbbbbbbbbbbaaaabbbbbbbaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaabbbbbbbaaaabbabbbbbbaabbaabaaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbaaaaaaabbbaaabbbaabaaabbbbbbbbbbbbbbbbaaabbbbbbbbaaabbbbbbabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbaababaaabbbbbbbaaaaababbbbbaaaaaabbbaaababbabbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaaabbbbbabaaabbbabbbaaaaabbbabbbbbbbbbbbbbbbaaaabbbbbbbbaaabbbbbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabaaaabbbbbbbaaaaaaaabbbbbbabaaabbbbabbabaabbbbbbbbbbbbbbbaaabbbbbbaaabbbaaaabbbbbaaaabbbaabaaabbbaaabaaabbbbbbbbbbbbbaaaaabbbbbbbaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabaaaaabbbaaabbbbbbaaaaaabaabbbbbbbbbaabbbbbbaababbbbbbbbbbbbbbbbaaaaabbbaaaaabbaaaabbbbbbaaabababbabbbbbbbaabaabbbbbbbbbbbbbaaaaabbbbbbbaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaabbbbbbaabbbbbbaaaaaabbaabbbbbbbbbaaaabbaabbbaabbbbbbbbbbbbbbbbaabaabbaaabbbbbaaaaabbbbaaaaababaabbbbbbbbaababbbbbbbbbbbbbaaaaaaabbbbbbaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaaabbbbbbbabbbbbbaaaaaabbbabbbbbbbbbbbaaabbabbbbabbbbbbbbbbbbbbbbaabbaababbbbbbbbbbbaaaaabbaabaababbaaabbbbaabaabbbbbbbbbbbbaaaaaaabbbbbbaaabbbaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbabbbbbbaaaaabbbbabbbbbbbbbbbaaabbaabbbabbbbbbbbbbbbbbbbbabbbabaabbbbbbbbbbbbbbaabaabaababaabaabbbbabbabbbbbbbbbbbbaaaaaaabbbbbbaabbbbaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbaabbbbbaaabbbbbbbabbbbbbbbbaaabbbaabbbbabbbbbbbbbbbbbbbbbabbbabaabbbbbbbbbbbbbbaabaabaababbabaabbbbabbabbbbbbbbbbbbaabbaaaaabbbbbabbbbaaaaaaabbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbaabbbbaaaabbbbbbbabbbbbbbaaaaabbbaabbbbaabbbbbbbbbbbbbbbbabbbaaaabbbbbbbbbbbbbbaabbaaaabaababbabbbbabbabbbbbbbbbbbbaabbbaaaabbbbbabbbbbbaaabbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbaabbbaaaaabbbbbbaabbbbbbbabbbabbbbabbbbbaabbbbbbbbbbbbbbbabbbbbaaaaaabbbbbbbbbbabbbaaaabbaaabbaabbbabbabbbbbbbbbbbbaabbbaaaaabbbbabbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbaabbaaaaaabbbbbaaabbbbbbbabaaabbbbabbbbbbaaabbbbbbbbbbbbbaabbbbaaaaaaaabbbbbbbbaaabaaaabbbbbbaabbbbabbaabbbbbbbbbbbaabbbaaaaaabbbabbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaabbbbbbbbbbbbbbabbaaaaabbbbbbababbbbbbbaaaaabbbbbbbbbbbbbaaabbbbbbaaaaabaabbbbbbaabbabbbbbbbbbbababaabbbbbaabbbbbabbaaabaaaabbbbbaabbbbaaaaabbbabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbabaaaaabbbbbbbababbbbbbbaabbaaabbbbbbbbbbbbaaabbbbbaaabaabaaaabbbbaababbbbbbbbbbababababbbaabbbbbbabbaaaaabbaabbbbaabbbbbaaaaabbabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaaaabbabbbbbbabaaaaabbbbbbaababbbbbbbaabbbbaaabbbbbbbbbbbbaaaabbbaabbaabbaaaaaabaaabbbbbbbbbbbbaaaaaabbaabbbbbaabaaaaabaaaaabbbaabbbbbaaaaabbabbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaaaaaaaaabbbbbabaaaabbbbbbbaababbbbbbbbbbbbbbaabbbbbbbbbbbbbbaaabbbabbbaababbbbaaaabbbbbbbbbbbbbaaaabaabaabbbbbabbabaaababaaabbbaabbbbbbaaaabbabbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaababbaaaaaaaaabbbbbaaaaaabbbbbbbaababbbbbbbbbbbbbbaabbabbbbbbbbbbbbaaaaaaaabbaaaaabbbabaabbbbbbbbbbbbaaabbaabbaabaaaabaabaaababbaabbbaabbbbbbaaaaaaabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaababbbabbaaaaabbbbbaaaabbbbbbbbbaababbbbbbbbbbbbbbaabaabbbbbbbbbbbbbbbaaababbaaababbbabaabbbbbbbbbbbbaaabbbabbaabaaabbaabaabaabbbbbbbaabbbbbbbbaaaaabbbbbbabbbaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaababbbabbbaaabbbaaaaaaabbbbbbbbbaababbbbbbbbbbbbbbabbbaabbbbbbbbbbbbbbbaaaaabbbaaabbbaaabbbbbbbbbbbbbaaababaabaaaaaabaabbabbaaaabbbbbaabbbbbbbbaaaaabbbbbaaabaaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaaabaaaaaaaaaaaaaaaaabbbbbbbbbbababbbbbbbbbbbbbbabbbaabbbbbbbbbbbbbaaabbbabbbbbbbbbbbbbbbbbbbbabbbbabbbaababaaabaababbaabbaaaabbbbbaabbbbbbbbaaaaabbbbbaaaaaababababaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbababbaaaaaaaaaaaaaaaabbbbbbbbbbababbbbbbbbbbbbbbabbbbabbbbbbbabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbaabbbbabaaaabaaaaabbaaabaabbaaaaabbbbbaabbbbbbbbaaaaabbbbbaaaaaababbbabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabaabbaabbaaaabaaaaabbbbbbbbbbbaaabbbbbbbbbbbbbbaabababbbbbbbababbbbbbbaaabbbbbbbbbbbbbbbbbbbaabbbbabaabaaaaaabbbaabbabbbaaabbbbbbbaabbbbbbbbbaabaabbbbaaaaabaabbaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbaaaaaaaaabaabbaaaababaaaaaaaabbbbbbbbbbaaabbbbbbbbbbbbbbbababbbbbbbbbaaaaaaaaaaabbbbbbbbbbbbbbbbbbabbaabbabaaaabbaaaaabbaaaaaabbaaaabbbbbbbaabbbbbbbbbaaaaabbbbbaaabaabbaabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbaaaaabbbbbaaabbbaabbaaaaaaaaabbbbbbbbbbbaabbbbbbbbbbbbbbbaaabbbbbbbbbbabaaaaaaabbbbbbbbbbbbbbbbbbaabbaabbabbaaabbbbaabbbaaaabbbaaaaabbbbbbbaabbbbbbbbbaaaaaabbaaaaaaaaabaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaaaaaaabaababaaaaaabaaaaaabaabbbbbbbbbbaabbbbbbbbbbbbbbbaaabbbabbaabbaabaaaaaabaaaaaaaaaaaaaaabaaabbaaaaaabaaaaaaaaabbaaaaabaaaaaabbbbbbbbaabbbbbbbbaaaaaaaaaaaaaaaaaaaaaabaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbaaaaaaaaaabaabaabaaababaabbbaabbbbbbbbbbbabbbbbbbbbbbbbbbbbabbbabaaabbbabbaabbaaaaaabaaaaaaabbbaaaabaabaabaaaabbbababbbaaabbbaaaabbbbbbbbbbaabbbbbbbbabbbaaabaabaaaaaaaaabaabbbaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaaaaaabbabbabaaabaaabaaaabbbbabbbbbbbbbbbabbbbbbbbbbbbbbbbaabaaabaaabbbabaabaaaabbbbbbbbbbbbbbaaabaaabbaaababbbbbbbabbaaaabaaaaabbbbbbbbbbbaabbbbbbbbabbbaaabaaaaaaaaaaabbbbaabaaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaaaaabbbbbbaaaaaabbaaaaaaabbbabbbbbbbbbbbabbbbbbbbbbbbbbbbaaaababababbbababaaabbaaaaaabbbbbbaaabbbbabbbbaaaaabbbbbbabbaabbaaaaaabbbbbbbbbbbaabbbbbbbaabbbaaaaaaabbabaaaaabbaaaaaaaabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbaaaaabbbbbbbaaababaabaaaaaaaabbaabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbaaababbbaaabababaaaaaaaaaaaaaaabbbabbbbbaabbabbbbbbbabbabbaaaaabaaabbbbbbbbbaabbbbbbbaabbbaaaaaaaaaaaaaabaaaabaaaaaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaaabbbbbbbababaababbbaaaaaabbaabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbaabaabaaaaaaaaaabbbbbbbbbbbbbbbbbababbbaabbbaaaaabbabbabbaabbbbbbaabbbbbbbbaabbbbbbaabbbbaaabaabaaaaaaaabbbbbbaaaaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbaabbbbbbbbaaaababaabaaaaabaabbabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbaabaaaaaaaaaaaabbbbbbbbbbbbbbaabbababbbaabaaaaaaaaaabbabbabaaaabbbabbbbbbbbaabbbbbbaabbbbaaaaaaaaaaaababbbbbbbaaaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbaaabbbbbbbbbbabbaaabbaaaabbbabbaabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbaaabababaaabbbbbbbbbbbbabbabbbababbbbaaaabbbbbbaabbabbbaaaaabbbabbbbbbbbaabbbbbbabbbbbaaaaaabaaabaaaabbbbbbbaaaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaaabbaaaaaaabbbbbbbbbaaaabbbabbaabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaaabbbbbbbbbbbbabbabbbaaaaabaaaabaaaabbbbbbbbbbaaaaaabbbabbbbbbbaabbbbbbabbbbaaaaaaabbabaaaaabbbbbbbaaaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaaaaaaaabbbaaaaabbbbbbbaaabbbabbbabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbabbbbbabbababaabaaaaaaaaabbabbbbbbbbbbaabaaabbbabbbbbbbaabbbbbaabbbbabaaaaabaaaabaaaabbbbbbaaaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaaaaabbbbaaaaaaaaaaabbaaabbbbabbbabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbabbbbbaabababbaababbaaaabaaaabbbbbbbbbaaaaaabbbabbbbbbbaabbbbbaabbbaabbaaaabaaabbaaabbbbbbbbaaabbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaabbbbaaaaaabbbbbabbaabbbbbabbbabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbabbbbbaabbbbbaabaaabbbabaababaabaaaabbbbbbbbbaaaaaabbbabbbbbbbaabbbbbabbbbaabbbaabbaaabbbabaaaaabbbbaabbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaaabbbaaaaaaaabbaaaaaaaaabbbbaaaaabbbbaabbbabbbbbbbbbabbbbbbbbaabbbbbbbbbbbbbbbbaaabbbbbbabbbbbaabbbbbbabbaaabbaabaaabaaaaabaabbbbbbbbbabaaaabbaabbbbbbaabbbbbabbbbabbbbaaabbbaaaaaaabbbaaaaaaaaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaabbbbbabaaaaabaaaaaaaaaabbbbbaaaaabbbaabbbaabbbbbbbbabbbbbbbaaaaaaabbbbbbbbbbbaaabbbbbbbabbbbbaabbbbbbaabaaaabbaabaabbaaabbaabbbbbbbbbaaaaaaabbabbbbbbaabbbbbabbbbabbbbaaabbaabbbbbbbbbbbaaaaababbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbabbbbbabaaaaaaaaaabbbaaabbbbbaaaaabbbabbbbaabbbbbbbbabbbbbbaaabaabaaabbbbbbaaaabbbbbbbbbaabbbbaabbbbabbaabaaaabbabaabbbbbbbbabbbbbbbbbaaaaaaabbaabbbbbaabbbbbabbbbaabbbaaaaaaabbbbbbbbbbbbbaaabaaaaabbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaabbbbbbaabbbbabaaaabbaaaabbbaaabbbbbaaaaabbaabbbbaabbbbbbbbabbbbbbaaaaabbbaabbbbbaabbbbbbbbbbbbbaabbbaabbbbaabbabbaaaabaaaabbbbbbbbaabbbbbbbbaaaaaaaabbaabbbbaabbbbbabbbbaabbaaaaaabbbbbaaaabbbbbbaaababbaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbbbaaaababbaaabbaaaaaaaaaaabbbbaaaaabbaaabaaaabbbbbbbbabbbbbbbbbabbbbaabbbbaabbbbbbbbbbbbbbbaabbaaabbbaaabbabaabaabaaabbbbbbbbbaabbbbbbbaabaaaaaaaaabbbbaabbbbbabbbbbabbaaaaabbbbbaaaaaaabbbbaaaaabbbbbbaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbaaaabbaaabbbaaaaaaaaaabbbbaaaabbbabaaabaabbbbbbbbabbbbbbbbbaabbbabbbbaabbbbbbbbbbbbbbbbaabbbaabbbaaaabbbbaabaaaaabbbbbbbbbaabbbbbbbaabbbbbbbbbbbbbbaabbbbbabbbbbabbbaaaaabbbbaaaaaaaabbbbaaaabbbbbbaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaabbbbbbbbbbbbbaaaaaaaabbaaaaaaaaaaabbbaaaabbbabbbbbaabbbbbbbbabbbbbbbbbaabbbabbbaabbbbbbbbbbbbbbbbbbabbbaaabbaabaaabbbaaaaaaaabbbbbbbbbaabbbbbbaabbbbbbbbbbbbbbaabbbbbaabbbbaabbaaaaabbbaaaaaaaaaabaaaaaabbbbbaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbaaaaaaabbaaaaabbaaaabbbaaaabbbabbbbbabbbbbbbbaabbbbbbaaaabbbbaabaabbbbbbbbbbbbbbbbbbbabbaaaabbabbbaaabbaabaaababbbbbbbbbbaabbbbbabbbbbbbbbbbbbbbaabbbbbaaaaaaaabbaaababbbaaaabbaaaaaaabaabbbbaaabbbbbbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaaaabbbbbbbbbbbbbbaaaaaaaabbaaaabbbaaaabbbbaaabbbabbbbbabbbbbbbaaabbbbbaaabbbbbbbaaabbbbbbbbbbbbbbbbbbbbabbabbabbabbbbbaabbabaabbaabbbbbbbbbbaaabbbabbbbbbbbbbbbbbbaabbbbbabbaaaaabbaaababbbaaaaaabaaabbaaaabbbaabbbbbbbbbbaaaabbbbbaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaaaaaaaabbaaaabbaaaabbbbbaaaabaabbbbaabbbbbbbaaabbbaaaaabbbbbbbbbbbbbbbbbbbbbbbabaabaaabaabbabaabbbbbbaababaabbbaabbbbbbbbbbaaabbabbbbbbbbbbbbbbbaabbbbbabbbbbbabbaaaaabbbaaaaaaaaaabbaaaaabaabbbbbbbbbbbabbbbbbbbaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbaaaaaaaaaabaaaaaabbaaaaaaaaaaaaaaaaaaaabaaaaaaabbbbbbaababbbaaaaabbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbaaaabbbbbbbbaaababbbbbabbbbbbbbbbbaaabaabbbbbbbbbbbbbbaabbbbbaabbbbbaabaaabbbbaaaaaaaaaaabbaaaaababbbbbbbbbbbbaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbaaabbbbbbbbbaaaaaabbaaababbbabbaaaaaaababaabbbabbbbbbaabbabbbaaaaabbbbbbbbbbbbbbbbbabbbaaababbbbaaaabaaabbbbbbbbbaabbbbbbbbaabbbbbbbbbbbaabaabbbbbbbbbbbbbbaabbbbbbabbbbbaabbaaabbbaabaaaaaaaabaaaaaababbbbbbbbbbbbaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaabbbaabbbbbbbbbbbaaaaaabbaaaaabbbabaaaaaaaabaaaabaaabbbbbaaabbabbbaabaaaaaabbbbbabbbbaababaaaabbbaaaaaaaaaaaabbbbbbbbbaabbbbbbbbbaabbbbbbbbbbbabaaabbbbbbbbbbbbbaabbbbbbabbbbbbabbaaaabbaaaabbaaaabbaaaaaababbbbbbbbbbbaaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbaabbbbbbbbbbbbbaaababbaaaaaaaaaaaaaaaaaabbaaaaabbbbbbaabbbbabbbaabbbbbabbbbbaabbbaaabaaaabbbbaaabbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaabbbbbbbbbbabbbbabbbbbbbbbbbbaabbbbbbaabbbbbabaaaaabaaaaabbaaaabbabaaaababbbbbbbbbbbbaabbbbbbbbabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaaaaaabbbbbbbbbbbbbbbaababbaaaabbaaaabbbaaaaabbbaaaabbbaaaabbbbbabbbbbbbbbbaaabbaaabbaabaaaabbbbaaabbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbaabbbbbbbbaabaaaaabbbbbbbbbbbaaabbbbbbaabbbaaaaaabaaaaaaaabaaaabbabaaaabbaaaaaaaaaabbaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbaaababbaaaabbaaaabbbaaaaabbbbbbaaaaabbbbbbbbabbbbbbbbbbaaaaaabaaaabaaaaaabbbabbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbaabbbbbbbaabbbaabbbbbbbbbbbbaaaabbbbbbaaaaaaaaaabaaabaaaaaaaaabbabaaaabbbbbbbbbbbaabaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbaaaaabaaaabbbaaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbaaaaaabbbbbbbaaaaaabbaabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbaaabbbaaabbaaaabbbbbbbbbbbbaabaaabbbbbbaaaabaaabaaabaaaaaaaaabbabaaabbbbbbbbbbbbbaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaaaaaaaaabbbbbaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbaaabbbbbbbbbbbbaaaabaabbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbaaaaaabbaaaabbbbbbbbbbbbbaabbbaaaaaaaaabbbaaabaaaaaaaaaaaaabbabbaabbbbbbbbbbbbbbaabbbbbbbbaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaaaaaaaaabbbbbaabbbbbbbbbbbbbbbbbbbbabbbbbbbbbbaabbbbbbbbbbbbaabaaabbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbaabbbbbbaabbbbbbbaaaaabaaaaabbaaaabbabaaaabbbbbbbbbbbbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaaabaaaaabbbbbbaabbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbaaaaabaaaabbbaaaabbabaaaabbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabaaaaabbbbbbaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbaaaabbbbbaaaabbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbaaaabbbaaabbbaaaabbabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaaaaaaaaabbbbbbaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbabbaabbbbabbaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbaabbbbaaaaaaaaaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbaaaaaaaabbbbbbaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbaabbaaaaaaabaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbaaabbbbaaaaaaaaaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaaaaabbbbbbbaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbaabbaabbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaaaabbbbaaaaaaaaaabbabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbaaaaabbbbbbbaaaaabbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbaaaabaabbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbaaabbabbaabbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaaaabbbbaaaaabaaaabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaabbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbaaaabbbbbabaaaabbbbbbbbbbbbbbbbbbaaaabbabbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaaaabbbbaaabbaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaabbaabbbbabaababbbbbbbbbbbbbbbbabaaabbaabbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaaabbbbbaaaaaaaaaababaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbaabaaabbaaabbaabbbbbbbbbbbbbbaabaaaabaabbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaaaaabbbbbbaaaaaaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbaabbbaaaabaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbaaaabaabbaaabbabbbbbbbbbbbbbbaabaaaababbbbbbbbbbbbbbaaaaaaaabbaaaabbbbbbbbbbbbbbabbbbbbbbbbbbbbaaaaabbbbbbaaaaaabbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbaaabbaaaabbaaabbbbbbbbbbbbbbbbbabbbbbbbbbbbaabbbbabbbbbabbbaabbaabbbbbbbbbbbaaaaaabaababbbbbbbbbbbbbbbaabaabaaaabbaabbbbbbbbbbbbbabbbbbbbbbbbbbbaaaaabbbbbbbaabbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbaababaabaaaaaaabbbbbbbbbbbbbbbbbabbbbbbbbbaaaaaaabaabbbbabbbbbbbbabbbbbbbbbbbaaaaaabaababbbbbbbbbbbbbbaaaaaaabaabbababbbbbbbbbbbbbabbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbabaaabaaabaaaabbbbbbbbbbbbbbbbbabbbbbbbbbababbaaababbbbabbbbbbbbaabbbbbbbbbaaaaababbbbabbbbbbbbbbbbbbaaababbbbbbaaaabbbbbbbbbbbbbabbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbabaaaaaaaaaaaaabbbbbbbbbbbbbbbbabbbbbbbbbaaaaaabbaabbbaabbbbbbbbbabbbbbbbbbaabaabbbbbbabbbbbbbbbbbbbbaaababbbbbaabaabbbbbbbbbbbbbabbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbaabbbaaaaaaaaaabbbbbbbbbbbbbbbbabbbbbbbbbaababbbbbbbbbbabbbbbbbbbaaabbbbbbbbabbbbbbbbbaabbbbbbbbbbbbbbaaaabbbbbabbbbbbbbbbbbbbbbbabbbbbbbbbbbbbaaaabaaabbbaabbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaabaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbabbbbbbbbbbbbabbbbbbbbbbaabbbbbbbbbaabbbbbbbbaabbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbabbbbbbbbbbbbbaaaaaaaabbbaaabbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabababababbaaaaaaaaaaaaabbbbbbbbbbbbbbbabbbbbbbbbbbbaabbbbbbbbbbaaabbbbbbaabbbbbbbbbbaaaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbabbbbbbbbbbbbaaaaabababbbaaabbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaaabaaabbbbaaaaaaabbbbbbbbbbbbbbbabbbbbbbbbbbbbaabbbbbbbbbbaaaaaaaaabbbbbbbbbbbbbaabbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbabbbbbbbbbbbbaaaaaaaaaaaaaabbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaabaabaabbbaaaaaaaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaaabbbbbbbbbbbbaabbbbbbbbbbbbbbbbabbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbabbbbbbbbbbbaaaaaaaaaaaaaaabbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaabaaaaaabaaaaaaaabbbbbbbbbbbbbbabbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbabbbbbbbbbbbaaaaaaaaaaaababbbaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaabbaaaaaaaabaaaaaabbbbbbbbbbbbbbabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaaaaaaabababbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbabbbbbbbbbbbaaaaabaaaaaababbaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbaabaabaaaaabbbbaaaaabbbbbbbbbbbbbabbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaabbbaaaaaabbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbabbbbbbbbbbbaaaaaaaabaaaaabaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaabbabbaaaabbbbbaaaaabbbbbbbbbbbbbabbbbbbbbbbbbabbabbbaaabbbbbbbbbbbbbbbbbbbbbbbabbaaaaaaaaaababaabbaaabbbbbbbbbbbbbaaaabbbbbbbbbbbbabbbbbbbbbbbaaaaaaaaaabaaaaabaabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaabbaaaaaaabbbbbaaaaaabbbbbbbbbbbbabbbbbbbbbbbaabaabbbaaabbbbbbbbbbbbbbbbbbbbbbbabaaabbbaaaabaaaaaaaaaaaabbbbbbbbbbbaaaabbbbbbbbbbbbabbbbbbbbbaaaaaaabaaaabaaabbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbaaaaaaaaaaabbbbbbaaaaabbbbbbbbbbbbabbbbbbbbbbbaaaaaaaabbabbbbbbbbbabbbbbbbbbbaabababaaaaabaabbaaabbbbbbbabbbbbbbbbbaaaabbbbbbbbbbbbbabbbbbbbbbaaaaaaaaaaaaaaabbbabbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbaabbbbbbbbaaaaabbbbbbbbbbbabbbbbbbbbbbbaabbbbbbbabbbbbabaabbbbbbbbaabaaaaaabbaaaaabaabababbbbbbbabbbbbbbbbbaaaaabbbbbbbbbbbbabbbbbbbbaaaaaaaaaaaaaaabbbaabbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbbbbbbbbbbaaaabbbbbbbbbbbbabbbbbbbbbbbbaabbbbbbbabbbbaabaabbaabbbbaaaabaaaaabaabbbbbaaaabaabbbbbabbbbbbbbbbbaaaabbbbbbbbbbbbabbbbbbbbaaaaabbbbbaaabaabbaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbaaaaaaabaabaaabaaaabaaabbbbaaabbbbbbaaaaaaaaabbaabbbbbbbbbaaaaabbbbbbbbbbbbbabbbbbbbaaaaabbbbbaaaaababbaabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbabbbbbbbbbbbbbbbbbbbaaabbaababaabaaaaaaaabbaabbbbbbbbbbbbaaaaabbbbabaabbbbbbbbbbaabbbbbbbbbbbbbbbbabbbbbbbaaaaabbbbbaaaaabaabbabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbabbbbbbbbbbbbbbbbbbbaaaaaabaaaaaaaaaaaaaabbbbbbbbbbbbbbbbaabaabbbbaaaabbbbbbbbbaaaabbbbbbbbbbbbbbbabbbbbbbaaaabbbbbbbaaaaaaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbaaaabaabaaabaaabbbbbbbbbbbbbbbbbbbbabbbbaabbbbbbbabaaaaaabbbbbbbbbbbbbbbabbbbbbbaaabbbbbbbbbbbbaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbaaabbaaaaaabaaabbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbabbbbbaaaabbbbbbbbbbbbbbbbbabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabbaaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbabbbbaaaaabbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbabbbbbbbbbbbbbbaaabbbbbbbbbbbaabbbbaaabbbbbbbbbbbbbbbbbbbabbbaaaaaabbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbaaaaaaaaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbababbbbbbbbbbbaaaabbabbbbbbbbbbbbbbbbbbbbbabbbaaaaabbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabbbbbbbbbbbbbbbbb",
        "bbbbbbbbbabbbbbbbbbbabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbaaabbaaaaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbababbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbabbaaaaaabbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbbbbbbbbbbbbbbbb",
        "bbbbbbbbbaabbbbbbbbbabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbbaaaaaaaaaaaaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaaaabbbaababaabbbbbbbbbbbbbbbbbbbbbbabaaaaaabbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbabbbbbbbbbbbbbbbbb",
        "bbbbbbbbbaaabbbbbbbbabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbbaaabaabbabaaaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaabaaabbaabaabbbbbbbbbbbbbbbbbbbbbbbbabbaaaaaaaabbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbabbbbbbbbbbabbbbbb",
        "bbbbbbbbbabaaabbbbbbaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbaaabaabbaaaaaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabaaaabaabbaabbbbbbbbbbbbbbbbbbbbbbbbabaaaaabaaaabbbbbbbbaaaabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbabbbbbbbbbaabbbbbb",
        "bbbbbbbbbaabbaaabbbbaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbbbbbaaaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbabbbbbbbbbaabbbbbb",
        "bbbbbbbbbaabbbaaaabbbabbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaabaaaaaabbbaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbabbbbbbbaaaabbbbbb",
        "bbbbbbbbbbabbbbbbaaababbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaabaabbaaaaaaaabbaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaaaaaaaaaabaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbabbbbbbaabbabbbbbb",
        "bbbbbbbbbbaabbbbbbbaaaabbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaabbaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbaabbbaaaabbaabbbbbb",
        "bbbbbbbbbbaaabbbbbbbbaabbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbabaaaaaaaaaaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaabbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbaabaaaabbbbaabbbbbb",
        "bbbbbbbbbbbaabbbbbbbbbabbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaabaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbaaaaabbbbbbabbbbbbb",
        "bbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaaaaaaaaaaababbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbabbbbbbbbbaabbbbbbb",
        "bbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaaaabaaaaabaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbaabbbbbbbb",
        "bbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaababbbbaaaaaaaaabaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaabaaaabbaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbb",
        "bbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabaaaabaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaabaaabaaaaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbaaaaaaaaabaabaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaaaaaaaabaaaaaaaabaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbabaaaaaaabaaaaaaaaaabbaaaaaababbbbbabbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbabbbbaabbbbbaaaaaaaabaaaaaaaaabbaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabaaaaaaaaaaaaabaaabbbaaaaaaabbbbaabbbbbbbbbbbbbbbaaaabbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbaabbbbabbabaaaaaaababaaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbbaaaaaaaaaabbbbaaaaaaaabbaabbbbbbbbbbbbbbbbbbaaabbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaabbbaaaaaaaaabaaaaaaabaaaaaaaaaaaabbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaababbbbabaaabaaaabbbbbbaaaaaaababbbbbbbbbbbbbbbbbbbbbaaabbbbbbaaaabbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbaaaaaaaaaaaaaaaaaaabaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaabbaaaaaaaaaabbbbbbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbaaabaaaaabbbbbbaaaaaaaabaaaaaaaaabaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaaaaaaaaaaaaabbbbbbbbaabbbbaaaaaaaabbbbbbbbbbbbbbbbbbaaabbaaabbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbaaaaaaaaaabbbaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaabaaaabbbbbbbbbaabbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbabbaabbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbbbbbbabbaaaaaaabbaaaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabaaaabbbbbbbbaabbbbaabaaaaaaaaabbaabbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbbaabbbbbbaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaabbbbbbbabbbbbabbaaaaaaaaaaaaaaaabbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbaaaaaaaabbbbabbbbabbbbbbbbbaaaaaaaabaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbaaaabbaaaabbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaabbbbbaabbbbaabbbaaaaaaaaaaaaaaaaabbbabbbbbbbabbbbbbbbbbaaaaaaaaaaaaaaaaabbbbaabbbaabbbbbbbbaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbaaabbbbbbbaaabbbbbbbbbbbbbbbbbbaaaaaabaababaaaabbbbaabbbbaabbbbaaaaaaabbaaaaaaaaaaaaaaaaaabbaaaaaaaabbaaaaaaaaaaaaaaaaabbbbbabbbbaabbbbbbbbaaaaababaaaaaaaaabbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbaaaabbbbbbbbbbaaabbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaabbbaabbbbaabbbbbaaaaaaaaabaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbbaaaaaaaabbbbabbbaaabbbbbaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbaaabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaabbabbbbbaabbbbbaaabaaaaabaabbbabbbaaaaaaaaaaaaaaaaaaaaaaaaaaaabbaaaabbbaaaaaaaabbbaabbbbbaaabaaaabbabaaaaabbbbbbbbbbbbbbbbbaaabbbbbbaaabbbbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbaaaaabbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbaaaaaaaaaaaaaaabaabbbbaabbaaaaaaabaaaaaaaaabbbbbbaaaaaaaaaaaaaaaaaabbaabbbbaaaaaaaabaaaaaaaabaabbbaabbbaaaabaaaaaaaaaaaabbbbbbbbbbbbbbbbaaabbbbbaaaabaaabbbbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbabbbbbaaaabbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbababaaaaaaaaaaabbbbaabbbaaaaaaabaaaaabaaabbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbaababaaabaaaaaaabababbbbaabaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbaaabbbbbaaaaabbbaaabbbbbbbbbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaaaaaaaaaaabbbbaabbbaaaaaaaaaaaabaaaabbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbaaaaaaaaaaaaaaaaabbaabbbaabaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbaaabbbbbbaaaaaabbbbaaabbbbbbaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbabbbbbaaaaaaaaabbaabbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbaabbaababaabaaabbbaabbbaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbaabbbbbbbaabaaaaabbbbbaaabbbbabbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbaaaaaaaaabbbbaabbbbaaaaaaaaaabbaabbbbbbbbbbbaaaaaaaaaaaaaaaabbbbbbbbbbbbaabaaaaaaaabaaabbbabbbbaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbaabbbbbbbaabaaaaaaaabbbbbaaaaaabbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbaabbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbaaaaaaabbbbaabbbbbaaaabbbbbbaabaaabbbbbbaaaabaaaaaaaaaaaaaabbbbbbbbbbbbaaababbaaaabaaabbbaabbbbaaaaaaaaaaabbbbbbbbbbbbbbbbbbaabbbbbaaaaaababaaaaaabbbbbbaaaaaabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbaabbbbbbbbaaabbbbbbbbbbbbbbbaaabbbbbbaabbbbbbbbbbbbbbbbbbaaaaaaaaaaabbbbbbabbbbaaaaaaaaababbbbbaaaaaaaaaaaaaaaaaaaaaaaabbbbbbaaaaaaaabbbbaaaaabbbbaabbbaaaaaaaaaabbbbbbbbbbbbbbbbbbaabbbbaaaaaaaaabbaaabaabbbbaaabbbaaabbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbaabbbbbbbbbbaabbbbbbbbbbbbbaabaabbbbbbaabbbbbbbbbbbbbbbbbbbaaaaaaaaabbbaaaabbbaabaaabbbaaabbbbaaaaaaaabbbaabaaaaaaaaaaaabbbbbaaaabbaaaaaabbaaabbbbbabbaaaaaaaabbbbbbbbbbbbbbbbbbbbaabbbbbaabaaabbaabaaababbbbaabbbbbbbabbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbaaabbbbbbbbbaaabbbbbbbbbbbaaabaabbbbbbbaabbbbbbbbbbbbbbbbbbabbaaaaaaaabaaabaaaaaabbaabbbaabbbbaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbbaabbbaaabaaabbbaaabbbaabaaaaaaaabbbbbbbbbbbbbbbbbbbaabbbbbbabaaaabbbaabbaaabbaaabbbbbbbbaabbbbbbbbbbbabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbaabbbbbbbbbbbaabbbbbbbbbaabbaabbbbbbbbbaabbbbbbbbbbbbbbbbaabbbaaaaaaaaaaaaabbbaaabbabbbbbbbbbaaaaaaaaabbbaaaabbaaaaaaaaabbbbbbbbbaabbbaaaabaaaabbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbaabbbbbbbabaabbaaabaababbbaabbbbbbbbbbaabbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbaabbbbbbbbbbbaabbbbbbbaaabaaabbbaabbbbbaabbbbbbbbbbbbbbaabbbbaaaaaaaaaaabbbbbbaabaabbbbbbbbbbaaabbaaaaaaaaaaaaaaaaaaaaaabbbbbbbbaabaaaabaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbaaabbbaaaabaaaabaaaaabaaabaaabbbbbbbbbbbbabbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaabbbbbbbbbbbaabbbbbaabbaabbbbbaaabbbbbaabbbbbbbbbbbaaabbbbbabbaaaaaaaaaabbbbbababbbbbbbbbbbaaaaaaabaaaabaaaabaaaaaaabbbbbbbbbbbabaabbbbbbaaaaaaaaaabbbbabbbbbbbbbbbbbbbbbaaabbbbaaaaababaabaaaabbbbaaabbbbbbbbbbbbaabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaaaabbbbbbbbbaabbbaaabaaabbbbaabaabbbbbaabbbbbbbbaaaaaabbbaabbbbbbaaaaaaaaabaababbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbaaaabbbbbaaaaaaaaaaabbbaabbbbbbbbbbbbbbbaaabbbaaabbbaaaabaaabaabbbaaabbbbbbbbbbbbbabbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaaaabbbbbbbaabbbaabaabbbbaaaaabaabbbbaabbbbbbbabbbbaabaabbbbbbbbaaaaaaaabbaaaaabbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbaabaaaaaaaaaaaaabbbabbbaaaaabbbbbbbbbbbaabbbbbabaaabbaaaabbbaabbbaabbbbbbbbbbbbbbaabbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbaaaaabbbbbbaabbbaabaabbbaaaaaaaabbbbbaaabbbbbabbbbbaaabbbbbbbbbbaaaaaaaaaaaaaaabbbbbbbbbbaaaaaaaaaaaabaaaaaaaabbbbbbbbbbbbbaaaaaaaaaaaaaaabbbbbaaaaabbbaabbbbbbbbaaabbbaabaaaaaabaabaaaaaabbaabbbbbbbbbbbbbaaabbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbaaabbbbbaabbbaabaabbaaabbabaabbbbbaabbbbbaabbbbbbabbbbbbbbbbbbbaaaaaaaaaaaaabbbbbbbbbbaabaaaaaaaabaaaabaabbbbbbbbbbbbbbaaaaaaaaabbbbbbbbbbbbaabbbbbabbbbbbbbaaabbaaaaaaaaaaabaaaabbbbbaaabbbbbbbbbbbbbaaabbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaaaabbbbaabbbaaaaabbbbaaabaabbbbbbaaabbbaaabbbbbabbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaabbaabaaaaaaaaaaaabaaabbbbbbaaaaaaaaaaaaaaaaabbbbbbbbbbbbabbbbbbaabbbbbbaaabbaabbbaaaaaabaabaaaabbaaabbbbbbbbbbaaaaabbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbaaabbbbaabbbaabbbbbbaabbabbaabbbbbaaaaabaaabbbabbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaabbaaaabbbbbbbbbaaaaaaaaabaaaaaaaaaaaaaaabbbbbbbbbbbbbbbabbbbbaabbbbbaaabbbbabaaaabaaaaaaaabaabbaaaabbbbbbbbaaaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbaaabbbbaabbbbbbbbbaabbaabaaaaabbbbaaaabbbaaaaabbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbaabbbbbbbbbbbbbbbbbaaaabaaabaabbaaabbaaaabaaaaaaaaabaaaaabbaaababbbbbaaaabbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbabbbbbaabbbbbbbbabbaabbaabaabbbbbbaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbbbaabbbbbaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbaaaaabbbaaaaabbbaaaaabaabbabaaaabaabbbaaabbabbbbaabbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbaabbbbbaabbbbbbaabbaabaabaaababbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbaaabbbbbbbbaaaaaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaaaaabbbaabaaaaaabbaabaaaaaabbaaabbbabbaaabbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaabbbbbbaabbbbbabbaabaabbaabaaaabbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbaaabbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbaaabaabbabaabbaaaabaabbaabbbbaabaabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbabbbbbbbaabbbbaabaabaabaabaaaaabbbbbbbbbaaaaaaabbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbaaabaaaaaabaaaaaaabbbbaabbbbbaaaabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbabbbbbbbbaabbbaabaaaabbaabaabbabbaabbbbbbbbbaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbaaaaaaaaaaaaabbbbbbbbbbbbbbbaaaaabbbbbbbbbbaabaaabaaabaaabaabbbaabbbbbbaaabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbaabbbbbbbbaabbbaaaaabbaabbabbbabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbabaaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbbaaaabbbbbaabbaaabaaabaaabbbaabbbbbbbaabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbaabbbbbbbbbaaabbaaabbaabbaababababaabaabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbbbbbabaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbabbaabbbbbaabaabbbaaaaabbbaabbbbbbbbabbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbaabbbbbbbbbbaaabbbaaaabbbaababaaabaaaaaaabbaaaaaabbbaaabbaaaabbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaabbbbbbaabaaaaaabbabbaaaaaaaaaaaabbbaaabbbbaabaaabbbbaabbaabbbbbbbbaaabbbbbbbbbabbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbabbbbbbbbbbbbbaabbbbbbbbaabaabaaababaabaabaaabbbaabbaaaaaaaaabbbbbbbbbbbbbbbbbbaaabbbaaaaaaabbbaaaabbbbaaaabaaabababbabaaabbaaaaabbaaaabbbbaabbbaabbbbaabbabbbbbbbaaabbbbbbbbbbabbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbaaabbbbbbbbbbbbbbaaabbbbbbaaaaabaabaabaabaababbaaabaababbaaaababbbbbbbbbbbbbbbaaaabbbbbaaaaaaabbbbbaaaabbabaaaaaaaabaaaabaaaabbbbaabbaababbbbaaaabaaabbbbaabaabbbbbaaabbbbbbbbbbbaabbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbbbbbbbbbbbaaabbbbaabaaaaabbabbabbabaabaabaababababaaababbbbbbbbbbbbbbaaabbbbbbbbaabbaabbbbbbbaaaaababbabaaabaaaabaaaaabaaaabbbababbbbaaaaaabaabbbbaaabbbbbaabbbbbbbbbbbbbaabbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbaaabbbaaabaabbaabbabaabaababbaababaaaaaaababbbbbbbbbbbaaaabbbbbbaaaaaaaaaaaaabbbbbbaaaaabaabaaabaaaabaabaabaabbbbbabaabbbaaaaaabaaabbbaabbbbaaabbbbbbbbbbbbbbbaaabbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaabbabbbabaabaababbbababaabaabababbbbbbbbbbaaabbbbbbbaaaaaaaaaaaaaabbbbbbbbaabaaaaaaaaaaaababbaabaabbbbbabaabbbaabbaaabbabbbbbbbaaabbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaabbbbaaaabbaabaabaabaabaababaabaaaabaabbbbbbbaaabbbbbbbbaaaaaaaaaaaaaaaabbbbbbbbaaaaaaaaaaaaaababbaabaabbbbbabbabbbaabaaaaaaaabbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaaabbbbbaabbaababbbabaaaaababbabaaaaaaabbbbbaaabbbbbbbbbbaaaaaaaaaaabaaaabbbbbbbbbbaaabbbaaaaabbabbaabaabbbbbaababaaaababbbaabbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaaabbbbbbaaaabbbaaaaabaaabbaaaabaaabbbaaaaabbbbbbbbbbbbaaaaaaaaaaaaaaabbbbbbbbbbbbaaaaaaaaabbabbaabaabbbbbaabaaaaaababbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababbbbbaaaaabbbbbbbbbbbbaaaaaaabbbaabbbbbbbbaaabbbbbbbbbbbbbbbaaaaaaaaaaaaaaabbbbbbbbbbbbbbaaabbbaaaabbaabaabbbbbaabbbbaaaaabbbbbbaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaababbbaabaaaaabbbbbbbbbbbaabbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbaaaabbaabbaaaaabbbbbaaaaaaaaabbbbbbaaaabbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaaabbaabbbbbaaaaabbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbaaaabaaaaaaaaaabbbbbbbbbbbbbbbbbbbaaaabbbaaaaabbbbbbabbbbbbbbbbaaaaabbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaaaabbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbaaaaaabbaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaaaaaaabbbbbbbbbbbbbaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbbaaaaaaabbbbbbbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbbbbbbbbaaaaaababaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbabbababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbaabaaaaabbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbabaaaababbabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaaaaaaababbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaaaaaaaabaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababbbaaaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaabbaaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabaaaaabaaaaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababaaababaaaababaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaaaababbbbbaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaabaaabaaaaaaaaaaabaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaabaaaaabaaabbbbbbaaaaaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaaaaaaabbbbbabbbbaaaaaaaabaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaaaabaaaabbbaaaaaaabbaaabaaaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbaaabaaaaaabbaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbaaaaabaaaaaaaaabaabbaaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaabaaabbabaaaaabaaaaabaabaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaabbaabaaaaaaaaaabaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaababbaabbaaaaaaaaaaaababbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaabbabbaaaaaaabaaabbabbaaaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbabbaabaaaaaaaaababaaaaabbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaababbbaabbababaaaaaabaabaaaaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbaaaaabaaaabaabaababaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaabbaaabaaaaabbaaaaabbaaaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababaaaaaabbaaabbbaaaabbaabaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaaabaaaabbbaaaaaaabbaaaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaaabaaaabbbbbbbbbbaaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabaabbaaaaaaaabbbbbbaaaaaaaaaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaabaabaaaaaaaaaaaaaaaaaabaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaaaabaababbbbbaaaabaaaaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaabbbbbbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaaabbaaaaaaababbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaaaaabbbaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababbbaaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaabbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaaabbababaaaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaaaaaaaaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbaaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb"
        };
        wxBitmap bitmap( xpm_data );
        return bitmap;
    }
    if (index == 15)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "284 314 2 1",
        "a c Black",
        "b c #FFFFFF",
        /* pixels */
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaababbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaabbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaaabbbbaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaabbbaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaababbbbaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaabbaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaabbaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaaabbbaaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbabbbbbaaaaaaaabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaabbbaabbaaabbbbbbbbbbbaaaaaaaabbbbaaaaaaaabbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbaaaaaaaabbbbbbbbbaaaabbbaaaaabbbbbaaabbbbbbbbbbaaaaaaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaabbbbbbaabbbbaaaaabbbbbaabbbbbabbbaabbbbbbabbbbbbbbbaabbbaabbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaababbbbbbbabbbbbbbabbbbbaaaaabbbbbabbbbbaaaaaaabbbbaabbbbaaaaaabbbbbabbbbbbaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaabbbbbbbabbbbbbaabbbbbabbbaaaaababbbbbabbbaaabbbbaabbbaabbbabbbbbbabbbbbbabbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbaabbbbbbbaabbbbaaabbbbaabbbbabbbaaaabbabbaabaabbaaaaaaaabbbbaabbbbbaabbbbbabbbbbbbaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbabbbbbbbaaaaaaaaaabbaaabbbbabbaabaaabaaaaaaaabaabbaabbabbbbbabbbbbaaabbbaabbbbbbbabbbbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaabbbaaaaaabbbaaaaaabbbaaaaaaabbbaabbabbbbaaabbbbbaaaabbbabbbaabbbbaaaaaaaaaaaaaabbbbbbaabbbbbaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbabbaaabbbaaaaaabbbbbbbbbbbbaaaaaaabbabbbbbaabaaabbaabbbbabbbbaabbaaaaaabbbbbbbaaabbbaaaabbbbbabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbabaabbbbbbaaaabbbaaaaaaabbbbbbbbaaaaabbbbbaaaaaaaaaabbbbabbbaaaaaaabbbbbbbbbbbbbaaaaabaaabbbaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbaaaabbbbbbbaabbaaabbbbaaaaaaaaabbbbbabbbbbaabbbbbaaabbbbaaaaaabbbbbbaaaaaaaaabbbaaaabbbbaabbabbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaabbbbaaaabbbbbbbbabbaabbbbbbbbbbbbaaaaaaaaabbbbbabbbbbbbaabbbbabbbbbaaaaaaaaabbbbbaaabbaabbbbbbaaaaabbbbbbaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaabaaabaabbbbbbbaabbabbaaaaaaaaaabbbbbbaaaabbbbbabbbbbbbaabbbbaaaaaaaaabbbbaaaaaaabaabbaabbbbbbbaaaaaabbbaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaaabbbaabbbbbbbabbbababbbbbbbbaaaaaaaabbbabbbbbaaaaaaabaabbbbaaaaaaaaaaaaaaaaabaaababbaabbbbbbbaaabbaaaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaabbbaaaaaaaabbabbaabaaaaaaaaaaaaaaaaaaaaabbbbbaaaabbaaaabbbbaaaaaaaaaabbbbbbbbbbabaabbabbbbbbbababbbbaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbabbbbbabbaaaaaaaabbaababbbbbbbbbaaaaaaaaaaabbbbbaabbbbbbaabbbbaaaaaaaaaaaaaaaaaaaaaababbaabbbbbaabaabbbbbabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaabaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbaaabbbaabbbbbaabaabbbbbaaabaababbbbbbbbbbbbbbbbbbbabbbbbabbbbbbbaabbbbabbbbbbbbbbbbbbbbbbaaababaaaaaaaaabbaaaabbbaabbbbbabbbbbbbbbbbbbbbbbbbbbaaabbbabaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbaabbaababbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbaababbbbbbbaabbababbbbbbbbbbbbbbbbbbbabbbbbabbbbbbbaabbbbabbbbbbbbbbbbbbbbbbbaababaabbbbbbaabbabaabbbaabbbaabbbbbbbbbbbbbbbbbbbbaaaabbaabaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbaababbabbbbbbbbbbbbbbbbbbbbbaaabbbaaaabbbbbbabaabbbbbbbbabbababbbbbbbbaaaaaaaaaaaabbbbaabbbbbbbaabbbbaaaaaaaaaaaaabbbbbbbaababaabbbbbbbabbaabaaabbaaaaaaaabbbbbbbbbbbbbbbbbbaabaaaabbaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbbaaabbabbbbbbbbbbbbbbbbbbbbbaabbbbbbaabbbbbbababbbbbbbbbabbababaaaaaaaabbbbbbbbbbabbbbaaaaaaaabaabbbbabbbbbbbbbbaaaaaaabbabaababbbbbbbbaabaaabbabbaaabbbaabbbbbbbbbbbbbbbbbbaaaabaabbabaaaabababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbbaaabaabbbbbbbbbbbbbbbbbbbaabbbbbbbabbbbbbbababbbbbbbbbaababaaaaabbbbbbbbbbbbbbbabbbbaaaabbbaaaabbbbabbbbbbbbbbbbbbbbaaaabaababbbbbbbbaababaababbaabbbbbabbbbbbbbbbbbbbbbbbbbaaabaaaaaaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbbaabbaabbbbbbbbbbbbbbbbbbaabbbbbbbabbbbbbbaaaabbbbbbbaaabaababbbbbbbbbbbbbbbbbbabbbbaaabbbbbbaabbbbabbbbbbbbbbbbbbbbbbbababaabbbbbbbbaaaabbababbbabbbbbaabbbbbbbbbbbbbbbbbbbbbabbbbaaaabbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbaabbaabbbbbbbbbbbbbbbbbbaabbbbbbbabbbbbbbaababbbbbbbaaabbabaabbbbbbbbbbbbbbbbbabbbbaabbbbbbbaabbbbabbbbbbbbbbbbbbbbbbaababaaabbbbbbbaaaabbaaabbaabbbbbaabbbbbbbbbbbbbbbbbbbbbaaabaabbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbaabbabbbbbbbbbbbbbbbbbbbaabbbbbaabbbbbbbbabaaabbbaaaaabbabaabbbbbbbbbbbbbbbbbabbbbaabbbbbbbaabbbbabbbbbbbbbbbbbbbbbbabaababaabbbbbbababbbbaabbaabbbbbaabbbbbbbbbbbbbbbbbbbbbbaaabaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbaaaaabbaabbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbabbbaaaaaaaaaabaababbbbbbbbbbbbbbbbbabbbbaabbbbbbbaabbbbabbbbbbbbbbbbbbbbbbabaababbaaaaaaaababbbbaabbaaabbbbabbbbbbbbbbbbbbbbbbbbbbbabaaaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaabbbbbbaabbbbbbbbbbbbbbbbbbbaaabbaaabbbbbbbabbbaabbbbbaaabbababbbbbbbbbbbbbbbbbabbbbaaaaaaaabaabbbbabbbbbbbbbbbbbbbbbaababbaaaabbaaabbbaaaabaabbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbabbbaaaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbabbbbbbbbaabbbbbbbbbbbbbbbbbbbaabbbbaabbbbbbbbabbabbbbbbbaabbabaabbbbbbbbbbbbbbbbabbbbaaaabbbaaaabbbbabbbbbbbbbbbbbbbbbabaabaaabbbbbbabbbabbaaaabaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbabbbaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaabaabbbbbbbbabbbbbbbbbbbbbbbbbbaabbbbbbabbbbbbbbabaabbbbbbbbaababaabbbbbbbbbbbbbbbbabbbaaaaaabaaaaabbbbabbbbbbbbbbbbbbbbbababbaabbbbbbbbabaabbbbaabaabbbbbabbbbbbbbbbbbbbbbbbbbbaaaaabbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabaabbbbbbbaabbbbbbbbbbbbbbbbbabbbbbbbaabbbbbbbaaabbbbbbbbbaabaababbbbbbbbbbbbbbbbabbbaaaaabaabaaaaabbabbbbbbbbbbbbbbbbbababaaabbbbbbbbababbbbaabbabbbbbbaabbbbbbbbbbbbbbbbbbbaabaaabbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbaababbbbbbbaabbbbbbbbbbbbbbbbbabbbbbbbaabbbbbbbbaabbbbbbbbbaabbabaabbbbbaaaaabbbbbabbaabbbabbbaabbaabbabbbbbbbbbbbbbbbbaababababbbbbbbbaaabbbbaabbabbbbbbbabbbbbbbbbbbbbbbbbbbaabbbabbaabaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaabbbbbbbbabbbbbbbbbbbbbbbbbaabbbbbbaaabbbbbbbaaabbbbbaaaaabbaaaabbbaaabbbaaabbbabaaaabbabbbabbaaaaaabbbaaaaaaaabbbbbabaababaabbbbbbbaaabbbbabbaabbbbbbbabbbbbbbbbbbbbbbbbabaaaaaaababbbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaabbbbbbbbbbabbbbbbbbbbbbbbbbbaabbbbbaaaabbbbbbbaaaabbbaabbaaabaababbbabbbbbbbabbbaaabaabbaaaaabbaaabaabbbabbbbbbbabbbbababaabaaabbbbbaaabbbbbabbaabbbbbbaabbbbbbbbbbbbbbbbaaaaaaaaaababbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbbbbaaaaaaabbbaaaabababbbabbbbbbbabbbaaabaabbaaaaaabaabbaaabbabbbbbbbaabbaaaaaaaaabaaabaaaaabbbbaabaaaaabbbaabbbbbbbbbbbbbbbbaaaaaaabbabbabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbaabbbbaabbbbbbbaabbaabbbaaabaaababbaabbbbbbbaabbababbbbbabbbbabbbbaaaabbabbbbbbbbabbabaaaabaaabbaaaabaabbbbabbaabbaaaaabbbbbbbbbbbbbbbbaabbbbaabbabbaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbabbbbbbabbbbbbbbabaaabaaaaaaabaaaabaabbbbbbbaabaabaaaaaaabbbbaaaaaaabaababbbbbbbbabbababaabbbaaaaaabaabbbbaabbabbbbbabbbbbbbbbbbbbbbbbaaaabbaaaababbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbaabbaabbbbbbbbbbbbbbbbbbbabbbbbbaabbbbbbbaaaabbbababaababaabbabbbbbbbaabaababaaaaabbbbabbbbaabaababbbbbbbbabaaaabaaabbaabaaaaabbbbbabbaabbbbbaabbbbbbbbbbbbbbbbaabaaaabaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaaabbbbaaaaabbbbbbbbbbbbbbbabbbbbbbabbbbbbbaabaabbaaaabbbabbaabaabaaaaaabbaaabbabbbabbbbaaaaabaaaabaaaabbbbaabaaaabbabaaaababaaabbbbbabbaabbbbbbabbbbbbbbbbbbbaaaaaabaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbabbbbbaaabbabbbbbbbbbbbbbbbabbbbbbbabbbbbbbbaaaaababbaaaaabbaabbaaaabbbabbbaabbbaabaabbaababaabaabbabaaaaaaabaababaabaaaaabaaaaabbbbaabaaabbbbbaabbbbbbbbbbbbaabbabaabbbaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbaaaabbaabbbbbbbbbbbbbbbaaabaaaaaabbbbbaaaabaababbbaaaaabaabbaabbaaaabbbaaaaaaabbaaaaaaaaaaaabbbaaabbbbaabaaaaaaaaabbaabbaabaaabbabbaaabbbbbaabbbbbbbbbbbbaaabaabaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaaaabbaabbbbbbbbbbbbbbbbbaaaabbaaabbbbaabaabbbbaabbabbbaaaabbbaaaaababbbbaaaaaabbbaabbbaabbbabbbbaaaaaaabbaaaaaaaabbbaabbbbaababaaaaaaaaabbaabbbbbbbbbbbbbbaaababbbaabaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaababbbaabbbbbbbbbbbbbbbbbbbabbaaaaabbbabaabaabbbabaabbbaaaabbbaabbabaaabbabaaabbbaaaabbbaabbabbaaabbbaabbbaaaaaaaabbbabbbbbaababaaaaaabbaaaabbbbbbbbbbbbbbbaaaaaaaaaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbabbbbabbbbbbbbbbbbbbbbbbbaaaaaabaaababaabbabbbbaaaabbbabaabbabbaaabbaaaaaaabbbaabaaabbbaaaabaaabaabbabbbabaabaaabbaabbbbbbababaaabababbabbbbbbbbbbbbbbbbbaabaaababbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababbaabbbaabbbbbbbbbbbbbbbbbbbaaabababaaaabaababbaabbbaaaaabaaaaabbaaaaabbbbbbaaaaaaaaaaabbbbaaaabbaaaabaabbabaabaaaaaabbbbbbbabaaababbbaaaabbbbbbbbbbbbbbbbaabaaaabaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaabaaabbaaabbbbbbbbbbbbbbbbbbbaabbabbbaaabaaabbaabbbaaabbbaaabbbaabbaaaaaaaaaaaaaaaaaaaaaaaaaabaaabaabbaaaabbaaaabbbbbbbbbbbababababbaababbbbbbbbbbbbbbbbaabbbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbabaaaaaaabaaabbbbbbbbbbbbbbbbbbbaaabbbbbaaaababaaabbabbaaaaabbbaaaaaaaaabbbbbbbbbbbbbbbbbbbbaaaaaaaaaaabbaaaaaaaabaabaabbbbaabaabbbbbbaabbbbbbbbbbbbbbbbbaabbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaaaabbbbbabbbbbbbbbbbbbbbbbbbbababbbaaabbbaaaaabbaabbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbaaabaaaaaaabaaabbbaaaabbbbbbbbbbbbbbbbbaabbaaaaabaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaaabbbbabbbbbbbbbbbbbbbbbbaabaabbaaaaaabaaaabaaaaaaaaaabbbbbbbbbbbbbbaaaaaaaaaaaaaaabbbbbbbbbbbbbbaaaaaaaaaaaabbaaaaaabaaaaaaababbbbbbbbbbbbbbbbbaaabbbaaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaaaaabaabbbbbbbbbbbbbbbbbbabbabbaaaaabbbbbbbaaaaabbbbbbbbbbbbbaaaaaaaaaabaaaaaaaaaaaaaaaabbbbbbbbbbbbbaaaabaabbbaaabaaabaaaabbabbbbbbbbbbbbbbbbbaabbbaaabababbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaaaabbbbbbbbbbbbbbbbbbaaaaaaaaaaabbbbbaaaaabbbbbbbbaaaaaaaaaaaaabbaaaaaaaaaaaabbbbbaaaaaaaaabbbbbbbbaaaaaabbbbbbabbaaaaabaabbbbbbbbbbbbbbbbaabbaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaaabbaabbbbbbbbbbbbbbbbbbbbbabaaaaabbbbaaabbbbbbbbbaaaaabbaabbbabbaaaaaaaaaaaaaaaabbbaababbbaaaaaaabbbbbbbbaaaabbabaabbaaaaaabbbbbbbbbbbbbbbbbabbbbaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabaaaaabbbbbbbbbbbbbbbbbbbbaaaaaaabbaaaabbbbbbbaaaaaaaaabaababbaaaaaaaaaabbabbaaaaaaaaaaabbaaaaaaaaaaaabbbbbbbaaaaabaaaaabaabbbbbbbbbbbbbbbbbaabbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabaababbaaabbbbbbbbbbbbbbaaaaabbbaabbbbbbbbaaaabaaaaaaaaaabaaaabaaaaaaaaaaaaaaaaaaaaaaaaababaaabaaaaaaaaabbbbbbbaabbbbbbaabbbbbbbbbbbbbbbbbbaabbabaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaabaaaaaaabbbbbbbbbbbbaaaaaaaaaaabbbbbbaaaaaaaaabbaaaaaaaababaabaaaaaaaababbaaaaaaaabbaaaaaaaaaaabaaaaaaaaabbbbbaaaabaaaaabbbbbbbbbbbbbbaaaaaabaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbbaabbbbbbbbbbbbbaaaaaabaabbbbbbaaaaabaaaabbaabbaaabbbababaaabaaaaaaaaaaaaaabbbaaabaabaaabbaabbbababbaaabbbbbaaaaaaaaabbbbbbbbbbbbbaabbbaabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbaabbbbbbbbbbaaaaaaaabbaabbbaaaaababaaabaaaaaaaaaaaaaaaabababbaaaaaaaaaaabbbbabaaaaaaaaabaaaaaaaaabaabaaaabbbaaaaaaaaaabbbbbbbbbbbbabbbbaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaabbbbbbbbaaaaaabbbbbbbaabaabaaabaaaaabbaabbaaaababbabbbababbbbaaaaaabbbbbbbaaabbbabaaaaaaaaabbaaaaabbaaaabbbabbaaaaaabbbbbbbbbbbbabbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbaaabbbbbbbaaaaaaaaaabbbbbaaaaaaaaaaabaaaaabaaaaaabaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbbabaaaaabbbaaaaaaaaaaaaaaaaaabbbaaaaaaaabbbbbbbbbaabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaabaabbbbbaaaaaaaaaaabbbbbbaaaaaabababaaaaaaaaaaabaaaaaabbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabaaabbaababaaaaaaaaaabbbbaabaaaaaaabbbbbbbaaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbaabbbaaaaaaaaabaabbbbbbbabaaaaaaabaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaabababaaaaaabbbaaaaaaaaaaaabbbbbaabbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbabbbaaaaaababaaaabbbbbbabaaaabbbababaaaaaabbbbbbbbbaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbaaaaaaaaaaaaaaaaaabbabbabaabaaaabaaaaabbbabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaaaaaaaaaaaaaaaaaaaaabbaaaaaaaaaaaaaaabbbbbbaaaaaaaabbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbbbaaaaaaaaaaaaaabbaabbaaaaabbaaaaaaaabbaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaaaaaaabaaaaaaaaaaabbaaaaaabaaaabbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbaaaaaabaaabbbaaaaaaaaaaababaaabaaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaaaaaaaabbbbbbbaaaaaaaaaaaaaabbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbaaaaaaaaaaaaabbbbbbbaaaaaaaaaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbaabaaaabbbbbbbbbbbaaaaaaaaabbbbbaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbaaaaaaaabbbbbbbbbbbbbaabbbaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaaaaaabbbbbbbbbbbbbbaaaaaaabbaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaabbbaaaaabbbbbbbbbbbbbbbabbbabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbaaaabbbbbbbbbbbbbbbbbaaabaaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaaaaaabbbbbbbbbbbbbbbbbbaaaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbababbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbaaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaabbbbaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaabbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaabbbbabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbabbbbbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbbaabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbbbaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaaaaaabbabbbbaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaabbbbaaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabaabbbbabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbababbbbaaaaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaaaabaaabbbbabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbababaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabaaabababbbbaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaaaaaaaabaabbbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaababaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabaaaaaaaaaabbaabbbbaaabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaabbaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaabbbbabbbbbaabbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbabbbbabbbaaabbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabaaaaaabbbbaabbbbaabbbbbbbbbbbbbaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbbbaabbaaaabbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbaaaabbabbbbbbaabbbbabbbbbbbbbbbbbbbaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaabbbbbbabbaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaabbbbbbbaabbbabbbbbbbaaaaaabbabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaaaabbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbababbbbbbbaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaabaabaaaaabbbbbbbbbabbbabbbbbbaabaabaababbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaababbbbbbbbbaaabbaaaabbbbbbbbbbbbbbbbbbaaabbbbbbbaaaaaabbbabaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaababbbbbbbbaaaabbabbbbbaabbbabbaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbaaaaaabbbbaabbbaaabbaaabbbbbbbbbbbbbbbbaaabbbbbbbaabbbbbbbabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaababaaabaaaabbbbbbbaaaaaababbbbbaaaaaabbbaabbabaabbbbbbbbbbbbbbbbbbbbbbbbbaaabbaaaabbbbbabaabbbbabbaaabaaabbaabbbbbbbbbbbbbbbaaabbbbbbbbaaabaabaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaaaabbaaaabbbbbbaaaaaaaaabbbbbbbbaabbbbbbbaababbbbbbbbbbbbbbbbaaaabbbbaaaabbbaaaabbbbbbababbbaabaabbbbbaaababbbbbbbbbbbbbbbaaaabbbbbbbaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbbaaabbbbbbaaaaaabbaabbbbbbbbbaabbbbaaabbabbbbbbbbbbbbbbbbbabaabbbabaaabbbaaaabbbbbaaaaababaabbbbbbbaabbabbbbbbbbbbbbbbaaaaabbbbbbbaaaaaaaaaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaabbbbbbaabbbbbbaaaaabbbaabbbbbbbbbaaaabbaabbbabbbbbbbbbbbbbbbbbabbaabbaaabbbbbaaabaabaaaaaaababaabbbbbbbbaabaabbbbbbbbbbbbbaaaaabbbbbbbaaaaabaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaabbbbbbbbabbbbbbbaaaaabbbbabbbbbbbbbbbbaabbabbbaabbbbbbbbbbbbbbbbabbbabbabbbbbbbbbbbbaaaabbaabbababaaaabbbbaabbabbbbbbbbbbbbbaaaaabbbbbbbababbbaabaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbabbbbbbbaaaabbbbbabbbbbbbbbbaaaabbabbbaabbbbbbbbbbbbbbbbabbbaabaabbbbbbbbbbbbbbaabaabaababaabaabbbbabbabbbbbbbbbbbbbabaaaabbbbbbaaabbbaaaaabbabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbabbbbbbaaabbbbbbbabbbbbbbbaaabbbbaabbbbabbbbbbbbbbbbbbbbabbbbaaaabbbbbbbbbbbbbbaabbabaababbaababbbbabbabbbbbbbbbbbbbabbbaaaabbbbbabbbbbaaaaaaabbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbabbbbaaaabbbbbbbbabbbbbbbaababbbbaabbbbaabbbbbbbbbbbbbbbabbbbbaaabbbbbbbbbbbbbbaabbaaaabaabaababbbbabbabbbbbbbbbbbbbabbbaaaaabbbbabbbbbbbaabbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbabbbaaaaabbbbbbbaabbbbbbbabbabbbbbabbbbbaabbbbbbbbbbbbbbaabbbbaaaaaaaabbbbbbbbbaabbaaaabbaaabbabbbbabbabbbbbbbbbbbbbabbbaaaaabbbbabbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbabbbaaaaabbbbbbaaabbbbbbaaaaabbbbbabbbbbbaabbbbbbbbbbbbbbabbbbbbaaabaaabbbbbbbbbaabaababbbbbbbabbbbabbaaabbbbbbbbbbbabbbbaaaaabbbabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaababbbbbbbbbbbbbbabbaaaaaabbbbbaababbbbbbaaabaabbbbabbbbbbbaaaabbbbbbaaaaaaaabbbbbbaabbabbbbbbbbbaababaabbbbaaaabbbbabbaaabaaaaabbbbbabbbbaaaaaabbabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaababbbbbbbbbbbbbbaabaaaaabbbbbbabbabbbbbbbaabbaaaabbbbbbbbbbbbaabbbbbaaabaabbaaaabbbbababbbbbbbbbbbbabababbbaabbbbbaabbabaaabbbabbbbbabbbbbaaaaabbabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabaabbbbbaaaaaaabbbbbbbabbabbbbbbbbbbbbbbaabbbbbbbbbbbbaaabbbbbabbaabaaaaaaabaaabbbbbbbbbbbbaaaaaabbaabbbbbabbaabaabaaaaabbbbabbbbbaaaaabbabbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabaaaaaabaabbbbbbaaaaaabbbbbbbabbabbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaabbbabbbabaabbbbaaaabbbbbbbbbbbbbaaabbabbbabbbbbabbabbabbabbaabbbbabbbbbbaaaabbabbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaababbbaabaaaaabbbbbbaaaaabbbbbbbbabbabbbbbbbbbbbbbbabbaabbbbbbbbbbbbbaaaaaaabaaaaaabbaaaaabbbbbbbbbbbbaaabbaabbabbaaaabaabbabaabbaabbbbabbbbbbbbaaaaabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaababbbaabbaaaabbbbbaaaabbbbbbbbbbabbabbbbbbbbbbbbbbabbaabbbbbbbbbbbbbbbbbababbbaaaabbbaaaabbbbbbbbbbbaababbbaababaaaaababbaababaabbbbbbabbbbbbbbbaaabbbbbbbaabbaaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaabbaabbaaaaabbabaaaaabbbbbbbbbabbabbbbbbbbbbbbbbabbbabbbbbbbbbbbbbbbaaaaaabbbbaabbbaaabbbbbbbbabbbaaaabaababaaabaabaabbabbaaaaabbbbbabbbbbbbbaaaaabbbbbaaabaaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaabbaaaaaaaaaaaaaaaaabbbbbbbbbaababbbbbbbbbbbbbbabbbabbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbabbbaabbaaababaaabaaaabbaabbaaaaabbbbbabbbbbbbbaaaaabbbbbabaaaabaabbabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaaaabbaaabaaabaaaaaaabbbbbbbbbbbababbbbbbbbbbbbbbabbbabbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabaabababaaabaaabbaabbaaaabbbbbbbabbbbbbbbbaaaaabbbbaaaaabaabbbabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabaaaaabbabbbaabbaaaaaaaaaabbbbbbbbbbbaaabbbbbbbbbbbbbbabbabbbbbbbbbaaabbbbbbaaabbbbbbbbbbbbbbbbbbbbaabbbbabaabaaabaabbababaabbbaaaabbbbbbbabbbbbbbbbaaaaabbbbaaaaababbbabbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaaaaaabbaabbbaabbbaaaaaaaaabbbbbbbbbbaaabbbbbbbbbbbbbbabaabbbbbbbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbabbaabbabaaaabbaababbbaaaaabbbaaaabbbbbbbbabbbbbbbbbaaaaabbbbbbbaaaabbaabbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbaaaaabbbbbaaabbbaabbbaaaaaaaaabbbbbbbbbbbaabbbbbbbbbbbbbbaaaabbbbbbbbbbabaabbbaabbbbbbbbbbbbbbbbbbaabbaabaabbababbbbaabbbaaaabbbaababbbbbbbbbabbbbbbbbbaaaaaabbaaaaaaaaabaaabaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaaaaaaaabababbaaaaaaaaaaabbaabbbbbbbbbbbaabbbbbbbbbbbbbbaaaabbbabaabbbabbaaaabbbaaaaaaaaaaaaaaabaaabaaaaaaabaaaaaaaaabbaaaabbaaaaaabbbbbbbbbabbbbbbbbbabaaabaaaaaabaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaabaabbaaababaabbaaaabaaabbbabbbbbbbbbbbaabbbbbbbbbbbbbbbbabbbaabaabbbabbaabbaaaabbbbbbbbbbbbbbaabababbaabaaaabbbbbabbbaaabbaabaabbbbbbbbbbbabbbbbbbbaabbaaaaabbaabaaaaabbaabbbaabbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbaaaaaabbbbbaaaaaaaaaaaaaaabbbaabbbbbbbbbbbabbbbbbbbbbbbbbbbaaaaaabaaabbaaaabbaaabbbbbbbbbbbbbbaaabbaaabbbaabaabbbbbbabbaaabbaaaaabbbbbbbbbbbbabbbbbbbbabbbbaaaaaabaaaaaaaabbbaabaaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaaaaaabbbbbbabaababbaaaaaaabbbaabbbbbbbbbbbabbbbbbbbbbbbbbbbaaaaaaaababbaaabbaaabbaaaaaaabbbbaaabbbbbabbbbaaaaabbbbbaabbabbbaaaaaaabbbbbbbbbbbabbbbbbbaabbbbaaaaaaaaabbaaaaabaaaaaaaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbaaaaabbbbbbaabaaababaaaaabaabbbabbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbaaababbaaabaaabaaabbbbbaaaaaabbbbabbbbbbbabbbbbbbbbaabbabbaaaabbbaabbbbbbbbbbabbbbbbbabbbbaaaaaaaaaaaaaaabaaabaaaaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbaaabbbbbbbaabababbabbaaaaaaabbaabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbaababbabababababbbbbbbbbbbbbbbbbaababbbbabbbaaaaabaabbabbabbbbbbbaabbbbbbbbbabbbbbbbabbbbaaaaabaaaaaaaaabbbbbbaaaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbaabbbbbbbbbaaabbaaaabaaaabbabbaabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbaabaaaaaabaaaaabbbbbbbbbbbabbaabbababbbbabaaabbbaaaabbabbbbaaaabbbabbbbbbbbbabbbbbbaabbbbbaaaaaaaaabaaaabbbbbbbaaaaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbaabbbbbbbbbbbbbbaaabbaaaabbabbbabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbaabbaaabaaabbbbbbbbbbbbabbabbbabaabbbaaabbbbbbbaabbabbbaaaaabbbabbbbbbbbbabbbbbbabbbbbaaaaaabaaabaababbbbbbbabababbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbaaaaabaaaaaaabbbbbbbbbaaaaabbabbbabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbabbbaaaaaaabbbbbbbbbbbbabbabbbaaaaabaaaabaaaabbbbbbbbbbaabaaabbaabbbbbbbbabbbbbbabbbbaaaaaaabbabaaababbbbbbbaaaaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbabaaaaabbbbbaaaaaabbbbbaabbbbabbbabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbabbbbbabbaabbbabaaaaaaaaabaabbbbbbbbbbababaabbbabbbbbbbbabbbbbaabbbbababaaabbaaabaaabbbbbbbbaaaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbaaaaaabbbbaaaaabbaaaabbbaabbbbabbbaabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbabbbbbabbaaabbaabaababaabaaaabbbbbbbbbaaabaabbbabbbbbbbbabbbbbaabbbbabbaaaaaaaabbaaabbbbbbbbbaabbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaabbbbaaaaaaabbbbaabbaabbbbabbbaabbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaabbbbbaabbbbbaabaaabbaabbababaaaaababbbbbbbbbaaaaaaabbabbbbbbbbabbbbbabbbbbabbbaabbaaabaabaaaaaaabbbaabbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaabbbbbabaaaabbaaaaaaaaabbbbbaaaaabbbbabbbbabbbbbbbbbabbbbbbbaaaabbbbbbbbbbbbbbbaaabbbbbaabbbbbaabbbbbbaabaaabbaabaaabaaaaabaabbbbbbbbbaaaababbbabbbbbbbabbbbbabbbbbabbbaaabbbaaaaaaabbbaaaaaaaaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbabbbbbaaaaaaabbaaaaabaaabbbbbaaaaaabbbabbbbabbbbbbbbbabbbbbbaabbaaaabbbbbbbbbbaaabbbbbbbbabbbbbaabbbbbbbabaaabbbaabaabbbbbbbaabbbbbbbbbaaaaaabbbabbbbbbbabbbbbabbbbbabbbaaabbaabbbbbbbbbbbbbaaaaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbaabbbbaaaaaaaaaaaaabbaaaabbbbbaaaabbbaabbbbabbbbbbbbbabbbbbbaaaaabbaabbbbbbaaaabbbbbbbbbbaabbbbaabbbbabbaabaaaabbaababbbbbbbbaabbbbbbbbaaaaaaaabaaabbbbbabbbbbabbbbbabbbaaaaaabbbbbbbbbbbbbbbaaaaaaaaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbaabbbabbaaaabbaaaabbaaaabbbbbaaaabbbaabbbbabbbbbbbbbabbbbbbaaaabbbbabbbbbaaabbbbbbbbbbbbbaabbbaabbbbaabbaababaabbababbbbbbbbaabbbbbbbbbabaaababbbabbbbbabbbbbabbbbbabbbaaaaabbbbbbaaabbbbbbbaaaabbbbaaaaabbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbbbbaaababbabaabbaaaaabaaaaabbbbaaaabbbaabaaaabbbbbbbbbabbbbbbbbaabbbbabbbbbabbbbbbbbbbbbbbbaaabbaabbbbaaabbbbaabaabababbbbbbbbbabbbbbbbbbabaaaaaaaaabbbbbabbbbbabbbbbabbbaaaabbbbbaaaaaaabbbbbaaaabbbbbbaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbaaabbaaaabbaaaaaaaaaaabbbbaaaabbaaaaabbabbbbbbbbbabbbbbbbbbaabbbabbbbabbbbbbbbbbbbbbbbbaabbbaabbbaaaabbbbaababaaabbbbbbbbbaabbbbbbbaabbbbbbbbbbbbbbbabbbbbabbbbbabbbaaaabbbbbaaabaaaabbbbaaaabbbbbbaaabbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbabaaaaaaabbbbbbbbbbbbbaaaaaaaabbaaabaaaaaaabbbbaaaabbaabbbbbabbbbbbbbaabbbbbbbbaaabbbabbbaabbbbbbbbbbbbbbbbbbabbbaaabbaabaaabbbabaaaaaabbbbbbbbbaabbbbbbaabbbbbbbbbbbbbbbabbbbbaaabbbaabbaaaaabbbbaaaaaaaaabaaaaaabbbbbaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbaabaaaabbaaaaabbaaaabbbbaaaabbabbbbbaabbbbbbbbaabbbbbbaaabbbbbaaaaabbbbbbbbbbbbbbbbbbbabbaababbabbbbaabbabaaabaabbbbbbbbbbaabbbbbabbbbbbbbbbbbbbbbabbbbbabaaaaaabbaabaabbbaaaabbbaaaaaabaabbbbbabbbbbbbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbbbbbbbbabaaaaabbaaaaabbaaaabbbbabaabbabbbbbaabbbbbbbaaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbabbabaabbbbbaabaabaabbaabbbbbbbbbbaaabbbabbbbbbbbbbbbbbbbabbbbbabbbbbbabbaaaaabbbaaaaaabaaaabaaaabbbaaabbbbbbbbbaabbbbbbbbabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbaabaaaaabbaaaaabaaaaabbbbaaaabbabbbbbabbbbbbbbababbbaababbbbbbbbbbbbbbbbbbbbbbbbaababaaabaabbababbbbbbbaaaabaabbbabbbbbbbbbbbbaabbabbbbbbbbbbbbbbbbabbbbbabbbbbbaabaaaaabbbaaaaaaaaaabbaaaaaababbbbbbbbbbbaaabbbbbbbabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbaaaaaaaaaabbaaaaaabaaaaaaabaaaaaaaaaaaabaaaaaaabbbbbbbaababbaabaabbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaabbaaaabbbbbbbaaabbbbbbbaabbbbbbbbbbbbaabaabbbbbbbbbbbbbbbabbbbbaabbbbbbabbaaabbbaaaaaaaaaaabbaaaabaaabbbbbbbbbbbaaaaaaabbbabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbaaabbbbbbbbbbaaaababaaabaabbabbbaaaaaabaaaabbbaabbbbbbaabbabbabaaabbbbbbbbbbbbbbbbbaabbaaaabbbbbbaaaaaaaabbbbbbbbbaabbbbbbbbaabbbbbbbbbbbaabbabbbbbbbbbbbbbbbabbbbbbabbbbbbabbaaabbbaaaaaaabaaabbaaaabaabbbbbbbbbbbbaaaaabbbbbabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbabaaaaaaabbaaabbbbbbbbbbbaaaababaaaaaaabaabaaaaaaabbaaaabaabbbbbbaabbbabbaaabaaaaabbbbbaabbbbabaaaaaabbbbaaaaaaaaaaaabbbbbbbbbaabbbbbbbbbaabbbbbbbbbbaabbaaabbbbbbbbbbbbaabbbbbbaabbbbbabaaaaabbaaaabbaaaaabaaaaabaabbbbbbbbbbbbabaaaaabbbabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbaaabbbbbbbbbbbbbaabbabaaaaabaaaaaaaaaaaabbbaaaaabbbbbaaabbbbabbbabbbbbbabbbbbaabbbaaaaaaaabbbaaabbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaabbbbbbbbbaabbbbabbbbbbbbbbbbaabbbbbbbabbbbbabaaaaabbaaaabbaaaaababaaabaaabbbbbaaabbbaaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbaaaaaabbbbbbbbbbbbbbaababbaaaabbbaaabbbbaaaabbbbaaaaaaaaaaabbbbbabbbbbbbbbbaabbaaaabbaaaaaaabbbbaabbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbaabbbbbbbbaabbaaabbbbbbbbbbbbaaabbbbbbaabbbaaaaaaaaaaaaaaabaaaaababaaababaaaaaaaaaabbaaaaaaabbbabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbaaababbaababbbaaabbbbaaaabbbbbbbaaabbbbbbbbbbabbbbbbbbbaaaaaabbaaaabaabaabbbaabbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbaabbbbbbbabbbbaabbbbbbbbbbbbaaaabbbbbbaaaaaaaaaaaaaabbaaaaabaabbabaaaaabbbbbbbbbbbabaaaabbbbbbabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaaabbaaabbbbaaaabbbbbbbbbbbbbbbbbbbbabbbbbbbbbaaaaabbbbbbbbaaaaabbbabbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbaaabbbaaabbaaaabbbbbbbbbbbbaabaaabbbbbbbaaabaaaaaaabbaaaaaaaabbabaaabbbbbbbbbbbbbaaaaaaaaaaababbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaaaaaaaabbbbbaaabbbbbbbbbbbbbbbbbbbbabbbbbbbbbaaabbbbbbbbbbbbababbaabbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbaaaaaabbaaaabbbbbbbbbbbbbaabbbaaaaaaaaabbbaaaaaaaaaaaaaaababbabbaabbbbbbbbbbbbbbbaabbbbbbbbabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaaaaaaaabbbbbababbbbbbbbbbbbbbbbbbbbabbbbbbbbbbaabbbbbbbbbbbbabaaaabbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbabaabbbbbbbbbbbbbaabbbbbbbbbbbbbbbaaaaabbaaaabbaaaaababaaaabbbbbbbbbbbbbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaabaaaaabbbbbbaaabbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbaaaabbbaaabbbaaaaababaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbaaaaabbbbbbaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaaaabbbbbaaaaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbaaabbbaaabbbaaaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaaaaaaabbbbbbaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbaabaabbbbabaaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbaabbbbaaaaaaabaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababbbaaaaaaaaabbbbbbaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbaabbaaaaaaabaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbaaabbbbaaaaaaaaaaabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbabaaaabbbbbbbaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbabbbaaabaabbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbaaaaabbbaaaaabaaaaabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbaaaaabbbbbbbbaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbaaabbaabbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbaaabbabbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbaaaaabbbaaaaaabbaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaaaabbbbbabaaaabbbbbbbbbbbbbbbbbbaaaabaabbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbaaaaabbbbaaaabaaaaaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaabaabbbbababbabbbbbbbbbbbbbbbaabaaabbabbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbaaaaabbbbaaaaaaaaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbaaaaaabbaaabbabbbbbbbbbbbbbbbaabaaaababbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaaaaaabbbbbaaaaaaabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbaaabbbaaabbaabbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbaaabbabbbaaabaabbbbbbbbbbbbbbaabaaaababbbbbbbbbbbbbbaaaaaaaabbaaaabbbbbbbbbbbbbbaabbbbbbbbbbbbbaaaaabbbbbbaaaaaabbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaabbbbbbbaaabbbaaaabaaabbbbbbbbbbbbbbbbbbabbbbbbbbbbaaabbbbabbbbbabbbaabbaabbbbbbbbbbbabaaaaaaababbbbbbbbbbbbbbbaabbababaabbaabbbbbbbbbbbbbaabbbbbbbbbbbbbaaaaabbbbbbbbabbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbaaabbaaaabaaaaabbbbbbbbbbbbbbbbbabbbbbbbbbaabaaaabaabbbbabbbbbbbbabbbbbbbbbbbaaabaabaababbbbbbbbbbbbbbaaaaaabbaabbababbbbbbbbbbbbbaabbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbabababaaaaaaaaabbbbbbbbbbbbbbbbbabbbbbbbbbababaaaababbbaabbbbbbbbabbbbbbbbbbaabaaaabbbbabbbbbbbbbbbbbbbaababbbbbbaaaabbbbbbbbbbbbbaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbabababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbaabaabaaaabaaaabbbbbbbbbbbbbbbbbabbbbbbbbaaaaaabbaaabbbabbbbbbbbbaabbbbbbbbbaabaabbbbbbabbbbbbbbbbbbbbbaababbbbbaabaabbbbbbbbbbbbbaabbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbabbbbaaaaaaaaabbbbbbbbbbbbbbbbbabbbbbbbbaaababbbbbbbbbabbbbbbbbbbaabbbbbbbbbabbbbbbbbbabbbbbbbbbbbbbbbaaaabbbbbabbbbbbbbbbbbbbbbbaabbbbbbbbbbbbaababaaabbbaabbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaabbabaaaaaaaaaaaaabbbbbbbbbbbbbbbbabbbbbbbbbbbbabbbbbbbbbaaabbbbbbbbbabbbbbbbbbaabbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbaabbbbbbbbbbbbaaaaaaaabbbaaabbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaaaabaabaaaaaaaaaabbbbbbbbbbbbbbbbabbbbbbbbbbbbabbbbbbbbbbbaaabbbbbbaabbbbbbbbbbaaaabbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaabbbbbbbbbbbaaaaabaaaabbaabbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaabbaaabbbaaaaaaabbbbbbbbbbbbbbbbabbbbbbbbbbbbaaabbbbbbbbbbaaaaaaaaabbbbbbbbbbbbbaabbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbaabbbbbbbbbbbaaaaaaaabaaaaabbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaababbaabbbaabaaaaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbaaaabbbbbbbbbbbbaabbbbbbbbbbbbbbbbabbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbaabbbbbbbbbbbaaaaaaaaaaaababbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaababbaaaaaaaaaaaaaabbbbbbbbbbbbbbbabbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaaaaaababbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbaabbbbbbbbbbaaaaaaaaaaaabaabbaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbaaabaaaabaaabaabaaaabbbbbbbbbbbbbbabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaaaaaaabababbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbaaaaaaaabaababbaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaababaaaaabbbbaaaaabbbbbbbbbbbbbaabbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaabbbaaaaaabbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbaabbbbbbbbbbbaaaaaaaabbaaabaabaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbabbaabaaaabbbbbbaaaaabbbbbbbbbbbbaabbbbbbbbbbbbababbbbaabbbbbbbbbbbbbbbbbbbbbbbbabbaaaaaaaaabaabaabbbaabbbbbbbbbbbbbaaaabbbbbbbbbbbbaabbbbbbbbbbaabaaaaaaabaaaaabaabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbabbaaaaaaabbbbbbaaaaabbbbbbbbbbbbaabbbbbbbbbbbaabaabbaaaabbbbbbbbbbbbbbbbbbbbbbbabaaabbbaaaabaaaaaaaaaaabbbbbbbbbbbbbaaabbbbbbbbbbbbaabbbbbbbbaaaaaaabaaaaaaaabbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbabaaaaabaabbbbbbbaaaaabbbbbbbbbbbaabbbbbbbbbbbabaaaaaabaabbbbbbbbabbbbbbbbbbbaabababaaaaabbabaaaabbbbbbabbbbbbbbbbbaaaaabbbbbbbbbbbbaabbbbbbbbaabaaaaaaaaaaaabbbabbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaabaabbbbbbbbaaaaabbbbbbbbbbbaabbbbbbbbbbbaaabbbbbbabbbbbaabaabbbbbbbbaabaaaaaabbaaaaabaabaaabbbbbbbabbbbbbbbbbaaababbbbbbbbbbbbaabbbbbbbaaaaaaabaaaaaaabbbaabbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbaaaabbbbbbbbbbbaabbbbbbbbbbbbaabbbbbbaabbbbaababbbaabbbaaababaaaaabaabbbbbaaaababbbbbbabbbbbbbbbbbaaaabbbbbbbbbbbbaabbbbbbbaaaaabbbbbaaabaabbbabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbaaaabbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbaaaaaaababbaaabababaaabbbbbaaabbbbbaaaaaaaaabbbaabbbbbbbbbaaaaaabbbbbbbbbbbbaabbbbbbaaaaaabbbbaaaaababbbabbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbaabbbbbbbbbbbbbbbbbbaaaabbaabaaabbabaaababbbaabbbbbbbbbbbbaaaaabbbbabbabbbbbbbbbbbabbbbbbbbbbbbbbbbaabbbbbbaaaaabbbbbaaaaababbbabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbaabbbbbbbbbbbbbbbbbbbaabaaabaaaabaaaaaababbbbbbbbbbbbbbbbbaabaabbbbaaaabbbbbbbbbbbaaabbbbbbbbbbbbbbaabbbbbbbaaabbbbbbbaaaaaaaababaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbaabbbbbbbbbbbbbbbbbbbbaaabbaaaaaaabaaaaaabbbbbbbbbbbbbbbbbbbbbabbbbaaabbbbbbbbaaaaaaabbbbbbbbbbbbbbaabbbbbbaaaabbbbbbbbabaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabaaabaaabbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbaabbbbaaaabbbbbbbbbbbbbbbbbabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbaaabbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbaabbbaaaaabbbbbbbbbbbbbbbbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbabbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaabbbaaababbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbababbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbaaaaaaaaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbaaaaabbabbbbbbbbbbbbbbbbbbbbbaabaaaaaaabbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaabbbbbbbbbbbbbbbbbb",
        "bbbbbbbabbbbbbbbbbaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbaaabbaaaaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabbbbbbbbbaaaaabaabbbbbbbbbbbbbbbbbbbbbaababaaaabbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbabbbbbbbbbbbbbbbbbb",
        "bbbbbbbaabbbbbbbbbabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbbbaaaaaaaaaaaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaabbaaaabbbabbaaaabbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbabbbbbbbbbbbbbbbbbb",
        "bbbbbbbaaabbbbbbbbaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaaaabbbaaaaaabbaaaaaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbababaaaaaaabbbabbaabbbbbbbbbbbbbbbbbbbbbbbbabbaaaaaaabbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbbbbbbbbaabbbbbb",
        "bbbbbbbabaaabbbbbbaabbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbaaaaaabbaaaaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbaababaabbabaaabbbbbbbbbbbbbbbbbbbbbbbbabaaaaaabaaabbbbbbbbaaaabbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaabbbbbbbbbaabbbbbb",
        "bbbbbbbaabbaaabbbbbabbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaaaaaaabaaaaaaaaaaaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaababbbbbbbbaaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbaabbbbbbbbaaabbbbbb",
        "bbbbbbbbabbbaaaabbbabbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaabaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaaaaabbbaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbaabbbbbbbaaaabbbbbb",
        "bbbbbbbbabbbbbbaaabaabbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaabaaaaaaaaabaaaaaaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbaaaaaabaaaaaaaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbaabbbbbaaabaabbbbbb",
        "bbbbbbbbaabbbbbbbaaaabbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaabbaaaaaaaaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaabaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbabbbbaaabbbabbbbbbb",
        "bbbbbbbbbaabbbbbbbbaabbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbaaaaaaaabababbaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaabbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbaabbaaabbbbbabbbbbbb",
        "bbbbbbbbbaabbbbbbbbbabbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaaaabaaaaaabaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbaaaaabbbbbbaabbbbbbb",
        "bbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaababaaaaaaaaaaaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaaaaaaaabbabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbabbbbbbbbbaabbbbbbbb",
        "bbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbaabbbbbbbb",
        "bbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbaaaaaaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaabaaaabbbaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbb",
        "bbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaabaaaabaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbb",
        "bbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaabaaaabaabaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaaaaaaababaaaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaabaaaaaaaaaaabababaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaaaabbabaaaaaaabaaaaabaaabbaaaaaaababbbbaabbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbaaaaaaaabbaaaaaaaaabbbabbbbbbaaaaaaaababaaabaaabbbaaabaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaabaaaaaaaaaaabaaabbbaaaaaaaabbbbabbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbaabbbbabbbbaaaaaaababaaaaaaaaaaaaaaabaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaabbabaaaaaaaababbbbaaaaaaaabbaabbbbbbbbbbbbbbbbbbaabbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaabbbbaaaaaaaaabaaaaaaaaaaaaaaaaaaabbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbaaaaaabaaaabbbbbaaaaaaabaabbbbbbbbbbbbbbbbbbbbaaabbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbabbaaaaaaaaabbbaaaaaaaaabaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaabbbbbbabaaaaaaaabbbbbbbbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbaabbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbaaaaaaaaaaaaabaaaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabaaaaaaaaaaaaaabbbbbbbbaabbbaaaaaaaabbbbbbbbbbbbbbbbbbbaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbaaaaaaaaaabbbaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabaaaaaaaaaababbbbbbbbbbaabbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbaabbaabbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbbbbbabbaaaaaaabbaaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabaaaaaabaaabbbbbbbbbaabbbbaabaaaaaaaaabaabbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbaabbbbbbaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbaaaaaaabaaaaaaaabbbbbbbaabbbbaabbaaaaaaaaaaaaaaabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbaaaaaaaabbbaabbbbabbbbbbbbbaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbabbbbbbbbbbbbbbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaabbbbbbabbbbbabbbaaaaaaaaaaaaaaaaabbbbbbbbbbbaabbbbbbbbbbbaaaaaaaaaaaaaaaabbbbaabbbaabbbbbbbbaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbabbbbbbbbbbbbbbbaaabbbbbbbaabbbbbbbbbbbbbbbbbbaaaaaabbaabaaaaaabbbbaabbbbaabbbaaaaaaaabbaaaaaaaaabaaaaaaaabbaaaaaaaabbaaaaaaaaaaaaaaaaabbbbbabbbbaabbbbbbbbaaaaaabbaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaabbbbbbbbbbbbaaaabbbbaabbbaaabbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaabbbaabbbbaabbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaababaaabaabbbbaabbbbabbbbbbbaaaaaaaaaaabaaaaabbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbbbbbbbbaabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaabbbbbbbbbbbaaabbbbbaaaabbbbaabbbbbbbbbbbbbbbbbaaaaaaaabaaaaaabbbabbbbbabbbbbaaaaaaaaabbaabbaabbbaaabaaaabbbbaaaaaaaaaaaaaaaabbbaabbbaaabaabaabbbaabbbbbaaaaaabaaaaaaaaaabbbbbbbbbbbbbbbbbbaabbbbaabaabbbbbbbbbbbbbaabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaabbbbbbbbaaaabbbbbbaabaaabbbaaabbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaabbbbaabbaaaaaaabaaaaaaaabbbbbbbaaaaaaaaaaaaaaaaaaabaaabbbaaaaaaaabaaaaaaaababbbbaabbbaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbaaabbbbaaabbaaabbbbbbbbbbbaabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbabbbbbbaaaabbbbbbbaabbabaabbbbaabbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaabbbbbaabbaaaaaababaaaabbbabbbbbbbbbbbbbbaababbbbbbbbbbbbbbbaaaabbabbaabaaaaabaabbbbabbaabaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbaabbbbbbababbbbaaabbbbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbaaaaaaaaabbbbbbbbaabaaaaaaabbbbaabbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbbaabbbaaaaaaaabaaabaaaabbbbbbbbbbbbbbaababbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaabbaabbbaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbaaabbbaaaaababbbbbaaaabbbbbbbabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbaaaaaabbbbbbbbbbaabbbaaaababbbbbaabbbbbbbbbbbbbbbbbbbaaaaaaaaaabbbbaabbbbbaaaaaaababbaabbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbaabbabbaaaabaaabbbabbbbaaaaaabaaaaaaaaabbbbbbbbbbbbbbbbbbaabbbbaaaaabaabbbbbbbaaabbbbaabbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaabbbbaaabbbbbbbaabaaabaaaaababbbbaabbbbbbbbbbbbbbbbbbaaaaaaababbbbbabbbbbaaaaaaaaaabbabbbbbbbbbbbbbaaaaaaabaaaaababbbbbbbbbbbbaabaaaaaaabbaaabbaabbbbaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbaaabbbbbaabaabaaaaabbbbbaaaaaaabbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbaabbbbbbaabbbbbbaabaaaabaabbaaabbbbaabbbbbbbbbbbbbbbbbbbabaaaaabbbbaabbbbbaaaabbbbbbabaabbbbbbbbaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbabbaaaaaabbbaabbbaabbbaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbabbbbbbbbaabaabbbbaaabbbbbbbaaaaabbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbabbbbbbbbaaabbbbbaaaaaaaabbaaaaabbbbaabbbbbbbbbbbbbbbbbbbaaaaaaaabaabbbbbbaaabbaaaaaaaaaaabbbbbaaaaaaaaaaaaaaaaaaaaaaaabbbbbaaaaaaaabbbbaaaaaabbbbabbbbaaaaaaaabaabbbbbbbbbbbbbbbbbaaabbbaaaaabaabaaaabbaabbbbbaaabbaaabbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbabbbbbbbbbbaabbbbbaabaaabbaabaaabbbbbaabbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbaabbbaabaabbbaaaabbbbaaaaaaaaaaaaabaaaaabaaaaabbbbbaaaaaaaaaaaabbbbabbbbbaabbbaaaaaaabbbbbbbbbbbbbbbbbbbbaabbbbaabbbaabaabaaaaaabbbbaaabbbbbbaabbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbaabbbbbbbbbbaabbbbbaaaabbaabaaabbabbbbaabbbbbbbbbbbbbbbbbbaabaaaaaaaabaaaaaaaaaabbaabbbaabbbbbaaaaaaaaaaaaabaaaaaaaaaaaaabbbbaaabbbbaaaaaabbaaaabbbaabaaaaaaaabbbbbbbbbbbbbbbbbbbaaabbbaaaaaaaabbaaaaabbbbbaaabbbbbbbbaabbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbaabbbbbbbbbbbaabbbbbaaabaabaaabbaaabbbbaabbbbbbbbbbbbbbbbbabbbaaaaaaababaaaaabbaabbaabbbbbbbbbaaaaaaaaabbbaaaabaaaaaaaaaabbbbbbbbbaaabbbaaabaababbbbaaabaaaabbbbbbbbbbbbbbbbbbbbaabbbbaabaaaaaaabbaababbbbbaabbbbbbbbbbabbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbaabbbbbbbbbbbaabbbbbabaabaaabbaaaaabbbbaabbbbbbbbbbbbbbbaabbbbaaaaaaaaaabbbbbbbaabaabbbbbbbbbaaaabaabaabaaaaaaaaaaaaaaaabbbbbbbbbabbaaaabaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbaabbbbbaabaaaaaaaaaaaaabbbaaabbbbbbbbbbbabbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaabbbbbbbbbbbaabbbbbaabaaabbaabbaabbbbbaabbbbbbbbbbbbbaabbbbbabbaaaaaaaaabbbbbaaaabbbbbbbbbbaaaaababbaaabbaaabaaabbaaaabbbbbbbbbaabaabbbbbbaaaaaaaaaabbbbabbbbbbbbbbbbbbbbbbaabbbbbbbaabbbaaaabaabbbbbaabbbbbbbbbbbbbabbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbaaaabbbbbbbbbaabbbbbaaaabbaabbbaababbbbaabbbbbbbbbaaaaabbbbaabbbabbaaaaaaaabbabaabbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbabaabbbbbaaaaaaaababbbbaabbbbbbbbbbbbbbbaaabbbbaaabbaabbaaaaaaabbbbaabbbbbbbbbbbbbaabbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbaaaabbbbbbbbaabbbbbaabbaabaababaaabbbbaabbbbbbbaabbbaabbaabbbbbbbaaaaaaaabbaaaaaabbbbbbbbbbaaaaaaabaaaababaaaabaaabbbbbbbbbbbbbaabaaaabaaaaabaabbbabbbbaaaabbbbbbbbbbbbaabbbbaaaaabbaabbabbaabbbaaabbbbbbbbbbbbbaabbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbaaaaabbbbbbaabbbbbbbaabaaaaaaabaabbbbaaabbbbbaabbbbaaaabbbbbbbbbaaaaaaaaaaaaaaaabbbbbbbbbbaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbaaaaaaaaaaaaaaaabbbbbaabaabaaaabbbbbbbbbaaabbbbaaabaaaabaabaaabbbbaaabbbbbbbbbbbbbaaabbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbaaaabbbbbaabbbbbaabaaabaaabbabbbbbbbaabbbbaabbbbbbabbbbbbbbbbbbbaaaaaaaaaaaaabbbbbbbbbbbaababaaaaaabababbaabbbbbbbbbbbbbaaaaaaaaaabbabbbbbbbbbaaabbbbaabbbbbbbbaabbbbabaaaaabaaabaabaabbbaabbbbbbbbbbbbbaaabbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaaaabbbbaabbbbbaaaaabaabaaabaabbbbaaabbbaaaabbbbabbbbbbbbbbbbbbbabbaaaaaaaaaaaaaaabbbbaabaaaaaaaaaaaabaaabbbbbbbaaaaaaaaaaaaaaaabbbbbbbbbbbbabbbbbbaabbbbbbaaabbbbaaabaaaaabbaaaaaabbbaabbbbbbbbbbbaaaaabbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbaaabbbbaabbbbbabbabbbaabbaaaabbbbbaaababbaabbbaabbbbbbbbbbbbbbbbbbaaaaaaabaaaaaaaaabbaaaaabbbbbbaaaaaaabaaabaaaaaaaaaaaaaaaabbbbbbbbbbbbbbabbbbbaaabbbbbaaabbbaaabaaaaaaabbbbaaabbbaaabbbbbbbbbaaaabbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbaaabbbbaabbbbbbaabbaabbaabaabbbbbbaaaabbbaaaaaabbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaaaaaaabaaaaaaaaaaaaaaaaabaaabbbbbbbbbbbbbbbbbabbbbaababbbaaabbbbaaabaabbaaaaaaaaaabbbaababbbbbaaaaabbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbaabbbbaabbbbbaabaabbaabaaabbbbbbbbbaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbaabbbbaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbaaababbbaabaaabbbbaaabbaabbabaaabaaabbbaabbabbbbaaabbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbaabbbbbaabbbbaaaabbaaabaabbaaaabbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbaaabbbbbbbaaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaaaabbbbbbaaaaabaabaababbbbbbbaabbbabbbaaabbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbaabbbbbaabbbbaabbaabbaabaaabaaabbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbaaabbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbaaaaaaaabaabbabaabbbbbaabbbbabaaabbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbaabbbbbbaabbbbbbbaabaabbaabaabaabbbbbbbbaaaaaabbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbababbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbaaaaaabbaabaaaaaaabbbaaabbbbbaaaabbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbaabbbbbbbaabbbbbaabaabbaabaaaabaabbbbbbbbbbbaaaaaaaabbbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbaaaaaaaabbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbaaaaabbbbaabaabaabbbbaabbbbbbaabbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbabbbbbbbbbaabbbbaaaabaabaabaaababaaaabbbbbbbbbbaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbaaaaaaaabbbaabaabbbbaaabbbbbbbabbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbabbbbbbbbbbaabbbbabbbaababaaaaaababbabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbaabbbbbbbbbbbbbbbbbaabbbbbbbbbbbbaaabbbaabaaaaaabbaaaabbbbbabbbbbbbbaabbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbabbbbbbbbbbbaabbbbbbbabaaaaaaaaababaaaaaaaaaaaaaaabbbbbbaaaaaaaabbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaabbbbbbbbbbbaaabaaabbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbaabaaabaabbaabbbbaaabbbbbbbbaabbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbaabbbbbbbbbbbbaabbbbbbaabaaaabaabbabaaabbaabaaaaaaabbaaabaabbbbbabbbbbbbbbbbbbbbaaabbbaaaaaaabbbaaabbbbbbbbaabaaababbbaaabbbbbbbbbbbbaaaaabbbaaaabbbbaaaaaababbbbbbbaabbbbbbbbbbaabbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbaaabbbbbbbbbbbbbaaabbbbbaaaaaababbaabaabaaabbabaaaaabbababaaaabaaabbbbbbbbbbbbbaaabbbbbaaaaaaabbbbbaaabbbbbbaaaaaababaaaaabbaaaaaaaaabaaaaaaaaaabbbbbbbbbbaababbbbbbaabbbbbbbbbbbaabbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbaaabbbbbbbbbbbbbbbbbaabbbbbaabbbaabbaabbbbaabbbabaaaaabbababaaaababbbbbbbbbbbbbaaabbbbbbbaaabaaabbbbbbbaaabbbaaaabaaaabaaababaabaabaababaabaaaaababbbbbbbaaaabaabbbbaaabbbbbbbbbbbbbabbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbaaabbbbaaaaabbbabbaabaabbbabaaaaabbababbbaababbbbbbbbbbbaaabbbbbbbaaaaaaaaaaabbbbbbaaaabbaaaaaaaaaaaabababaaaaaabaabababbbababbbbbbbaaaaaabbbbaabbbbbbbbbbbbbbbaaabbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbbbbbbbaabaaabbabbbabbbbbabbabaabbbababbbbbbbbbaaabbbbbbbaaaaaaaaaaaaaabbbbbbbbaabbbbbaaaaabaababababbbbabaaaababbbababbbbbbbaaabbbbbaaabbbbbbbbbbbbbbbbbaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbaababaababbbabaaaaabbabaabbbababbbbbbbaaabbbbbbbbaaaaaabaaaaaaaaabbbbbbbbaaabbbaaaabaaababababbbbabbbbbbabbbabaabbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaaabbbbbbaaaabaababbaababbbbbbabaabbbaaabbbbbaaabbbbbbbbbbaaaaaababaaaaaaabbbbbbbbbbaabbbbbaaabababababbbbaabaaababbbaababbbbbbbbbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaabaaaabbbbbbbbbaaaaabaabaaaaabbabaabbbabbbbbaaaabbbbbbbbbbbaaaaaaaaaaaabaaabbbbbbbbbbbaaaabbbbbbaaababaaaaaaabababaabbaaaabbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbababbbbbbaaabbbbbbbbbaaabaaaaaaaabbaaaabbbbbbbaaabbbbbbbbbbbbbbbaaabaaaaaaabaaabbbbbbbbbbbbbaaabbbbbbbabaaabbaaaabababaabbbabbbbbbbbbaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbabbbbbaabaaaabbbbbbbbbbaaaaaaaabbbbbbbbbbaaaaabbbbbbbbbbbbbbbbaaabaaaaaaaaaaabbbbbbbbbbbbbbbaaaaabbbbbbaaaaabaaaabaaaabbbbbbbbbbbaaabbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabbbabbbbbaaaabbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbaaaaaaabaaaaaaabbbbbbbbbbbbbbbbbbaaaabbbbbbbbbbbabbbbbbbbbbbbbbbbaaabbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabaaabbbbbbbaaaaaaaabbbbbbbbbbbaaaaaaabbbbbbbbbbbbbbbbbbbbbbaaaaaaabaaaaaaabbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbbbbbbbbbaaaaabaabaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaaaaaaaabbbbbbbbbbbbaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbbbbbbbbbaaaaabbbbbbaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaabbbbbbbaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaaabababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbababbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbaabaaaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbabbbabbaaababbaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabaabaabababbabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbabbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabaaabaaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbababaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaababaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbabaaaaaaabbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaaabaaabbbbbabbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaababaababaaaaaaabaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaaabaabbbabaabaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaabaabaaaaaaaaaabaaabababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabaaabaaaaaaabbbbaaaaaababaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaababaaaaaaaaabbbbbbbbaaaaaabaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaabaabbaaabbbaaaaaabbbaabaaabaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbaaaaabaaaabbaaaaaaaaabbbaabbaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbaaababbbaaababaaaaabaaaaaabbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaabbaaabbaaaaaabaabbabbaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaaaabaabaabaaabbabaaabbaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabaabaaaabaaaaaaaaabaaaabbaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaababbbabbaaaaaabaabaababbabababababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbabbabbabaaaaaaaaaababbaaaaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaababbbabbabbaaaaaababaabbaaaaabababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaabaaaabaaaaaaaaabababbaabaaaaababbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaaabbabbaabbabbaaaaabbaababaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabaaaabbbaaaabbaaaaabaaaaaaabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaabbbbaaaaaabbbaaabbaaabbbaaabbabaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabaaaaaabaaabbbbaaaaabbaaaaaaabaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaaabbaabaaaaabbbbbbbbaaaabaaaaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaabaabbaaaaaaaaaabbaaaaaaabaabaabbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbbaaaaaabaabaaaaaaabaabaaabaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaabbbbbbbabaaaaaaabbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabbbaababbbaabbabaaabbaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaabbbabbbaabaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaabbaaaaaaaaabbbaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaaaaaaaaaaaaabaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbaaabaaaabaaaaaaabbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaaaaaaabbaaabaaababbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaabaaabbbbbbbaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb"
        };
        wxBitmap bitmap( xpm_data );
        return bitmap;
    }
    if (index == 16)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "16 16 9 1",
        "a c Black",
        "b c #FF0000",
        "c c #808000",
        "d c #C0C0C0",
        "e c #FFFF00",
        "f c #FFFFFF",
        "g c #000080",
        "h c #808080",
        "i c #008000",
        /* pixels */
        "bbbbbbbbbbbbbbbb",
        "iiiiiiiiiiiiiiib",
        "ihddddhdddhddhia",
        "idefffeffefffdia",
        "idfdcdfffffefdia",
        "ihfchcfgffdffhia",
        "idfdcdgedgfgfdia",
        "idffeffgffgefdia",
        "ihefffffeffffhia",
        "idffgggggggggdia",
        "idffefffffeffdia",
        "ihdddhddddhddhia",
        "iiiiiiiiiiiiiiia",
        "baaaaaaaaaaaaaaa",
        "bbbbbbbbbbbbbbbb",
        "bbbbbbbbbbbbbbbb"
        };
        wxBitmap bitmap( xpm_data );
        return bitmap;
    }
    if (index == 17)
    {
        /* XPM */
        static const char *xpm_data[] = {
        /* columns rows colors chars-per-pixel */
        "16 16 8 1",
        "a c Black",
        "b c #FF0000",
        "c c #808000",
        "d c #C0C0C0",
        "e c #FFFF00",
        "f c #008080",
        "g c #FFFFFF",
        "h c #808080",
        /* pixels */
        "ahbbbbbbbhbbbbbb",
        "bahbbbbhhdhbbbbb",
        "bbahbhhddddhbbbb",
        "bbbhhddddhhdhbbb",
        "bhhddddhhddddhbb",
        "hgdddhhdddddddhb",
        "hhghhdddddddddhb",
        "ahhgddddddddhaab",
        "bahhgdddddhaadab",
        "bbahhgddhaaddgfb",
        "bbbahhgaaeecgggf",
        "bbbbahhadccggffa",
        "bbbbbaaafggffaab",
        "bbbbbbbbaffaabbb",
        "bbbbbbbbbaabbbbb",
        "bbbbbbbbbbbbbbbb"
        };
        wxBitmap bitmap( xpm_data );
        return bitmap;
    }
    return wxNullBitmap;
}
